/* Device.c generated by valac 0.56.0, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_DEVICE_INITIALIZED_SIGNAL,
	MUSIC_DEVICE_DEVICE_UNMOUNTED_SIGNAL,
	MUSIC_DEVICE_INFOBAR_MESSAGE_SIGNAL,
	MUSIC_DEVICE_NUM_SIGNALS
};
static guint music_device_signals[MUSIC_DEVICE_NUM_SIGNALS] = {0};

static gchar* music_device_real_get_unique_identifier (MusicDevice* self);
static void g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GType music_device_get_type_once (void);

gboolean
music_device_start_initialization (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 36 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 36 "../core/Devices/Device.vala"
	if (_iface_->start_initialization) {
#line 36 "../core/Devices/Device.vala"
		return _iface_->start_initialization (self);
#line 74 "Device.c"
	}
#line 36 "../core/Devices/Device.vala"
	return FALSE;
#line 78 "Device.c"
}

void
music_device_finish_initialization (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 37 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 37 "../core/Devices/Device.vala"
	if (_iface_->finish_initialization) {
#line 37 "../core/Devices/Device.vala"
		_iface_->finish_initialization (self);
#line 93 "Device.c"
	}
}

gchar*
music_device_get_content_type (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 38 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 38 "../core/Devices/Device.vala"
	if (_iface_->get_content_type) {
#line 38 "../core/Devices/Device.vala"
		return _iface_->get_content_type (self);
#line 109 "Device.c"
	}
#line 38 "../core/Devices/Device.vala"
	return NULL;
#line 113 "Device.c"
}

gchar*
music_device_get_display_name (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 39 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 39 "../core/Devices/Device.vala"
	if (_iface_->get_display_name) {
#line 39 "../core/Devices/Device.vala"
		return _iface_->get_display_name (self);
#line 128 "Device.c"
	}
#line 39 "../core/Devices/Device.vala"
	return NULL;
#line 132 "Device.c"
}

gchar*
music_device_get_empty_device_title (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 40 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 40 "../core/Devices/Device.vala"
	if (_iface_->get_empty_device_title) {
#line 40 "../core/Devices/Device.vala"
		return _iface_->get_empty_device_title (self);
#line 147 "Device.c"
	}
#line 40 "../core/Devices/Device.vala"
	return NULL;
#line 151 "Device.c"
}

gchar*
music_device_get_empty_device_description (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 41 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 41 "../core/Devices/Device.vala"
	if (_iface_->get_empty_device_description) {
#line 41 "../core/Devices/Device.vala"
		return _iface_->get_empty_device_description (self);
#line 166 "Device.c"
	}
#line 41 "../core/Devices/Device.vala"
	return NULL;
#line 170 "Device.c"
}

void
music_device_set_display_name (MusicDevice* self,
                               const gchar* name)
{
	MusicDeviceIface* _iface_;
#line 42 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 42 "../core/Devices/Device.vala"
	if (_iface_->set_display_name) {
#line 42 "../core/Devices/Device.vala"
		_iface_->set_display_name (self, name);
#line 186 "Device.c"
	}
}

gchar*
music_device_get_fancy_description (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 43 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 43 "../core/Devices/Device.vala"
	if (_iface_->get_fancy_description) {
#line 43 "../core/Devices/Device.vala"
		return _iface_->get_fancy_description (self);
#line 202 "Device.c"
	}
#line 43 "../core/Devices/Device.vala"
	return NULL;
#line 206 "Device.c"
}

void
music_device_set_mount (MusicDevice* self,
                        GMount* mount)
{
	MusicDeviceIface* _iface_;
#line 44 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 44 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 44 "../core/Devices/Device.vala"
	if (_iface_->set_mount) {
#line 44 "../core/Devices/Device.vala"
		_iface_->set_mount (self, mount);
#line 222 "Device.c"
	}
}

GMount*
music_device_get_mount (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 45 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 45 "../core/Devices/Device.vala"
	if (_iface_->get_mount) {
#line 45 "../core/Devices/Device.vala"
		return _iface_->get_mount (self);
#line 238 "Device.c"
	}
#line 45 "../core/Devices/Device.vala"
	return NULL;
#line 242 "Device.c"
}

gchar*
music_device_get_uri (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 46 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 46 "../core/Devices/Device.vala"
	if (_iface_->get_uri) {
#line 46 "../core/Devices/Device.vala"
		return _iface_->get_uri (self);
#line 257 "Device.c"
	}
#line 46 "../core/Devices/Device.vala"
	return NULL;
#line 261 "Device.c"
}

void
music_device_set_icon (MusicDevice* self,
                       GIcon* icon)
{
	MusicDeviceIface* _iface_;
#line 47 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 47 "../core/Devices/Device.vala"
	if (_iface_->set_icon) {
#line 47 "../core/Devices/Device.vala"
		_iface_->set_icon (self, icon);
#line 277 "Device.c"
	}
}

GIcon*
music_device_get_icon (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 48 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 48 "../core/Devices/Device.vala"
	if (_iface_->get_icon) {
#line 48 "../core/Devices/Device.vala"
		return _iface_->get_icon (self);
#line 293 "Device.c"
	}
#line 48 "../core/Devices/Device.vala"
	return NULL;
#line 297 "Device.c"
}

guint64
music_device_get_capacity (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 49 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 49 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 49 "../core/Devices/Device.vala"
	if (_iface_->get_capacity) {
#line 49 "../core/Devices/Device.vala"
		return _iface_->get_capacity (self);
#line 312 "Device.c"
	}
#line 49 "../core/Devices/Device.vala"
	return 0ULL;
#line 316 "Device.c"
}

gchar*
music_device_get_fancy_capacity (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 50 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 50 "../core/Devices/Device.vala"
	if (_iface_->get_fancy_capacity) {
#line 50 "../core/Devices/Device.vala"
		return _iface_->get_fancy_capacity (self);
#line 331 "Device.c"
	}
#line 50 "../core/Devices/Device.vala"
	return NULL;
#line 335 "Device.c"
}

guint64
music_device_get_used_space (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 51 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 51 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 51 "../core/Devices/Device.vala"
	if (_iface_->get_used_space) {
#line 51 "../core/Devices/Device.vala"
		return _iface_->get_used_space (self);
#line 350 "Device.c"
	}
#line 51 "../core/Devices/Device.vala"
	return 0ULL;
#line 354 "Device.c"
}

guint64
music_device_get_free_space (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 52 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 52 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 52 "../core/Devices/Device.vala"
	if (_iface_->get_free_space) {
#line 52 "../core/Devices/Device.vala"
		return _iface_->get_free_space (self);
#line 369 "Device.c"
	}
#line 52 "../core/Devices/Device.vala"
	return 0ULL;
#line 373 "Device.c"
}

void
music_device_unmount (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 53 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 53 "../core/Devices/Device.vala"
	if (_iface_->unmount) {
#line 53 "../core/Devices/Device.vala"
		_iface_->unmount (self);
#line 388 "Device.c"
	}
}

void
music_device_eject (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 54 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 54 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 54 "../core/Devices/Device.vala"
	if (_iface_->eject) {
#line 54 "../core/Devices/Device.vala"
		_iface_->eject (self);
#line 404 "Device.c"
	}
}

void
music_device_synchronize (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 55 "../core/Devices/Device.vala"
	g_return_if_fail (self != NULL);
#line 55 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 55 "../core/Devices/Device.vala"
	if (_iface_->synchronize) {
#line 55 "../core/Devices/Device.vala"
		_iface_->synchronize (self);
#line 420 "Device.c"
	}
}

gboolean
music_device_only_use_custom_view (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 56 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 56 "../core/Devices/Device.vala"
	if (_iface_->only_use_custom_view) {
#line 56 "../core/Devices/Device.vala"
		return _iface_->only_use_custom_view (self);
#line 436 "Device.c"
	}
#line 56 "../core/Devices/Device.vala"
	return FALSE;
#line 440 "Device.c"
}

GtkWidget*
music_device_get_custom_view (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 57 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 57 "../core/Devices/Device.vala"
	if (_iface_->get_custom_view) {
#line 57 "../core/Devices/Device.vala"
		return _iface_->get_custom_view (self);
#line 455 "Device.c"
	}
#line 57 "../core/Devices/Device.vala"
	return NULL;
#line 459 "Device.c"
}

gboolean
music_device_read_only (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 58 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 58 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 58 "../core/Devices/Device.vala"
	if (_iface_->read_only) {
#line 58 "../core/Devices/Device.vala"
		return _iface_->read_only (self);
#line 474 "Device.c"
	}
#line 58 "../core/Devices/Device.vala"
	return FALSE;
#line 478 "Device.c"
}

MusicLibrary*
music_device_get_library (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 59 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 59 "../core/Devices/Device.vala"
	if (_iface_->get_library) {
#line 59 "../core/Devices/Device.vala"
		return _iface_->get_library (self);
#line 493 "Device.c"
	}
#line 59 "../core/Devices/Device.vala"
	return NULL;
#line 497 "Device.c"
}

GeeCollection*
music_device_delete_doubles (MusicDevice* self,
                             GeeCollection* source_list,
                             GeeCollection* to_remove)
{
	GeeLinkedList* new_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeCollection* result;
#line 61 "../core/Devices/Device.vala"
	g_return_val_if_fail (source_list != NULL, NULL);
#line 61 "../core/Devices/Device.vala"
	g_return_val_if_fail (to_remove != NULL, NULL);
#line 62 "../core/Devices/Device.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "../core/Devices/Device.vala"
	new_list = _tmp0_;
#line 516 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 63 "../core/Devices/Device.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) source_list);
#line 63 "../core/Devices/Device.vala"
		_m_it = _tmp1_;
#line 63 "../core/Devices/Device.vala"
		while (TRUE) {
#line 526 "Device.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* _tmp5_;
#line 63 "../core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 63 "../core/Devices/Device.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 63 "../core/Devices/Device.vala"
				break;
#line 538 "Device.c"
			}
#line 63 "../core/Devices/Device.vala"
			_tmp3_ = _m_it;
#line 63 "../core/Devices/Device.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 63 "../core/Devices/Device.vala"
			m = (MusicMedia*) _tmp4_;
#line 64 "../core/Devices/Device.vala"
			_tmp5_ = m;
#line 64 "../core/Devices/Device.vala"
			if (_tmp5_ != NULL) {
#line 550 "Device.c"
				gboolean needed = FALSE;
#line 65 "../core/Devices/Device.vala"
				needed = TRUE;
#line 554 "Device.c"
				{
					GeeIterator* _med_it = NULL;
					GeeIterator* _tmp6_;
#line 66 "../core/Devices/Device.vala"
					_tmp6_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 66 "../core/Devices/Device.vala"
					_med_it = _tmp6_;
#line 66 "../core/Devices/Device.vala"
					while (TRUE) {
#line 564 "Device.c"
						GeeIterator* _tmp7_;
						MusicMedia* med = NULL;
						GeeIterator* _tmp8_;
						gpointer _tmp9_;
						gboolean _tmp10_ = FALSE;
						MusicMedia* _tmp11_;
#line 66 "../core/Devices/Device.vala"
						_tmp7_ = _med_it;
#line 66 "../core/Devices/Device.vala"
						if (!gee_iterator_next (_tmp7_)) {
#line 66 "../core/Devices/Device.vala"
							break;
#line 577 "Device.c"
						}
#line 66 "../core/Devices/Device.vala"
						_tmp8_ = _med_it;
#line 66 "../core/Devices/Device.vala"
						_tmp9_ = gee_iterator_get (_tmp8_);
#line 66 "../core/Devices/Device.vala"
						med = (MusicMedia*) _tmp9_;
#line 67 "../core/Devices/Device.vala"
						_tmp11_ = med;
#line 67 "../core/Devices/Device.vala"
						if (_tmp11_ != NULL) {
#line 589 "Device.c"
							MusicMedia* _tmp12_;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 67 "../core/Devices/Device.vala"
							_tmp12_ = med;
#line 67 "../core/Devices/Device.vala"
							_tmp13_ = music_media_get_title (_tmp12_);
#line 67 "../core/Devices/Device.vala"
							_tmp14_ = _tmp13_;
#line 67 "../core/Devices/Device.vala"
							_tmp10_ = _tmp14_ != NULL;
#line 601 "Device.c"
						} else {
#line 67 "../core/Devices/Device.vala"
							_tmp10_ = FALSE;
#line 605 "Device.c"
						}
#line 67 "../core/Devices/Device.vala"
						if (_tmp10_) {
#line 609 "Device.c"
							gboolean _tmp15_ = FALSE;
							MusicMedia* _tmp16_;
							const gchar* _tmp17_;
							const gchar* _tmp18_;
#line 68 "../core/Devices/Device.vala"
							_tmp16_ = med;
#line 68 "../core/Devices/Device.vala"
							_tmp17_ = music_media_get_album (_tmp16_);
#line 68 "../core/Devices/Device.vala"
							_tmp18_ = _tmp17_;
#line 68 "../core/Devices/Device.vala"
							if (_tmp18_ != NULL) {
#line 622 "Device.c"
								MusicMedia* _tmp19_;
								const gchar* _tmp20_;
								const gchar* _tmp21_;
#line 68 "../core/Devices/Device.vala"
								_tmp19_ = m;
#line 68 "../core/Devices/Device.vala"
								_tmp20_ = music_media_get_album (_tmp19_);
#line 68 "../core/Devices/Device.vala"
								_tmp21_ = _tmp20_;
#line 68 "../core/Devices/Device.vala"
								_tmp15_ = _tmp21_ != NULL;
#line 634 "Device.c"
							} else {
#line 68 "../core/Devices/Device.vala"
								_tmp15_ = FALSE;
#line 638 "Device.c"
							}
#line 68 "../core/Devices/Device.vala"
							if (_tmp15_) {
#line 642 "Device.c"
								gboolean _tmp22_ = FALSE;
								gboolean _tmp23_ = FALSE;
								MusicMedia* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								MusicMedia* _tmp29_;
								const gchar* _tmp30_;
								const gchar* _tmp31_;
								gchar* _tmp32_;
								gchar* _tmp33_;
								gboolean _tmp34_;
#line 69 "../core/Devices/Device.vala"
								_tmp24_ = med;
#line 69 "../core/Devices/Device.vala"
								_tmp25_ = music_media_get_title (_tmp24_);
#line 69 "../core/Devices/Device.vala"
								_tmp26_ = _tmp25_;
#line 69 "../core/Devices/Device.vala"
								_tmp27_ = g_utf8_strdown (_tmp26_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
								_tmp28_ = _tmp27_;
#line 69 "../core/Devices/Device.vala"
								_tmp29_ = m;
#line 69 "../core/Devices/Device.vala"
								_tmp30_ = music_media_get_title (_tmp29_);
#line 69 "../core/Devices/Device.vala"
								_tmp31_ = _tmp30_;
#line 69 "../core/Devices/Device.vala"
								_tmp32_ = g_utf8_strdown (_tmp31_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
								_tmp33_ = _tmp32_;
#line 69 "../core/Devices/Device.vala"
								_tmp34_ = g_strcmp0 (_tmp28_, _tmp33_) == 0;
#line 69 "../core/Devices/Device.vala"
								_g_free0 (_tmp33_);
#line 69 "../core/Devices/Device.vala"
								_g_free0 (_tmp28_);
#line 69 "../core/Devices/Device.vala"
								if (_tmp34_) {
#line 684 "Device.c"
									MusicMedia* _tmp35_;
									const gchar* _tmp36_;
									const gchar* _tmp37_;
									gchar* _tmp38_;
									gchar* _tmp39_;
									MusicMedia* _tmp40_;
									const gchar* _tmp41_;
									const gchar* _tmp42_;
									gchar* _tmp43_;
									gchar* _tmp44_;
#line 69 "../core/Devices/Device.vala"
									_tmp35_ = med;
#line 69 "../core/Devices/Device.vala"
									_tmp36_ = music_media_get_artist (_tmp35_);
#line 69 "../core/Devices/Device.vala"
									_tmp37_ = _tmp36_;
#line 69 "../core/Devices/Device.vala"
									_tmp38_ = g_utf8_strdown (_tmp37_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp39_ = _tmp38_;
#line 69 "../core/Devices/Device.vala"
									_tmp40_ = m;
#line 69 "../core/Devices/Device.vala"
									_tmp41_ = music_media_get_artist (_tmp40_);
#line 69 "../core/Devices/Device.vala"
									_tmp42_ = _tmp41_;
#line 69 "../core/Devices/Device.vala"
									_tmp43_ = g_utf8_strdown (_tmp42_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp44_ = _tmp43_;
#line 69 "../core/Devices/Device.vala"
									_tmp23_ = g_strcmp0 (_tmp39_, _tmp44_) == 0;
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp44_);
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp39_);
#line 721 "Device.c"
								} else {
#line 69 "../core/Devices/Device.vala"
									_tmp23_ = FALSE;
#line 725 "Device.c"
								}
#line 69 "../core/Devices/Device.vala"
								if (_tmp23_) {
#line 729 "Device.c"
									MusicMedia* _tmp45_;
									const gchar* _tmp46_;
									const gchar* _tmp47_;
									gchar* _tmp48_;
									gchar* _tmp49_;
									MusicMedia* _tmp50_;
									const gchar* _tmp51_;
									const gchar* _tmp52_;
									gchar* _tmp53_;
									gchar* _tmp54_;
#line 69 "../core/Devices/Device.vala"
									_tmp45_ = med;
#line 69 "../core/Devices/Device.vala"
									_tmp46_ = music_media_get_album (_tmp45_);
#line 69 "../core/Devices/Device.vala"
									_tmp47_ = _tmp46_;
#line 69 "../core/Devices/Device.vala"
									_tmp48_ = g_utf8_strdown (_tmp47_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp49_ = _tmp48_;
#line 69 "../core/Devices/Device.vala"
									_tmp50_ = m;
#line 69 "../core/Devices/Device.vala"
									_tmp51_ = music_media_get_album (_tmp50_);
#line 69 "../core/Devices/Device.vala"
									_tmp52_ = _tmp51_;
#line 69 "../core/Devices/Device.vala"
									_tmp53_ = g_utf8_strdown (_tmp52_, (gssize) -1);
#line 69 "../core/Devices/Device.vala"
									_tmp54_ = _tmp53_;
#line 69 "../core/Devices/Device.vala"
									_tmp22_ = g_strcmp0 (_tmp49_, _tmp54_) == 0;
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp54_);
#line 69 "../core/Devices/Device.vala"
									_g_free0 (_tmp49_);
#line 766 "Device.c"
								} else {
#line 69 "../core/Devices/Device.vala"
									_tmp22_ = FALSE;
#line 770 "Device.c"
								}
#line 69 "../core/Devices/Device.vala"
								if (_tmp22_) {
#line 70 "../core/Devices/Device.vala"
									needed = FALSE;
#line 71 "../core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 71 "../core/Devices/Device.vala"
									break;
#line 780 "Device.c"
								}
							} else {
								gboolean _tmp55_ = FALSE;
								MusicMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gchar* _tmp59_;
								gchar* _tmp60_;
								MusicMedia* _tmp61_;
								const gchar* _tmp62_;
								const gchar* _tmp63_;
								gchar* _tmp64_;
								gchar* _tmp65_;
								gboolean _tmp66_;
#line 74 "../core/Devices/Device.vala"
								_tmp56_ = med;
#line 74 "../core/Devices/Device.vala"
								_tmp57_ = music_media_get_title (_tmp56_);
#line 74 "../core/Devices/Device.vala"
								_tmp58_ = _tmp57_;
#line 74 "../core/Devices/Device.vala"
								_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
								_tmp60_ = _tmp59_;
#line 74 "../core/Devices/Device.vala"
								_tmp61_ = m;
#line 74 "../core/Devices/Device.vala"
								_tmp62_ = music_media_get_title (_tmp61_);
#line 74 "../core/Devices/Device.vala"
								_tmp63_ = _tmp62_;
#line 74 "../core/Devices/Device.vala"
								_tmp64_ = g_utf8_strdown (_tmp63_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
								_tmp65_ = _tmp64_;
#line 74 "../core/Devices/Device.vala"
								_tmp66_ = g_strcmp0 (_tmp60_, _tmp65_) == 0;
#line 74 "../core/Devices/Device.vala"
								_g_free0 (_tmp65_);
#line 74 "../core/Devices/Device.vala"
								_g_free0 (_tmp60_);
#line 74 "../core/Devices/Device.vala"
								if (_tmp66_) {
#line 823 "Device.c"
									MusicMedia* _tmp67_;
									const gchar* _tmp68_;
									const gchar* _tmp69_;
									gchar* _tmp70_;
									gchar* _tmp71_;
									MusicMedia* _tmp72_;
									const gchar* _tmp73_;
									const gchar* _tmp74_;
									gchar* _tmp75_;
									gchar* _tmp76_;
#line 74 "../core/Devices/Device.vala"
									_tmp67_ = med;
#line 74 "../core/Devices/Device.vala"
									_tmp68_ = music_media_get_artist (_tmp67_);
#line 74 "../core/Devices/Device.vala"
									_tmp69_ = _tmp68_;
#line 74 "../core/Devices/Device.vala"
									_tmp70_ = g_utf8_strdown (_tmp69_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
									_tmp71_ = _tmp70_;
#line 74 "../core/Devices/Device.vala"
									_tmp72_ = m;
#line 74 "../core/Devices/Device.vala"
									_tmp73_ = music_media_get_artist (_tmp72_);
#line 74 "../core/Devices/Device.vala"
									_tmp74_ = _tmp73_;
#line 74 "../core/Devices/Device.vala"
									_tmp75_ = g_utf8_strdown (_tmp74_, (gssize) -1);
#line 74 "../core/Devices/Device.vala"
									_tmp76_ = _tmp75_;
#line 74 "../core/Devices/Device.vala"
									_tmp55_ = g_strcmp0 (_tmp71_, _tmp76_) == 0;
#line 74 "../core/Devices/Device.vala"
									_g_free0 (_tmp76_);
#line 74 "../core/Devices/Device.vala"
									_g_free0 (_tmp71_);
#line 860 "Device.c"
								} else {
#line 74 "../core/Devices/Device.vala"
									_tmp55_ = FALSE;
#line 864 "Device.c"
								}
#line 74 "../core/Devices/Device.vala"
								if (_tmp55_) {
#line 75 "../core/Devices/Device.vala"
									needed = FALSE;
#line 76 "../core/Devices/Device.vala"
									_g_object_unref0 (med);
#line 76 "../core/Devices/Device.vala"
									break;
#line 874 "Device.c"
								}
							}
						}
#line 66 "../core/Devices/Device.vala"
						_g_object_unref0 (med);
#line 880 "Device.c"
					}
#line 66 "../core/Devices/Device.vala"
					_g_object_unref0 (_med_it);
#line 884 "Device.c"
				}
#line 81 "../core/Devices/Device.vala"
				if (needed == TRUE) {
#line 888 "Device.c"
					GeeLinkedList* _tmp77_;
					MusicMedia* _tmp78_;
#line 82 "../core/Devices/Device.vala"
					_tmp77_ = new_list;
#line 82 "../core/Devices/Device.vala"
					_tmp78_ = m;
#line 82 "../core/Devices/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp77_, _tmp78_);
#line 897 "Device.c"
				}
			}
#line 63 "../core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 902 "Device.c"
		}
#line 63 "../core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 906 "Device.c"
	}
#line 87 "../core/Devices/Device.vala"
	result = (GeeCollection*) new_list;
#line 87 "../core/Devices/Device.vala"
	return result;
#line 912 "Device.c"
}

gboolean
music_device_will_fit (MusicDevice* self,
                       GeeCollection* list)
{
	guint64 list_size = 0ULL;
	gboolean result;
#line 90 "../core/Devices/Device.vala"
	g_return_val_if_fail (list != NULL, FALSE);
#line 91 "../core/Devices/Device.vala"
	list_size = (guint64) 0;
#line 925 "Device.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp0_;
#line 92 "../core/Devices/Device.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) list);
#line 92 "../core/Devices/Device.vala"
		_m_it = _tmp0_;
#line 92 "../core/Devices/Device.vala"
		while (TRUE) {
#line 935 "Device.c"
			GeeIterator* _tmp1_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MusicMedia* _tmp4_;
			guint64 _tmp5_;
			guint64 _tmp6_;
#line 92 "../core/Devices/Device.vala"
			_tmp1_ = _m_it;
#line 92 "../core/Devices/Device.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 92 "../core/Devices/Device.vala"
				break;
#line 949 "Device.c"
			}
#line 92 "../core/Devices/Device.vala"
			_tmp2_ = _m_it;
#line 92 "../core/Devices/Device.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 92 "../core/Devices/Device.vala"
			m = (MusicMedia*) _tmp3_;
#line 93 "../core/Devices/Device.vala"
			_tmp4_ = m;
#line 93 "../core/Devices/Device.vala"
			_tmp5_ = music_media_get_file_size (_tmp4_);
#line 93 "../core/Devices/Device.vala"
			_tmp6_ = _tmp5_;
#line 93 "../core/Devices/Device.vala"
			list_size += _tmp6_;
#line 92 "../core/Devices/Device.vala"
			_g_object_unref0 (m);
#line 967 "Device.c"
		}
#line 92 "../core/Devices/Device.vala"
		_g_object_unref0 (_m_it);
#line 971 "Device.c"
	}
#line 96 "../core/Devices/Device.vala"
	result = music_device_get_capacity (self) > list_size;
#line 96 "../core/Devices/Device.vala"
	return result;
#line 977 "Device.c"
}

static gchar*
music_device_real_get_unique_identifier (MusicDevice* self)
{
	GMount* m = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
	gchar* result;
#line 100 "../core/Devices/Device.vala"
	_tmp0_ = music_device_get_mount (self);
#line 100 "../core/Devices/Device.vala"
	m = _tmp0_;
#line 101 "../core/Devices/Device.vala"
	_tmp1_ = m;
#line 101 "../core/Devices/Device.vala"
	if (_tmp1_ != NULL) {
#line 995 "Device.c"
		gchar* uuid = NULL;
		GMount* _tmp2_;
		gchar* _tmp3_;
		GFile* root = NULL;
		GMount* _tmp4_;
		GFile* _tmp5_;
		gchar* rv = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GFile* _tmp9_;
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 102 "../core/Devices/Device.vala"
		_tmp2_ = m;
#line 102 "../core/Devices/Device.vala"
		_tmp3_ = g_mount_get_uuid (_tmp2_);
#line 102 "../core/Devices/Device.vala"
		uuid = _tmp3_;
#line 103 "../core/Devices/Device.vala"
		_tmp4_ = m;
#line 103 "../core/Devices/Device.vala"
		_tmp5_ = g_mount_get_root (_tmp4_);
#line 103 "../core/Devices/Device.vala"
		root = _tmp5_;
#line 104 "../core/Devices/Device.vala"
		_tmp6_ = g_strdup ("");
#line 104 "../core/Devices/Device.vala"
		rv = _tmp6_;
#line 105 "../core/Devices/Device.vala"
		_tmp7_ = uuid;
#line 105 "../core/Devices/Device.vala"
		g_debug ("Device.vala:105: uuid: %s\n", _tmp7_);
#line 106 "../core/Devices/Device.vala"
		_tmp9_ = root;
#line 106 "../core/Devices/Device.vala"
		if (_tmp9_ != NULL) {
#line 1033 "Device.c"
			GFile* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 106 "../core/Devices/Device.vala"
			_tmp10_ = root;
#line 106 "../core/Devices/Device.vala"
			_tmp11_ = g_file_get_uri (_tmp10_);
#line 106 "../core/Devices/Device.vala"
			_tmp12_ = _tmp11_;
#line 106 "../core/Devices/Device.vala"
			_tmp8_ = _tmp12_ != NULL;
#line 106 "../core/Devices/Device.vala"
			_g_free0 (_tmp12_);
#line 1047 "Device.c"
		} else {
#line 106 "../core/Devices/Device.vala"
			_tmp8_ = FALSE;
#line 1051 "Device.c"
		}
#line 106 "../core/Devices/Device.vala"
		if (_tmp8_) {
#line 1055 "Device.c"
			const gchar* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 107 "../core/Devices/Device.vala"
			_tmp13_ = rv;
#line 107 "../core/Devices/Device.vala"
			_tmp14_ = root;
#line 107 "../core/Devices/Device.vala"
			_tmp15_ = g_file_get_uri (_tmp14_);
#line 107 "../core/Devices/Device.vala"
			_tmp16_ = _tmp15_;
#line 107 "../core/Devices/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 107 "../core/Devices/Device.vala"
			_g_free0 (rv);
#line 107 "../core/Devices/Device.vala"
			rv = _tmp17_;
#line 107 "../core/Devices/Device.vala"
			_g_free0 (_tmp16_);
#line 1077 "Device.c"
		}
#line 109 "../core/Devices/Device.vala"
		_tmp19_ = uuid;
#line 109 "../core/Devices/Device.vala"
		if (_tmp19_ != NULL) {
#line 1083 "Device.c"
			const gchar* _tmp20_;
#line 109 "../core/Devices/Device.vala"
			_tmp20_ = uuid;
#line 109 "../core/Devices/Device.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, "") != 0;
#line 1089 "Device.c"
		} else {
#line 109 "../core/Devices/Device.vala"
			_tmp18_ = FALSE;
#line 1093 "Device.c"
		}
#line 109 "../core/Devices/Device.vala"
		if (_tmp18_) {
#line 1097 "Device.c"
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 110 "../core/Devices/Device.vala"
			_tmp21_ = rv;
#line 110 "../core/Devices/Device.vala"
			_tmp22_ = uuid;
#line 110 "../core/Devices/Device.vala"
			_tmp23_ = g_strconcat ("/", _tmp22_, NULL);
#line 110 "../core/Devices/Device.vala"
			_tmp24_ = _tmp23_;
#line 110 "../core/Devices/Device.vala"
			_tmp25_ = g_strconcat (_tmp21_, _tmp24_, NULL);
#line 110 "../core/Devices/Device.vala"
			_g_free0 (rv);
#line 110 "../core/Devices/Device.vala"
			rv = _tmp25_;
#line 110 "../core/Devices/Device.vala"
			_g_free0 (_tmp24_);
#line 1119 "Device.c"
		}
#line 113 "../core/Devices/Device.vala"
		result = rv;
#line 113 "../core/Devices/Device.vala"
		_g_object_unref0 (root);
#line 113 "../core/Devices/Device.vala"
		_g_free0 (uuid);
#line 113 "../core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 113 "../core/Devices/Device.vala"
		return result;
#line 1131 "Device.c"
	} else {
		gchar* _tmp26_;
#line 115 "../core/Devices/Device.vala"
		_tmp26_ = music_device_get_uri (self);
#line 115 "../core/Devices/Device.vala"
		result = _tmp26_;
#line 115 "../core/Devices/Device.vala"
		_g_object_unref0 (m);
#line 115 "../core/Devices/Device.vala"
		return result;
#line 1142 "Device.c"
	}
}

gchar*
music_device_get_unique_identifier (MusicDevice* self)
{
	MusicDeviceIface* _iface_;
#line 99 "../core/Devices/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../core/Devices/Device.vala"
	_iface_ = MUSIC_DEVICE_GET_INTERFACE (self);
#line 99 "../core/Devices/Device.vala"
	if (_iface_->get_unique_identifier) {
#line 99 "../core/Devices/Device.vala"
		return _iface_->get_unique_identifier (self);
#line 1158 "Device.c"
	}
#line 99 "../core/Devices/Device.vala"
	return NULL;
#line 1162 "Device.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_ENUM) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 31 "../core/Devices/Device.vala"
	g_return_if_fail (n_param_values == 3);
#line 31 "../core/Devices/Device.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 31 "../core/Devices/Device.vala"
		data1 = closure->data;
#line 31 "../core/Devices/Device.vala"
		data2 = param_values->data[0].v_pointer;
#line 1187 "Device.c"
	} else {
#line 31 "../core/Devices/Device.vala"
		data1 = param_values->data[0].v_pointer;
#line 31 "../core/Devices/Device.vala"
		data2 = closure->data;
#line 1193 "Device.c"
	}
#line 31 "../core/Devices/Device.vala"
	callback = (GMarshalFunc_VOID__STRING_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 31 "../core/Devices/Device.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 1199 "Device.c"
}

static void
music_device_default_init (MusicDeviceIface * iface,
                           gpointer iface_data)
{
#line 31 "../core/Devices/Device.vala"
	music_device_signals[MUSIC_DEVICE_INITIALIZED_SIGNAL] = g_signal_new ("initialized", MUSIC_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_DEVICE);
#line 31 "../core/Devices/Device.vala"
	music_device_signals[MUSIC_DEVICE_DEVICE_UNMOUNTED_SIGNAL] = g_signal_new ("device-unmounted", MUSIC_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 31 "../core/Devices/Device.vala"
	music_device_signals[MUSIC_DEVICE_INFOBAR_MESSAGE_SIGNAL] = g_signal_new ("infobar-message", MUSIC_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_ENUM, G_TYPE_NONE, 2, G_TYPE_STRING, gtk_message_type_get_type ());
#line 31 "../core/Devices/Device.vala"
	iface->get_unique_identifier = music_device_real_get_unique_identifier;
#line 1214 "Device.c"
}

static GType
music_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDeviceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_device_type_id;
	music_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicDevice", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_device_type_id, G_TYPE_OBJECT);
	return music_device_type_id;
}

GType
music_device_get_type (void)
{
	static volatile gsize music_device_type_id__once = 0;
	if (g_once_init_enter (&music_device_type_id__once)) {
		GType music_device_type_id;
		music_device_type_id = music_device_get_type_once ();
		g_once_init_leave (&music_device_type_id__once, music_device_type_id);
	}
	return music_device_type_id__once;
}

