/* DeviceManager.c generated by valac 0.56.0, the Vala compiler
 * generated from DeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_DEVICE_MANAGER_0_PROPERTY,
	MUSIC_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_device_manager_properties[MUSIC_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
typedef struct _MusicDeviceManagerGetPreExistingMountsData MusicDeviceManagerGetPreExistingMountsData;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_DEVICE_MANAGER_DEVICE_ADDED_SIGNAL,
	MUSIC_DEVICE_MANAGER_DEVICE_REMOVED_SIGNAL,
	MUSIC_DEVICE_MANAGER_DEVICE_NAME_CHANGED_SIGNAL,
	MUSIC_DEVICE_MANAGER_MOUNT_ADDED_SIGNAL,
	MUSIC_DEVICE_MANAGER_MOUNT_REMOVED_SIGNAL,
	MUSIC_DEVICE_MANAGER_NUM_SIGNALS
};
static guint music_device_manager_signals[MUSIC_DEVICE_MANAGER_NUM_SIGNALS] = {0};

struct _MusicDeviceManagerPrivate {
	GVolumeMonitor* vm;
	GeeTreeSet* initialized_devices;
	GeeTreeSet* mounts_availables;
	GeeTreeSet* local_playlists;
};

struct _Block9Data {
	int _ref_count_;
	MusicDeviceManager* self;
	GeeTreeSet* mounts;
	GeeTreeSet* volumes;
	gpointer _async_data_;
};

struct _MusicDeviceManagerGetPreExistingMountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicDeviceManager* self;
	Block9Data* _data9_;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GVolumeMonitor* _tmp2_;
	GList* _tmp3_;
	GList* m_collection;
	GList* m_it;
	GMount* _tmp4_;
	GMount* m;
	GeeTreeSet* _tmp5_;
	GMount* _tmp6_;
	GVolumeMonitor* _tmp7_;
	GList* _tmp8_;
	GList* v_collection;
	GList* v_it;
	GVolume* _tmp9_;
	GVolume* v;
	GeeTreeSet* _tmp10_;
	GVolume* _tmp11_;
};

static gint MusicDeviceManager_private_offset;
static gpointer music_device_manager_parent_class = NULL;
static MusicDeviceManager* music_device_manager_device_manager;
static MusicDeviceManager* music_device_manager_device_manager = NULL;

static MusicDeviceManager* music_device_manager_new (void);
static MusicDeviceManager* music_device_manager_construct (GType object_type);
static void __lambda25_ (MusicDeviceManager* self,
                  GMount* mount);
static void ___lambda25__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                GMount* mount,
                                                gpointer self);
static void _music_device_manager_mount_changed_g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                         GMount* mount,
                                                                         gpointer self);
static void _music_device_manager_mount_pre_unmount_g_volume_monitor_mount_pre_unmount (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self);
static void __lambda26_ (MusicDeviceManager* self,
                  GMount* mount);
static void ___lambda26__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                  GMount* mount,
                                                  gpointer self);
static void music_device_manager_volume_added (MusicDeviceManager* self,
                                        GVolume* volume);
static void _music_device_manager_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                       GVolume* volume,
                                                                       gpointer self);
static void music_device_manager_get_pre_existing_mounts_data_free (gpointer _data);
static gboolean music_device_manager_get_pre_existing_mounts_co (MusicDeviceManagerGetPreExistingMountsData* _data_);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean __lambda27_ (Block9Data* _data9_);
static gboolean ___lambda27__gsource_func (gpointer self);
static void music_device_manager_real_mount_changed (MusicDeviceManager* self,
                                              GMount* mount);
static void music_device_manager_real_mount_pre_unmount (MusicDeviceManager* self,
                                                  GMount* mount);
static void music_device_manager_finalize (GObject * obj);
static GType music_device_manager_get_type_once (void);

static inline gpointer
music_device_manager_get_instance_private (MusicDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicDeviceManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../core/Devices/DeviceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 157 "DeviceManager.c"
}

MusicDeviceManager*
music_device_manager_get_default (void)
{
	MusicDeviceManager* _tmp0_;
	MusicDeviceManager* _tmp2_;
	MusicDeviceManager* _tmp3_;
	MusicDeviceManager* result;
#line 47 "../core/Devices/DeviceManager.vala"
	_tmp0_ = music_device_manager_device_manager;
#line 47 "../core/Devices/DeviceManager.vala"
	if (_tmp0_ == NULL) {
#line 171 "DeviceManager.c"
		MusicDeviceManager* _tmp1_;
#line 48 "../core/Devices/DeviceManager.vala"
		_tmp1_ = music_device_manager_new ();
#line 48 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (music_device_manager_device_manager);
#line 48 "../core/Devices/DeviceManager.vala"
		music_device_manager_device_manager = _tmp1_;
#line 179 "DeviceManager.c"
	}
#line 49 "../core/Devices/DeviceManager.vala"
	_tmp2_ = music_device_manager_device_manager;
#line 49 "../core/Devices/DeviceManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 49 "../core/Devices/DeviceManager.vala"
	result = _tmp3_;
#line 49 "../core/Devices/DeviceManager.vala"
	return result;
#line 189 "DeviceManager.c"
}

static void
__lambda25_ (MusicDeviceManager* self,
             GMount* mount)
{
	GeeTreeSet* _tmp0_;
#line 58 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 58 "../core/Devices/DeviceManager.vala"
	_tmp0_ = self->priv->mounts_availables;
#line 58 "../core/Devices/DeviceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, mount);
#line 58 "../core/Devices/DeviceManager.vala"
	g_signal_emit (self, music_device_manager_signals[MUSIC_DEVICE_MANAGER_MOUNT_ADDED_SIGNAL], 0, mount);
#line 205 "DeviceManager.c"
}

static void
___lambda25__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                           GMount* mount,
                                           gpointer self)
{
#line 58 "../core/Devices/DeviceManager.vala"
	__lambda25_ ((MusicDeviceManager*) self, mount);
#line 215 "DeviceManager.c"
}

static void
_music_device_manager_mount_changed_g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                    GMount* mount,
                                                                    gpointer self)
{
#line 59 "../core/Devices/DeviceManager.vala"
	music_device_manager_mount_changed ((MusicDeviceManager*) self, mount);
#line 225 "DeviceManager.c"
}

static void
_music_device_manager_mount_pre_unmount_g_volume_monitor_mount_pre_unmount (GVolumeMonitor* _sender,
                                                                            GMount* mount,
                                                                            gpointer self)
{
#line 60 "../core/Devices/DeviceManager.vala"
	music_device_manager_mount_pre_unmount ((MusicDeviceManager*) self, mount);
#line 235 "DeviceManager.c"
}

static void
__lambda26_ (MusicDeviceManager* self,
             GMount* mount)
{
	GeeTreeSet* _tmp0_;
#line 61 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 61 "../core/Devices/DeviceManager.vala"
	_tmp0_ = self->priv->mounts_availables;
#line 61 "../core/Devices/DeviceManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, mount);
#line 61 "../core/Devices/DeviceManager.vala"
	g_signal_emit (self, music_device_manager_signals[MUSIC_DEVICE_MANAGER_MOUNT_REMOVED_SIGNAL], 0, mount);
#line 251 "DeviceManager.c"
}

static void
___lambda26__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                             GMount* mount,
                                             gpointer self)
{
#line 61 "../core/Devices/DeviceManager.vala"
	__lambda26_ ((MusicDeviceManager*) self, mount);
#line 261 "DeviceManager.c"
}

static void
_music_device_manager_volume_added_g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                  GVolume* volume,
                                                                  gpointer self)
{
#line 62 "../core/Devices/DeviceManager.vala"
	music_device_manager_volume_added ((MusicDeviceManager*) self, volume);
#line 271 "DeviceManager.c"
}

static MusicDeviceManager*
music_device_manager_construct (GType object_type)
{
	MusicDeviceManager * self = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	GeeTreeSet* _tmp2_;
	GVolumeMonitor* _tmp3_;
	GVolumeMonitor* _tmp4_;
	GVolumeMonitor* _tmp5_;
	GVolumeMonitor* _tmp6_;
	GVolumeMonitor* _tmp7_;
	GVolumeMonitor* _tmp8_;
#line 52 "../core/Devices/DeviceManager.vala"
	self = (MusicDeviceManager*) g_object_new (object_type, NULL);
#line 53 "../core/Devices/DeviceManager.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_DEVICE, NULL, NULL, NULL, NULL, NULL);
#line 53 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->initialized_devices);
#line 53 "../core/Devices/DeviceManager.vala"
	self->priv->initialized_devices = _tmp0_;
#line 54 "../core/Devices/DeviceManager.vala"
	_tmp1_ = gee_tree_set_new (g_mount_get_type (), NULL, NULL, NULL, NULL, NULL);
#line 54 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->mounts_availables);
#line 54 "../core/Devices/DeviceManager.vala"
	self->priv->mounts_availables = _tmp1_;
#line 55 "../core/Devices/DeviceManager.vala"
	_tmp2_ = gee_tree_set_new (MUSIC_TYPE_PLAYLIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 55 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->local_playlists);
#line 55 "../core/Devices/DeviceManager.vala"
	self->priv->local_playlists = _tmp2_;
#line 57 "../core/Devices/DeviceManager.vala"
	_tmp3_ = g_volume_monitor_get ();
#line 57 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->vm);
#line 57 "../core/Devices/DeviceManager.vala"
	self->priv->vm = _tmp3_;
#line 58 "../core/Devices/DeviceManager.vala"
	_tmp4_ = self->priv->vm;
#line 58 "../core/Devices/DeviceManager.vala"
	g_signal_connect_object (_tmp4_, "mount-added", (GCallback) ___lambda25__g_volume_monitor_mount_added, self, 0);
#line 59 "../core/Devices/DeviceManager.vala"
	_tmp5_ = self->priv->vm;
#line 59 "../core/Devices/DeviceManager.vala"
	g_signal_connect_object (_tmp5_, "mount-changed", (GCallback) _music_device_manager_mount_changed_g_volume_monitor_mount_changed, self, 0);
#line 60 "../core/Devices/DeviceManager.vala"
	_tmp6_ = self->priv->vm;
#line 60 "../core/Devices/DeviceManager.vala"
	g_signal_connect_object (_tmp6_, "mount-pre-unmount", (GCallback) _music_device_manager_mount_pre_unmount_g_volume_monitor_mount_pre_unmount, self, 0);
#line 61 "../core/Devices/DeviceManager.vala"
	_tmp7_ = self->priv->vm;
#line 61 "../core/Devices/DeviceManager.vala"
	g_signal_connect_object (_tmp7_, "mount-removed", (GCallback) ___lambda26__g_volume_monitor_mount_removed, self, 0);
#line 62 "../core/Devices/DeviceManager.vala"
	_tmp8_ = self->priv->vm;
#line 62 "../core/Devices/DeviceManager.vala"
	g_signal_connect_object (_tmp8_, "volume-added", (GCallback) _music_device_manager_volume_added_g_volume_monitor_volume_added, self, 0);
#line 63 "../core/Devices/DeviceManager.vala"
	music_device_manager_get_pre_existing_mounts (self, NULL, NULL);
#line 52 "../core/Devices/DeviceManager.vala"
	return self;
#line 337 "DeviceManager.c"
}

static MusicDeviceManager*
music_device_manager_new (void)
{
#line 52 "../core/Devices/DeviceManager.vala"
	return music_device_manager_construct (MUSIC_TYPE_DEVICE_MANAGER);
#line 345 "DeviceManager.c"
}

static void
music_device_manager_get_pre_existing_mounts_data_free (gpointer _data)
{
	MusicDeviceManagerGetPreExistingMountsData* _data_;
	_data_ = _data;
#line 30 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../core/Devices/DeviceManager.vala"
	g_slice_free (MusicDeviceManagerGetPreExistingMountsData, _data_);
#line 357 "DeviceManager.c"
}

void
music_device_manager_get_pre_existing_mounts (MusicDeviceManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	MusicDeviceManagerGetPreExistingMountsData* _data_;
	MusicDeviceManager* _tmp0_;
#line 30 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 30 "../core/Devices/DeviceManager.vala"
	_data_ = g_slice_new0 (MusicDeviceManagerGetPreExistingMountsData);
#line 30 "../core/Devices/DeviceManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../core/Devices/DeviceManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_device_manager_get_pre_existing_mounts_data_free);
#line 30 "../core/Devices/DeviceManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../core/Devices/DeviceManager.vala"
	_data_->self = _tmp0_;
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_get_pre_existing_mounts_co (_data_);
#line 381 "DeviceManager.c"
}

void
music_device_manager_get_pre_existing_mounts_finish (MusicDeviceManager* self,
                                                     GAsyncResult* _res_)
{
	MusicDeviceManagerGetPreExistingMountsData* _data_;
#line 30 "../core/Devices/DeviceManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 391 "DeviceManager.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 66 "../core/Devices/DeviceManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 66 "../core/Devices/DeviceManager.vala"
	return _data9_;
#line 401 "DeviceManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 66 "../core/Devices/DeviceManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 411 "DeviceManager.c"
		MusicDeviceManager* self;
#line 66 "../core/Devices/DeviceManager.vala"
		self = _data9_->self;
#line 66 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (_data9_->volumes);
#line 66 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (_data9_->mounts);
#line 66 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (self);
#line 66 "../core/Devices/DeviceManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 423 "DeviceManager.c"
	}
}

static void
_g_object_unref0_ (gpointer var)
{
#line 70 "../core/Devices/DeviceManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 432 "DeviceManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 70 "../core/Devices/DeviceManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 440 "DeviceManager.c"
}

static gboolean
__lambda27_ (Block9Data* _data9_)
{
	MusicDeviceManager* self;
	gboolean result;
#line 78 "../core/Devices/DeviceManager.vala"
	self = _data9_->self;
#line 450 "DeviceManager.c"
	{
		GeeIterator* _m_it = NULL;
		GeeTreeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 79 "../core/Devices/DeviceManager.vala"
		_tmp0_ = _data9_->mounts;
#line 79 "../core/Devices/DeviceManager.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 79 "../core/Devices/DeviceManager.vala"
		_m_it = _tmp1_;
#line 79 "../core/Devices/DeviceManager.vala"
		while (TRUE) {
#line 463 "DeviceManager.c"
			GeeIterator* _tmp2_;
			GMount* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeTreeSet* _tmp5_;
			GMount* _tmp6_;
			GMount* _tmp7_;
#line 79 "../core/Devices/DeviceManager.vala"
			_tmp2_ = _m_it;
#line 79 "../core/Devices/DeviceManager.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 79 "../core/Devices/DeviceManager.vala"
				break;
#line 477 "DeviceManager.c"
			}
#line 79 "../core/Devices/DeviceManager.vala"
			_tmp3_ = _m_it;
#line 79 "../core/Devices/DeviceManager.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 79 "../core/Devices/DeviceManager.vala"
			m = (GMount*) _tmp4_;
#line 80 "../core/Devices/DeviceManager.vala"
			_tmp5_ = self->priv->mounts_availables;
#line 80 "../core/Devices/DeviceManager.vala"
			_tmp6_ = m;
#line 80 "../core/Devices/DeviceManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 81 "../core/Devices/DeviceManager.vala"
			_tmp7_ = m;
#line 81 "../core/Devices/DeviceManager.vala"
			g_signal_emit (self, music_device_manager_signals[MUSIC_DEVICE_MANAGER_MOUNT_ADDED_SIGNAL], 0, _tmp7_);
#line 79 "../core/Devices/DeviceManager.vala"
			_g_object_unref0 (m);
#line 497 "DeviceManager.c"
		}
#line 79 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (_m_it);
#line 501 "DeviceManager.c"
	}
	{
		GeeIterator* _v_it = NULL;
		GeeTreeSet* _tmp8_;
		GeeIterator* _tmp9_;
#line 84 "../core/Devices/DeviceManager.vala"
		_tmp8_ = _data9_->volumes;
#line 84 "../core/Devices/DeviceManager.vala"
		_tmp9_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp8_);
#line 84 "../core/Devices/DeviceManager.vala"
		_v_it = _tmp9_;
#line 84 "../core/Devices/DeviceManager.vala"
		while (TRUE) {
#line 515 "DeviceManager.c"
			GeeIterator* _tmp10_;
			GVolume* v = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GVolume* _tmp13_;
#line 84 "../core/Devices/DeviceManager.vala"
			_tmp10_ = _v_it;
#line 84 "../core/Devices/DeviceManager.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 84 "../core/Devices/DeviceManager.vala"
				break;
#line 527 "DeviceManager.c"
			}
#line 84 "../core/Devices/DeviceManager.vala"
			_tmp11_ = _v_it;
#line 84 "../core/Devices/DeviceManager.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 84 "../core/Devices/DeviceManager.vala"
			v = (GVolume*) _tmp12_;
#line 85 "../core/Devices/DeviceManager.vala"
			_tmp13_ = v;
#line 85 "../core/Devices/DeviceManager.vala"
			music_device_manager_volume_added (self, _tmp13_);
#line 84 "../core/Devices/DeviceManager.vala"
			_g_object_unref0 (v);
#line 541 "DeviceManager.c"
		}
#line 84 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (_v_it);
#line 545 "DeviceManager.c"
	}
#line 88 "../core/Devices/DeviceManager.vala"
	result = FALSE;
#line 88 "../core/Devices/DeviceManager.vala"
	return result;
#line 551 "DeviceManager.c"
}

static gboolean
___lambda27__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda27_ (self);
#line 78 "../core/Devices/DeviceManager.vala"
	return result;
#line 561 "DeviceManager.c"
}

static gboolean
music_device_manager_get_pre_existing_mounts_co (MusicDeviceManagerGetPreExistingMountsData* _data_)
{
#line 66 "../core/Devices/DeviceManager.vala"
	switch (_data_->_state_) {
#line 66 "../core/Devices/DeviceManager.vala"
		case 0:
#line 571 "DeviceManager.c"
		goto _state_0;
		default:
#line 66 "../core/Devices/DeviceManager.vala"
		g_assert_not_reached ();
#line 576 "DeviceManager.c"
	}
	_state_0:
#line 66 "../core/Devices/DeviceManager.vala"
	_data_->_data9_ = g_slice_new0 (Block9Data);
#line 66 "../core/Devices/DeviceManager.vala"
	_data_->_data9_->_ref_count_ = 1;
#line 66 "../core/Devices/DeviceManager.vala"
	_data_->_data9_->self = g_object_ref (_data_->self);
#line 66 "../core/Devices/DeviceManager.vala"
	_data_->_data9_->_async_data_ = _data_;
#line 67 "../core/Devices/DeviceManager.vala"
	_data_->_tmp0_ = gee_tree_set_new (g_mount_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 67 "../core/Devices/DeviceManager.vala"
	_data_->_data9_->mounts = _data_->_tmp0_;
#line 68 "../core/Devices/DeviceManager.vala"
	_data_->_tmp1_ = gee_tree_set_new (g_volume_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 68 "../core/Devices/DeviceManager.vala"
	_data_->_data9_->volumes = _data_->_tmp1_;
#line 70 "../core/Devices/DeviceManager.vala"
	_data_->_tmp2_ = _data_->self->priv->vm;
#line 70 "../core/Devices/DeviceManager.vala"
	_data_->_tmp3_ = g_volume_monitor_get_mounts (_data_->_tmp2_);
#line 599 "DeviceManager.c"
	{
#line 70 "../core/Devices/DeviceManager.vala"
		_data_->m_collection = _data_->_tmp3_;
#line 70 "../core/Devices/DeviceManager.vala"
		for (_data_->m_it = _data_->m_collection; _data_->m_it != NULL; _data_->m_it = _data_->m_it->next) {
#line 70 "../core/Devices/DeviceManager.vala"
			_data_->_tmp4_ = _g_object_ref0 ((GMount*) _data_->m_it->data);
#line 70 "../core/Devices/DeviceManager.vala"
			_data_->m = _data_->_tmp4_;
#line 609 "DeviceManager.c"
			{
#line 71 "../core/Devices/DeviceManager.vala"
				_data_->_tmp5_ = _data_->_data9_->mounts;
#line 71 "../core/Devices/DeviceManager.vala"
				_data_->_tmp6_ = _data_->m;
#line 71 "../core/Devices/DeviceManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp5_, _data_->_tmp6_);
#line 70 "../core/Devices/DeviceManager.vala"
				_g_object_unref0 (_data_->m);
#line 619 "DeviceManager.c"
			}
		}
#line 70 "../core/Devices/DeviceManager.vala"
		(_data_->m_collection == NULL) ? NULL : (_data_->m_collection = (_g_list_free__g_object_unref0_ (_data_->m_collection), NULL));
#line 624 "DeviceManager.c"
	}
#line 74 "../core/Devices/DeviceManager.vala"
	_data_->_tmp7_ = _data_->self->priv->vm;
#line 74 "../core/Devices/DeviceManager.vala"
	_data_->_tmp8_ = g_volume_monitor_get_volumes (_data_->_tmp7_);
#line 630 "DeviceManager.c"
	{
#line 74 "../core/Devices/DeviceManager.vala"
		_data_->v_collection = _data_->_tmp8_;
#line 74 "../core/Devices/DeviceManager.vala"
		for (_data_->v_it = _data_->v_collection; _data_->v_it != NULL; _data_->v_it = _data_->v_it->next) {
#line 74 "../core/Devices/DeviceManager.vala"
			_data_->_tmp9_ = _g_object_ref0 ((GVolume*) _data_->v_it->data);
#line 74 "../core/Devices/DeviceManager.vala"
			_data_->v = _data_->_tmp9_;
#line 640 "DeviceManager.c"
			{
#line 75 "../core/Devices/DeviceManager.vala"
				_data_->_tmp10_ = _data_->_data9_->volumes;
#line 75 "../core/Devices/DeviceManager.vala"
				_data_->_tmp11_ = _data_->v;
#line 75 "../core/Devices/DeviceManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp10_, _data_->_tmp11_);
#line 74 "../core/Devices/DeviceManager.vala"
				_g_object_unref0 (_data_->v);
#line 650 "DeviceManager.c"
			}
		}
#line 74 "../core/Devices/DeviceManager.vala"
		(_data_->v_collection == NULL) ? NULL : (_data_->v_collection = (_g_list_free__g_object_unref0_ (_data_->v_collection), NULL));
#line 655 "DeviceManager.c"
	}
#line 78 "../core/Devices/DeviceManager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda27__gsource_func, block9_data_ref (_data_->_data9_), block9_data_unref);
#line 66 "../core/Devices/DeviceManager.vala"
	block9_data_unref (_data_->_data9_);
#line 66 "../core/Devices/DeviceManager.vala"
	_data_->_data9_ = NULL;
#line 66 "../core/Devices/DeviceManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 66 "../core/Devices/DeviceManager.vala"
	if (_data_->_state_ != 0) {
#line 66 "../core/Devices/DeviceManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 66 "../core/Devices/DeviceManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 671 "DeviceManager.c"
		}
	}
#line 66 "../core/Devices/DeviceManager.vala"
	g_object_unref (_data_->_async_result);
#line 66 "../core/Devices/DeviceManager.vala"
	return FALSE;
#line 678 "DeviceManager.c"
}

static void
music_device_manager_volume_added (MusicDeviceManager* self,
                                   GVolume* volume)
{
	gboolean _tmp0_ = FALSE;
	MusicSettingsMain* _tmp1_;
	MusicSettingsMain* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
#line 92 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 92 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (volume != NULL);
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp1_ = music_settings_main_get_default ();
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp2_ = _tmp1_;
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp3_ = music_settings_main_get_music_mount_name (_tmp2_);
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp4_ = _tmp3_;
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp5_ = g_volume_get_name (volume);
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp6_ = _tmp5_;
#line 93 "../core/Devices/DeviceManager.vala"
	_tmp7_ = g_strcmp0 (_tmp4_, _tmp6_) == 0;
#line 93 "../core/Devices/DeviceManager.vala"
	_g_free0 (_tmp6_);
#line 93 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (_tmp2_);
#line 93 "../core/Devices/DeviceManager.vala"
	if (_tmp7_) {
#line 717 "DeviceManager.c"
		GMount* _tmp8_;
		GMount* _tmp9_;
#line 93 "../core/Devices/DeviceManager.vala"
		_tmp8_ = g_volume_get_mount (volume);
#line 93 "../core/Devices/DeviceManager.vala"
		_tmp9_ = _tmp8_;
#line 93 "../core/Devices/DeviceManager.vala"
		_tmp0_ = _tmp9_ == NULL;
#line 93 "../core/Devices/DeviceManager.vala"
		_g_object_unref0 (_tmp9_);
#line 728 "DeviceManager.c"
	} else {
#line 93 "../core/Devices/DeviceManager.vala"
		_tmp0_ = FALSE;
#line 732 "DeviceManager.c"
	}
#line 93 "../core/Devices/DeviceManager.vala"
	if (_tmp0_) {
#line 736 "DeviceManager.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 94 "../core/Devices/DeviceManager.vala"
		_tmp10_ = g_volume_get_name (volume);
#line 94 "../core/Devices/DeviceManager.vala"
		_tmp11_ = _tmp10_;
#line 94 "../core/Devices/DeviceManager.vala"
		g_debug ("DeviceManager.vala:94: mounting %s because it is believed to be the mu" \
"sic folder\n", _tmp11_);
#line 94 "../core/Devices/DeviceManager.vala"
		_g_free0 (_tmp11_);
#line 95 "../core/Devices/DeviceManager.vala"
		g_volume_mount (volume, G_MOUNT_MOUNT_NONE, NULL, NULL, NULL, NULL);
#line 749 "DeviceManager.c"
	}
}

void
music_device_manager_device_initialized (MusicDeviceManager* self,
                                         MusicDevice* d)
{
	GeeTreeSet* _tmp0_;
#line 99 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 99 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (d != NULL);
#line 100 "../core/Devices/DeviceManager.vala"
	g_debug ("DeviceManager.vala:100: adding device\n");
#line 101 "../core/Devices/DeviceManager.vala"
	g_signal_emit (self, music_device_manager_signals[MUSIC_DEVICE_MANAGER_DEVICE_ADDED_SIGNAL], 0, d);
#line 102 "../core/Devices/DeviceManager.vala"
	_tmp0_ = self->priv->initialized_devices;
#line 102 "../core/Devices/DeviceManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, d);
#line 770 "DeviceManager.c"
}

static void
music_device_manager_real_mount_changed (MusicDeviceManager* self,
                                         GMount* mount)
{
#line 105 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 779 "DeviceManager.c"
}

void
music_device_manager_mount_changed (MusicDeviceManager* self,
                                    GMount* mount)
{
	MusicDeviceManagerClass* _klass_;
#line 105 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 105 "../core/Devices/DeviceManager.vala"
	_klass_ = MUSIC_DEVICE_MANAGER_GET_CLASS (self);
#line 105 "../core/Devices/DeviceManager.vala"
	if (_klass_->mount_changed) {
#line 105 "../core/Devices/DeviceManager.vala"
		_klass_->mount_changed (self, mount);
#line 795 "DeviceManager.c"
	}
}

static void
music_device_manager_real_mount_pre_unmount (MusicDeviceManager* self,
                                             GMount* mount)
{
#line 109 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (mount != NULL);
#line 805 "DeviceManager.c"
}

void
music_device_manager_mount_pre_unmount (MusicDeviceManager* self,
                                        GMount* mount)
{
	MusicDeviceManagerClass* _klass_;
#line 109 "../core/Devices/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 109 "../core/Devices/DeviceManager.vala"
	_klass_ = MUSIC_DEVICE_MANAGER_GET_CLASS (self);
#line 109 "../core/Devices/DeviceManager.vala"
	if (_klass_->mount_pre_unmount) {
#line 109 "../core/Devices/DeviceManager.vala"
		_klass_->mount_pre_unmount (self, mount);
#line 821 "DeviceManager.c"
	}
}

GeeCollection*
music_device_manager_get_initialized_devices (MusicDeviceManager* self)
{
	GeeTreeSet* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 113 "../core/Devices/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "../core/Devices/DeviceManager.vala"
	_tmp0_ = self->priv->initialized_devices;
#line 114 "../core/Devices/DeviceManager.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 114 "../core/Devices/DeviceManager.vala"
	result = _tmp1_;
#line 114 "../core/Devices/DeviceManager.vala"
	return result;
#line 841 "DeviceManager.c"
}

GeeCollection*
music_device_manager_get_available_mounts (MusicDeviceManager* self)
{
	GeeTreeSet* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 117 "../core/Devices/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../core/Devices/DeviceManager.vala"
	_tmp0_ = self->priv->mounts_availables;
#line 118 "../core/Devices/DeviceManager.vala"
	_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 118 "../core/Devices/DeviceManager.vala"
	result = _tmp1_;
#line 118 "../core/Devices/DeviceManager.vala"
	return result;
#line 860 "DeviceManager.c"
}

static void
music_device_manager_class_init (MusicDeviceManagerClass * klass,
                                 gpointer klass_data)
{
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Devices/DeviceManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicDeviceManager_private_offset);
#line 30 "../core/Devices/DeviceManager.vala"
	((MusicDeviceManagerClass *) klass)->mount_changed = (void (*) (MusicDeviceManager*, GMount*)) music_device_manager_real_mount_changed;
#line 30 "../core/Devices/DeviceManager.vala"
	((MusicDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (MusicDeviceManager*, GMount*)) music_device_manager_real_mount_pre_unmount;
#line 30 "../core/Devices/DeviceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_device_manager_finalize;
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_signals[MUSIC_DEVICE_MANAGER_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", MUSIC_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_DEVICE);
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_signals[MUSIC_DEVICE_MANAGER_DEVICE_REMOVED_SIGNAL] = g_signal_new ("device-removed", MUSIC_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_DEVICE);
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_signals[MUSIC_DEVICE_MANAGER_DEVICE_NAME_CHANGED_SIGNAL] = g_signal_new ("device-name-changed", MUSIC_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_DEVICE);
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_signals[MUSIC_DEVICE_MANAGER_MOUNT_ADDED_SIGNAL] = g_signal_new ("mount-added", MUSIC_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_mount_get_type ());
#line 30 "../core/Devices/DeviceManager.vala"
	music_device_manager_signals[MUSIC_DEVICE_MANAGER_MOUNT_REMOVED_SIGNAL] = g_signal_new ("mount-removed", MUSIC_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_mount_get_type ());
#line 887 "DeviceManager.c"
}

static void
music_device_manager_instance_init (MusicDeviceManager * self,
                                    gpointer klass)
{
#line 30 "../core/Devices/DeviceManager.vala"
	self->priv = music_device_manager_get_instance_private (self);
#line 896 "DeviceManager.c"
}

static void
music_device_manager_finalize (GObject * obj)
{
	MusicDeviceManager * self;
#line 30 "../core/Devices/DeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_DEVICE_MANAGER, MusicDeviceManager);
#line 31 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->vm);
#line 40 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->initialized_devices);
#line 41 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->mounts_availables);
#line 42 "../core/Devices/DeviceManager.vala"
	_g_object_unref0 (self->priv->local_playlists);
#line 30 "../core/Devices/DeviceManager.vala"
	G_OBJECT_CLASS (music_device_manager_parent_class)->finalize (obj);
#line 915 "DeviceManager.c"
}

static GType
music_device_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicDeviceManager), 0, (GInstanceInitFunc) music_device_manager_instance_init, NULL };
	GType music_device_manager_type_id;
	music_device_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicDeviceManager", &g_define_type_info, 0);
	MusicDeviceManager_private_offset = g_type_add_instance_private (music_device_manager_type_id, sizeof (MusicDeviceManagerPrivate));
	return music_device_manager_type_id;
}

GType
music_device_manager_get_type (void)
{
	static volatile gsize music_device_manager_type_id__once = 0;
	if (g_once_init_enter (&music_device_manager_type_id__once)) {
		GType music_device_manager_type_id;
		music_device_manager_type_id = music_device_manager_get_type_once ();
		g_once_init_leave (&music_device_manager_type_id__once, music_device_manager_type_id);
	}
	return music_device_manager_type_id__once;
}

