/* EqualizerPreset.c generated by valac 0.56.0, the Vala compiler
 * generated from EqualizerPreset.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	MUSIC_EQUALIZER_PRESET_0_PROPERTY,
	MUSIC_EQUALIZER_PRESET_NAME_PROPERTY,
	MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY,
	MUSIC_EQUALIZER_PRESET_NUM_PROPERTIES
};
static GParamSpec* music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicEqualizerPresetPrivate {
	gchar* _name;
	gboolean _is_default;
};

static gint MusicEqualizerPreset_private_offset;
static gpointer music_equalizer_preset_parent_class = NULL;

static void music_equalizer_preset_finalize (GObject * obj);
static GType music_equalizer_preset_get_type_once (void);
static void _vala_music_equalizer_preset_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_equalizer_preset_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
music_equalizer_preset_get_instance_private (MusicEqualizerPreset* self)
{
	return G_STRUCT_MEMBER_P (self, MusicEqualizerPreset_private_offset);
}

MusicEqualizerPreset*
music_equalizer_preset_construct_basic (GType object_type,
                                        const gchar* name)
{
	MusicEqualizerPreset * self = NULL;
#line 37 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 38 "../core/EqualizerPreset.vala"
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
#line 93 "EqualizerPreset.c"
	{
		gint i = 0;
#line 39 "../core/EqualizerPreset.vala"
		i = 0;
#line 98 "EqualizerPreset.c"
		{
			gboolean _tmp0_ = FALSE;
#line 39 "../core/EqualizerPreset.vala"
			_tmp0_ = TRUE;
#line 39 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 105 "EqualizerPreset.c"
				GeeArrayList* _tmp2_;
#line 39 "../core/EqualizerPreset.vala"
				if (!_tmp0_) {
#line 109 "EqualizerPreset.c"
					gint _tmp1_;
#line 39 "../core/EqualizerPreset.vala"
					_tmp1_ = i;
#line 39 "../core/EqualizerPreset.vala"
					i = _tmp1_ + 1;
#line 115 "EqualizerPreset.c"
				}
#line 39 "../core/EqualizerPreset.vala"
				_tmp0_ = FALSE;
#line 39 "../core/EqualizerPreset.vala"
				if (!(i < 10)) {
#line 39 "../core/EqualizerPreset.vala"
					break;
#line 123 "EqualizerPreset.c"
				}
#line 40 "../core/EqualizerPreset.vala"
				_tmp2_ = self->gains;
#line 40 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) 0));
#line 129 "EqualizerPreset.c"
			}
		}
	}
#line 37 "../core/EqualizerPreset.vala"
	return self;
#line 135 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_new_basic (const gchar* name)
{
#line 37 "../core/EqualizerPreset.vala"
	return music_equalizer_preset_construct_basic (MUSIC_TYPE_EQUALIZER_PRESET, name);
#line 143 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_construct_with_gains (GType object_type,
                                             const gchar* name,
                                             gint* items,
                                             gint items_length1)
{
	MusicEqualizerPreset * self = NULL;
#line 44 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 45 "../core/EqualizerPreset.vala"
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
#line 157 "EqualizerPreset.c"
	{
		gint i = 0;
#line 46 "../core/EqualizerPreset.vala"
		i = 0;
#line 162 "EqualizerPreset.c"
		{
			gboolean _tmp0_ = FALSE;
#line 46 "../core/EqualizerPreset.vala"
			_tmp0_ = TRUE;
#line 46 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 169 "EqualizerPreset.c"
				GeeArrayList* _tmp2_;
				gint _tmp3_;
#line 46 "../core/EqualizerPreset.vala"
				if (!_tmp0_) {
#line 174 "EqualizerPreset.c"
					gint _tmp1_;
#line 46 "../core/EqualizerPreset.vala"
					_tmp1_ = i;
#line 46 "../core/EqualizerPreset.vala"
					i = _tmp1_ + 1;
#line 180 "EqualizerPreset.c"
				}
#line 46 "../core/EqualizerPreset.vala"
				_tmp0_ = FALSE;
#line 46 "../core/EqualizerPreset.vala"
				if (!(i < 10)) {
#line 46 "../core/EqualizerPreset.vala"
					break;
#line 188 "EqualizerPreset.c"
				}
#line 47 "../core/EqualizerPreset.vala"
				_tmp2_ = self->gains;
#line 47 "../core/EqualizerPreset.vala"
				_tmp3_ = items[i];
#line 47 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) _tmp3_));
#line 196 "EqualizerPreset.c"
			}
		}
	}
#line 44 "../core/EqualizerPreset.vala"
	return self;
#line 202 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_new_with_gains (const gchar* name,
                                       gint* items,
                                       gint items_length1)
{
#line 44 "../core/EqualizerPreset.vala"
	return music_equalizer_preset_construct_with_gains (MUSIC_TYPE_EQUALIZER_PRESET, name, items, items_length1);
#line 212 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_construct_from_string (GType object_type,
                                              const gchar* data)
{
	MusicEqualizerPreset * self = NULL;
	gchar** vals = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint vals_length1;
	gint _vals_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
#line 51 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 52 "../core/EqualizerPreset.vala"
	_tmp1_ = _tmp0_ = g_strsplit (data, "/", 0);
#line 52 "../core/EqualizerPreset.vala"
	vals = _tmp1_;
#line 52 "../core/EqualizerPreset.vala"
	vals_length1 = _vala_array_length (_tmp0_);
#line 52 "../core/EqualizerPreset.vala"
	_vals_size_ = vals_length1;
#line 53 "../core/EqualizerPreset.vala"
	_tmp2_ = vals;
#line 53 "../core/EqualizerPreset.vala"
	_tmp2__length1 = vals_length1;
#line 53 "../core/EqualizerPreset.vala"
	_tmp3_ = _tmp2_[0];
#line 53 "../core/EqualizerPreset.vala"
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", _tmp3_, NULL);
#line 246 "EqualizerPreset.c"
	{
		gint i = 0;
#line 54 "../core/EqualizerPreset.vala"
		i = 1;
#line 251 "EqualizerPreset.c"
		{
			gboolean _tmp4_ = FALSE;
#line 54 "../core/EqualizerPreset.vala"
			_tmp4_ = TRUE;
#line 54 "../core/EqualizerPreset.vala"
			while (TRUE) {
#line 258 "EqualizerPreset.c"
				gchar** _tmp6_;
				gint _tmp6__length1;
				GeeArrayList* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
#line 54 "../core/EqualizerPreset.vala"
				if (!_tmp4_) {
#line 267 "EqualizerPreset.c"
					gint _tmp5_;
#line 54 "../core/EqualizerPreset.vala"
					_tmp5_ = i;
#line 54 "../core/EqualizerPreset.vala"
					i = _tmp5_ + 1;
#line 273 "EqualizerPreset.c"
				}
#line 54 "../core/EqualizerPreset.vala"
				_tmp4_ = FALSE;
#line 54 "../core/EqualizerPreset.vala"
				_tmp6_ = vals;
#line 54 "../core/EqualizerPreset.vala"
				_tmp6__length1 = vals_length1;
#line 54 "../core/EqualizerPreset.vala"
				if (!(i < _tmp6__length1)) {
#line 54 "../core/EqualizerPreset.vala"
					break;
#line 285 "EqualizerPreset.c"
				}
#line 55 "../core/EqualizerPreset.vala"
				_tmp7_ = self->gains;
#line 55 "../core/EqualizerPreset.vala"
				_tmp8_ = vals;
#line 55 "../core/EqualizerPreset.vala"
				_tmp8__length1 = vals_length1;
#line 55 "../core/EqualizerPreset.vala"
				_tmp9_ = _tmp8_[i];
#line 55 "../core/EqualizerPreset.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, (gpointer) ((gintptr) atoi (_tmp9_)));
#line 297 "EqualizerPreset.c"
			}
		}
	}
#line 51 "../core/EqualizerPreset.vala"
	vals = (_vala_array_free (vals, vals_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../core/EqualizerPreset.vala"
	return self;
#line 305 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_new_from_string (const gchar* data)
{
#line 51 "../core/EqualizerPreset.vala"
	return music_equalizer_preset_construct_from_string (MUSIC_TYPE_EQUALIZER_PRESET, data);
#line 313 "EqualizerPreset.c"
}

gchar*
music_equalizer_preset_to_string (MusicEqualizerPreset* self)
{
	gchar* str_preset = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* result;
#line 59 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../core/EqualizerPreset.vala"
	_tmp0_ = g_strdup ("");
#line 60 "../core/EqualizerPreset.vala"
	str_preset = _tmp0_;
#line 62 "../core/EqualizerPreset.vala"
	_tmp2_ = self->priv->_name;
#line 62 "../core/EqualizerPreset.vala"
	if (_tmp2_ != NULL) {
#line 334 "EqualizerPreset.c"
		const gchar* _tmp3_;
#line 62 "../core/EqualizerPreset.vala"
		_tmp3_ = self->priv->_name;
#line 62 "../core/EqualizerPreset.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
#line 340 "EqualizerPreset.c"
	} else {
#line 62 "../core/EqualizerPreset.vala"
		_tmp1_ = FALSE;
#line 344 "EqualizerPreset.c"
	}
#line 62 "../core/EqualizerPreset.vala"
	if (_tmp1_) {
#line 348 "EqualizerPreset.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 63 "../core/EqualizerPreset.vala"
		_tmp4_ = self->priv->_name;
#line 63 "../core/EqualizerPreset.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 63 "../core/EqualizerPreset.vala"
		_g_free0 (str_preset);
#line 63 "../core/EqualizerPreset.vala"
		str_preset = _tmp5_;
#line 359 "EqualizerPreset.c"
		{
			gint i = 0;
#line 64 "../core/EqualizerPreset.vala"
			i = 0;
#line 364 "EqualizerPreset.c"
			{
				gboolean _tmp6_ = FALSE;
#line 64 "../core/EqualizerPreset.vala"
				_tmp6_ = TRUE;
#line 64 "../core/EqualizerPreset.vala"
				while (TRUE) {
#line 371 "EqualizerPreset.c"
					const gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
#line 64 "../core/EqualizerPreset.vala"
					if (!_tmp6_) {
#line 380 "EqualizerPreset.c"
						gint _tmp7_;
#line 64 "../core/EqualizerPreset.vala"
						_tmp7_ = i;
#line 64 "../core/EqualizerPreset.vala"
						i = _tmp7_ + 1;
#line 386 "EqualizerPreset.c"
					}
#line 64 "../core/EqualizerPreset.vala"
					_tmp6_ = FALSE;
#line 64 "../core/EqualizerPreset.vala"
					if (!(i < 10)) {
#line 64 "../core/EqualizerPreset.vala"
						break;
#line 394 "EqualizerPreset.c"
					}
#line 65 "../core/EqualizerPreset.vala"
					_tmp8_ = str_preset;
#line 65 "../core/EqualizerPreset.vala"
					_tmp9_ = g_strdup_printf ("%i", music_equalizer_preset_get_gain (self, i));
#line 65 "../core/EqualizerPreset.vala"
					_tmp10_ = _tmp9_;
#line 65 "../core/EqualizerPreset.vala"
					_tmp11_ = g_strconcat ("/", _tmp10_, NULL);
#line 65 "../core/EqualizerPreset.vala"
					_tmp12_ = _tmp11_;
#line 65 "../core/EqualizerPreset.vala"
					_tmp13_ = g_strconcat (_tmp8_, _tmp12_, NULL);
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (str_preset);
#line 65 "../core/EqualizerPreset.vala"
					str_preset = _tmp13_;
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (_tmp12_);
#line 65 "../core/EqualizerPreset.vala"
					_g_free0 (_tmp10_);
#line 416 "EqualizerPreset.c"
				}
			}
		}
	}
#line 69 "../core/EqualizerPreset.vala"
	result = str_preset;
#line 69 "../core/EqualizerPreset.vala"
	return result;
#line 425 "EqualizerPreset.c"
}

void
music_equalizer_preset_set_gain (MusicEqualizerPreset* self,
                                 gint index,
                                 gint val)
{
	GeeArrayList* _tmp0_;
#line 72 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 73 "../core/EqualizerPreset.vala"
	if (index > 9) {
#line 74 "../core/EqualizerPreset.vala"
		return;
#line 440 "EqualizerPreset.c"
	}
#line 77 "../core/EqualizerPreset.vala"
	_tmp0_ = self->gains;
#line 77 "../core/EqualizerPreset.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, index, (gpointer) ((gintptr) val));
#line 446 "EqualizerPreset.c"
}

gint
music_equalizer_preset_get_gain (MusicEqualizerPreset* self,
                                 gint index)
{
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	gint result;
#line 80 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 81 "../core/EqualizerPreset.vala"
	_tmp0_ = self->gains;
#line 81 "../core/EqualizerPreset.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, index);
#line 81 "../core/EqualizerPreset.vala"
	result = (gint) ((gintptr) _tmp1_);
#line 81 "../core/EqualizerPreset.vala"
	return result;
#line 466 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_construct (GType object_type)
{
	MusicEqualizerPreset * self = NULL;
#line 31 "../core/EqualizerPreset.vala"
	self = (MusicEqualizerPreset*) g_object_new (object_type, NULL);
#line 31 "../core/EqualizerPreset.vala"
	return self;
#line 477 "EqualizerPreset.c"
}

MusicEqualizerPreset*
music_equalizer_preset_new (void)
{
#line 31 "../core/EqualizerPreset.vala"
	return music_equalizer_preset_construct (MUSIC_TYPE_EQUALIZER_PRESET);
#line 485 "EqualizerPreset.c"
}

const gchar*
music_equalizer_preset_get_name (MusicEqualizerPreset* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/EqualizerPreset.vala"
	_tmp0_ = self->priv->_name;
#line 32 "../core/EqualizerPreset.vala"
	result = _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
	return result;
#line 501 "EqualizerPreset.c"
}

void
music_equalizer_preset_set_name (MusicEqualizerPreset* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 32 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/EqualizerPreset.vala"
	old_value = music_equalizer_preset_get_name (self);
#line 32 "../core/EqualizerPreset.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 515 "EqualizerPreset.c"
		gchar* _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../core/EqualizerPreset.vala"
		_g_free0 (self->priv->_name);
#line 32 "../core/EqualizerPreset.vala"
		self->priv->_name = _tmp0_;
#line 32 "../core/EqualizerPreset.vala"
		g_object_notify_by_pspec ((GObject *) self, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NAME_PROPERTY]);
#line 525 "EqualizerPreset.c"
	}
}

gboolean
music_equalizer_preset_get_is_default (MusicEqualizerPreset* self)
{
	gboolean result;
#line 35 "../core/EqualizerPreset.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "../core/EqualizerPreset.vala"
	result = self->priv->_is_default;
#line 35 "../core/EqualizerPreset.vala"
	return result;
#line 539 "EqualizerPreset.c"
}

void
music_equalizer_preset_set_is_default (MusicEqualizerPreset* self,
                                       gboolean value)
{
	gboolean old_value;
#line 35 "../core/EqualizerPreset.vala"
	g_return_if_fail (self != NULL);
#line 35 "../core/EqualizerPreset.vala"
	old_value = music_equalizer_preset_get_is_default (self);
#line 35 "../core/EqualizerPreset.vala"
	if (old_value != value) {
#line 35 "../core/EqualizerPreset.vala"
		self->priv->_is_default = value;
#line 35 "../core/EqualizerPreset.vala"
		g_object_notify_by_pspec ((GObject *) self, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY]);
#line 557 "EqualizerPreset.c"
	}
}

static void
music_equalizer_preset_class_init (MusicEqualizerPresetClass * klass,
                                   gpointer klass_data)
{
#line 31 "../core/EqualizerPreset.vala"
	music_equalizer_preset_parent_class = g_type_class_peek_parent (klass);
#line 31 "../core/EqualizerPreset.vala"
	g_type_class_adjust_private_offset (klass, &MusicEqualizerPreset_private_offset);
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_equalizer_preset_get_property;
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_equalizer_preset_set_property;
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (klass)->finalize = music_equalizer_preset_finalize;
#line 31 "../core/EqualizerPreset.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_EQUALIZER_PRESET_NAME_PROPERTY, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 31 "../core/EqualizerPreset.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 579 "EqualizerPreset.c"
}

static void
music_equalizer_preset_instance_init (MusicEqualizerPreset * self,
                                      gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 31 "../core/EqualizerPreset.vala"
	self->priv = music_equalizer_preset_get_instance_private (self);
#line 33 "../core/EqualizerPreset.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 33 "../core/EqualizerPreset.vala"
	self->gains = _tmp0_;
#line 35 "../core/EqualizerPreset.vala"
	self->priv->_is_default = FALSE;
#line 595 "EqualizerPreset.c"
}

static void
music_equalizer_preset_finalize (GObject * obj)
{
	MusicEqualizerPreset * self;
#line 31 "../core/EqualizerPreset.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
#line 32 "../core/EqualizerPreset.vala"
	_g_free0 (self->priv->_name);
#line 33 "../core/EqualizerPreset.vala"
	_g_object_unref0 (self->gains);
#line 31 "../core/EqualizerPreset.vala"
	G_OBJECT_CLASS (music_equalizer_preset_parent_class)->finalize (obj);
#line 610 "EqualizerPreset.c"
}

static GType
music_equalizer_preset_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicEqualizerPresetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_equalizer_preset_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicEqualizerPreset), 0, (GInstanceInitFunc) music_equalizer_preset_instance_init, NULL };
	GType music_equalizer_preset_type_id;
	music_equalizer_preset_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicEqualizerPreset", &g_define_type_info, 0);
	MusicEqualizerPreset_private_offset = g_type_add_instance_private (music_equalizer_preset_type_id, sizeof (MusicEqualizerPresetPrivate));
	return music_equalizer_preset_type_id;
}

GType
music_equalizer_preset_get_type (void)
{
	static volatile gsize music_equalizer_preset_type_id__once = 0;
	if (g_once_init_enter (&music_equalizer_preset_type_id__once)) {
		GType music_equalizer_preset_type_id;
		music_equalizer_preset_type_id = music_equalizer_preset_get_type_once ();
		g_once_init_leave (&music_equalizer_preset_type_id__once, music_equalizer_preset_type_id);
	}
	return music_equalizer_preset_type_id__once;
}

static void
_vala_music_equalizer_preset_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
#line 31 "../core/EqualizerPreset.vala"
	switch (property_id) {
#line 31 "../core/EqualizerPreset.vala"
		case MUSIC_EQUALIZER_PRESET_NAME_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		g_value_set_string (value, music_equalizer_preset_get_name (self));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 31 "../core/EqualizerPreset.vala"
		case MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		g_value_set_boolean (value, music_equalizer_preset_get_is_default (self));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 657 "EqualizerPreset.c"
		default:
#line 31 "../core/EqualizerPreset.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 663 "EqualizerPreset.c"
	}
}

static void
_vala_music_equalizer_preset_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
#line 31 "../core/EqualizerPreset.vala"
	switch (property_id) {
#line 31 "../core/EqualizerPreset.vala"
		case MUSIC_EQUALIZER_PRESET_NAME_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		music_equalizer_preset_set_name (self, g_value_get_string (value));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 31 "../core/EqualizerPreset.vala"
		case MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
#line 31 "../core/EqualizerPreset.vala"
		music_equalizer_preset_set_is_default (self, g_value_get_boolean (value));
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 689 "EqualizerPreset.c"
		default:
#line 31 "../core/EqualizerPreset.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../core/EqualizerPreset.vala"
		break;
#line 695 "EqualizerPreset.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

