/* Playback.c generated by valac 0.56.0, the Vala compiler
 * generated from Playback.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gst/gst.h>
#include <float.h>
#include <math.h>

enum  {
	MUSIC_PLAYBACK_END_OF_STREAM_SIGNAL,
	MUSIC_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL,
	MUSIC_PLAYBACK_ERROR_OCCURED_SIGNAL,
	MUSIC_PLAYBACK_NUM_SIGNALS
};
static guint music_playback_signals[MUSIC_PLAYBACK_NUM_SIGNALS] = {0};

static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GType music_playback_get_type_once (void);

GeeCollection*
music_playback_get_supported_uri (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 31 "../core/GStreamer/Playback.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 31 "../core/GStreamer/Playback.vala"
	if (_iface_->get_supported_uri) {
#line 31 "../core/GStreamer/Playback.vala"
		return _iface_->get_supported_uri (self);
#line 71 "Playback.c"
	}
#line 31 "../core/GStreamer/Playback.vala"
	return NULL;
#line 75 "Playback.c"
}

void
music_playback_play (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 45 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 45 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 45 "../core/GStreamer/Playback.vala"
	if (_iface_->play) {
#line 45 "../core/GStreamer/Playback.vala"
		_iface_->play (self);
#line 90 "Playback.c"
	}
}

void
music_playback_pause (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 46 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 46 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 46 "../core/GStreamer/Playback.vala"
	if (_iface_->pause) {
#line 46 "../core/GStreamer/Playback.vala"
		_iface_->pause (self);
#line 106 "Playback.c"
	}
}

void
music_playback_set_state (MusicPlayback* self,
                          GstState s)
{
	MusicPlaybackIface* _iface_;
#line 47 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 47 "../core/GStreamer/Playback.vala"
	if (_iface_->set_state) {
#line 47 "../core/GStreamer/Playback.vala"
		_iface_->set_state (self, s);
#line 123 "Playback.c"
	}
}

void
music_playback_set_media (MusicPlayback* self,
                          MusicMedia* media)
{
	MusicPlaybackIface* _iface_;
#line 48 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 48 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 48 "../core/GStreamer/Playback.vala"
	if (_iface_->set_media) {
#line 48 "../core/GStreamer/Playback.vala"
		_iface_->set_media (self, media);
#line 140 "Playback.c"
	}
}

void
music_playback_set_position (MusicPlayback* self,
                             gint64 pos)
{
	MusicPlaybackIface* _iface_;
#line 49 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 49 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 49 "../core/GStreamer/Playback.vala"
	if (_iface_->set_position) {
#line 49 "../core/GStreamer/Playback.vala"
		_iface_->set_position (self, pos);
#line 157 "Playback.c"
	}
}

gint64
music_playback_get_position (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 50 "../core/GStreamer/Playback.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 50 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 50 "../core/GStreamer/Playback.vala"
	if (_iface_->get_position) {
#line 50 "../core/GStreamer/Playback.vala"
		return _iface_->get_position (self);
#line 173 "Playback.c"
	}
#line 50 "../core/GStreamer/Playback.vala"
	return -1LL;
#line 177 "Playback.c"
}

gint64
music_playback_get_duration (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 51 "../core/GStreamer/Playback.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 51 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 51 "../core/GStreamer/Playback.vala"
	if (_iface_->get_duration) {
#line 51 "../core/GStreamer/Playback.vala"
		return _iface_->get_duration (self);
#line 192 "Playback.c"
	}
#line 51 "../core/GStreamer/Playback.vala"
	return -1LL;
#line 196 "Playback.c"
}

void
music_playback_set_volume (MusicPlayback* self,
                           gdouble val)
{
	MusicPlaybackIface* _iface_;
#line 52 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 52 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 52 "../core/GStreamer/Playback.vala"
	if (_iface_->set_volume) {
#line 52 "../core/GStreamer/Playback.vala"
		_iface_->set_volume (self, val);
#line 212 "Playback.c"
	}
}

gdouble
music_playback_get_volume (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 53 "../core/GStreamer/Playback.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 53 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 53 "../core/GStreamer/Playback.vala"
	if (_iface_->get_volume) {
#line 53 "../core/GStreamer/Playback.vala"
		return _iface_->get_volume (self);
#line 228 "Playback.c"
	}
#line 53 "../core/GStreamer/Playback.vala"
	return -1.0;
#line 232 "Playback.c"
}

gboolean
music_playback_update_position (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 59 "../core/GStreamer/Playback.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 59 "../core/GStreamer/Playback.vala"
	if (_iface_->update_position) {
#line 59 "../core/GStreamer/Playback.vala"
		return _iface_->update_position (self);
#line 247 "Playback.c"
	}
#line 59 "../core/GStreamer/Playback.vala"
	return FALSE;
#line 251 "Playback.c"
}

void
music_playback_enable_equalizer (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 60 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 60 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 60 "../core/GStreamer/Playback.vala"
	if (_iface_->enable_equalizer) {
#line 60 "../core/GStreamer/Playback.vala"
		_iface_->enable_equalizer (self);
#line 266 "Playback.c"
	}
}

void
music_playback_disable_equalizer (MusicPlayback* self)
{
	MusicPlaybackIface* _iface_;
#line 61 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 61 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 61 "../core/GStreamer/Playback.vala"
	if (_iface_->disable_equalizer) {
#line 61 "../core/GStreamer/Playback.vala"
		_iface_->disable_equalizer (self);
#line 282 "Playback.c"
	}
}

void
music_playback_set_equalizer_gain (MusicPlayback* self,
                                   gint index,
                                   gint val)
{
	MusicPlaybackIface* _iface_;
#line 62 "../core/GStreamer/Playback.vala"
	g_return_if_fail (self != NULL);
#line 62 "../core/GStreamer/Playback.vala"
	_iface_ = MUSIC_PLAYBACK_GET_INTERFACE (self);
#line 62 "../core/GStreamer/Playback.vala"
	if (_iface_->set_equalizer_gain) {
#line 62 "../core/GStreamer/Playback.vala"
		_iface_->set_equalizer_gain (self, index, val);
#line 300 "Playback.c"
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../core/GStreamer/Playback.vala"
	g_return_if_fail (n_param_values == 2);
#line 29 "../core/GStreamer/Playback.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../core/GStreamer/Playback.vala"
		data1 = closure->data;
#line 29 "../core/GStreamer/Playback.vala"
		data2 = param_values->data[0].v_pointer;
#line 326 "Playback.c"
	} else {
#line 29 "../core/GStreamer/Playback.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../core/GStreamer/Playback.vala"
		data2 = closure->data;
#line 332 "Playback.c"
	}
#line 29 "../core/GStreamer/Playback.vala"
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
#line 29 "../core/GStreamer/Playback.vala"
	callback (data1, g_value_get_int64 (param_values + 1), data2);
#line 338 "Playback.c"
}

static void
music_playback_default_init (MusicPlaybackIface * iface,
                             gpointer iface_data)
{
#line 29 "../core/GStreamer/Playback.vala"
	music_playback_signals[MUSIC_PLAYBACK_END_OF_STREAM_SIGNAL] = g_signal_new ("end-of-stream", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/GStreamer/Playback.vala"
	music_playback_signals[MUSIC_PLAYBACK_CURRENT_POSITION_UPDATE_SIGNAL] = g_signal_new ("current-position-update", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
#line 29 "../core/GStreamer/Playback.vala"
	music_playback_signals[MUSIC_PLAYBACK_ERROR_OCCURED_SIGNAL] = g_signal_new ("error-occured", MUSIC_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 351 "Playback.c"
}

static GType
music_playback_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaybackIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playback_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_playback_type_id;
	music_playback_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicPlayback", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_playback_type_id, G_TYPE_OBJECT);
	return music_playback_type_id;
}

GType
music_playback_get_type (void)
{
	static volatile gsize music_playback_type_id__once = 0;
	if (g_once_init_enter (&music_playback_type_id__once)) {
		GType music_playback_type_id;
		music_playback_type_id = music_playback_get_type_once ();
		g_once_init_leave (&music_playback_type_id__once, music_playback_type_id);
	}
	return music_playback_type_id__once;
}

