/* LibrariesManager.c generated by valac 0.56.0, the Vala compiler
 * generated from LibrariesManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <time.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_LIBRARIES_MANAGER_0_PROPERTY,
	MUSIC_LIBRARIES_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_libraries_manager_properties[MUSIC_LIBRARIES_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MusicLibrariesManagerTransferMediasAsyncData MusicLibrariesManagerTransferMediasAsyncData;
enum  {
	MUSIC_LIBRARIES_MANAGER_ADD_HEADLESS_PLAYLIST_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_CANCEL_TRANSFER_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_OPERATION_TERMINATED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_NUM_SIGNALS
};
static guint music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_NUM_SIGNALS] = {0};

struct _MusicLibrariesManagerPrivate {
	gchar* old_search;
	GeeHashMap* libraries;
	gint current_index;
};

struct _Block6Data {
	int _ref_count_;
	MusicLibrariesManager* self;
	GeeTreeSet* copied_list;
	gpointer _async_data_;
};

struct _MusicLibrariesManagerTransferMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibrariesManager* self;
	GeeCollection* list;
	Block6Data* _data6_;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index;
	gint total;
	gint _tmp3_;
	gint _tmp4_;
	GeeTreeSet* _tmp5_;
	GeeIterator* _m_it;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	MusicMedia* m;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	MusicMedia* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	gboolean _tmp16_;
	GFile* dest;
	MusicMedia* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gboolean success;
	gboolean _tmp20_;
	MusicMedia* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	MusicMedia* copy;
	MusicMedia* _tmp25_;
	MusicMedia* _tmp26_;
	MusicMedia* _tmp27_;
	GFile* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	MusicMedia* _tmp31_;
	MusicMedia* _tmp32_;
	MusicMedia* _tmp33_;
	time_t _tmp34_;
	GeeTreeSet* _tmp35_;
	MusicMedia* _tmp36_;
	MusicMedia* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GFile* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GError* err;
	MusicMedia* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GError* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	MusicMedia* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	const gchar* _tmp56_;
	MusicMedia* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	MusicMedia* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gint _tmp64_;
	GError* _inner_error0_;
};

static gint MusicLibrariesManager_private_offset;
static gpointer music_libraries_manager_parent_class = NULL;

static void music_libraries_manager_transfer_medias_async_data_free (gpointer _data);
static gboolean music_libraries_manager_transfer_medias_async_co (MusicLibrariesManagerTransferMediasAsyncData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static gboolean __lambda15_ (Block6Data* _data6_);
static gboolean ___lambda15__gsource_func (gpointer self);
static void music_libraries_manager_finalize (GObject * obj);
static GType music_libraries_manager_get_type_once (void);

static inline gpointer
music_libraries_manager_get_instance_private (MusicLibrariesManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLibrariesManager_private_offset);
}

MusicLibrariesManager*
music_libraries_manager_construct (GType object_type)
{
	MusicLibrariesManager * self = NULL;
	GeeHashMap* _tmp0_;
#line 49 "../core/LibrariesManager.vala"
	self = (MusicLibrariesManager*) g_object_new (object_type, NULL);
#line 50 "../core/LibrariesManager.vala"
	_tmp0_ = gee_hash_map_new (MUSIC_TYPE_LIBRARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 50 "../core/LibrariesManager.vala"
	_g_object_unref0 (self->priv->libraries);
#line 50 "../core/LibrariesManager.vala"
	self->priv->libraries = _tmp0_;
#line 49 "../core/LibrariesManager.vala"
	return self;
#line 197 "LibrariesManager.c"
}

MusicLibrariesManager*
music_libraries_manager_new (void)
{
#line 49 "../core/LibrariesManager.vala"
	return music_libraries_manager_construct (MUSIC_TYPE_LIBRARIES_MANAGER);
#line 205 "LibrariesManager.c"
}

void
music_libraries_manager_add_library (MusicLibrariesManager* self,
                                     MusicLibrary* library)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_;
#line 53 "../core/LibrariesManager.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/LibrariesManager.vala"
	g_return_if_fail (library != NULL);
#line 54 "../core/LibrariesManager.vala"
	_tmp0_ = self->priv->libraries;
#line 54 "../core/LibrariesManager.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 54 "../core/LibrariesManager.vala"
	_tmp2_ = _tmp1_;
#line 54 "../core/LibrariesManager.vala"
	_tmp3_ = _tmp2_;
#line 54 "../core/LibrariesManager.vala"
	_tmp4_ = !gee_collection_contains ((GeeCollection*) _tmp3_, library);
#line 54 "../core/LibrariesManager.vala"
	_g_object_unref0 (_tmp3_);
#line 54 "../core/LibrariesManager.vala"
	if (_tmp4_) {
#line 235 "LibrariesManager.c"
		GeeHashMap* _tmp5_;
#line 55 "../core/LibrariesManager.vala"
		_tmp5_ = self->priv->libraries;
#line 55 "../core/LibrariesManager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, library, (gpointer) ((gintptr) self->priv->current_index));
#line 56 "../core/LibrariesManager.vala"
		g_signal_emit (self, music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL], 0, library);
#line 243 "LibrariesManager.c"
	}
}

void
music_libraries_manager_remove_library (MusicLibrariesManager* self,
                                        MusicLibrary* library)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_;
#line 60 "../core/LibrariesManager.vala"
	g_return_if_fail (self != NULL);
#line 60 "../core/LibrariesManager.vala"
	g_return_if_fail (library != NULL);
#line 61 "../core/LibrariesManager.vala"
	_tmp0_ = self->priv->libraries;
#line 61 "../core/LibrariesManager.vala"
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 61 "../core/LibrariesManager.vala"
	_tmp2_ = _tmp1_;
#line 61 "../core/LibrariesManager.vala"
	_tmp3_ = _tmp2_;
#line 61 "../core/LibrariesManager.vala"
	_tmp4_ = gee_collection_contains ((GeeCollection*) _tmp3_, library);
#line 61 "../core/LibrariesManager.vala"
	_g_object_unref0 (_tmp3_);
#line 61 "../core/LibrariesManager.vala"
	if (_tmp4_) {
#line 274 "LibrariesManager.c"
		GeeHashMap* _tmp5_;
#line 62 "../core/LibrariesManager.vala"
		g_signal_emit (self, music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL], 0, library);
#line 63 "../core/LibrariesManager.vala"
		_tmp5_ = self->priv->libraries;
#line 63 "../core/LibrariesManager.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, library, NULL);
#line 282 "LibrariesManager.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../core/LibrariesManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 291 "LibrariesManager.c"
}

MusicLibrary*
music_libraries_manager_get_library_from_index (MusicLibrariesManager* self,
                                                gint index)
{
	MusicLibrary* result;
#line 67 "../core/LibrariesManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 301 "LibrariesManager.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 68 "../core/LibrariesManager.vala"
		_tmp0_ = self->priv->libraries;
#line 68 "../core/LibrariesManager.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 68 "../core/LibrariesManager.vala"
		_tmp2_ = _tmp1_;
#line 68 "../core/LibrariesManager.vala"
		_tmp3_ = _tmp2_;
#line 68 "../core/LibrariesManager.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 68 "../core/LibrariesManager.vala"
		_tmp5_ = _tmp4_;
#line 68 "../core/LibrariesManager.vala"
		_g_object_unref0 (_tmp3_);
#line 68 "../core/LibrariesManager.vala"
		_entry_it = _tmp5_;
#line 68 "../core/LibrariesManager.vala"
		while (TRUE) {
#line 328 "LibrariesManager.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
#line 68 "../core/LibrariesManager.vala"
			_tmp6_ = _entry_it;
#line 68 "../core/LibrariesManager.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 68 "../core/LibrariesManager.vala"
				break;
#line 342 "LibrariesManager.c"
			}
#line 68 "../core/LibrariesManager.vala"
			_tmp7_ = _entry_it;
#line 68 "../core/LibrariesManager.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 68 "../core/LibrariesManager.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 69 "../core/LibrariesManager.vala"
			_tmp9_ = entry;
#line 69 "../core/LibrariesManager.vala"
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
#line 69 "../core/LibrariesManager.vala"
			_tmp11_ = _tmp10_;
#line 69 "../core/LibrariesManager.vala"
			if (((gint) ((gintptr) _tmp11_)) == index) {
#line 358 "LibrariesManager.c"
				GeeMapEntry* _tmp12_;
				gconstpointer _tmp13_;
				gconstpointer _tmp14_;
				MusicLibrary* _tmp15_;
#line 70 "../core/LibrariesManager.vala"
				_tmp12_ = entry;
#line 70 "../core/LibrariesManager.vala"
				_tmp13_ = gee_map_entry_get_key (_tmp12_);
#line 70 "../core/LibrariesManager.vala"
				_tmp14_ = _tmp13_;
#line 70 "../core/LibrariesManager.vala"
				_tmp15_ = _g_object_ref0 ((MusicLibrary*) _tmp14_);
#line 70 "../core/LibrariesManager.vala"
				result = _tmp15_;
#line 70 "../core/LibrariesManager.vala"
				_g_object_unref0 (entry);
#line 70 "../core/LibrariesManager.vala"
				_g_object_unref0 (_entry_it);
#line 70 "../core/LibrariesManager.vala"
				return result;
#line 379 "LibrariesManager.c"
			}
#line 68 "../core/LibrariesManager.vala"
			_g_object_unref0 (entry);
#line 383 "LibrariesManager.c"
		}
#line 68 "../core/LibrariesManager.vala"
		_g_object_unref0 (_entry_it);
#line 387 "LibrariesManager.c"
	}
#line 73 "../core/LibrariesManager.vala"
	result = NULL;
#line 73 "../core/LibrariesManager.vala"
	return result;
#line 393 "LibrariesManager.c"
}

void
music_libraries_manager_search_for_string (MusicLibrariesManager* self,
                                           const gchar* search)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 76 "../core/LibrariesManager.vala"
	g_return_if_fail (self != NULL);
#line 76 "../core/LibrariesManager.vala"
	g_return_if_fail (search != NULL);
#line 77 "../core/LibrariesManager.vala"
	_tmp0_ = self->priv->old_search;
#line 77 "../core/LibrariesManager.vala"
	if (g_strcmp0 (_tmp0_, search) == 0) {
#line 78 "../core/LibrariesManager.vala"
		return;
#line 412 "LibrariesManager.c"
	}
#line 81 "../core/LibrariesManager.vala"
	_tmp1_ = g_strdup (search);
#line 81 "../core/LibrariesManager.vala"
	_g_free0 (self->priv->old_search);
#line 81 "../core/LibrariesManager.vala"
	self->priv->old_search = _tmp1_;
#line 420 "LibrariesManager.c"
	{
		GeeIterator* _library_it = NULL;
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
#line 82 "../core/LibrariesManager.vala"
		_tmp2_ = self->priv->libraries;
#line 82 "../core/LibrariesManager.vala"
		_tmp3_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp2_);
#line 82 "../core/LibrariesManager.vala"
		_tmp4_ = _tmp3_;
#line 82 "../core/LibrariesManager.vala"
		_tmp5_ = _tmp4_;
#line 82 "../core/LibrariesManager.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 82 "../core/LibrariesManager.vala"
		_tmp7_ = _tmp6_;
#line 82 "../core/LibrariesManager.vala"
		_g_object_unref0 (_tmp5_);
#line 82 "../core/LibrariesManager.vala"
		_library_it = _tmp7_;
#line 82 "../core/LibrariesManager.vala"
		while (TRUE) {
#line 447 "LibrariesManager.c"
			GeeIterator* _tmp8_;
			MusicLibrary* library = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			MusicLibrary* _tmp11_;
#line 82 "../core/LibrariesManager.vala"
			_tmp8_ = _library_it;
#line 82 "../core/LibrariesManager.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 82 "../core/LibrariesManager.vala"
				break;
#line 459 "LibrariesManager.c"
			}
#line 82 "../core/LibrariesManager.vala"
			_tmp9_ = _library_it;
#line 82 "../core/LibrariesManager.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 82 "../core/LibrariesManager.vala"
			library = (MusicLibrary*) _tmp10_;
#line 83 "../core/LibrariesManager.vala"
			_tmp11_ = library;
#line 83 "../core/LibrariesManager.vala"
			music_library_search_medias (_tmp11_, search);
#line 82 "../core/LibrariesManager.vala"
			_g_object_unref0 (library);
#line 473 "LibrariesManager.c"
		}
#line 82 "../core/LibrariesManager.vala"
		_g_object_unref0 (_library_it);
#line 477 "LibrariesManager.c"
	}
}

void
music_libraries_manager_transfer_to_local_library (MusicLibrariesManager* self,
                                                   GeeCollection* to_transfer)
{
	MusicLibrary* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
#line 87 "../core/LibrariesManager.vala"
	g_return_if_fail (self != NULL);
#line 87 "../core/LibrariesManager.vala"
	g_return_if_fail (to_transfer != NULL);
#line 88 "../core/LibrariesManager.vala"
	_tmp0_ = self->local_library;
#line 88 "../core/LibrariesManager.vala"
	if (_tmp0_ == NULL) {
#line 89 "../core/LibrariesManager.vala"
		return;
#line 499 "LibrariesManager.c"
	}
#line 92 "../core/LibrariesManager.vala"
	if (to_transfer == NULL) {
#line 92 "../core/LibrariesManager.vala"
		_tmp1_ = TRUE;
#line 505 "LibrariesManager.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 92 "../core/LibrariesManager.vala"
		_tmp2_ = gee_collection_get_size (to_transfer);
#line 92 "../core/LibrariesManager.vala"
		_tmp3_ = _tmp2_;
#line 92 "../core/LibrariesManager.vala"
		_tmp1_ = _tmp3_ == 0;
#line 515 "LibrariesManager.c"
	}
#line 92 "../core/LibrariesManager.vala"
	if (_tmp1_) {
#line 93 "../core/LibrariesManager.vala"
		g_warning ("LibrariesManager.vala:93: No songs in transfer list\n");
#line 94 "../core/LibrariesManager.vala"
		return;
#line 523 "LibrariesManager.c"
	}
#line 97 "../core/LibrariesManager.vala"
	_tmp4_ = gee_collection_get_size (to_transfer);
#line 97 "../core/LibrariesManager.vala"
	_tmp5_ = _tmp4_;
#line 97 "../core/LibrariesManager.vala"
	g_debug ("LibrariesManager.vala:97: Found %d medias to import.", _tmp5_);
#line 99 "../core/LibrariesManager.vala"
	music_libraries_manager_transfer_medias_async (self, to_transfer, NULL, NULL);
#line 100 "../core/LibrariesManager.vala"
	return;
#line 535 "LibrariesManager.c"
}

static void
music_libraries_manager_transfer_medias_async_data_free (gpointer _data)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
	_data_ = _data;
#line 29 "../core/LibrariesManager.vala"
	_g_object_unref0 (_data_->list);
#line 29 "../core/LibrariesManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../core/LibrariesManager.vala"
	g_slice_free (MusicLibrariesManagerTransferMediasAsyncData, _data_);
#line 549 "LibrariesManager.c"
}

void
music_libraries_manager_transfer_medias_async (MusicLibrariesManager* self,
                                               GeeCollection* list,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
	MusicLibrariesManager* _tmp0_;
	GeeCollection* _tmp1_;
#line 29 "../core/LibrariesManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../core/LibrariesManager.vala"
	g_return_if_fail (list != NULL);
#line 29 "../core/LibrariesManager.vala"
	_data_ = g_slice_new0 (MusicLibrariesManagerTransferMediasAsyncData);
#line 29 "../core/LibrariesManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../core/LibrariesManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, music_libraries_manager_transfer_medias_async_data_free);
#line 29 "../core/LibrariesManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../core/LibrariesManager.vala"
	_data_->self = _tmp0_;
#line 29 "../core/LibrariesManager.vala"
	_tmp1_ = _g_object_ref0 (list);
#line 29 "../core/LibrariesManager.vala"
	_g_object_unref0 (_data_->list);
#line 29 "../core/LibrariesManager.vala"
	_data_->list = _tmp1_;
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_transfer_medias_async_co (_data_);
#line 583 "LibrariesManager.c"
}

void
music_libraries_manager_transfer_medias_finish (MusicLibrariesManager* self,
                                                GAsyncResult* _res_)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
#line 29 "../core/LibrariesManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 593 "LibrariesManager.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 103 "../core/LibrariesManager.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 103 "../core/LibrariesManager.vala"
	return _data6_;
#line 603 "LibrariesManager.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 103 "../core/LibrariesManager.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 613 "LibrariesManager.c"
		MusicLibrariesManager* self;
#line 103 "../core/LibrariesManager.vala"
		self = _data6_->self;
#line 103 "../core/LibrariesManager.vala"
		_g_object_unref0 (_data6_->copied_list);
#line 103 "../core/LibrariesManager.vala"
		_g_object_unref0 (self);
#line 103 "../core/LibrariesManager.vala"
		g_slice_free (Block6Data, _data6_);
#line 623 "LibrariesManager.c"
	}
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
#line 111 "../core/LibrariesManager.vala"
	return result;
#line 634 "LibrariesManager.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 656 "LibrariesManager.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 660 "LibrariesManager.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 666 "LibrariesManager.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 670 "LibrariesManager.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 674 "LibrariesManager.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 682 "LibrariesManager.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 710 "LibrariesManager.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 719 "LibrariesManager.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 733 "LibrariesManager.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 742 "LibrariesManager.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 756 "LibrariesManager.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 765 "LibrariesManager.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 774 "LibrariesManager.c"
}

static gboolean
__lambda15_ (Block6Data* _data6_)
{
	MusicLibrariesManager* self;
	MusicLibrary* _tmp0_;
	GeeTreeSet* _tmp1_;
	gboolean result;
#line 158 "../core/LibrariesManager.vala"
	self = _data6_->self;
#line 159 "../core/LibrariesManager.vala"
	_tmp0_ = self->local_library;
#line 159 "../core/LibrariesManager.vala"
	_tmp1_ = _data6_->copied_list;
#line 159 "../core/LibrariesManager.vala"
	music_library_add_medias (_tmp0_, (GeeCollection*) _tmp1_);
#line 160 "../core/LibrariesManager.vala"
	result = FALSE;
#line 160 "../core/LibrariesManager.vala"
	return result;
#line 796 "LibrariesManager.c"
}

static gboolean
___lambda15__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda15_ (self);
#line 158 "../core/LibrariesManager.vala"
	return result;
#line 806 "LibrariesManager.c"
}

static gboolean
music_libraries_manager_transfer_medias_async_co (MusicLibrariesManagerTransferMediasAsyncData* _data_)
{
#line 103 "../core/LibrariesManager.vala"
	switch (_data_->_state_) {
#line 103 "../core/LibrariesManager.vala"
		case 0:
#line 816 "LibrariesManager.c"
		goto _state_0;
		default:
#line 103 "../core/LibrariesManager.vala"
		g_assert_not_reached ();
#line 821 "LibrariesManager.c"
	}
	_state_0:
#line 103 "../core/LibrariesManager.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 103 "../core/LibrariesManager.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 103 "../core/LibrariesManager.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 103 "../core/LibrariesManager.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 104 "../core/LibrariesManager.vala"
	if (_data_->list == NULL) {
#line 104 "../core/LibrariesManager.vala"
		_data_->_tmp0_ = TRUE;
#line 836 "LibrariesManager.c"
	} else {
#line 104 "../core/LibrariesManager.vala"
		_data_->_tmp1_ = gee_collection_get_size (_data_->list);
#line 104 "../core/LibrariesManager.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 104 "../core/LibrariesManager.vala"
		_data_->_tmp0_ = _data_->_tmp2_ == 0;
#line 844 "LibrariesManager.c"
	}
#line 104 "../core/LibrariesManager.vala"
	if (_data_->_tmp0_) {
#line 105 "../core/LibrariesManager.vala"
		block6_data_unref (_data_->_data6_);
#line 105 "../core/LibrariesManager.vala"
		_data_->_data6_ = NULL;
#line 105 "../core/LibrariesManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 105 "../core/LibrariesManager.vala"
		if (_data_->_state_ != 0) {
#line 105 "../core/LibrariesManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 105 "../core/LibrariesManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 860 "LibrariesManager.c"
			}
		}
#line 105 "../core/LibrariesManager.vala"
		g_object_unref (_data_->_async_result);
#line 105 "../core/LibrariesManager.vala"
		return FALSE;
#line 867 "LibrariesManager.c"
	}
#line 108 "../core/LibrariesManager.vala"
	_data_->index = 0;
#line 110 "../core/LibrariesManager.vala"
	_data_->self->progress = (gdouble) 0;
#line 111 "../core/LibrariesManager.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 113 "../core/LibrariesManager.vala"
	_data_->_tmp3_ = gee_collection_get_size (_data_->list);
#line 113 "../core/LibrariesManager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 113 "../core/LibrariesManager.vala"
	_data_->total = _data_->_tmp4_;
#line 114 "../core/LibrariesManager.vala"
	_data_->_tmp5_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 114 "../core/LibrariesManager.vala"
	_data_->_data6_->copied_list = _data_->_tmp5_;
#line 885 "LibrariesManager.c"
	{
#line 116 "../core/LibrariesManager.vala"
		_data_->_tmp6_ = gee_iterable_iterator ((GeeIterable*) _data_->list);
#line 116 "../core/LibrariesManager.vala"
		_data_->_m_it = _data_->_tmp6_;
#line 116 "../core/LibrariesManager.vala"
		while (TRUE) {
#line 116 "../core/LibrariesManager.vala"
			_data_->_tmp7_ = _data_->_m_it;
#line 116 "../core/LibrariesManager.vala"
			if (!gee_iterator_next (_data_->_tmp7_)) {
#line 116 "../core/LibrariesManager.vala"
				break;
#line 899 "LibrariesManager.c"
			}
#line 116 "../core/LibrariesManager.vala"
			_data_->_tmp8_ = _data_->_m_it;
#line 116 "../core/LibrariesManager.vala"
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 116 "../core/LibrariesManager.vala"
			_data_->m = (MusicMedia*) _data_->_tmp9_;
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp10_ = _data_->m;
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp11_ = music_media_get_uri (_data_->_tmp10_);
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp14_ = g_file_new_for_uri (_data_->_tmp13_);
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 118 "../core/LibrariesManager.vala"
			_data_->_tmp16_ = g_file_query_exists (_data_->_tmp15_, NULL);
#line 118 "../core/LibrariesManager.vala"
			_g_object_unref0 (_data_->_tmp15_);
#line 118 "../core/LibrariesManager.vala"
			_g_free0 (_data_->_tmp13_);
#line 118 "../core/LibrariesManager.vala"
			if (_data_->_tmp16_) {
#line 927 "LibrariesManager.c"
				{
#line 120 "../core/LibrariesManager.vala"
					_data_->_tmp17_ = _data_->m;
#line 120 "../core/LibrariesManager.vala"
					_data_->_tmp18_ = music_file_utils_get_new_destination (_data_->_tmp17_);
#line 120 "../core/LibrariesManager.vala"
					_data_->dest = _data_->_tmp18_;
#line 121 "../core/LibrariesManager.vala"
					_data_->_tmp19_ = _data_->dest;
#line 121 "../core/LibrariesManager.vala"
					if (_data_->_tmp19_ == NULL) {
#line 122 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->dest);
#line 122 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->m);
#line 122 "../core/LibrariesManager.vala"
						break;
#line 945 "LibrariesManager.c"
					}
#line 126 "../core/LibrariesManager.vala"
					_data_->success = FALSE;
#line 127 "../core/LibrariesManager.vala"
					_data_->_tmp21_ = _data_->m;
#line 127 "../core/LibrariesManager.vala"
					_data_->_tmp22_ = music_media_get_file (_data_->_tmp21_);
#line 127 "../core/LibrariesManager.vala"
					_data_->_tmp23_ = _data_->_tmp22_;
#line 127 "../core/LibrariesManager.vala"
					_data_->_tmp24_ = _data_->dest;
#line 127 "../core/LibrariesManager.vala"
					_data_->_tmp20_ = g_file_copy (_data_->_tmp23_, _data_->_tmp24_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_data_->_inner_error0_);
#line 127 "../core/LibrariesManager.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 127 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->dest);
#line 963 "LibrariesManager.c"
						goto __catch0_g_error;
					}
#line 127 "../core/LibrariesManager.vala"
					_data_->success = _data_->_tmp20_;
#line 129 "../core/LibrariesManager.vala"
					if (_data_->success) {
#line 130 "../core/LibrariesManager.vala"
						_data_->_tmp25_ = _data_->m;
#line 130 "../core/LibrariesManager.vala"
						_data_->_tmp26_ = music_media_copy (_data_->_tmp25_);
#line 130 "../core/LibrariesManager.vala"
						_data_->copy = _data_->_tmp26_;
#line 131 "../core/LibrariesManager.vala"
						g_debug ("LibrariesManager.vala:131: success copying file\n");
#line 132 "../core/LibrariesManager.vala"
						_data_->_tmp27_ = _data_->copy;
#line 132 "../core/LibrariesManager.vala"
						_data_->_tmp28_ = _data_->dest;
#line 132 "../core/LibrariesManager.vala"
						_data_->_tmp29_ = g_file_get_uri (_data_->_tmp28_);
#line 132 "../core/LibrariesManager.vala"
						_data_->_tmp30_ = _data_->_tmp29_;
#line 132 "../core/LibrariesManager.vala"
						music_media_set_uri (_data_->_tmp27_, _data_->_tmp30_);
#line 132 "../core/LibrariesManager.vala"
						_g_free0 (_data_->_tmp30_);
#line 133 "../core/LibrariesManager.vala"
						_data_->_tmp31_ = _data_->copy;
#line 133 "../core/LibrariesManager.vala"
						music_media_set_rowid (_data_->_tmp31_, (gint64) 0);
#line 134 "../core/LibrariesManager.vala"
						_data_->_tmp32_ = _data_->copy;
#line 134 "../core/LibrariesManager.vala"
						music_media_set_is_temporary (_data_->_tmp32_, FALSE);
#line 135 "../core/LibrariesManager.vala"
						_data_->_tmp33_ = _data_->copy;
#line 135 "../core/LibrariesManager.vala"
						_data_->_tmp34_ = time (NULL);
#line 135 "../core/LibrariesManager.vala"
						music_media_set_date_added (_data_->_tmp33_, (guint) ((gint) _data_->_tmp34_));
#line 136 "../core/LibrariesManager.vala"
						_data_->_tmp35_ = _data_->_data6_->copied_list;
#line 136 "../core/LibrariesManager.vala"
						_data_->_tmp36_ = _data_->copy;
#line 136 "../core/LibrariesManager.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp35_, _data_->_tmp36_);
#line 129 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->copy);
#line 1012 "LibrariesManager.c"
					} else {
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp37_ = _data_->m;
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp38_ = music_media_get_uri (_data_->_tmp37_);
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp39_ = _data_->_tmp38_;
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp40_ = _data_->_tmp39_;
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp41_ = _data_->dest;
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp42_ = g_file_get_path (_data_->_tmp41_);
#line 138 "../core/LibrariesManager.vala"
						_data_->_tmp43_ = _data_->_tmp42_;
#line 138 "../core/LibrariesManager.vala"
						g_warning ("LibrariesManager.vala:138: Failure: Could not copy imported media %s t" \
"o media folder %s", _data_->_tmp40_, _data_->_tmp43_);
#line 138 "../core/LibrariesManager.vala"
						_g_free0 (_data_->_tmp43_);
#line 138 "../core/LibrariesManager.vala"
						_g_free0 (_data_->_tmp40_);
#line 139 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->dest);
#line 139 "../core/LibrariesManager.vala"
						_g_object_unref0 (_data_->m);
#line 139 "../core/LibrariesManager.vala"
						break;
#line 1040 "LibrariesManager.c"
					}
#line 119 "../core/LibrariesManager.vala"
					_g_object_unref0 (_data_->dest);
#line 1044 "LibrariesManager.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
#line 119 "../core/LibrariesManager.vala"
					_data_->err = _data_->_inner_error0_;
#line 119 "../core/LibrariesManager.vala"
					_data_->_inner_error0_ = NULL;
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp44_ = _data_->m;
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp45_ = music_media_get_uri (_data_->_tmp44_);
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp46_ = _data_->_tmp45_;
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp47_ = _data_->_tmp46_;
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp48_ = _data_->err;
#line 142 "../core/LibrariesManager.vala"
					_data_->_tmp49_ = _data_->_tmp48_->message;
#line 142 "../core/LibrariesManager.vala"
					g_warning ("LibrariesManager.vala:142: Could not copy imported media %s to media f" \
"older: %s\n", _data_->_tmp47_, _data_->_tmp49_);
#line 142 "../core/LibrariesManager.vala"
					_g_free0 (_data_->_tmp47_);
#line 143 "../core/LibrariesManager.vala"
					_g_error_free0 (_data_->err);
#line 143 "../core/LibrariesManager.vala"
					_g_object_unref0 (_data_->m);
#line 143 "../core/LibrariesManager.vala"
					break;
#line 1075 "LibrariesManager.c"
				}
				__finally0:
#line 119 "../core/LibrariesManager.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 119 "../core/LibrariesManager.vala"
					_g_object_unref0 (_data_->m);
#line 119 "../core/LibrariesManager.vala"
					_g_object_unref0 (_data_->_m_it);
#line 119 "../core/LibrariesManager.vala"
					block6_data_unref (_data_->_data6_);
#line 119 "../core/LibrariesManager.vala"
					_data_->_data6_ = NULL;
#line 119 "../core/LibrariesManager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 119 "../core/LibrariesManager.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 119 "../core/LibrariesManager.vala"
					g_object_unref (_data_->_async_result);
#line 119 "../core/LibrariesManager.vala"
					return FALSE;
#line 1096 "LibrariesManager.c"
				}
#line 146 "../core/LibrariesManager.vala"
				_data_->_tmp50_ = g_strdup (_ ("Importing <b>$NAME</b> by <b>$ARTIST</b> to library…"));
#line 146 "../core/LibrariesManager.vala"
				_g_free0 (_data_->self->current_operation);
#line 146 "../core/LibrariesManager.vala"
				_data_->self->current_operation = _data_->_tmp50_;
#line 147 "../core/LibrariesManager.vala"
				_data_->_tmp51_ = _data_->self->current_operation;
#line 147 "../core/LibrariesManager.vala"
				_data_->_tmp52_ = _data_->m;
#line 147 "../core/LibrariesManager.vala"
				_data_->_tmp53_ = music_media_get_display_title (_data_->_tmp52_);
#line 147 "../core/LibrariesManager.vala"
				_data_->_tmp54_ = _data_->_tmp53_;
#line 147 "../core/LibrariesManager.vala"
				_data_->_tmp55_ = string_replace (_data_->_tmp51_, "$NAME", _data_->_tmp54_);
#line 147 "../core/LibrariesManager.vala"
				_g_free0 (_data_->self->current_operation);
#line 147 "../core/LibrariesManager.vala"
				_data_->self->current_operation = _data_->_tmp55_;
#line 147 "../core/LibrariesManager.vala"
				_g_free0 (_data_->_tmp54_);
#line 148 "../core/LibrariesManager.vala"
				_data_->_tmp56_ = _data_->self->current_operation;
#line 148 "../core/LibrariesManager.vala"
				_data_->_tmp57_ = _data_->m;
#line 148 "../core/LibrariesManager.vala"
				_data_->_tmp58_ = music_media_get_display_artist (_data_->_tmp57_);
#line 148 "../core/LibrariesManager.vala"
				_data_->_tmp59_ = _data_->_tmp58_;
#line 148 "../core/LibrariesManager.vala"
				_data_->_tmp60_ = string_replace (_data_->_tmp56_, "$ARTIST", _data_->_tmp59_);
#line 148 "../core/LibrariesManager.vala"
				_g_free0 (_data_->self->current_operation);
#line 148 "../core/LibrariesManager.vala"
				_data_->self->current_operation = _data_->_tmp60_;
#line 148 "../core/LibrariesManager.vala"
				_g_free0 (_data_->_tmp59_);
#line 1136 "LibrariesManager.c"
			} else {
#line 150 "../core/LibrariesManager.vala"
				_data_->_tmp61_ = _data_->m;
#line 150 "../core/LibrariesManager.vala"
				_data_->_tmp62_ = music_media_get_display_title (_data_->_tmp61_);
#line 150 "../core/LibrariesManager.vala"
				_data_->_tmp63_ = _data_->_tmp62_;
#line 150 "../core/LibrariesManager.vala"
				g_message ("LibrariesManager.vala:150: Skipped transferring media %s. Either alrea" \
"dy in library, or has invalid file path.\n", _data_->_tmp63_);
#line 150 "../core/LibrariesManager.vala"
				_g_free0 (_data_->_tmp63_);
#line 1148 "LibrariesManager.c"
			}
#line 152 "../core/LibrariesManager.vala"
			_data_->_tmp64_ = _data_->index;
#line 152 "../core/LibrariesManager.vala"
			_data_->index = _data_->_tmp64_ + 1;
#line 153 "../core/LibrariesManager.vala"
			_data_->self->progress = ((gdouble) _data_->index) / _data_->total;
#line 116 "../core/LibrariesManager.vala"
			_g_object_unref0 (_data_->m);
#line 1158 "LibrariesManager.c"
		}
#line 116 "../core/LibrariesManager.vala"
		_g_object_unref0 (_data_->_m_it);
#line 1162 "LibrariesManager.c"
	}
#line 156 "../core/LibrariesManager.vala"
	_data_->self->progress = (gdouble) 1;
#line 158 "../core/LibrariesManager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda15__gsource_func, block6_data_ref (_data_->_data6_), block6_data_unref);
#line 103 "../core/LibrariesManager.vala"
	block6_data_unref (_data_->_data6_);
#line 103 "../core/LibrariesManager.vala"
	_data_->_data6_ = NULL;
#line 103 "../core/LibrariesManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 103 "../core/LibrariesManager.vala"
	if (_data_->_state_ != 0) {
#line 103 "../core/LibrariesManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 103 "../core/LibrariesManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1180 "LibrariesManager.c"
		}
	}
#line 103 "../core/LibrariesManager.vala"
	g_object_unref (_data_->_async_result);
#line 103 "../core/LibrariesManager.vala"
	return FALSE;
#line 1187 "LibrariesManager.c"
}

gboolean
music_libraries_manager_do_progress_notification_with_timeout (MusicLibrariesManager* self)
{
	MusicNotificationManager* _tmp0_;
	MusicNotificationManager* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result;
#line 164 "../core/LibrariesManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 166 "../core/LibrariesManager.vala"
	_tmp0_ = music_notification_manager_get_default ();
#line 166 "../core/LibrariesManager.vala"
	_tmp1_ = _tmp0_;
#line 166 "../core/LibrariesManager.vala"
	_tmp2_ = self->current_operation;
#line 166 "../core/LibrariesManager.vala"
	_tmp3_ = string_replace (_tmp2_, "&", "&amp;");
#line 166 "../core/LibrariesManager.vala"
	_tmp4_ = _tmp3_;
#line 166 "../core/LibrariesManager.vala"
	g_signal_emit_by_name (_tmp1_, "update-progress", _tmp4_, self->progress);
#line 166 "../core/LibrariesManager.vala"
	_g_free0 (_tmp4_);
#line 166 "../core/LibrariesManager.vala"
	_g_object_unref0 (_tmp1_);
#line 168 "../core/LibrariesManager.vala"
	if (self->progress < ((gdouble) 1)) {
#line 169 "../core/LibrariesManager.vala"
		result = TRUE;
#line 169 "../core/LibrariesManager.vala"
		return result;
#line 1223 "LibrariesManager.c"
	}
#line 172 "../core/LibrariesManager.vala"
	result = FALSE;
#line 172 "../core/LibrariesManager.vala"
	return result;
#line 1229 "LibrariesManager.c"
}

static void
music_libraries_manager_class_init (MusicLibrariesManagerClass * klass,
                                    gpointer klass_data)
{
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/LibrariesManager.vala"
	g_type_class_adjust_private_offset (klass, &MusicLibrariesManager_private_offset);
#line 29 "../core/LibrariesManager.vala"
	G_OBJECT_CLASS (klass)->finalize = music_libraries_manager_finalize;
#line 1242 "LibrariesManager.c"
	/**
	     * Headless playlists are playlists that are not linked to a library.
	     */
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_ADD_HEADLESS_PLAYLIST_SIGNAL] = g_signal_new ("add-headless-playlist", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL] = g_signal_new ("library-removed", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_LIBRARY);
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL] = g_signal_new ("library-added", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_LIBRARY);
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_CANCEL_TRANSFER_SIGNAL] = g_signal_new ("cancel-transfer", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/LibrariesManager.vala"
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_OPERATION_TERMINATED_SIGNAL] = g_signal_new ("operation-terminated", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1256 "LibrariesManager.c"
}

static void
music_libraries_manager_instance_init (MusicLibrariesManager * self,
                                       gpointer klass)
{
#line 29 "../core/LibrariesManager.vala"
	self->priv = music_libraries_manager_get_instance_private (self);
#line 43 "../core/LibrariesManager.vala"
	self->priv->old_search = NULL;
#line 46 "../core/LibrariesManager.vala"
	self->priv->current_index = 0;
#line 1269 "LibrariesManager.c"
}

static void
music_libraries_manager_finalize (GObject * obj)
{
	MusicLibrariesManager * self;
#line 29 "../core/LibrariesManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARIES_MANAGER, MusicLibrariesManager);
#line 42 "../core/LibrariesManager.vala"
	_g_free0 (self->current_operation);
#line 43 "../core/LibrariesManager.vala"
	_g_free0 (self->priv->old_search);
#line 45 "../core/LibrariesManager.vala"
	_g_object_unref0 (self->priv->libraries);
#line 47 "../core/LibrariesManager.vala"
	_g_object_unref0 (self->local_library);
#line 29 "../core/LibrariesManager.vala"
	G_OBJECT_CLASS (music_libraries_manager_parent_class)->finalize (obj);
#line 1288 "LibrariesManager.c"
}

static GType
music_libraries_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibrariesManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_libraries_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibrariesManager), 0, (GInstanceInitFunc) music_libraries_manager_instance_init, NULL };
	GType music_libraries_manager_type_id;
	music_libraries_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicLibrariesManager", &g_define_type_info, 0);
	MusicLibrariesManager_private_offset = g_type_add_instance_private (music_libraries_manager_type_id, sizeof (MusicLibrariesManagerPrivate));
	return music_libraries_manager_type_id;
}

GType
music_libraries_manager_get_type (void)
{
	static volatile gsize music_libraries_manager_type_id__once = 0;
	if (g_once_init_enter (&music_libraries_manager_type_id__once)) {
		GType music_libraries_manager_type_id;
		music_libraries_manager_type_id = music_libraries_manager_get_type_once ();
		g_once_init_leave (&music_libraries_manager_type_id__once, music_libraries_manager_type_id);
	}
	return music_libraries_manager_type_id__once;
}

