/* Library.c generated by valac 0.56.0, the Vala compiler
 * generated from Library.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

enum  {
	MUSIC_LIBRARY_0_PROPERTY,
	MUSIC_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_library_properties[MUSIC_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_LIBRARY_FILE_OPERATIONS_STARTED_SIGNAL,
	MUSIC_LIBRARY_FILE_OPERATIONS_DONE_SIGNAL,
	MUSIC_LIBRARY_MEDIA_ADDED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_UPDATED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_REMOVED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_IMPORTED_SIGNAL,
	MUSIC_LIBRARY_SEARCH_FINISHED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_ADDED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_NAME_UPDATED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_REMOVED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_ADDED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_NAME_UPDATED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_REMOVED_SIGNAL,
	MUSIC_LIBRARY_NUM_SIGNALS
};
static guint music_library_signals[MUSIC_LIBRARY_NUM_SIGNALS] = {0};

static gpointer music_library_parent_class = NULL;

static void music_library_real_initialize_library (MusicLibrary* self);
static void music_library_real_add_files_to_library (MusicLibrary* self,
                                              GeeCollection* files);
static GeeCollection* music_library_real_get_medias (MusicLibrary* self);
static GeeCollection* music_library_real_get_playlists (MusicLibrary* self);
static GeeCollection* music_library_real_get_smart_playlists (MusicLibrary* self);
static void music_library_real_search_medias (MusicLibrary* self,
                                       const gchar* search);
static GeeCollection* music_library_real_get_search_result (MusicLibrary* self);
static void music_library_real_add_media (MusicLibrary* self,
                                   MusicMedia* s);
static void music_library_real_add_medias (MusicLibrary* self,
                                    GeeCollection* new_media);
static MusicMedia* music_library_real_find_media (MusicLibrary* self,
                                           MusicMedia* to_find);
static MusicMedia* music_library_real_media_from_file (MusicLibrary* self,
                                                GFile* file);
static MusicMedia* music_library_real_media_from_uri (MusicLibrary* self,
                                               const gchar* uri);
static MusicMedia* music_library_real_media_from_id (MusicLibrary* self,
                                              gint64 id);
static GeeCollection* music_library_real_medias_from_uris (MusicLibrary* self,
                                                    GeeCollection* uris);
static GeeCollection* music_library_real_medias_from_ids (MusicLibrary* self,
                                                   GeeCollection* ids);
static void music_library_real_update_media (MusicLibrary* self,
                                      MusicMedia* s,
                                      gboolean update_meta,
                                      gboolean record_time);
static void music_library_real_update_medias (MusicLibrary* self,
                                       GeeCollection* updates,
                                       gboolean update_meta,
                                       gboolean record_time);
static void music_library_real_remove_media (MusicLibrary* self,
                                      MusicMedia* s,
                                      gboolean trash);
static void music_library_real_remove_medias (MusicLibrary* self,
                                       GeeCollection* to_remove,
                                       gboolean trash);
static gboolean music_library_real_support_smart_playlists (MusicLibrary* self);
static void music_library_real_add_smart_playlist (MusicLibrary* self,
                                            MusicSmartPlaylist* p);
static void music_library_real_remove_smart_playlist (MusicLibrary* self,
                                               gint64 id);
static MusicSmartPlaylist* music_library_real_smart_playlist_from_id (MusicLibrary* self,
                                                               gint64 id);
static MusicSmartPlaylist* music_library_real_smart_playlist_from_name (MusicLibrary* self,
                                                                 const gchar* name);
static gboolean music_library_real_support_playlists (MusicLibrary* self);
static void music_library_real_add_playlist (MusicLibrary* self,
                                      MusicStaticPlaylist* p);
static void music_library_real_remove_playlist (MusicLibrary* self,
                                         gint64 id);
static MusicStaticPlaylist* music_library_real_playlist_from_id (MusicLibrary* self,
                                                          gint64 id);
static MusicStaticPlaylist* music_library_real_playlist_from_name (MusicLibrary* self,
                                                            const gchar* name);
static gboolean music_library_real_start_file_operations (MusicLibrary* self,
                                                   const gchar* message);
static gboolean music_library_real_doing_file_operations (MusicLibrary* self);
static void music_library_real_finish_file_operations (MusicLibrary* self);
static GType music_library_get_type_once (void);

static void
music_library_real_initialize_library (MusicLibrary* self)
{
#line 52 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_initialize_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 52 "../core/Library.vala"
	return;
#line 137 "Library.c"
}

void
music_library_initialize_library (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 52 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 52 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 52 "../core/Library.vala"
	if (_klass_->initialize_library) {
#line 52 "../core/Library.vala"
		_klass_->initialize_library (self);
#line 152 "Library.c"
	}
}

static void
music_library_real_add_files_to_library (MusicLibrary* self,
                                         GeeCollection* files)
{
#line 53 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_add_files_to_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "../core/Library.vala"
	return;
#line 164 "Library.c"
}

void
music_library_add_files_to_library (MusicLibrary* self,
                                    GeeCollection* files)
{
	MusicLibraryClass* _klass_;
#line 53 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 53 "../core/Library.vala"
	if (_klass_->add_files_to_library) {
#line 53 "../core/Library.vala"
		_klass_->add_files_to_library (self, files);
#line 180 "Library.c"
	}
}

static GeeCollection*
music_library_real_get_medias (MusicLibrary* self)
{
#line 55 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_get_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 55 "../core/Library.vala"
	return NULL;
#line 191 "Library.c"
}

GeeCollection*
music_library_get_medias (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 55 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 55 "../core/Library.vala"
	if (_klass_->get_medias) {
#line 55 "../core/Library.vala"
		return _klass_->get_medias (self);
#line 206 "Library.c"
	}
#line 55 "../core/Library.vala"
	return NULL;
#line 210 "Library.c"
}

static GeeCollection*
music_library_real_get_playlists (MusicLibrary* self)
{
#line 56 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_get_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "../core/Library.vala"
	return NULL;
#line 220 "Library.c"
}

GeeCollection*
music_library_get_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 56 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 56 "../core/Library.vala"
	if (_klass_->get_playlists) {
#line 56 "../core/Library.vala"
		return _klass_->get_playlists (self);
#line 235 "Library.c"
	}
#line 56 "../core/Library.vala"
	return NULL;
#line 239 "Library.c"
}

static GeeCollection*
music_library_real_get_smart_playlists (MusicLibrary* self)
{
#line 57 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_get_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 57 "../core/Library.vala"
	return NULL;
#line 249 "Library.c"
}

GeeCollection*
music_library_get_smart_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 57 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 57 "../core/Library.vala"
	if (_klass_->get_smart_playlists) {
#line 57 "../core/Library.vala"
		return _klass_->get_smart_playlists (self);
#line 264 "Library.c"
	}
#line 57 "../core/Library.vala"
	return NULL;
#line 268 "Library.c"
}

static void
music_library_real_search_medias (MusicLibrary* self,
                                  const gchar* search)
{
#line 59 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_search_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 59 "../core/Library.vala"
	return;
#line 279 "Library.c"
}

void
music_library_search_medias (MusicLibrary* self,
                             const gchar* search)
{
	MusicLibraryClass* _klass_;
#line 59 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 59 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 59 "../core/Library.vala"
	if (_klass_->search_medias) {
#line 59 "../core/Library.vala"
		_klass_->search_medias (self, search);
#line 295 "Library.c"
	}
}

static GeeCollection*
music_library_real_get_search_result (MusicLibrary* self)
{
#line 60 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_get_search_result'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 60 "../core/Library.vala"
	return NULL;
#line 306 "Library.c"
}

GeeCollection*
music_library_get_search_result (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 60 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 60 "../core/Library.vala"
	if (_klass_->get_search_result) {
#line 60 "../core/Library.vala"
		return _klass_->get_search_result (self);
#line 321 "Library.c"
	}
#line 60 "../core/Library.vala"
	return NULL;
#line 325 "Library.c"
}

static void
music_library_real_add_media (MusicLibrary* self,
                              MusicMedia* s)
{
#line 62 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 62 "../core/Library.vala"
	return;
#line 336 "Library.c"
}

void
music_library_add_media (MusicLibrary* self,
                         MusicMedia* s)
{
	MusicLibraryClass* _klass_;
#line 62 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 62 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 62 "../core/Library.vala"
	if (_klass_->add_media) {
#line 62 "../core/Library.vala"
		_klass_->add_media (self, s);
#line 352 "Library.c"
	}
}

static void
music_library_real_add_medias (MusicLibrary* self,
                               GeeCollection* new_media)
{
#line 63 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 63 "../core/Library.vala"
	return;
#line 364 "Library.c"
}

void
music_library_add_medias (MusicLibrary* self,
                          GeeCollection* new_media)
{
	MusicLibraryClass* _klass_;
#line 63 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 63 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 63 "../core/Library.vala"
	if (_klass_->add_medias) {
#line 63 "../core/Library.vala"
		_klass_->add_medias (self, new_media);
#line 380 "Library.c"
	}
}

static MusicMedia*
music_library_real_find_media (MusicLibrary* self,
                               MusicMedia* to_find)
{
#line 64 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_find_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 64 "../core/Library.vala"
	return NULL;
#line 392 "Library.c"
}

MusicMedia*
music_library_find_media (MusicLibrary* self,
                          MusicMedia* to_find)
{
	MusicLibraryClass* _klass_;
#line 64 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 64 "../core/Library.vala"
	if (_klass_->find_media) {
#line 64 "../core/Library.vala"
		return _klass_->find_media (self, to_find);
#line 408 "Library.c"
	}
#line 64 "../core/Library.vala"
	return NULL;
#line 412 "Library.c"
}

static MusicMedia*
music_library_real_media_from_file (MusicLibrary* self,
                                    GFile* file)
{
#line 65 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 65 "../core/Library.vala"
	return NULL;
#line 423 "Library.c"
}

MusicMedia*
music_library_media_from_file (MusicLibrary* self,
                               GFile* file)
{
	MusicLibraryClass* _klass_;
#line 65 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 65 "../core/Library.vala"
	if (_klass_->media_from_file) {
#line 65 "../core/Library.vala"
		return _klass_->media_from_file (self, file);
#line 439 "Library.c"
	}
#line 65 "../core/Library.vala"
	return NULL;
#line 443 "Library.c"
}

static MusicMedia*
music_library_real_media_from_uri (MusicLibrary* self,
                                   const gchar* uri)
{
#line 66 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_uri'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 66 "../core/Library.vala"
	return NULL;
#line 454 "Library.c"
}

MusicMedia*
music_library_media_from_uri (MusicLibrary* self,
                              const gchar* uri)
{
	MusicLibraryClass* _klass_;
#line 66 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 66 "../core/Library.vala"
	if (_klass_->media_from_uri) {
#line 66 "../core/Library.vala"
		return _klass_->media_from_uri (self, uri);
#line 470 "Library.c"
	}
#line 66 "../core/Library.vala"
	return NULL;
#line 474 "Library.c"
}

static MusicMedia*
music_library_real_media_from_id (MusicLibrary* self,
                                  gint64 id)
{
#line 67 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 67 "../core/Library.vala"
	return NULL;
#line 485 "Library.c"
}

MusicMedia*
music_library_media_from_id (MusicLibrary* self,
                             gint64 id)
{
	MusicLibraryClass* _klass_;
#line 67 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 67 "../core/Library.vala"
	if (_klass_->media_from_id) {
#line 67 "../core/Library.vala"
		return _klass_->media_from_id (self, id);
#line 501 "Library.c"
	}
#line 67 "../core/Library.vala"
	return NULL;
#line 505 "Library.c"
}

static GeeCollection*
music_library_real_medias_from_uris (MusicLibrary* self,
                                     GeeCollection* uris)
{
#line 68 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_medias_from_uris'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 68 "../core/Library.vala"
	return NULL;
#line 516 "Library.c"
}

GeeCollection*
music_library_medias_from_uris (MusicLibrary* self,
                                GeeCollection* uris)
{
	MusicLibraryClass* _klass_;
#line 68 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 68 "../core/Library.vala"
	if (_klass_->medias_from_uris) {
#line 68 "../core/Library.vala"
		return _klass_->medias_from_uris (self, uris);
#line 532 "Library.c"
	}
#line 68 "../core/Library.vala"
	return NULL;
#line 536 "Library.c"
}

static GeeCollection*
music_library_real_medias_from_ids (MusicLibrary* self,
                                    GeeCollection* ids)
{
#line 69 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_medias_from_ids'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 69 "../core/Library.vala"
	return NULL;
#line 547 "Library.c"
}

GeeCollection*
music_library_medias_from_ids (MusicLibrary* self,
                               GeeCollection* ids)
{
	MusicLibraryClass* _klass_;
#line 69 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 69 "../core/Library.vala"
	if (_klass_->medias_from_ids) {
#line 69 "../core/Library.vala"
		return _klass_->medias_from_ids (self, ids);
#line 563 "Library.c"
	}
#line 69 "../core/Library.vala"
	return NULL;
#line 567 "Library.c"
}

static void
music_library_real_update_media (MusicLibrary* self,
                                 MusicMedia* s,
                                 gboolean update_meta,
                                 gboolean record_time)
{
#line 70 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_update_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 70 "../core/Library.vala"
	return;
#line 580 "Library.c"
}

void
music_library_update_media (MusicLibrary* self,
                            MusicMedia* s,
                            gboolean update_meta,
                            gboolean record_time)
{
	MusicLibraryClass* _klass_;
#line 70 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 70 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 70 "../core/Library.vala"
	if (_klass_->update_media) {
#line 70 "../core/Library.vala"
		_klass_->update_media (self, s, update_meta, record_time);
#line 598 "Library.c"
	}
}

static void
music_library_real_update_medias (MusicLibrary* self,
                                  GeeCollection* updates,
                                  gboolean update_meta,
                                  gboolean record_time)
{
#line 71 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_update_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 71 "../core/Library.vala"
	return;
#line 612 "Library.c"
}

void
music_library_update_medias (MusicLibrary* self,
                             GeeCollection* updates,
                             gboolean update_meta,
                             gboolean record_time)
{
	MusicLibraryClass* _klass_;
#line 71 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 71 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 71 "../core/Library.vala"
	if (_klass_->update_medias) {
#line 71 "../core/Library.vala"
		_klass_->update_medias (self, updates, update_meta, record_time);
#line 630 "Library.c"
	}
}

static void
music_library_real_remove_media (MusicLibrary* self,
                                 MusicMedia* s,
                                 gboolean trash)
{
#line 72 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 72 "../core/Library.vala"
	return;
#line 643 "Library.c"
}

void
music_library_remove_media (MusicLibrary* self,
                            MusicMedia* s,
                            gboolean trash)
{
	MusicLibraryClass* _klass_;
#line 72 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 72 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 72 "../core/Library.vala"
	if (_klass_->remove_media) {
#line 72 "../core/Library.vala"
		_klass_->remove_media (self, s, trash);
#line 660 "Library.c"
	}
}

static void
music_library_real_remove_medias (MusicLibrary* self,
                                  GeeCollection* to_remove,
                                  gboolean trash)
{
#line 73 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 73 "../core/Library.vala"
	return;
#line 673 "Library.c"
}

void
music_library_remove_medias (MusicLibrary* self,
                             GeeCollection* to_remove,
                             gboolean trash)
{
	MusicLibraryClass* _klass_;
#line 73 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 73 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 73 "../core/Library.vala"
	if (_klass_->remove_medias) {
#line 73 "../core/Library.vala"
		_klass_->remove_medias (self, to_remove, trash);
#line 690 "Library.c"
	}
}

static gboolean
music_library_real_support_smart_playlists (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
#line 75 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_support_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 75 "../core/Library.vala"
	return _tmp0_;
#line 702 "Library.c"
}

gboolean
music_library_support_smart_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 75 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 75 "../core/Library.vala"
	if (_klass_->support_smart_playlists) {
#line 75 "../core/Library.vala"
		return _klass_->support_smart_playlists (self);
#line 717 "Library.c"
	}
#line 75 "../core/Library.vala"
	return FALSE;
#line 721 "Library.c"
}

static void
music_library_real_add_smart_playlist (MusicLibrary* self,
                                       MusicSmartPlaylist* p)
{
#line 76 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_add_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 76 "../core/Library.vala"
	return;
#line 732 "Library.c"
}

void
music_library_add_smart_playlist (MusicLibrary* self,
                                  MusicSmartPlaylist* p)
{
	MusicLibraryClass* _klass_;
#line 76 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 76 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 76 "../core/Library.vala"
	if (_klass_->add_smart_playlist) {
#line 76 "../core/Library.vala"
		_klass_->add_smart_playlist (self, p);
#line 748 "Library.c"
	}
}

static void
music_library_real_remove_smart_playlist (MusicLibrary* self,
                                          gint64 id)
{
#line 77 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 77 "../core/Library.vala"
	return;
#line 760 "Library.c"
}

void
music_library_remove_smart_playlist (MusicLibrary* self,
                                     gint64 id)
{
	MusicLibraryClass* _klass_;
#line 77 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 77 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 77 "../core/Library.vala"
	if (_klass_->remove_smart_playlist) {
#line 77 "../core/Library.vala"
		_klass_->remove_smart_playlist (self, id);
#line 776 "Library.c"
	}
}

static MusicSmartPlaylist*
music_library_real_smart_playlist_from_id (MusicLibrary* self,
                                           gint64 id)
{
#line 78 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_smart_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 78 "../core/Library.vala"
	return NULL;
#line 788 "Library.c"
}

MusicSmartPlaylist*
music_library_smart_playlist_from_id (MusicLibrary* self,
                                      gint64 id)
{
	MusicLibraryClass* _klass_;
#line 78 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 78 "../core/Library.vala"
	if (_klass_->smart_playlist_from_id) {
#line 78 "../core/Library.vala"
		return _klass_->smart_playlist_from_id (self, id);
#line 804 "Library.c"
	}
#line 78 "../core/Library.vala"
	return NULL;
#line 808 "Library.c"
}

static MusicSmartPlaylist*
music_library_real_smart_playlist_from_name (MusicLibrary* self,
                                             const gchar* name)
{
#line 79 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_smart_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 79 "../core/Library.vala"
	return NULL;
#line 819 "Library.c"
}

MusicSmartPlaylist*
music_library_smart_playlist_from_name (MusicLibrary* self,
                                        const gchar* name)
{
	MusicLibraryClass* _klass_;
#line 79 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 79 "../core/Library.vala"
	if (_klass_->smart_playlist_from_name) {
#line 79 "../core/Library.vala"
		return _klass_->smart_playlist_from_name (self, name);
#line 835 "Library.c"
	}
#line 79 "../core/Library.vala"
	return NULL;
#line 839 "Library.c"
}

static gboolean
music_library_real_support_playlists (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
#line 81 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_support_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 81 "../core/Library.vala"
	return _tmp0_;
#line 850 "Library.c"
}

gboolean
music_library_support_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 81 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 81 "../core/Library.vala"
	if (_klass_->support_playlists) {
#line 81 "../core/Library.vala"
		return _klass_->support_playlists (self);
#line 865 "Library.c"
	}
#line 81 "../core/Library.vala"
	return FALSE;
#line 869 "Library.c"
}

static void
music_library_real_add_playlist (MusicLibrary* self,
                                 MusicStaticPlaylist* p)
{
#line 82 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_add_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 82 "../core/Library.vala"
	return;
#line 880 "Library.c"
}

void
music_library_add_playlist (MusicLibrary* self,
                            MusicStaticPlaylist* p)
{
	MusicLibraryClass* _klass_;
#line 82 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 82 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 82 "../core/Library.vala"
	if (_klass_->add_playlist) {
#line 82 "../core/Library.vala"
		_klass_->add_playlist (self, p);
#line 896 "Library.c"
	}
}

static void
music_library_real_remove_playlist (MusicLibrary* self,
                                    gint64 id)
{
#line 83 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 83 "../core/Library.vala"
	return;
#line 908 "Library.c"
}

void
music_library_remove_playlist (MusicLibrary* self,
                               gint64 id)
{
	MusicLibraryClass* _klass_;
#line 83 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 83 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 83 "../core/Library.vala"
	if (_klass_->remove_playlist) {
#line 83 "../core/Library.vala"
		_klass_->remove_playlist (self, id);
#line 924 "Library.c"
	}
}

static MusicStaticPlaylist*
music_library_real_playlist_from_id (MusicLibrary* self,
                                     gint64 id)
{
#line 84 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 84 "../core/Library.vala"
	return NULL;
#line 936 "Library.c"
}

MusicStaticPlaylist*
music_library_playlist_from_id (MusicLibrary* self,
                                gint64 id)
{
	MusicLibraryClass* _klass_;
#line 84 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 84 "../core/Library.vala"
	if (_klass_->playlist_from_id) {
#line 84 "../core/Library.vala"
		return _klass_->playlist_from_id (self, id);
#line 952 "Library.c"
	}
#line 84 "../core/Library.vala"
	return NULL;
#line 956 "Library.c"
}

static MusicStaticPlaylist*
music_library_real_playlist_from_name (MusicLibrary* self,
                                       const gchar* name)
{
#line 85 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 85 "../core/Library.vala"
	return NULL;
#line 967 "Library.c"
}

MusicStaticPlaylist*
music_library_playlist_from_name (MusicLibrary* self,
                                  const gchar* name)
{
	MusicLibraryClass* _klass_;
#line 85 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 85 "../core/Library.vala"
	if (_klass_->playlist_from_name) {
#line 85 "../core/Library.vala"
		return _klass_->playlist_from_name (self, name);
#line 983 "Library.c"
	}
#line 85 "../core/Library.vala"
	return NULL;
#line 987 "Library.c"
}

static gboolean
music_library_real_start_file_operations (MusicLibrary* self,
                                          const gchar* message)
{
	gboolean _tmp0_ = FALSE;
#line 87 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_start_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 87 "../core/Library.vala"
	return _tmp0_;
#line 999 "Library.c"
}

gboolean
music_library_start_file_operations (MusicLibrary* self,
                                     const gchar* message)
{
	MusicLibraryClass* _klass_;
#line 87 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 87 "../core/Library.vala"
	if (_klass_->start_file_operations) {
#line 87 "../core/Library.vala"
		return _klass_->start_file_operations (self, message);
#line 1015 "Library.c"
	}
#line 87 "../core/Library.vala"
	return FALSE;
#line 1019 "Library.c"
}

static gboolean
music_library_real_doing_file_operations (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
#line 88 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_doing_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 88 "../core/Library.vala"
	return _tmp0_;
#line 1030 "Library.c"
}

gboolean
music_library_doing_file_operations (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 88 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 88 "../core/Library.vala"
	if (_klass_->doing_file_operations) {
#line 88 "../core/Library.vala"
		return _klass_->doing_file_operations (self);
#line 1045 "Library.c"
	}
#line 88 "../core/Library.vala"
	return FALSE;
#line 1049 "Library.c"
}

static void
music_library_real_finish_file_operations (MusicLibrary* self)
{
#line 89 "../core/Library.vala"
	g_critical ("Type `%s' does not implement abstract method `music_library_finish_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 89 "../core/Library.vala"
	return;
#line 1059 "Library.c"
}

void
music_library_finish_file_operations (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
#line 89 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 89 "../core/Library.vala"
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
#line 89 "../core/Library.vala"
	if (_klass_->finish_file_operations) {
#line 89 "../core/Library.vala"
		_klass_->finish_file_operations (self);
#line 1074 "Library.c"
	}
}

gint
music_library_playlist_count_without_read_only (MusicLibrary* self)
{
	gint i = 0;
	gint result;
#line 91 "../core/Library.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "../core/Library.vala"
	i = 0;
#line 1087 "Library.c"
	{
		GeeIterator* _p_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 93 "../core/Library.vala"
		_tmp0_ = music_library_get_playlists (self);
#line 93 "../core/Library.vala"
		_tmp1_ = _tmp0_;
#line 93 "../core/Library.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 93 "../core/Library.vala"
		_tmp3_ = _tmp2_;
#line 93 "../core/Library.vala"
		_g_object_unref0 (_tmp1_);
#line 93 "../core/Library.vala"
		_p_it = _tmp3_;
#line 93 "../core/Library.vala"
		while (TRUE) {
#line 1108 "Library.c"
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 93 "../core/Library.vala"
			_tmp4_ = _p_it;
#line 93 "../core/Library.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 93 "../core/Library.vala"
				break;
#line 1122 "Library.c"
			}
#line 93 "../core/Library.vala"
			_tmp5_ = _p_it;
#line 93 "../core/Library.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 93 "../core/Library.vala"
			p = (MusicStaticPlaylist*) _tmp6_;
#line 94 "../core/Library.vala"
			_tmp7_ = p;
#line 94 "../core/Library.vala"
			_tmp8_ = music_static_playlist_get_read_only (_tmp7_);
#line 94 "../core/Library.vala"
			_tmp9_ = _tmp8_;
#line 94 "../core/Library.vala"
			if (_tmp9_ == FALSE) {
#line 1138 "Library.c"
				gint _tmp10_;
#line 95 "../core/Library.vala"
				_tmp10_ = i;
#line 95 "../core/Library.vala"
				i = _tmp10_ + 1;
#line 1144 "Library.c"
			}
#line 93 "../core/Library.vala"
			_g_object_unref0 (p);
#line 1148 "Library.c"
		}
#line 93 "../core/Library.vala"
		_g_object_unref0 (_p_it);
#line 1152 "Library.c"
	}
#line 97 "../core/Library.vala"
	result = i;
#line 97 "../core/Library.vala"
	return result;
#line 1158 "Library.c"
}

void
music_library_media_from_name (MusicLibrary* self,
                               GeeCollection* tests,
                               GeeCollection* found,
                               GeeCollection* not_found)
{
#line 100 "../core/Library.vala"
	g_return_if_fail (self != NULL);
#line 100 "../core/Library.vala"
	g_return_if_fail (tests != NULL);
#line 100 "../core/Library.vala"
	g_return_if_fail (found != NULL);
#line 100 "../core/Library.vala"
	g_return_if_fail (not_found != NULL);
#line 1175 "Library.c"
	{
		GeeIterator* _test_it = NULL;
		GeeIterator* _tmp0_;
#line 101 "../core/Library.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) tests);
#line 101 "../core/Library.vala"
		_test_it = _tmp0_;
#line 101 "../core/Library.vala"
		while (TRUE) {
#line 1185 "Library.c"
			GeeIterator* _tmp1_;
			MusicMedia* test = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MusicMedia* media_found = NULL;
			MusicMedia* _tmp4_;
			MusicMedia* _tmp5_;
			MusicMedia* _tmp6_;
#line 101 "../core/Library.vala"
			_tmp1_ = _test_it;
#line 101 "../core/Library.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 101 "../core/Library.vala"
				break;
#line 1200 "Library.c"
			}
#line 101 "../core/Library.vala"
			_tmp2_ = _test_it;
#line 101 "../core/Library.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 101 "../core/Library.vala"
			test = (MusicMedia*) _tmp3_;
#line 102 "../core/Library.vala"
			_tmp4_ = test;
#line 102 "../core/Library.vala"
			_tmp5_ = music_library_find_media (self, _tmp4_);
#line 102 "../core/Library.vala"
			media_found = _tmp5_;
#line 103 "../core/Library.vala"
			_tmp6_ = media_found;
#line 103 "../core/Library.vala"
			if (_tmp6_ != NULL) {
#line 1218 "Library.c"
				MusicMedia* _tmp7_;
				gint64 _tmp8_;
				gint64 _tmp9_;
#line 104 "../core/Library.vala"
				_tmp7_ = media_found;
#line 104 "../core/Library.vala"
				_tmp8_ = music_media_get_rowid (_tmp7_);
#line 104 "../core/Library.vala"
				_tmp9_ = _tmp8_;
#line 104 "../core/Library.vala"
				gee_collection_add (found, &_tmp9_);
#line 1230 "Library.c"
			} else {
				MusicMedia* _tmp10_;
#line 106 "../core/Library.vala"
				_tmp10_ = test;
#line 106 "../core/Library.vala"
				gee_collection_add (not_found, _tmp10_);
#line 1237 "Library.c"
			}
#line 101 "../core/Library.vala"
			_g_object_unref0 (media_found);
#line 101 "../core/Library.vala"
			_g_object_unref0 (test);
#line 1243 "Library.c"
		}
#line 101 "../core/Library.vala"
		_g_object_unref0 (_test_it);
#line 1247 "Library.c"
	}
}

MusicLibrary*
music_library_construct (GType object_type)
{
	MusicLibrary * self = NULL;
#line 29 "../core/Library.vala"
	self = (MusicLibrary*) g_object_new (object_type, NULL);
#line 29 "../core/Library.vala"
	return self;
#line 1259 "Library.c"
}

static void
music_library_class_init (MusicLibraryClass * klass,
                          gpointer klass_data)
{
#line 29 "../core/Library.vala"
	music_library_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_library_real_initialize_library;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_library_real_add_files_to_library;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_medias;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_playlists;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_smart_playlists;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_library_real_search_medias;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_search_result;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_library_real_add_media;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_library_real_add_medias;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_library_real_find_media;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_library_real_media_from_file;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_library_real_media_from_uri;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_library_real_media_from_id;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_library_real_medias_from_uris;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_library_real_medias_from_ids;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_library_real_update_media;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_library_real_update_medias;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_library_real_remove_media;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_library_real_remove_medias;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_library_real_support_smart_playlists;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_library_real_add_smart_playlist;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_library_real_remove_smart_playlist;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_library_real_smart_playlist_from_id;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_library_real_smart_playlist_from_name;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_library_real_support_playlists;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_library_real_add_playlist;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_library_real_remove_playlist;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_library_real_playlist_from_id;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_library_real_playlist_from_name;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_library_real_start_file_operations;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_library_real_doing_file_operations;
#line 29 "../core/Library.vala"
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_library_real_finish_file_operations;
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_FILE_OPERATIONS_STARTED_SIGNAL] = g_signal_new ("file-operations-started", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_FILE_OPERATIONS_DONE_SIGNAL] = g_signal_new ("file-operations-done", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_MEDIA_ADDED_SIGNAL] = g_signal_new ("media-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_MEDIA_UPDATED_SIGNAL] = g_signal_new ("media-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_MEDIA_REMOVED_SIGNAL] = g_signal_new ("media-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_SEARCH_FINISHED_SIGNAL] = g_signal_new ("search-finished", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_ADDED_SIGNAL] = g_signal_new ("playlist-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_NAME_UPDATED_SIGNAL] = g_signal_new ("playlist-name-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_REMOVED_SIGNAL] = g_signal_new ("playlist-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_ADDED_SIGNAL] = g_signal_new ("smartplaylist-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_NAME_UPDATED_SIGNAL] = g_signal_new ("smartplaylist-name-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
#line 29 "../core/Library.vala"
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_REMOVED_SIGNAL] = g_signal_new ("smartplaylist-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
#line 1358 "Library.c"
}

static void
music_library_instance_init (MusicLibrary * self,
                             gpointer klass)
{
}

static GType
music_library_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibrary), 0, (GInstanceInitFunc) music_library_instance_init, NULL };
	GType music_library_type_id;
	music_library_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicLibrary", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return music_library_type_id;
}

GType
music_library_get_type (void)
{
	static volatile gsize music_library_type_id__once = 0;
	if (g_once_init_enter (&music_library_type_id__once)) {
		GType music_library_type_id;
		music_library_type_id = music_library_get_type_once ();
		g_once_init_leave (&music_library_type_id__once, music_library_type_id);
	}
	return music_library_type_id__once;
}

