/* Playlist.c generated by valac 0.56.0, the Vala compiler
 * generated from Playlist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_PLAYLIST_0_PROPERTY,
	MUSIC_PLAYLIST_MEDIAS_PROPERTY,
	MUSIC_PLAYLIST_ROWID_PROPERTY,
	MUSIC_PLAYLIST_NAME_PROPERTY,
	MUSIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_playlist_properties[MUSIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PLAYLIST_REQUEST_PLAY_SIGNAL,
	MUSIC_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_PLAYLIST_MEDIA_REMOVED_SIGNAL,
	MUSIC_PLAYLIST_UPDATED_SIGNAL,
	MUSIC_PLAYLIST_CLEARED_SIGNAL,
	MUSIC_PLAYLIST_NUM_SIGNALS
};
static guint music_playlist_signals[MUSIC_PLAYLIST_NUM_SIGNALS] = {0};

struct _MusicPlaylistPrivate {
	GeeArrayList* _medias;
	gint64 _rowid;
};

static gint MusicPlaylist_private_offset;
static gpointer music_playlist_parent_class = NULL;

VALA_EXTERN void music_playlist_set_medias (MusicPlaylist* self,
                                GeeArrayList* value);
static void music_playlist_real_add_media (MusicPlaylist* self,
                                    MusicMedia* to_remove);
static void music_playlist_real_add_medias (MusicPlaylist* self,
                                     GeeCollection* to_add);
static void music_playlist_real_remove_media (MusicPlaylist* self,
                                       MusicMedia* to_remove);
static void music_playlist_real_remove_medias (MusicPlaylist* self,
                                        GeeCollection* to_remove);
static void music_playlist_real_clear (MusicPlaylist* self);
static void music_playlist_finalize (GObject * obj);
static GType music_playlist_get_type_once (void);
static void _vala_music_playlist_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_music_playlist_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
music_playlist_get_instance_private (MusicPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaylist_private_offset);
}

static void
music_playlist_real_add_media (MusicPlaylist* self,
                               MusicMedia* to_remove)
{
#line 53 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `music_playlist_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 53 "../core/Playlists/Playlist.vala"
	return;
#line 104 "Playlist.c"
}

void
music_playlist_add_media (MusicPlaylist* self,
                          MusicMedia* to_remove)
{
	MusicPlaylistClass* _klass_;
#line 53 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 53 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 53 "../core/Playlists/Playlist.vala"
	if (_klass_->add_media) {
#line 53 "../core/Playlists/Playlist.vala"
		_klass_->add_media (self, to_remove);
#line 120 "Playlist.c"
	}
}

static void
music_playlist_real_add_medias (MusicPlaylist* self,
                                GeeCollection* to_add)
{
#line 54 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `music_playlist_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 54 "../core/Playlists/Playlist.vala"
	return;
#line 132 "Playlist.c"
}

void
music_playlist_add_medias (MusicPlaylist* self,
                           GeeCollection* to_add)
{
	MusicPlaylistClass* _klass_;
#line 54 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 54 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 54 "../core/Playlists/Playlist.vala"
	if (_klass_->add_medias) {
#line 54 "../core/Playlists/Playlist.vala"
		_klass_->add_medias (self, to_add);
#line 148 "Playlist.c"
	}
}

static void
music_playlist_real_remove_media (MusicPlaylist* self,
                                  MusicMedia* to_remove)
{
#line 55 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `music_playlist_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 55 "../core/Playlists/Playlist.vala"
	return;
#line 160 "Playlist.c"
}

void
music_playlist_remove_media (MusicPlaylist* self,
                             MusicMedia* to_remove)
{
	MusicPlaylistClass* _klass_;
#line 55 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 55 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 55 "../core/Playlists/Playlist.vala"
	if (_klass_->remove_media) {
#line 55 "../core/Playlists/Playlist.vala"
		_klass_->remove_media (self, to_remove);
#line 176 "Playlist.c"
	}
}

static void
music_playlist_real_remove_medias (MusicPlaylist* self,
                                   GeeCollection* to_remove)
{
#line 56 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `music_playlist_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 56 "../core/Playlists/Playlist.vala"
	return;
#line 188 "Playlist.c"
}

void
music_playlist_remove_medias (MusicPlaylist* self,
                              GeeCollection* to_remove)
{
	MusicPlaylistClass* _klass_;
#line 56 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 56 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 56 "../core/Playlists/Playlist.vala"
	if (_klass_->remove_medias) {
#line 56 "../core/Playlists/Playlist.vala"
		_klass_->remove_medias (self, to_remove);
#line 204 "Playlist.c"
	}
}

static void
music_playlist_real_clear (MusicPlaylist* self)
{
#line 57 "../core/Playlists/Playlist.vala"
	g_critical ("Type `%s' does not implement abstract method `music_playlist_clear'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 57 "../core/Playlists/Playlist.vala"
	return;
#line 215 "Playlist.c"
}

void
music_playlist_clear (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
#line 57 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 57 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 57 "../core/Playlists/Playlist.vala"
	if (_klass_->clear) {
#line 57 "../core/Playlists/Playlist.vala"
		_klass_->clear (self);
#line 230 "Playlist.c"
	}
}

gboolean
music_playlist_is_empty (MusicPlaylist* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 59 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp0_ = music_playlist_get_medias (self);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 60 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 60 "../core/Playlists/Playlist.vala"
	_tmp3_ = _tmp2_;
#line 60 "../core/Playlists/Playlist.vala"
	result = _tmp3_ <= 0;
#line 60 "../core/Playlists/Playlist.vala"
	return result;
#line 256 "Playlist.c"
}

/**
    * Retrives a Media at an index in this playlist
    */
MusicMedia*
music_playlist_get (MusicPlaylist* self,
                    gint index)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	MusicMedia* result;
#line 66 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../core/Playlists/Playlist.vala"
	_tmp0_ = music_playlist_get_medias (self);
#line 67 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 67 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, index);
#line 67 "../core/Playlists/Playlist.vala"
	result = (MusicMedia*) _tmp2_;
#line 67 "../core/Playlists/Playlist.vala"
	return result;
#line 282 "Playlist.c"
}

void
music_playlist_set (MusicPlaylist* self,
                    gint index,
                    MusicMedia* m)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 70 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 70 "../core/Playlists/Playlist.vala"
	g_return_if_fail (m != NULL);
#line 71 "../core/Playlists/Playlist.vala"
	_tmp0_ = music_playlist_get_medias (self);
#line 71 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 71 "../core/Playlists/Playlist.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp1_, index, m);
#line 302 "Playlist.c"
}

GeeIterator*
music_playlist_iterator (MusicPlaylist* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* result;
#line 74 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../core/Playlists/Playlist.vala"
	_tmp0_ = music_playlist_get_medias (self);
#line 75 "../core/Playlists/Playlist.vala"
	_tmp1_ = _tmp0_;
#line 75 "../core/Playlists/Playlist.vala"
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 75 "../core/Playlists/Playlist.vala"
	result = _tmp2_;
#line 75 "../core/Playlists/Playlist.vala"
	return result;
#line 324 "Playlist.c"
}

MusicPlaylist*
music_playlist_construct (GType object_type)
{
	MusicPlaylist * self = NULL;
#line 29 "../core/Playlists/Playlist.vala"
	self = (MusicPlaylist*) g_object_new (object_type, NULL);
#line 29 "../core/Playlists/Playlist.vala"
	return self;
#line 335 "Playlist.c"
}

GeeArrayList*
music_playlist_get_medias (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
#line 32 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 32 "../core/Playlists/Playlist.vala"
	if (_klass_->get_medias) {
#line 32 "../core/Playlists/Playlist.vala"
		return _klass_->get_medias (self);
#line 350 "Playlist.c"
	}
#line 32 "../core/Playlists/Playlist.vala"
	return NULL;
#line 354 "Playlist.c"
}

static GeeArrayList*
music_playlist_real_get_medias (MusicPlaylist* base)
{
	GeeArrayList* result;
	MusicPlaylist* self;
	GeeArrayList* _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
	self = base;
#line 32 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->priv->_medias;
#line 32 "../core/Playlists/Playlist.vala"
	result = _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
	return result;
#line 371 "Playlist.c"
}

void
music_playlist_set_medias (MusicPlaylist* self,
                           GeeArrayList* value)
{
	MusicPlaylistClass* _klass_;
#line 32 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 32 "../core/Playlists/Playlist.vala"
	if (_klass_->set_medias) {
#line 32 "../core/Playlists/Playlist.vala"
		_klass_->set_medias (self, value);
#line 387 "Playlist.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../core/Playlists/Playlist.vala"
	return self ? g_object_ref (self) : NULL;
#line 396 "Playlist.c"
}

static void
music_playlist_real_set_medias (MusicPlaylist* base,
                                GeeArrayList* value)
{
	MusicPlaylist* self;
	GeeArrayList* old_value;
#line 32 "../core/Playlists/Playlist.vala"
	self = base;
#line 32 "../core/Playlists/Playlist.vala"
	old_value = music_playlist_real_get_medias (base);
#line 32 "../core/Playlists/Playlist.vala"
	if (old_value != value) {
#line 411 "Playlist.c"
		GeeArrayList* _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../core/Playlists/Playlist.vala"
		_g_object_unref0 (self->priv->_medias);
#line 32 "../core/Playlists/Playlist.vala"
		self->priv->_medias = _tmp0_;
#line 32 "../core/Playlists/Playlist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_MEDIAS_PROPERTY]);
#line 421 "Playlist.c"
	}
}

gint64
music_playlist_get_rowid (MusicPlaylist* self)
{
	gint64 result;
#line 34 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 34 "../core/Playlists/Playlist.vala"
	result = self->priv->_rowid;
#line 34 "../core/Playlists/Playlist.vala"
	return result;
#line 435 "Playlist.c"
}

void
music_playlist_set_rowid (MusicPlaylist* self,
                          gint64 value)
{
	gint64 old_value;
#line 34 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 34 "../core/Playlists/Playlist.vala"
	old_value = music_playlist_get_rowid (self);
#line 34 "../core/Playlists/Playlist.vala"
	if (old_value != value) {
#line 34 "../core/Playlists/Playlist.vala"
		self->priv->_rowid = value;
#line 34 "../core/Playlists/Playlist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_ROWID_PROPERTY]);
#line 453 "Playlist.c"
	}
}

const gchar*
music_playlist_get_name (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
#line 38 "../core/Playlists/Playlist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 38 "../core/Playlists/Playlist.vala"
	if (_klass_->get_name) {
#line 38 "../core/Playlists/Playlist.vala"
		return _klass_->get_name (self);
#line 469 "Playlist.c"
	}
#line 38 "../core/Playlists/Playlist.vala"
	return NULL;
#line 473 "Playlist.c"
}

static const gchar*
music_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicPlaylist* self;
	const gchar* _tmp0_;
#line 38 "../core/Playlists/Playlist.vala"
	self = base;
#line 39 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->_name;
#line 39 "../core/Playlists/Playlist.vala"
	result = _tmp0_;
#line 39 "../core/Playlists/Playlist.vala"
	return result;
#line 490 "Playlist.c"
}

void
music_playlist_set_name (MusicPlaylist* self,
                         const gchar* value)
{
	MusicPlaylistClass* _klass_;
#line 41 "../core/Playlists/Playlist.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Playlists/Playlist.vala"
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
#line 41 "../core/Playlists/Playlist.vala"
	if (_klass_->set_name) {
#line 41 "../core/Playlists/Playlist.vala"
		_klass_->set_name (self, value);
#line 506 "Playlist.c"
	}
}

static void
music_playlist_real_set_name (MusicPlaylist* base,
                              const gchar* value)
{
	MusicPlaylist* self;
	gchar* old_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 41 "../core/Playlists/Playlist.vala"
	self = base;
#line 42 "../core/Playlists/Playlist.vala"
	_tmp0_ = self->_name;
#line 42 "../core/Playlists/Playlist.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 42 "../core/Playlists/Playlist.vala"
	old_name = _tmp1_;
#line 43 "../core/Playlists/Playlist.vala"
	_tmp2_ = g_strdup (value);
#line 43 "../core/Playlists/Playlist.vala"
	_g_free0 (self->_name);
#line 43 "../core/Playlists/Playlist.vala"
	self->_name = _tmp2_;
#line 44 "../core/Playlists/Playlist.vala"
	g_signal_emit (self, music_playlist_signals[MUSIC_PLAYLIST_UPDATED_SIGNAL], 0, old_name);
#line 41 "../core/Playlists/Playlist.vala"
	_g_free0 (old_name);
#line 41 "../core/Playlists/Playlist.vala"
	g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_NAME_PROPERTY]);
#line 539 "Playlist.c"
}

static void
music_playlist_class_init (MusicPlaylistClass * klass,
                           gpointer klass_data)
{
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/Playlists/Playlist.vala"
	g_type_class_adjust_private_offset (klass, &MusicPlaylist_private_offset);
#line 29 "../core/Playlists/Playlist.vala"
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_playlist_real_add_media;
#line 29 "../core/Playlists/Playlist.vala"
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_playlist_real_add_medias;
#line 29 "../core/Playlists/Playlist.vala"
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_playlist_real_remove_media;
#line 29 "../core/Playlists/Playlist.vala"
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_playlist_real_remove_medias;
#line 29 "../core/Playlists/Playlist.vala"
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_playlist_real_clear;
#line 29 "../core/Playlists/Playlist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->get_medias = music_playlist_real_get_medias;
#line 29 "../core/Playlists/Playlist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->set_medias = music_playlist_real_set_medias;
#line 29 "../core/Playlists/Playlist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_playlist_real_get_name;
#line 29 "../core/Playlists/Playlist.vala"
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_playlist_real_set_name;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playlist_get_property;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playlist_set_property;
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (klass)->finalize = music_playlist_finalize;
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_MEDIAS_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_MEDIAS_PROPERTY] = g_param_spec_object ("medias", "medias", "medias", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_ROWID_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../core/Playlists/Playlist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_NAME_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_signals[MUSIC_PLAYLIST_REQUEST_PLAY_SIGNAL] = g_signal_new ("request-play", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_signals[MUSIC_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("media-added", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_signals[MUSIC_PLAYLIST_MEDIA_REMOVED_SIGNAL] = g_signal_new ("media-removed", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_signals[MUSIC_PLAYLIST_UPDATED_SIGNAL] = g_signal_new ("updated", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 29 "../core/Playlists/Playlist.vala"
	music_playlist_signals[MUSIC_PLAYLIST_CLEARED_SIGNAL] = g_signal_new ("cleared", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 590 "Playlist.c"
}

static void
music_playlist_instance_init (MusicPlaylist * self,
                              gpointer klass)
{
	GeeArrayList* _tmp0_;
	gchar* _tmp1_;
#line 29 "../core/Playlists/Playlist.vala"
	self->priv = music_playlist_get_instance_private (self);
#line 32 "../core/Playlists/Playlist.vala"
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 32 "../core/Playlists/Playlist.vala"
	self->priv->_medias = _tmp0_;
#line 36 "../core/Playlists/Playlist.vala"
	_tmp1_ = g_strdup ("");
#line 36 "../core/Playlists/Playlist.vala"
	self->_name = _tmp1_;
#line 609 "Playlist.c"
}

static void
music_playlist_finalize (GObject * obj)
{
	MusicPlaylist * self;
#line 29 "../core/Playlists/Playlist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
#line 32 "../core/Playlists/Playlist.vala"
	_g_object_unref0 (self->priv->_medias);
#line 35 "../core/Playlists/Playlist.vala"
	_g_object_unref0 (self->icon);
#line 36 "../core/Playlists/Playlist.vala"
	_g_free0 (self->_name);
#line 29 "../core/Playlists/Playlist.vala"
	G_OBJECT_CLASS (music_playlist_parent_class)->finalize (obj);
#line 626 "Playlist.c"
}

static GType
music_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaylist), 0, (GInstanceInitFunc) music_playlist_instance_init, NULL };
	GType music_playlist_type_id;
	music_playlist_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaylist", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicPlaylist_private_offset = g_type_add_instance_private (music_playlist_type_id, sizeof (MusicPlaylistPrivate));
	return music_playlist_type_id;
}

GType
music_playlist_get_type (void)
{
	static volatile gsize music_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_playlist_type_id__once)) {
		GType music_playlist_type_id;
		music_playlist_type_id = music_playlist_get_type_once ();
		g_once_init_leave (&music_playlist_type_id__once, music_playlist_type_id);
	}
	return music_playlist_type_id__once;
}

static void
_vala_music_playlist_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MusicPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
#line 29 "../core/Playlists/Playlist.vala"
	switch (property_id) {
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_MEDIAS_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_object (value, music_playlist_get_medias (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_ROWID_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_int64 (value, music_playlist_get_rowid (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_NAME_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		g_value_set_string (value, music_playlist_get_name (self));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 679 "Playlist.c"
		default:
#line 29 "../core/Playlists/Playlist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 685 "Playlist.c"
	}
}

static void
_vala_music_playlist_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MusicPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
#line 29 "../core/Playlists/Playlist.vala"
	switch (property_id) {
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_MEDIAS_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		music_playlist_set_medias (self, g_value_get_object (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_ROWID_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		music_playlist_set_rowid (self, g_value_get_int64 (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 29 "../core/Playlists/Playlist.vala"
		case MUSIC_PLAYLIST_NAME_PROPERTY:
#line 29 "../core/Playlists/Playlist.vala"
		music_playlist_set_name (self, g_value_get_string (value));
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 717 "Playlist.c"
		default:
#line 29 "../core/Playlists/Playlist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Playlists/Playlist.vala"
		break;
#line 723 "Playlist.c"
	}
}

