/* SmartPlaylist.c generated by valac 0.56.0, the Vala compiler
 * generated from SmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	MUSIC_SMART_PLAYLIST_0_PROPERTY,
	MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY,
	MUSIC_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _MusicSmartPlaylistPrivate {
	MusicSmartPlaylistConditionalType _conditional;
	gint _query_count;
	gboolean _limit;
	guint _limit_amount;
	MusicLibrary* _library;
};

struct _Block10Data {
	int _ref_count_;
	MusicSmartPlaylist* self;
	GeeCollection* given_library;
};

struct _Block11Data {
	int _ref_count_;
	Block10Data * _data10_;
	GeeTreeSet* added;
	GeeTreeSet* removed;
};

static gint MusicSmartPlaylist_private_offset;
static gpointer music_smart_playlist_parent_class = NULL;

static void music_smart_playlist_real_add_media (MusicPlaylist* base,
                                          MusicMedia* m);
static void music_smart_playlist_real_add_medias (MusicPlaylist* base,
                                           GeeCollection* to_add);
static void music_smart_playlist_real_remove_media (MusicPlaylist* base,
                                             MusicMedia* to_remove);
static void music_smart_playlist_real_remove_medias (MusicPlaylist* base,
                                              GeeCollection* to_remove);
static void music_smart_playlist_real_analyse_all (MusicSmartPlaylist* self);
static void music_smart_playlist_analyse_list (MusicSmartPlaylist* self,
                                        GeeCollection* given_library);
static void music_smart_playlist_real_clear_queries (MusicSmartPlaylist* self);
static GeeCollection* music_smart_playlist_real_get_queries (MusicSmartPlaylist* self);
static void music_smart_playlist_real_add_query (MusicSmartPlaylist* self,
                                          MusicSmartQuery* s);
static void music_smart_playlist_real_add_queries (MusicSmartPlaylist* self,
                                            GeeCollection* queries);
static void music_smart_playlist_real_clear (MusicPlaylist* base);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void* __lambda10_ (Block10Data* _data10_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean __lambda11_ (Block11Data* _data11_);
static gboolean ___lambda11__gsource_func (gpointer self);
static gpointer ___lambda10__gthread_func (gpointer self);
static GObject * music_smart_playlist_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _music_smart_playlist___lambda12_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda12__music_library_media_added (MusicLibrary* _sender,
                                                                   GeeCollection* medias,
                                                                   gpointer self);
static void _music_smart_playlist___lambda13_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda13__music_library_media_updated (MusicLibrary* _sender,
                                                                     GeeCollection* medias,
                                                                     gpointer self);
static void _music_smart_playlist___lambda14_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda14__music_library_media_removed (MusicLibrary* _sender,
                                                                     GeeCollection* medias,
                                                                     gpointer self);
static void music_smart_playlist_finalize (GObject * obj);
static GType music_smart_playlist_get_type_once (void);
static void _vala_music_smart_playlist_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_smart_playlist_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
music_smart_playlist_get_instance_private (MusicSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSmartPlaylist_private_offset);
}

static GType
music_smart_playlist_conditional_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL, "MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL", "all"}, {MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY, "MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY", "any"}, {0, NULL, NULL}};
	GType music_smart_playlist_conditional_type_type_id;
	music_smart_playlist_conditional_type_type_id = g_enum_register_static ("MusicSmartPlaylistConditionalType", values);
	return music_smart_playlist_conditional_type_type_id;
}

GType
music_smart_playlist_conditional_type_get_type (void)
{
	static volatile gsize music_smart_playlist_conditional_type_type_id__once = 0;
	if (g_once_init_enter (&music_smart_playlist_conditional_type_type_id__once)) {
		GType music_smart_playlist_conditional_type_type_id;
		music_smart_playlist_conditional_type_type_id = music_smart_playlist_conditional_type_get_type_once ();
		g_once_init_leave (&music_smart_playlist_conditional_type_type_id__once, music_smart_playlist_conditional_type_type_id);
	}
	return music_smart_playlist_conditional_type_type_id__once;
}

MusicSmartPlaylist*
music_smart_playlist_construct (GType object_type,
                                MusicLibrary* library)
{
	MusicSmartPlaylist * self = NULL;
#line 48 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (library != NULL, NULL);
#line 49 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) g_object_new (object_type, "library", library, NULL);
#line 48 "../core/Playlists/SmartPlaylist.vala"
	return self;
#line 176 "SmartPlaylist.c"
}

MusicSmartPlaylist*
music_smart_playlist_new (MusicLibrary* library)
{
#line 48 "../core/Playlists/SmartPlaylist.vala"
	return music_smart_playlist_construct (MUSIC_TYPE_SMART_PLAYLIST, library);
#line 184 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_add_media (MusicPlaylist* base,
                                     MusicMedia* m)
{
	MusicSmartPlaylist * self;
#line 81 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) base;
#line 81 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (m != NULL);
#line 82 "../core/Playlists/SmartPlaylist.vala"
	g_warning ("SmartPlaylist.vala:82: Trying to force the media addition to a smart p" \
"laylist!");
#line 198 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_add_medias (MusicPlaylist* base,
                                      GeeCollection* to_add)
{
	MusicSmartPlaylist * self;
#line 85 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) base;
#line 85 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (to_add != NULL);
#line 86 "../core/Playlists/SmartPlaylist.vala"
	g_warning ("SmartPlaylist.vala:86: Trying to force the media addition to a smart p" \
"laylist!");
#line 212 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_remove_media (MusicPlaylist* base,
                                        MusicMedia* to_remove)
{
	MusicSmartPlaylist * self;
#line 89 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) base;
#line 89 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 90 "../core/Playlists/SmartPlaylist.vala"
	g_warning ("SmartPlaylist.vala:90: Trying to force the media removal from a smart " \
"playlist!");
#line 226 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_remove_medias (MusicPlaylist* base,
                                         GeeCollection* to_remove)
{
	MusicSmartPlaylist * self;
#line 93 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) base;
#line 93 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 94 "../core/Playlists/SmartPlaylist.vala"
	g_warning ("SmartPlaylist.vala:94: Trying to force the media removal from a smart " \
"playlist!");
#line 240 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_analyse_all (MusicSmartPlaylist* self)
{
	MusicLibrary* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
#line 98 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->priv->_library;
#line 98 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = music_library_get_medias (_tmp0_);
#line 98 "../core/Playlists/SmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 98 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_analyse_list (self, _tmp2_);
#line 98 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (_tmp2_);
#line 259 "SmartPlaylist.c"
}

void
music_smart_playlist_analyse_all (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 97 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 97 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 97 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->analyse_all) {
#line 97 "../core/Playlists/SmartPlaylist.vala"
		_klass_->analyse_all (self);
#line 274 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_clear_queries (MusicSmartPlaylist* self)
{
	GeeTreeSet* _tmp0_;
#line 106 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_set_query_count (self, 0);
#line 107 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->queries;
#line 107 "../core/Playlists/SmartPlaylist.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 108 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 290 "SmartPlaylist.c"
}

void
music_smart_playlist_clear_queries (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 105 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 105 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 105 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->clear_queries) {
#line 105 "../core/Playlists/SmartPlaylist.vala"
		_klass_->clear_queries (self);
#line 305 "SmartPlaylist.c"
	}
}

static GeeCollection*
music_smart_playlist_real_get_queries (MusicSmartPlaylist* self)
{
	GeeTreeSet* _tmp0_;
	GeeBidirSortedSet* _tmp1_;
	GeeBidirSortedSet* _tmp2_;
	GeeCollection* result;
#line 112 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->queries;
#line 112 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp0_);
#line 112 "../core/Playlists/SmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 112 "../core/Playlists/SmartPlaylist.vala"
	result = (GeeCollection*) _tmp2_;
#line 112 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 326 "SmartPlaylist.c"
}

GeeCollection*
music_smart_playlist_get_queries (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 111 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 111 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->get_queries) {
#line 111 "../core/Playlists/SmartPlaylist.vala"
		return _klass_->get_queries (self);
#line 341 "SmartPlaylist.c"
	}
#line 111 "../core/Playlists/SmartPlaylist.vala"
	return NULL;
#line 345 "SmartPlaylist.c"
}

static void
music_smart_playlist_real_add_query (MusicSmartPlaylist* self,
                                     MusicSmartQuery* s)
{
	gint _tmp0_;
	GeeTreeSet* _tmp1_;
#line 115 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (s != NULL);
#line 116 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->priv->_query_count;
#line 116 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_set_query_count (self, _tmp0_ + 1);
#line 117 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = self->queries;
#line 117 "../core/Playlists/SmartPlaylist.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
#line 118 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_analyse_all (self);
#line 119 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 368 "SmartPlaylist.c"
}

void
music_smart_playlist_add_query (MusicSmartPlaylist* self,
                                MusicSmartQuery* s)
{
	MusicSmartPlaylistClass* _klass_;
#line 115 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 115 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 115 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->add_query) {
#line 115 "../core/Playlists/SmartPlaylist.vala"
		_klass_->add_query (self, s);
#line 384 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_add_queries (MusicSmartPlaylist* self,
                                       GeeCollection* queries)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeTreeSet* _tmp3_;
#line 122 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (queries != NULL);
#line 123 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->priv->_query_count;
#line 123 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = gee_collection_get_size (queries);
#line 123 "../core/Playlists/SmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 123 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_set_query_count (self, _tmp0_ + _tmp2_);
#line 124 "../core/Playlists/SmartPlaylist.vala"
	_tmp3_ = self->queries;
#line 124 "../core/Playlists/SmartPlaylist.vala"
	gee_collection_add_all ((GeeCollection*) _tmp3_, queries);
#line 125 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_analyse_all (self);
#line 126 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 414 "SmartPlaylist.c"
}

void
music_smart_playlist_add_queries (MusicSmartPlaylist* self,
                                  GeeCollection* queries)
{
	MusicSmartPlaylistClass* _klass_;
#line 122 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 122 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 122 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->add_queries) {
#line 122 "../core/Playlists/SmartPlaylist.vala"
		_klass_->add_queries (self, queries);
#line 430 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_clear (MusicPlaylist* base)
{
	MusicSmartPlaylist * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 130 "../core/Playlists/SmartPlaylist.vala"
	self = (MusicSmartPlaylist*) base;
#line 131 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 131 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 131 "../core/Playlists/SmartPlaylist.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 132 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "cleared");
#line 450 "SmartPlaylist.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 469 "SmartPlaylist.c"
}

gboolean
music_smart_playlist_media_matches_query (MusicSmartQuery* q,
                                          MusicMedia* s)
{
	MusicSmartQueryFieldType _tmp0_;
	MusicSmartQueryFieldType _tmp1_;
	gboolean result;
#line 139 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (q != NULL, FALSE);
#line 139 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 140 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = music_smart_query_get_field (q);
#line 140 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 140 "../core/Playlists/SmartPlaylist.vala"
	switch (_tmp1_) {
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_URI:
#line 491 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp2_;
			MusicSmartQueryComparatorType _tmp3_;
#line 142 "../core/Playlists/SmartPlaylist.vala"
			_tmp2_ = music_smart_query_get_comparator (q);
#line 142 "../core/Playlists/SmartPlaylist.vala"
			_tmp3_ = _tmp2_;
#line 142 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp3_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 501 "SmartPlaylist.c"
				GValue _tmp4_ = {0};
				GValue _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp4_);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp5_ = _tmp4_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp6_ = g_value_get_string (&_tmp5_);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp8_ = _tmp7_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp9_ = music_media_get_uri (s);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp10_ = _tmp9_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp11_ = _tmp10_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp13_ = _tmp12_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_tmp14_ = g_strcmp0 (_tmp8_, _tmp13_) == 0;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp13_);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp11_);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp8_);
#line 143 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp14_;
#line 143 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 545 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp15_;
				MusicSmartQueryComparatorType _tmp16_;
#line 144 "../core/Playlists/SmartPlaylist.vala"
				_tmp15_ = music_smart_query_get_comparator (q);
#line 144 "../core/Playlists/SmartPlaylist.vala"
				_tmp16_ = _tmp15_;
#line 144 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp16_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 555 "SmartPlaylist.c"
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					GValue _tmp22_ = {0};
					GValue _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gboolean _tmp27_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp17_ = music_media_get_uri (s);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp18_ = _tmp17_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp19_ = _tmp18_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp20_ = g_utf8_strdown (_tmp19_, (gssize) -1);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp21_ = _tmp20_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp22_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp23_ = _tmp22_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp24_ = g_value_get_string (&_tmp23_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp26_ = _tmp25_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_tmp27_ = string_contains (_tmp21_, _tmp26_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp26_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp21_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp19_);
#line 145 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp27_;
#line 145 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 599 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp28_;
					MusicSmartQueryComparatorType _tmp29_;
#line 146 "../core/Playlists/SmartPlaylist.vala"
					_tmp28_ = music_smart_query_get_comparator (q);
#line 146 "../core/Playlists/SmartPlaylist.vala"
					_tmp29_ = _tmp28_;
#line 146 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp29_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 609 "SmartPlaylist.c"
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						GValue _tmp35_ = {0};
						GValue _tmp36_;
						const gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gboolean _tmp40_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp30_ = music_media_get_uri (s);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp31_ = _tmp30_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp32_ = _tmp31_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp33_ = g_utf8_strdown (_tmp32_, (gssize) -1);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp34_ = _tmp33_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp35_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp36_ = _tmp35_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp37_ = g_value_get_string (&_tmp36_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp38_ = g_utf8_strdown (_tmp37_, (gssize) -1);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp39_ = _tmp38_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_tmp40_ = !string_contains (_tmp34_, _tmp39_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp39_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp34_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp32_);
#line 147 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp40_;
#line 147 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 653 "SmartPlaylist.c"
					}
				}
			}
#line 148 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 659 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_ALBUM:
#line 663 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp41_;
			MusicSmartQueryComparatorType _tmp42_;
#line 150 "../core/Playlists/SmartPlaylist.vala"
			_tmp41_ = music_smart_query_get_comparator (q);
#line 150 "../core/Playlists/SmartPlaylist.vala"
			_tmp42_ = _tmp41_;
#line 150 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp42_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 673 "SmartPlaylist.c"
				GValue _tmp43_ = {0};
				GValue _tmp44_;
				const gchar* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gboolean _tmp52_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp43_);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp44_ = _tmp43_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp45_ = g_value_get_string (&_tmp44_);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp46_ = g_utf8_strdown (_tmp45_, (gssize) -1);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp47_ = _tmp46_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp48_ = music_media_get_album (s);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp49_ = _tmp48_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp50_ = g_utf8_strdown (_tmp49_, (gssize) -1);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp51_ = _tmp50_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_tmp52_ = g_strcmp0 (_tmp47_, _tmp51_) == 0;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp51_);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp47_);
#line 151 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp52_;
#line 151 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 712 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp53_;
				MusicSmartQueryComparatorType _tmp54_;
#line 152 "../core/Playlists/SmartPlaylist.vala"
				_tmp53_ = music_smart_query_get_comparator (q);
#line 152 "../core/Playlists/SmartPlaylist.vala"
				_tmp54_ = _tmp53_;
#line 152 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp54_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 722 "SmartPlaylist.c"
					const gchar* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					GValue _tmp59_ = {0};
					GValue _tmp60_;
					const gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
					gboolean _tmp64_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp55_ = music_media_get_album (s);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp56_ = _tmp55_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp57_ = g_utf8_strdown (_tmp56_, (gssize) -1);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp58_ = _tmp57_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp59_);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp60_ = _tmp59_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp61_ = g_value_get_string (&_tmp60_);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp62_ = g_utf8_strdown (_tmp61_, (gssize) -1);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp63_ = _tmp62_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_tmp64_ = string_contains (_tmp58_, _tmp63_);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp63_);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp58_);
#line 153 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp64_;
#line 153 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 761 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp65_;
					MusicSmartQueryComparatorType _tmp66_;
#line 154 "../core/Playlists/SmartPlaylist.vala"
					_tmp65_ = music_smart_query_get_comparator (q);
#line 154 "../core/Playlists/SmartPlaylist.vala"
					_tmp66_ = _tmp65_;
#line 154 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp66_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 771 "SmartPlaylist.c"
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
						GValue _tmp71_ = {0};
						GValue _tmp72_;
						const gchar* _tmp73_;
						gchar* _tmp74_;
						gchar* _tmp75_;
						gboolean _tmp76_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp67_ = music_media_get_album (s);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp68_ = _tmp67_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp69_ = g_utf8_strdown (_tmp68_, (gssize) -1);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp70_ = _tmp69_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp71_);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp72_ = _tmp71_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp73_ = g_value_get_string (&_tmp72_);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp74_ = g_utf8_strdown (_tmp73_, (gssize) -1);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp75_ = _tmp74_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_tmp76_ = !string_contains (_tmp70_, _tmp75_);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp75_);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp70_);
#line 155 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp76_;
#line 155 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 810 "SmartPlaylist.c"
					}
				}
			}
#line 156 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 816 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_ARTIST:
#line 820 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp77_;
			MusicSmartQueryComparatorType _tmp78_;
#line 158 "../core/Playlists/SmartPlaylist.vala"
			_tmp77_ = music_smart_query_get_comparator (q);
#line 158 "../core/Playlists/SmartPlaylist.vala"
			_tmp78_ = _tmp77_;
#line 158 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp78_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 830 "SmartPlaylist.c"
				GValue _tmp79_ = {0};
				GValue _tmp80_;
				const gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				const gchar* _tmp84_;
				const gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				gboolean _tmp88_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp79_);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp80_ = _tmp79_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp81_ = g_value_get_string (&_tmp80_);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp82_ = g_utf8_strdown (_tmp81_, (gssize) -1);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp83_ = _tmp82_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp84_ = music_media_get_artist (s);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp85_ = _tmp84_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp86_ = g_utf8_strdown (_tmp85_, (gssize) -1);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp87_ = _tmp86_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_tmp88_ = g_strcmp0 (_tmp83_, _tmp87_) == 0;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp87_);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp83_);
#line 159 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp88_;
#line 159 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 869 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp89_;
				MusicSmartQueryComparatorType _tmp90_;
#line 160 "../core/Playlists/SmartPlaylist.vala"
				_tmp89_ = music_smart_query_get_comparator (q);
#line 160 "../core/Playlists/SmartPlaylist.vala"
				_tmp90_ = _tmp89_;
#line 160 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp90_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 879 "SmartPlaylist.c"
					const gchar* _tmp91_;
					const gchar* _tmp92_;
					gchar* _tmp93_;
					gchar* _tmp94_;
					GValue _tmp95_ = {0};
					GValue _tmp96_;
					const gchar* _tmp97_;
					gchar* _tmp98_;
					gchar* _tmp99_;
					gboolean _tmp100_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp91_ = music_media_get_artist (s);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp92_ = _tmp91_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp93_ = g_utf8_strdown (_tmp92_, (gssize) -1);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp94_ = _tmp93_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp95_);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp96_ = _tmp95_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp97_ = g_value_get_string (&_tmp96_);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp98_ = g_utf8_strdown (_tmp97_, (gssize) -1);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp99_ = _tmp98_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_tmp100_ = string_contains (_tmp94_, _tmp99_);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp99_);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp94_);
#line 161 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp100_;
#line 161 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 918 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp101_;
					MusicSmartQueryComparatorType _tmp102_;
#line 162 "../core/Playlists/SmartPlaylist.vala"
					_tmp101_ = music_smart_query_get_comparator (q);
#line 162 "../core/Playlists/SmartPlaylist.vala"
					_tmp102_ = _tmp101_;
#line 162 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp102_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 928 "SmartPlaylist.c"
						const gchar* _tmp103_;
						const gchar* _tmp104_;
						gchar* _tmp105_;
						gchar* _tmp106_;
						GValue _tmp107_ = {0};
						GValue _tmp108_;
						const gchar* _tmp109_;
						gchar* _tmp110_;
						gchar* _tmp111_;
						gboolean _tmp112_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp103_ = music_media_get_artist (s);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp104_ = _tmp103_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp105_ = g_utf8_strdown (_tmp104_, (gssize) -1);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp106_ = _tmp105_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp107_);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp108_ = _tmp107_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp109_ = g_value_get_string (&_tmp108_);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp110_ = g_utf8_strdown (_tmp109_, (gssize) -1);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp111_ = _tmp110_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_tmp112_ = !string_contains (_tmp106_, _tmp111_);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp111_);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp106_);
#line 163 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp112_;
#line 163 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 967 "SmartPlaylist.c"
					}
				}
			}
#line 164 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 973 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMPOSER:
#line 977 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp113_;
			MusicSmartQueryComparatorType _tmp114_;
#line 166 "../core/Playlists/SmartPlaylist.vala"
			_tmp113_ = music_smart_query_get_comparator (q);
#line 166 "../core/Playlists/SmartPlaylist.vala"
			_tmp114_ = _tmp113_;
#line 166 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp114_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 987 "SmartPlaylist.c"
				GValue _tmp115_ = {0};
				GValue _tmp116_;
				const gchar* _tmp117_;
				gchar* _tmp118_;
				gchar* _tmp119_;
				const gchar* _tmp120_;
				const gchar* _tmp121_;
				gchar* _tmp122_;
				gchar* _tmp123_;
				gboolean _tmp124_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp115_);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp116_ = _tmp115_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp117_ = g_value_get_string (&_tmp116_);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp118_ = g_utf8_strdown (_tmp117_, (gssize) -1);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp119_ = _tmp118_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp120_ = music_media_get_composer (s);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp121_ = _tmp120_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp122_ = g_utf8_strdown (_tmp121_, (gssize) -1);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp123_ = _tmp122_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_tmp124_ = g_strcmp0 (_tmp119_, _tmp123_) == 0;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp123_);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp119_);
#line 167 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp124_;
#line 167 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1026 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp125_;
				MusicSmartQueryComparatorType _tmp126_;
#line 168 "../core/Playlists/SmartPlaylist.vala"
				_tmp125_ = music_smart_query_get_comparator (q);
#line 168 "../core/Playlists/SmartPlaylist.vala"
				_tmp126_ = _tmp125_;
#line 168 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp126_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 1036 "SmartPlaylist.c"
					const gchar* _tmp127_;
					const gchar* _tmp128_;
					gchar* _tmp129_;
					gchar* _tmp130_;
					GValue _tmp131_ = {0};
					GValue _tmp132_;
					const gchar* _tmp133_;
					gchar* _tmp134_;
					gchar* _tmp135_;
					gboolean _tmp136_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp127_ = music_media_get_composer (s);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp128_ = _tmp127_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp129_ = g_utf8_strdown (_tmp128_, (gssize) -1);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp130_ = _tmp129_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp131_);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp132_ = _tmp131_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp133_ = g_value_get_string (&_tmp132_);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp134_ = g_utf8_strdown (_tmp133_, (gssize) -1);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp135_ = _tmp134_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_tmp136_ = string_contains (_tmp130_, _tmp135_);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp135_);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp130_);
#line 169 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp136_;
#line 169 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1075 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp137_;
					MusicSmartQueryComparatorType _tmp138_;
#line 170 "../core/Playlists/SmartPlaylist.vala"
					_tmp137_ = music_smart_query_get_comparator (q);
#line 170 "../core/Playlists/SmartPlaylist.vala"
					_tmp138_ = _tmp137_;
#line 170 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp138_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 1085 "SmartPlaylist.c"
						const gchar* _tmp139_;
						const gchar* _tmp140_;
						gchar* _tmp141_;
						gchar* _tmp142_;
						GValue _tmp143_ = {0};
						GValue _tmp144_;
						const gchar* _tmp145_;
						gchar* _tmp146_;
						gchar* _tmp147_;
						gboolean _tmp148_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp139_ = music_media_get_composer (s);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp140_ = _tmp139_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp141_ = g_utf8_strdown (_tmp140_, (gssize) -1);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp142_ = _tmp141_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp143_);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp144_ = _tmp143_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp145_ = g_value_get_string (&_tmp144_);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp146_ = g_utf8_strdown (_tmp145_, (gssize) -1);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp147_ = _tmp146_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_tmp148_ = !string_contains (_tmp142_, _tmp147_);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp147_);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp142_);
#line 171 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp148_;
#line 171 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1124 "SmartPlaylist.c"
					}
				}
			}
#line 172 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1130 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMMENT:
#line 1134 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp149_;
			MusicSmartQueryComparatorType _tmp150_;
#line 174 "../core/Playlists/SmartPlaylist.vala"
			_tmp149_ = music_smart_query_get_comparator (q);
#line 174 "../core/Playlists/SmartPlaylist.vala"
			_tmp150_ = _tmp149_;
#line 174 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp150_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 1144 "SmartPlaylist.c"
				GValue _tmp151_ = {0};
				GValue _tmp152_;
				const gchar* _tmp153_;
				gchar* _tmp154_;
				gchar* _tmp155_;
				const gchar* _tmp156_;
				const gchar* _tmp157_;
				gchar* _tmp158_;
				gchar* _tmp159_;
				gboolean _tmp160_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp151_);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp152_ = _tmp151_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp153_ = g_value_get_string (&_tmp152_);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp154_ = g_utf8_strdown (_tmp153_, (gssize) -1);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp155_ = _tmp154_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp156_ = music_media_get_comment (s);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp157_ = _tmp156_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp158_ = g_utf8_strdown (_tmp157_, (gssize) -1);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp159_ = _tmp158_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_tmp160_ = g_strcmp0 (_tmp155_, _tmp159_) == 0;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp159_);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp155_);
#line 175 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp160_;
#line 175 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1183 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp161_;
				MusicSmartQueryComparatorType _tmp162_;
#line 176 "../core/Playlists/SmartPlaylist.vala"
				_tmp161_ = music_smart_query_get_comparator (q);
#line 176 "../core/Playlists/SmartPlaylist.vala"
				_tmp162_ = _tmp161_;
#line 176 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp162_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 1193 "SmartPlaylist.c"
					const gchar* _tmp163_;
					const gchar* _tmp164_;
					gchar* _tmp165_;
					gchar* _tmp166_;
					GValue _tmp167_ = {0};
					GValue _tmp168_;
					const gchar* _tmp169_;
					gchar* _tmp170_;
					gchar* _tmp171_;
					gboolean _tmp172_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp163_ = music_media_get_comment (s);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp164_ = _tmp163_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp165_ = g_utf8_strdown (_tmp164_, (gssize) -1);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp166_ = _tmp165_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp167_);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp168_ = _tmp167_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp169_ = g_value_get_string (&_tmp168_);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp170_ = g_utf8_strdown (_tmp169_, (gssize) -1);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp171_ = _tmp170_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_tmp172_ = string_contains (_tmp166_, _tmp171_);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp171_);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp166_);
#line 177 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp172_;
#line 177 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1232 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp173_;
					MusicSmartQueryComparatorType _tmp174_;
#line 178 "../core/Playlists/SmartPlaylist.vala"
					_tmp173_ = music_smart_query_get_comparator (q);
#line 178 "../core/Playlists/SmartPlaylist.vala"
					_tmp174_ = _tmp173_;
#line 178 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp174_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 1242 "SmartPlaylist.c"
						const gchar* _tmp175_;
						const gchar* _tmp176_;
						gchar* _tmp177_;
						gchar* _tmp178_;
						GValue _tmp179_ = {0};
						GValue _tmp180_;
						const gchar* _tmp181_;
						gchar* _tmp182_;
						gchar* _tmp183_;
						gboolean _tmp184_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp175_ = music_media_get_comment (s);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp176_ = _tmp175_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp177_ = g_utf8_strdown (_tmp176_, (gssize) -1);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp178_ = _tmp177_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp179_);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp180_ = _tmp179_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp181_ = g_value_get_string (&_tmp180_);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp182_ = g_utf8_strdown (_tmp181_, (gssize) -1);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp183_ = _tmp182_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_tmp184_ = !string_contains (_tmp178_, _tmp183_);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp183_);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp178_);
#line 179 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp184_;
#line 179 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1281 "SmartPlaylist.c"
					}
				}
			}
#line 180 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1287 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_GENRE:
#line 1291 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp185_;
			MusicSmartQueryComparatorType _tmp186_;
#line 182 "../core/Playlists/SmartPlaylist.vala"
			_tmp185_ = music_smart_query_get_comparator (q);
#line 182 "../core/Playlists/SmartPlaylist.vala"
			_tmp186_ = _tmp185_;
#line 182 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp186_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 1301 "SmartPlaylist.c"
				GValue _tmp187_ = {0};
				GValue _tmp188_;
				const gchar* _tmp189_;
				gchar* _tmp190_;
				gchar* _tmp191_;
				const gchar* _tmp192_;
				const gchar* _tmp193_;
				gchar* _tmp194_;
				gchar* _tmp195_;
				gboolean _tmp196_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp187_);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp188_ = _tmp187_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp189_ = g_value_get_string (&_tmp188_);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp190_ = g_utf8_strdown (_tmp189_, (gssize) -1);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp191_ = _tmp190_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp192_ = music_media_get_genre (s);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp193_ = _tmp192_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp194_ = g_utf8_strdown (_tmp193_, (gssize) -1);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp195_ = _tmp194_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_tmp196_ = g_strcmp0 (_tmp191_, _tmp195_) == 0;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp195_);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp191_);
#line 183 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp196_;
#line 183 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1340 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp197_;
				MusicSmartQueryComparatorType _tmp198_;
#line 184 "../core/Playlists/SmartPlaylist.vala"
				_tmp197_ = music_smart_query_get_comparator (q);
#line 184 "../core/Playlists/SmartPlaylist.vala"
				_tmp198_ = _tmp197_;
#line 184 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp198_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 1350 "SmartPlaylist.c"
					const gchar* _tmp199_;
					const gchar* _tmp200_;
					gchar* _tmp201_;
					gchar* _tmp202_;
					GValue _tmp203_ = {0};
					GValue _tmp204_;
					const gchar* _tmp205_;
					gchar* _tmp206_;
					gchar* _tmp207_;
					gboolean _tmp208_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp199_ = music_media_get_genre (s);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp200_ = _tmp199_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp201_ = g_utf8_strdown (_tmp200_, (gssize) -1);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp202_ = _tmp201_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp203_);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp204_ = _tmp203_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp205_ = g_value_get_string (&_tmp204_);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp206_ = g_utf8_strdown (_tmp205_, (gssize) -1);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp207_ = _tmp206_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_tmp208_ = string_contains (_tmp202_, _tmp207_);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp207_);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp202_);
#line 185 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp208_;
#line 185 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1389 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp209_;
					MusicSmartQueryComparatorType _tmp210_;
#line 186 "../core/Playlists/SmartPlaylist.vala"
					_tmp209_ = music_smart_query_get_comparator (q);
#line 186 "../core/Playlists/SmartPlaylist.vala"
					_tmp210_ = _tmp209_;
#line 186 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp210_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 1399 "SmartPlaylist.c"
						const gchar* _tmp211_;
						const gchar* _tmp212_;
						gchar* _tmp213_;
						gchar* _tmp214_;
						GValue _tmp215_ = {0};
						GValue _tmp216_;
						const gchar* _tmp217_;
						gchar* _tmp218_;
						gchar* _tmp219_;
						gboolean _tmp220_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp211_ = music_media_get_genre (s);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp212_ = _tmp211_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp213_ = g_utf8_strdown (_tmp212_, (gssize) -1);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp214_ = _tmp213_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp215_);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp216_ = _tmp215_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp217_ = g_value_get_string (&_tmp216_);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp218_ = g_utf8_strdown (_tmp217_, (gssize) -1);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp219_ = _tmp218_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_tmp220_ = !string_contains (_tmp214_, _tmp219_);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp219_);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp214_);
#line 187 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp220_;
#line 187 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1438 "SmartPlaylist.c"
					}
				}
			}
#line 188 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1444 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_GROUPING:
#line 1448 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp221_;
			MusicSmartQueryComparatorType _tmp222_;
#line 190 "../core/Playlists/SmartPlaylist.vala"
			_tmp221_ = music_smart_query_get_comparator (q);
#line 190 "../core/Playlists/SmartPlaylist.vala"
			_tmp222_ = _tmp221_;
#line 190 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp222_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 1458 "SmartPlaylist.c"
				GValue _tmp223_ = {0};
				GValue _tmp224_;
				const gchar* _tmp225_;
				gchar* _tmp226_;
				gchar* _tmp227_;
				const gchar* _tmp228_;
				const gchar* _tmp229_;
				gchar* _tmp230_;
				gchar* _tmp231_;
				gboolean _tmp232_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp223_);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp224_ = _tmp223_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp225_ = g_value_get_string (&_tmp224_);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp226_ = g_utf8_strdown (_tmp225_, (gssize) -1);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp227_ = _tmp226_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp228_ = music_media_get_grouping (s);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp229_ = _tmp228_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp230_ = g_utf8_strdown (_tmp229_, (gssize) -1);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp231_ = _tmp230_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_tmp232_ = g_strcmp0 (_tmp227_, _tmp231_) == 0;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp231_);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp227_);
#line 191 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp232_;
#line 191 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1497 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp233_;
				MusicSmartQueryComparatorType _tmp234_;
#line 192 "../core/Playlists/SmartPlaylist.vala"
				_tmp233_ = music_smart_query_get_comparator (q);
#line 192 "../core/Playlists/SmartPlaylist.vala"
				_tmp234_ = _tmp233_;
#line 192 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp234_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 1507 "SmartPlaylist.c"
					const gchar* _tmp235_;
					const gchar* _tmp236_;
					gchar* _tmp237_;
					gchar* _tmp238_;
					GValue _tmp239_ = {0};
					GValue _tmp240_;
					const gchar* _tmp241_;
					gchar* _tmp242_;
					gchar* _tmp243_;
					gboolean _tmp244_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp235_ = music_media_get_grouping (s);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp236_ = _tmp235_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp237_ = g_utf8_strdown (_tmp236_, (gssize) -1);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp238_ = _tmp237_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp239_);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp240_ = _tmp239_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp241_ = g_value_get_string (&_tmp240_);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp242_ = g_utf8_strdown (_tmp241_, (gssize) -1);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp243_ = _tmp242_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_tmp244_ = string_contains (_tmp238_, _tmp243_);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp243_);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp238_);
#line 193 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp244_;
#line 193 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1546 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp245_;
					MusicSmartQueryComparatorType _tmp246_;
#line 194 "../core/Playlists/SmartPlaylist.vala"
					_tmp245_ = music_smart_query_get_comparator (q);
#line 194 "../core/Playlists/SmartPlaylist.vala"
					_tmp246_ = _tmp245_;
#line 194 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp246_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 1556 "SmartPlaylist.c"
						const gchar* _tmp247_;
						const gchar* _tmp248_;
						gchar* _tmp249_;
						gchar* _tmp250_;
						GValue _tmp251_ = {0};
						GValue _tmp252_;
						const gchar* _tmp253_;
						gchar* _tmp254_;
						gchar* _tmp255_;
						gboolean _tmp256_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp247_ = music_media_get_grouping (s);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp248_ = _tmp247_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp249_ = g_utf8_strdown (_tmp248_, (gssize) -1);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp250_ = _tmp249_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp251_);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp252_ = _tmp251_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp253_ = g_value_get_string (&_tmp252_);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp254_ = g_utf8_strdown (_tmp253_, (gssize) -1);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp255_ = _tmp254_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_tmp256_ = !string_contains (_tmp250_, _tmp255_);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp255_);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp250_);
#line 195 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp256_;
#line 195 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1595 "SmartPlaylist.c"
					}
				}
			}
#line 196 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1601 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_TITLE:
#line 1605 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp257_;
			MusicSmartQueryComparatorType _tmp258_;
#line 198 "../core/Playlists/SmartPlaylist.vala"
			_tmp257_ = music_smart_query_get_comparator (q);
#line 198 "../core/Playlists/SmartPlaylist.vala"
			_tmp258_ = _tmp257_;
#line 198 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp258_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
#line 1615 "SmartPlaylist.c"
				GValue _tmp259_ = {0};
				GValue _tmp260_;
				const gchar* _tmp261_;
				gchar* _tmp262_;
				gchar* _tmp263_;
				const gchar* _tmp264_;
				const gchar* _tmp265_;
				gchar* _tmp266_;
				gchar* _tmp267_;
				gboolean _tmp268_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp259_);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp260_ = _tmp259_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp261_ = g_value_get_string (&_tmp260_);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp262_ = g_utf8_strdown (_tmp261_, (gssize) -1);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp263_ = _tmp262_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp264_ = music_media_get_title (s);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp265_ = _tmp264_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp266_ = g_utf8_strdown (_tmp265_, (gssize) -1);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp267_ = _tmp266_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_tmp268_ = g_strcmp0 (_tmp263_, _tmp267_) == 0;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp267_);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				_g_free0 (_tmp263_);
#line 199 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp268_;
#line 199 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1654 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp269_;
				MusicSmartQueryComparatorType _tmp270_;
#line 200 "../core/Playlists/SmartPlaylist.vala"
				_tmp269_ = music_smart_query_get_comparator (q);
#line 200 "../core/Playlists/SmartPlaylist.vala"
				_tmp270_ = _tmp269_;
#line 200 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp270_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
#line 1664 "SmartPlaylist.c"
					const gchar* _tmp271_;
					const gchar* _tmp272_;
					gchar* _tmp273_;
					gchar* _tmp274_;
					GValue _tmp275_ = {0};
					GValue _tmp276_;
					const gchar* _tmp277_;
					gchar* _tmp278_;
					gchar* _tmp279_;
					gboolean _tmp280_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp271_ = music_media_get_title (s);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp272_ = _tmp271_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp273_ = g_utf8_strdown (_tmp272_, (gssize) -1);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp274_ = _tmp273_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp275_);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp276_ = _tmp275_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp277_ = g_value_get_string (&_tmp276_);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp278_ = g_utf8_strdown (_tmp277_, (gssize) -1);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp279_ = _tmp278_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_tmp280_ = string_contains (_tmp274_, _tmp279_);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp279_);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					_g_free0 (_tmp274_);
#line 201 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp280_;
#line 201 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1703 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp281_;
					MusicSmartQueryComparatorType _tmp282_;
#line 202 "../core/Playlists/SmartPlaylist.vala"
					_tmp281_ = music_smart_query_get_comparator (q);
#line 202 "../core/Playlists/SmartPlaylist.vala"
					_tmp282_ = _tmp281_;
#line 202 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp282_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
#line 1713 "SmartPlaylist.c"
						const gchar* _tmp283_;
						const gchar* _tmp284_;
						gchar* _tmp285_;
						gchar* _tmp286_;
						GValue _tmp287_ = {0};
						GValue _tmp288_;
						const gchar* _tmp289_;
						gchar* _tmp290_;
						gchar* _tmp291_;
						gboolean _tmp292_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp283_ = music_media_get_title (s);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp284_ = _tmp283_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp285_ = g_utf8_strdown (_tmp284_, (gssize) -1);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp286_ = _tmp285_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp287_);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp288_ = _tmp287_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp289_ = g_value_get_string (&_tmp288_);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp290_ = g_utf8_strdown (_tmp289_, (gssize) -1);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp291_ = _tmp290_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_tmp292_ = !string_contains (_tmp286_, _tmp291_);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp291_);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						_g_free0 (_tmp286_);
#line 203 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp292_;
#line 203 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1752 "SmartPlaylist.c"
					}
				}
			}
#line 204 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1758 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_BITRATE:
#line 1762 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp293_;
			MusicSmartQueryComparatorType _tmp294_;
#line 206 "../core/Playlists/SmartPlaylist.vala"
			_tmp293_ = music_smart_query_get_comparator (q);
#line 206 "../core/Playlists/SmartPlaylist.vala"
			_tmp294_ = _tmp293_;
#line 206 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp294_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 1772 "SmartPlaylist.c"
				GValue _tmp295_ = {0};
				GValue _tmp296_;
				guint _tmp297_;
				guint _tmp298_;
#line 207 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp295_);
#line 207 "../core/Playlists/SmartPlaylist.vala"
				_tmp296_ = _tmp295_;
#line 207 "../core/Playlists/SmartPlaylist.vala"
				_tmp297_ = music_media_get_bitrate (s);
#line 207 "../core/Playlists/SmartPlaylist.vala"
				_tmp298_ = _tmp297_;
#line 207 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp296_)) == _tmp298_;
#line 207 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1789 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp299_;
				MusicSmartQueryComparatorType _tmp300_;
#line 208 "../core/Playlists/SmartPlaylist.vala"
				_tmp299_ = music_smart_query_get_comparator (q);
#line 208 "../core/Playlists/SmartPlaylist.vala"
				_tmp300_ = _tmp299_;
#line 208 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp300_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 1799 "SmartPlaylist.c"
					guint _tmp301_;
					guint _tmp302_;
					GValue _tmp303_ = {0};
					GValue _tmp304_;
#line 209 "../core/Playlists/SmartPlaylist.vala"
					_tmp301_ = music_media_get_bitrate (s);
#line 209 "../core/Playlists/SmartPlaylist.vala"
					_tmp302_ = _tmp301_;
#line 209 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp303_);
#line 209 "../core/Playlists/SmartPlaylist.vala"
					_tmp304_ = _tmp303_;
#line 209 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp302_ <= ((guint) g_value_get_int (&_tmp304_));
#line 209 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1816 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp305_;
					MusicSmartQueryComparatorType _tmp306_;
#line 210 "../core/Playlists/SmartPlaylist.vala"
					_tmp305_ = music_smart_query_get_comparator (q);
#line 210 "../core/Playlists/SmartPlaylist.vala"
					_tmp306_ = _tmp305_;
#line 210 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp306_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 1826 "SmartPlaylist.c"
						guint _tmp307_;
						guint _tmp308_;
						GValue _tmp309_ = {0};
						GValue _tmp310_;
#line 211 "../core/Playlists/SmartPlaylist.vala"
						_tmp307_ = music_media_get_bitrate (s);
#line 211 "../core/Playlists/SmartPlaylist.vala"
						_tmp308_ = _tmp307_;
#line 211 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp309_);
#line 211 "../core/Playlists/SmartPlaylist.vala"
						_tmp310_ = _tmp309_;
#line 211 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp308_ >= ((guint) g_value_get_int (&_tmp310_));
#line 211 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1843 "SmartPlaylist.c"
					}
				}
			}
#line 212 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1849 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_PLAYCOUNT:
#line 1853 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp311_;
			MusicSmartQueryComparatorType _tmp312_;
#line 214 "../core/Playlists/SmartPlaylist.vala"
			_tmp311_ = music_smart_query_get_comparator (q);
#line 214 "../core/Playlists/SmartPlaylist.vala"
			_tmp312_ = _tmp311_;
#line 214 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp312_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 1863 "SmartPlaylist.c"
				GValue _tmp313_ = {0};
				GValue _tmp314_;
				guint _tmp315_;
				guint _tmp316_;
#line 215 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp313_);
#line 215 "../core/Playlists/SmartPlaylist.vala"
				_tmp314_ = _tmp313_;
#line 215 "../core/Playlists/SmartPlaylist.vala"
				_tmp315_ = music_media_get_play_count (s);
#line 215 "../core/Playlists/SmartPlaylist.vala"
				_tmp316_ = _tmp315_;
#line 215 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp314_)) == _tmp316_;
#line 215 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1880 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp317_;
				MusicSmartQueryComparatorType _tmp318_;
#line 216 "../core/Playlists/SmartPlaylist.vala"
				_tmp317_ = music_smart_query_get_comparator (q);
#line 216 "../core/Playlists/SmartPlaylist.vala"
				_tmp318_ = _tmp317_;
#line 216 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp318_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 1890 "SmartPlaylist.c"
					guint _tmp319_;
					guint _tmp320_;
					GValue _tmp321_ = {0};
					GValue _tmp322_;
#line 217 "../core/Playlists/SmartPlaylist.vala"
					_tmp319_ = music_media_get_play_count (s);
#line 217 "../core/Playlists/SmartPlaylist.vala"
					_tmp320_ = _tmp319_;
#line 217 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp321_);
#line 217 "../core/Playlists/SmartPlaylist.vala"
					_tmp322_ = _tmp321_;
#line 217 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp320_ <= ((guint) g_value_get_int (&_tmp322_));
#line 217 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1907 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp323_;
					MusicSmartQueryComparatorType _tmp324_;
#line 218 "../core/Playlists/SmartPlaylist.vala"
					_tmp323_ = music_smart_query_get_comparator (q);
#line 218 "../core/Playlists/SmartPlaylist.vala"
					_tmp324_ = _tmp323_;
#line 218 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp324_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 1917 "SmartPlaylist.c"
						guint _tmp325_;
						guint _tmp326_;
						GValue _tmp327_ = {0};
						GValue _tmp328_;
#line 219 "../core/Playlists/SmartPlaylist.vala"
						_tmp325_ = music_media_get_play_count (s);
#line 219 "../core/Playlists/SmartPlaylist.vala"
						_tmp326_ = _tmp325_;
#line 219 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp327_);
#line 219 "../core/Playlists/SmartPlaylist.vala"
						_tmp328_ = _tmp327_;
#line 219 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp326_ >= ((guint) g_value_get_int (&_tmp328_));
#line 219 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 1934 "SmartPlaylist.c"
					}
				}
			}
#line 220 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 1940 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_SKIPCOUNT:
#line 1944 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp329_;
			MusicSmartQueryComparatorType _tmp330_;
#line 222 "../core/Playlists/SmartPlaylist.vala"
			_tmp329_ = music_smart_query_get_comparator (q);
#line 222 "../core/Playlists/SmartPlaylist.vala"
			_tmp330_ = _tmp329_;
#line 222 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp330_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 1954 "SmartPlaylist.c"
				GValue _tmp331_ = {0};
				GValue _tmp332_;
				guint _tmp333_;
				guint _tmp334_;
#line 223 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp331_);
#line 223 "../core/Playlists/SmartPlaylist.vala"
				_tmp332_ = _tmp331_;
#line 223 "../core/Playlists/SmartPlaylist.vala"
				_tmp333_ = music_media_get_skip_count (s);
#line 223 "../core/Playlists/SmartPlaylist.vala"
				_tmp334_ = _tmp333_;
#line 223 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp332_)) == _tmp334_;
#line 223 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 1971 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp335_;
				MusicSmartQueryComparatorType _tmp336_;
#line 224 "../core/Playlists/SmartPlaylist.vala"
				_tmp335_ = music_smart_query_get_comparator (q);
#line 224 "../core/Playlists/SmartPlaylist.vala"
				_tmp336_ = _tmp335_;
#line 224 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp336_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 1981 "SmartPlaylist.c"
					guint _tmp337_;
					guint _tmp338_;
					GValue _tmp339_ = {0};
					GValue _tmp340_;
#line 225 "../core/Playlists/SmartPlaylist.vala"
					_tmp337_ = music_media_get_skip_count (s);
#line 225 "../core/Playlists/SmartPlaylist.vala"
					_tmp338_ = _tmp337_;
#line 225 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp339_);
#line 225 "../core/Playlists/SmartPlaylist.vala"
					_tmp340_ = _tmp339_;
#line 225 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp338_ <= ((guint) g_value_get_int (&_tmp340_));
#line 225 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 1998 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp341_;
					MusicSmartQueryComparatorType _tmp342_;
#line 226 "../core/Playlists/SmartPlaylist.vala"
					_tmp341_ = music_smart_query_get_comparator (q);
#line 226 "../core/Playlists/SmartPlaylist.vala"
					_tmp342_ = _tmp341_;
#line 226 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp342_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 2008 "SmartPlaylist.c"
						guint _tmp343_;
						guint _tmp344_;
						GValue _tmp345_ = {0};
						GValue _tmp346_;
#line 227 "../core/Playlists/SmartPlaylist.vala"
						_tmp343_ = music_media_get_skip_count (s);
#line 227 "../core/Playlists/SmartPlaylist.vala"
						_tmp344_ = _tmp343_;
#line 227 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp345_);
#line 227 "../core/Playlists/SmartPlaylist.vala"
						_tmp346_ = _tmp345_;
#line 227 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp344_ >= ((guint) g_value_get_int (&_tmp346_));
#line 227 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2025 "SmartPlaylist.c"
					}
				}
			}
#line 228 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2031 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_YEAR:
#line 2035 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp347_;
			MusicSmartQueryComparatorType _tmp348_;
#line 230 "../core/Playlists/SmartPlaylist.vala"
			_tmp347_ = music_smart_query_get_comparator (q);
#line 230 "../core/Playlists/SmartPlaylist.vala"
			_tmp348_ = _tmp347_;
#line 230 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp348_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 2045 "SmartPlaylist.c"
				GValue _tmp349_ = {0};
				GValue _tmp350_;
				guint _tmp351_;
				guint _tmp352_;
#line 231 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp349_);
#line 231 "../core/Playlists/SmartPlaylist.vala"
				_tmp350_ = _tmp349_;
#line 231 "../core/Playlists/SmartPlaylist.vala"
				_tmp351_ = music_media_get_year (s);
#line 231 "../core/Playlists/SmartPlaylist.vala"
				_tmp352_ = _tmp351_;
#line 231 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp350_)) == _tmp352_;
#line 231 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2062 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp353_;
				MusicSmartQueryComparatorType _tmp354_;
#line 232 "../core/Playlists/SmartPlaylist.vala"
				_tmp353_ = music_smart_query_get_comparator (q);
#line 232 "../core/Playlists/SmartPlaylist.vala"
				_tmp354_ = _tmp353_;
#line 232 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp354_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 2072 "SmartPlaylist.c"
					guint _tmp355_;
					guint _tmp356_;
					GValue _tmp357_ = {0};
					GValue _tmp358_;
#line 233 "../core/Playlists/SmartPlaylist.vala"
					_tmp355_ = music_media_get_year (s);
#line 233 "../core/Playlists/SmartPlaylist.vala"
					_tmp356_ = _tmp355_;
#line 233 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp357_);
#line 233 "../core/Playlists/SmartPlaylist.vala"
					_tmp358_ = _tmp357_;
#line 233 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp356_ <= ((guint) g_value_get_int (&_tmp358_));
#line 233 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 2089 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp359_;
					MusicSmartQueryComparatorType _tmp360_;
#line 234 "../core/Playlists/SmartPlaylist.vala"
					_tmp359_ = music_smart_query_get_comparator (q);
#line 234 "../core/Playlists/SmartPlaylist.vala"
					_tmp360_ = _tmp359_;
#line 234 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp360_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 2099 "SmartPlaylist.c"
						guint _tmp361_;
						guint _tmp362_;
						GValue _tmp363_ = {0};
						GValue _tmp364_;
#line 235 "../core/Playlists/SmartPlaylist.vala"
						_tmp361_ = music_media_get_year (s);
#line 235 "../core/Playlists/SmartPlaylist.vala"
						_tmp362_ = _tmp361_;
#line 235 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp363_);
#line 235 "../core/Playlists/SmartPlaylist.vala"
						_tmp364_ = _tmp363_;
#line 235 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp362_ >= ((guint) g_value_get_int (&_tmp364_));
#line 235 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2116 "SmartPlaylist.c"
					}
				}
			}
#line 236 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2122 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_LENGTH:
#line 2126 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp365_;
			MusicSmartQueryComparatorType _tmp366_;
#line 238 "../core/Playlists/SmartPlaylist.vala"
			_tmp365_ = music_smart_query_get_comparator (q);
#line 238 "../core/Playlists/SmartPlaylist.vala"
			_tmp366_ = _tmp365_;
#line 238 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp366_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 2136 "SmartPlaylist.c"
				GValue _tmp367_ = {0};
				GValue _tmp368_;
				guint _tmp369_;
				guint _tmp370_;
#line 239 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp367_);
#line 239 "../core/Playlists/SmartPlaylist.vala"
				_tmp368_ = _tmp367_;
#line 239 "../core/Playlists/SmartPlaylist.vala"
				_tmp369_ = music_media_get_length (s);
#line 239 "../core/Playlists/SmartPlaylist.vala"
				_tmp370_ = _tmp369_;
#line 239 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp368_)) == _tmp370_;
#line 239 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2153 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp371_;
				MusicSmartQueryComparatorType _tmp372_;
#line 240 "../core/Playlists/SmartPlaylist.vala"
				_tmp371_ = music_smart_query_get_comparator (q);
#line 240 "../core/Playlists/SmartPlaylist.vala"
				_tmp372_ = _tmp371_;
#line 240 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp372_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 2163 "SmartPlaylist.c"
					guint _tmp373_;
					guint _tmp374_;
					GValue _tmp375_ = {0};
					GValue _tmp376_;
#line 241 "../core/Playlists/SmartPlaylist.vala"
					_tmp373_ = music_media_get_length (s);
#line 241 "../core/Playlists/SmartPlaylist.vala"
					_tmp374_ = _tmp373_;
#line 241 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp375_);
#line 241 "../core/Playlists/SmartPlaylist.vala"
					_tmp376_ = _tmp375_;
#line 241 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp374_ <= ((guint) g_value_get_int (&_tmp376_));
#line 241 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 2180 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp377_;
					MusicSmartQueryComparatorType _tmp378_;
#line 242 "../core/Playlists/SmartPlaylist.vala"
					_tmp377_ = music_smart_query_get_comparator (q);
#line 242 "../core/Playlists/SmartPlaylist.vala"
					_tmp378_ = _tmp377_;
#line 242 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp378_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 2190 "SmartPlaylist.c"
						guint _tmp379_;
						guint _tmp380_;
						GValue _tmp381_ = {0};
						GValue _tmp382_;
#line 243 "../core/Playlists/SmartPlaylist.vala"
						_tmp379_ = music_media_get_length (s);
#line 243 "../core/Playlists/SmartPlaylist.vala"
						_tmp380_ = _tmp379_;
#line 243 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp381_);
#line 243 "../core/Playlists/SmartPlaylist.vala"
						_tmp382_ = _tmp381_;
#line 243 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp380_ >= ((guint) g_value_get_int (&_tmp382_));
#line 243 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2207 "SmartPlaylist.c"
					}
				}
			}
#line 244 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2213 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_RATING:
#line 2217 "SmartPlaylist.c"
		{
			MusicSmartQueryComparatorType _tmp383_;
			MusicSmartQueryComparatorType _tmp384_;
#line 246 "../core/Playlists/SmartPlaylist.vala"
			_tmp383_ = music_smart_query_get_comparator (q);
#line 246 "../core/Playlists/SmartPlaylist.vala"
			_tmp384_ = _tmp383_;
#line 246 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp384_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 2227 "SmartPlaylist.c"
				GValue _tmp385_ = {0};
				GValue _tmp386_;
				guint _tmp387_;
				guint _tmp388_;
#line 247 "../core/Playlists/SmartPlaylist.vala"
				music_smart_query_get_value (q, &_tmp385_);
#line 247 "../core/Playlists/SmartPlaylist.vala"
				_tmp386_ = _tmp385_;
#line 247 "../core/Playlists/SmartPlaylist.vala"
				_tmp387_ = music_media_get_rating (s);
#line 247 "../core/Playlists/SmartPlaylist.vala"
				_tmp388_ = _tmp387_;
#line 247 "../core/Playlists/SmartPlaylist.vala"
				result = ((guint) g_value_get_int (&_tmp386_)) == _tmp388_;
#line 247 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2244 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp389_;
				MusicSmartQueryComparatorType _tmp390_;
#line 248 "../core/Playlists/SmartPlaylist.vala"
				_tmp389_ = music_smart_query_get_comparator (q);
#line 248 "../core/Playlists/SmartPlaylist.vala"
				_tmp390_ = _tmp389_;
#line 248 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp390_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
#line 2254 "SmartPlaylist.c"
					guint _tmp391_;
					guint _tmp392_;
					GValue _tmp393_ = {0};
					GValue _tmp394_;
#line 249 "../core/Playlists/SmartPlaylist.vala"
					_tmp391_ = music_media_get_rating (s);
#line 249 "../core/Playlists/SmartPlaylist.vala"
					_tmp392_ = _tmp391_;
#line 249 "../core/Playlists/SmartPlaylist.vala"
					music_smart_query_get_value (q, &_tmp393_);
#line 249 "../core/Playlists/SmartPlaylist.vala"
					_tmp394_ = _tmp393_;
#line 249 "../core/Playlists/SmartPlaylist.vala"
					result = _tmp392_ <= ((guint) g_value_get_int (&_tmp394_));
#line 249 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 2271 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp395_;
					MusicSmartQueryComparatorType _tmp396_;
#line 250 "../core/Playlists/SmartPlaylist.vala"
					_tmp395_ = music_smart_query_get_comparator (q);
#line 250 "../core/Playlists/SmartPlaylist.vala"
					_tmp396_ = _tmp395_;
#line 250 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp396_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
#line 2281 "SmartPlaylist.c"
						guint _tmp397_;
						guint _tmp398_;
						GValue _tmp399_ = {0};
						GValue _tmp400_;
#line 251 "../core/Playlists/SmartPlaylist.vala"
						_tmp397_ = music_media_get_rating (s);
#line 251 "../core/Playlists/SmartPlaylist.vala"
						_tmp398_ = _tmp397_;
#line 251 "../core/Playlists/SmartPlaylist.vala"
						music_smart_query_get_value (q, &_tmp399_);
#line 251 "../core/Playlists/SmartPlaylist.vala"
						_tmp400_ = _tmp399_;
#line 251 "../core/Playlists/SmartPlaylist.vala"
						result = _tmp398_ >= ((guint) g_value_get_int (&_tmp400_));
#line 251 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2298 "SmartPlaylist.c"
					}
				}
			}
#line 252 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2304 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_DATE_ADDED:
#line 2308 "SmartPlaylist.c"
		{
			GDateTime* now = NULL;
			GDateTime* _tmp401_;
			GDateTime* played = NULL;
			guint _tmp402_;
			guint _tmp403_;
			GDateTime* _tmp404_;
			GDateTime* _tmp405_;
			GValue _tmp406_ = {0};
			GValue _tmp407_;
			GDateTime* _tmp408_;
			MusicSmartQueryComparatorType _tmp409_;
			MusicSmartQueryComparatorType _tmp410_;
#line 254 "../core/Playlists/SmartPlaylist.vala"
			_tmp401_ = g_date_time_new_now_local ();
#line 254 "../core/Playlists/SmartPlaylist.vala"
			now = _tmp401_;
#line 255 "../core/Playlists/SmartPlaylist.vala"
			_tmp402_ = music_media_get_date_added (s);
#line 255 "../core/Playlists/SmartPlaylist.vala"
			_tmp403_ = _tmp402_;
#line 255 "../core/Playlists/SmartPlaylist.vala"
			_tmp404_ = g_date_time_new_from_unix_local ((gint64) _tmp403_);
#line 255 "../core/Playlists/SmartPlaylist.vala"
			played = _tmp404_;
#line 256 "../core/Playlists/SmartPlaylist.vala"
			_tmp405_ = played;
#line 256 "../core/Playlists/SmartPlaylist.vala"
			music_smart_query_get_value (q, &_tmp406_);
#line 256 "../core/Playlists/SmartPlaylist.vala"
			_tmp407_ = _tmp406_;
#line 256 "../core/Playlists/SmartPlaylist.vala"
			_tmp408_ = g_date_time_add_days (_tmp405_, g_value_get_int (&_tmp407_));
#line 256 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (played);
#line 256 "../core/Playlists/SmartPlaylist.vala"
			played = _tmp408_;
#line 258 "../core/Playlists/SmartPlaylist.vala"
			_tmp409_ = music_smart_query_get_comparator (q);
#line 258 "../core/Playlists/SmartPlaylist.vala"
			_tmp410_ = _tmp409_;
#line 258 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp410_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 2352 "SmartPlaylist.c"
				gboolean _tmp411_ = FALSE;
				GDateTime* _tmp412_;
				GDateTime* _tmp413_;
#line 259 "../core/Playlists/SmartPlaylist.vala"
				_tmp412_ = now;
#line 259 "../core/Playlists/SmartPlaylist.vala"
				_tmp413_ = played;
#line 259 "../core/Playlists/SmartPlaylist.vala"
				if (g_date_time_get_day_of_year (_tmp412_) == g_date_time_get_day_of_year (_tmp413_)) {
#line 2362 "SmartPlaylist.c"
					GDateTime* _tmp414_;
					GDateTime* _tmp415_;
#line 259 "../core/Playlists/SmartPlaylist.vala"
					_tmp414_ = now;
#line 259 "../core/Playlists/SmartPlaylist.vala"
					_tmp415_ = played;
#line 259 "../core/Playlists/SmartPlaylist.vala"
					_tmp411_ = g_date_time_get_year (_tmp414_) == g_date_time_get_year (_tmp415_);
#line 2371 "SmartPlaylist.c"
				} else {
#line 259 "../core/Playlists/SmartPlaylist.vala"
					_tmp411_ = FALSE;
#line 2375 "SmartPlaylist.c"
				}
#line 259 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp411_;
#line 259 "../core/Playlists/SmartPlaylist.vala"
				_g_date_time_unref0 (played);
#line 259 "../core/Playlists/SmartPlaylist.vala"
				_g_date_time_unref0 (now);
#line 259 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2385 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp416_;
				MusicSmartQueryComparatorType _tmp417_;
#line 260 "../core/Playlists/SmartPlaylist.vala"
				_tmp416_ = music_smart_query_get_comparator (q);
#line 260 "../core/Playlists/SmartPlaylist.vala"
				_tmp417_ = _tmp416_;
#line 260 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp417_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN) {
#line 2395 "SmartPlaylist.c"
					GDateTime* _tmp418_;
					GDateTime* _tmp419_;
#line 261 "../core/Playlists/SmartPlaylist.vala"
					_tmp418_ = played;
#line 261 "../core/Playlists/SmartPlaylist.vala"
					_tmp419_ = now;
#line 261 "../core/Playlists/SmartPlaylist.vala"
					result = g_date_time_compare (_tmp418_, _tmp419_) > 0;
#line 261 "../core/Playlists/SmartPlaylist.vala"
					_g_date_time_unref0 (played);
#line 261 "../core/Playlists/SmartPlaylist.vala"
					_g_date_time_unref0 (now);
#line 261 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 2410 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp420_;
					MusicSmartQueryComparatorType _tmp421_;
#line 262 "../core/Playlists/SmartPlaylist.vala"
					_tmp420_ = music_smart_query_get_comparator (q);
#line 262 "../core/Playlists/SmartPlaylist.vala"
					_tmp421_ = _tmp420_;
#line 262 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp421_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE) {
#line 2420 "SmartPlaylist.c"
						GDateTime* _tmp422_;
						GDateTime* _tmp423_;
#line 263 "../core/Playlists/SmartPlaylist.vala"
						_tmp422_ = now;
#line 263 "../core/Playlists/SmartPlaylist.vala"
						_tmp423_ = played;
#line 263 "../core/Playlists/SmartPlaylist.vala"
						result = g_date_time_compare (_tmp422_, _tmp423_) > 0;
#line 263 "../core/Playlists/SmartPlaylist.vala"
						_g_date_time_unref0 (played);
#line 263 "../core/Playlists/SmartPlaylist.vala"
						_g_date_time_unref0 (now);
#line 263 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2435 "SmartPlaylist.c"
					}
				}
			}
#line 265 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (played);
#line 265 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (now);
#line 265 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2445 "SmartPlaylist.c"
		}
#line 140 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_QUERY_FIELD_TYPE_LAST_PLAYED:
#line 2449 "SmartPlaylist.c"
		{
			guint _tmp424_;
			guint _tmp425_;
			GDateTime* now = NULL;
			GDateTime* _tmp426_;
			GDateTime* played = NULL;
			guint _tmp427_;
			guint _tmp428_;
			GDateTime* _tmp429_;
			GDateTime* _tmp430_;
			GValue _tmp431_ = {0};
			GValue _tmp432_;
			GDateTime* _tmp433_;
			MusicSmartQueryComparatorType _tmp434_;
			MusicSmartQueryComparatorType _tmp435_;
#line 267 "../core/Playlists/SmartPlaylist.vala"
			_tmp424_ = music_media_get_last_played (s);
#line 267 "../core/Playlists/SmartPlaylist.vala"
			_tmp425_ = _tmp424_;
#line 267 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp425_ == ((guint) 0)) {
#line 268 "../core/Playlists/SmartPlaylist.vala"
				result = FALSE;
#line 268 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2475 "SmartPlaylist.c"
			}
#line 270 "../core/Playlists/SmartPlaylist.vala"
			_tmp426_ = g_date_time_new_now_local ();
#line 270 "../core/Playlists/SmartPlaylist.vala"
			now = _tmp426_;
#line 271 "../core/Playlists/SmartPlaylist.vala"
			_tmp427_ = music_media_get_last_played (s);
#line 271 "../core/Playlists/SmartPlaylist.vala"
			_tmp428_ = _tmp427_;
#line 271 "../core/Playlists/SmartPlaylist.vala"
			_tmp429_ = g_date_time_new_from_unix_local ((gint64) _tmp428_);
#line 271 "../core/Playlists/SmartPlaylist.vala"
			played = _tmp429_;
#line 272 "../core/Playlists/SmartPlaylist.vala"
			_tmp430_ = played;
#line 272 "../core/Playlists/SmartPlaylist.vala"
			music_smart_query_get_value (q, &_tmp431_);
#line 272 "../core/Playlists/SmartPlaylist.vala"
			_tmp432_ = _tmp431_;
#line 272 "../core/Playlists/SmartPlaylist.vala"
			_tmp433_ = g_date_time_add_days (_tmp430_, g_value_get_int (&_tmp432_));
#line 272 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (played);
#line 272 "../core/Playlists/SmartPlaylist.vala"
			played = _tmp433_;
#line 274 "../core/Playlists/SmartPlaylist.vala"
			_tmp434_ = music_smart_query_get_comparator (q);
#line 274 "../core/Playlists/SmartPlaylist.vala"
			_tmp435_ = _tmp434_;
#line 274 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp435_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
#line 2507 "SmartPlaylist.c"
				gboolean _tmp436_ = FALSE;
				GDateTime* _tmp437_;
				GDateTime* _tmp438_;
#line 275 "../core/Playlists/SmartPlaylist.vala"
				_tmp437_ = now;
#line 275 "../core/Playlists/SmartPlaylist.vala"
				_tmp438_ = played;
#line 275 "../core/Playlists/SmartPlaylist.vala"
				if (g_date_time_get_day_of_year (_tmp437_) == g_date_time_get_day_of_year (_tmp438_)) {
#line 2517 "SmartPlaylist.c"
					GDateTime* _tmp439_;
					GDateTime* _tmp440_;
#line 275 "../core/Playlists/SmartPlaylist.vala"
					_tmp439_ = now;
#line 275 "../core/Playlists/SmartPlaylist.vala"
					_tmp440_ = played;
#line 275 "../core/Playlists/SmartPlaylist.vala"
					_tmp436_ = g_date_time_get_year (_tmp439_) == g_date_time_get_year (_tmp440_);
#line 2526 "SmartPlaylist.c"
				} else {
#line 275 "../core/Playlists/SmartPlaylist.vala"
					_tmp436_ = FALSE;
#line 2530 "SmartPlaylist.c"
				}
#line 275 "../core/Playlists/SmartPlaylist.vala"
				result = _tmp436_;
#line 275 "../core/Playlists/SmartPlaylist.vala"
				_g_date_time_unref0 (played);
#line 275 "../core/Playlists/SmartPlaylist.vala"
				_g_date_time_unref0 (now);
#line 275 "../core/Playlists/SmartPlaylist.vala"
				return result;
#line 2540 "SmartPlaylist.c"
			} else {
				MusicSmartQueryComparatorType _tmp441_;
				MusicSmartQueryComparatorType _tmp442_;
#line 276 "../core/Playlists/SmartPlaylist.vala"
				_tmp441_ = music_smart_query_get_comparator (q);
#line 276 "../core/Playlists/SmartPlaylist.vala"
				_tmp442_ = _tmp441_;
#line 276 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp442_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN) {
#line 2550 "SmartPlaylist.c"
					GDateTime* _tmp443_;
					GDateTime* _tmp444_;
#line 277 "../core/Playlists/SmartPlaylist.vala"
					_tmp443_ = played;
#line 277 "../core/Playlists/SmartPlaylist.vala"
					_tmp444_ = now;
#line 277 "../core/Playlists/SmartPlaylist.vala"
					result = g_date_time_compare (_tmp443_, _tmp444_) > 0;
#line 277 "../core/Playlists/SmartPlaylist.vala"
					_g_date_time_unref0 (played);
#line 277 "../core/Playlists/SmartPlaylist.vala"
					_g_date_time_unref0 (now);
#line 277 "../core/Playlists/SmartPlaylist.vala"
					return result;
#line 2565 "SmartPlaylist.c"
				} else {
					MusicSmartQueryComparatorType _tmp445_;
					MusicSmartQueryComparatorType _tmp446_;
#line 278 "../core/Playlists/SmartPlaylist.vala"
					_tmp445_ = music_smart_query_get_comparator (q);
#line 278 "../core/Playlists/SmartPlaylist.vala"
					_tmp446_ = _tmp445_;
#line 278 "../core/Playlists/SmartPlaylist.vala"
					if (_tmp446_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE) {
#line 2575 "SmartPlaylist.c"
						GDateTime* _tmp447_;
						GDateTime* _tmp448_;
#line 279 "../core/Playlists/SmartPlaylist.vala"
						_tmp447_ = now;
#line 279 "../core/Playlists/SmartPlaylist.vala"
						_tmp448_ = played;
#line 279 "../core/Playlists/SmartPlaylist.vala"
						result = g_date_time_compare (_tmp447_, _tmp448_) > 0;
#line 279 "../core/Playlists/SmartPlaylist.vala"
						_g_date_time_unref0 (played);
#line 279 "../core/Playlists/SmartPlaylist.vala"
						_g_date_time_unref0 (now);
#line 279 "../core/Playlists/SmartPlaylist.vala"
						return result;
#line 2590 "SmartPlaylist.c"
					}
				}
			}
#line 281 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (played);
#line 281 "../core/Playlists/SmartPlaylist.vala"
			_g_date_time_unref0 (now);
#line 281 "../core/Playlists/SmartPlaylist.vala"
			break;
#line 2600 "SmartPlaylist.c"
		}
		default:
#line 140 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 2605 "SmartPlaylist.c"
	}
#line 284 "../core/Playlists/SmartPlaylist.vala"
	result = FALSE;
#line 284 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 2611 "SmartPlaylist.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 287 "../core/Playlists/SmartPlaylist.vala"
	return self ? g_object_ref (self) : NULL;
#line 2619 "SmartPlaylist.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 287 "../core/Playlists/SmartPlaylist.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	return _data10_;
#line 2629 "SmartPlaylist.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 287 "../core/Playlists/SmartPlaylist.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2639 "SmartPlaylist.c"
		MusicSmartPlaylist* self;
#line 287 "../core/Playlists/SmartPlaylist.vala"
		self = _data10_->self;
#line 287 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (_data10_->given_library);
#line 287 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (self);
#line 287 "../core/Playlists/SmartPlaylist.vala"
		g_slice_free (Block10Data, _data10_);
#line 2649 "SmartPlaylist.c"
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 288 "../core/Playlists/SmartPlaylist.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 288 "../core/Playlists/SmartPlaylist.vala"
	return _data11_;
#line 2660 "SmartPlaylist.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 2670 "SmartPlaylist.c"
		MusicSmartPlaylist* self;
#line 288 "../core/Playlists/SmartPlaylist.vala"
		self = _data11_->_data10_->self;
#line 288 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (_data11_->removed);
#line 288 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (_data11_->added);
#line 288 "../core/Playlists/SmartPlaylist.vala"
		block10_data_unref (_data11_->_data10_);
#line 288 "../core/Playlists/SmartPlaylist.vala"
		_data11_->_data10_ = NULL;
#line 288 "../core/Playlists/SmartPlaylist.vala"
		g_slice_free (Block11Data, _data11_);
#line 2684 "SmartPlaylist.c"
	}
}

static gboolean
__lambda11_ (Block11Data* _data11_)
{
	Block10Data* _data10_;
	MusicSmartPlaylist* self;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	gboolean result;
#line 320 "../core/Playlists/SmartPlaylist.vala"
	_data10_ = _data11_->_data10_;
#line 320 "../core/Playlists/SmartPlaylist.vala"
	self = _data10_->self;
#line 322 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = _data11_->added;
#line 322 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp0_);
#line 323 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = _data11_->removed;
#line 323 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp1_);
#line 324 "../core/Playlists/SmartPlaylist.vala"
	result = FALSE;
#line 324 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 2712 "SmartPlaylist.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ (self);
#line 320 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 2722 "SmartPlaylist.c"
}

static void*
__lambda10_ (Block10Data* _data10_)
{
	MusicSmartPlaylist* self;
	Block11Data* _data11_;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	void* result;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	self = _data10_->self;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_data11_->_ref_count_ = 1;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_data11_->_data10_ = block10_data_ref (_data10_);
#line 289 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 289 "../core/Playlists/SmartPlaylist.vala"
	_data11_->added = _tmp0_;
#line 290 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 290 "../core/Playlists/SmartPlaylist.vala"
	_data11_->removed = _tmp1_;
#line 2749 "SmartPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp2_;
#line 292 "../core/Playlists/SmartPlaylist.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _data10_->given_library);
#line 292 "../core/Playlists/SmartPlaylist.vala"
		_m_it = _tmp2_;
#line 292 "../core/Playlists/SmartPlaylist.vala"
		while (TRUE) {
#line 2759 "SmartPlaylist.c"
			GeeIterator* _tmp3_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			gint match_count = 0;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			MusicSmartPlaylistConditionalType _tmp18_;
			MusicSmartPlaylistConditionalType _tmp19_;
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_;
			gboolean _tmp47_;
#line 292 "../core/Playlists/SmartPlaylist.vala"
			_tmp3_ = _m_it;
#line 292 "../core/Playlists/SmartPlaylist.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 292 "../core/Playlists/SmartPlaylist.vala"
				break;
#line 2780 "SmartPlaylist.c"
			}
#line 292 "../core/Playlists/SmartPlaylist.vala"
			_tmp4_ = _m_it;
#line 292 "../core/Playlists/SmartPlaylist.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 292 "../core/Playlists/SmartPlaylist.vala"
			m = (MusicMedia*) _tmp5_;
#line 293 "../core/Playlists/SmartPlaylist.vala"
			_tmp6_ = m;
#line 293 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp6_ == NULL) {
#line 294 "../core/Playlists/SmartPlaylist.vala"
				_g_object_unref0 (m);
#line 294 "../core/Playlists/SmartPlaylist.vala"
				continue;
#line 2796 "SmartPlaylist.c"
			}
#line 296 "../core/Playlists/SmartPlaylist.vala"
			match_count = 0;
#line 2800 "SmartPlaylist.c"
			{
				GeeIterator* _q_it = NULL;
				GeeTreeSet* _tmp7_;
				GeeIterator* _tmp8_;
#line 298 "../core/Playlists/SmartPlaylist.vala"
				_tmp7_ = self->queries;
#line 298 "../core/Playlists/SmartPlaylist.vala"
				_tmp8_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp7_);
#line 298 "../core/Playlists/SmartPlaylist.vala"
				_q_it = _tmp8_;
#line 298 "../core/Playlists/SmartPlaylist.vala"
				while (TRUE) {
#line 2813 "SmartPlaylist.c"
					GeeIterator* _tmp9_;
					MusicSmartQuery* q = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					MusicSmartQuery* _tmp12_;
					MusicMedia* _tmp13_;
#line 298 "../core/Playlists/SmartPlaylist.vala"
					_tmp9_ = _q_it;
#line 298 "../core/Playlists/SmartPlaylist.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 298 "../core/Playlists/SmartPlaylist.vala"
						break;
#line 2826 "SmartPlaylist.c"
					}
#line 298 "../core/Playlists/SmartPlaylist.vala"
					_tmp10_ = _q_it;
#line 298 "../core/Playlists/SmartPlaylist.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 298 "../core/Playlists/SmartPlaylist.vala"
					q = (MusicSmartQuery*) _tmp11_;
#line 299 "../core/Playlists/SmartPlaylist.vala"
					_tmp12_ = q;
#line 299 "../core/Playlists/SmartPlaylist.vala"
					_tmp13_ = m;
#line 299 "../core/Playlists/SmartPlaylist.vala"
					if (music_smart_playlist_media_matches_query (_tmp12_, _tmp13_)) {
#line 2840 "SmartPlaylist.c"
						gint _tmp14_;
#line 300 "../core/Playlists/SmartPlaylist.vala"
						_tmp14_ = match_count;
#line 300 "../core/Playlists/SmartPlaylist.vala"
						match_count = _tmp14_ + 1;
#line 2846 "SmartPlaylist.c"
					}
#line 298 "../core/Playlists/SmartPlaylist.vala"
					_g_object_unref0 (q);
#line 2850 "SmartPlaylist.c"
				}
#line 298 "../core/Playlists/SmartPlaylist.vala"
				_g_object_unref0 (_q_it);
#line 2854 "SmartPlaylist.c"
			}
#line 303 "../core/Playlists/SmartPlaylist.vala"
			_tmp18_ = music_smart_playlist_get_conditional (self);
#line 303 "../core/Playlists/SmartPlaylist.vala"
			_tmp19_ = _tmp18_;
#line 303 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp19_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL) {
#line 2862 "SmartPlaylist.c"
				GeeTreeSet* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp20_ = self->queries;
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp22_ = _tmp21_;
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp17_ = match_count == _tmp22_;
#line 2874 "SmartPlaylist.c"
			} else {
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp17_ = FALSE;
#line 2878 "SmartPlaylist.c"
			}
#line 303 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp17_) {
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp16_ = TRUE;
#line 2884 "SmartPlaylist.c"
			} else {
				gboolean _tmp23_ = FALSE;
				MusicSmartPlaylistConditionalType _tmp24_;
				MusicSmartPlaylistConditionalType _tmp25_;
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp24_ = music_smart_playlist_get_conditional (self);
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp25_ = _tmp24_;
#line 304 "../core/Playlists/SmartPlaylist.vala"
				if (_tmp25_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
#line 304 "../core/Playlists/SmartPlaylist.vala"
					_tmp23_ = match_count >= 1;
#line 2897 "SmartPlaylist.c"
				} else {
#line 304 "../core/Playlists/SmartPlaylist.vala"
					_tmp23_ = FALSE;
#line 2901 "SmartPlaylist.c"
				}
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp16_ = _tmp23_;
#line 2905 "SmartPlaylist.c"
			}
#line 303 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp16_) {
#line 2909 "SmartPlaylist.c"
				MusicMedia* _tmp26_;
				gboolean _tmp27_;
				gboolean _tmp28_;
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp26_ = m;
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp27_ = music_media_get_is_temporary (_tmp26_);
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp28_ = _tmp27_;
#line 304 "../core/Playlists/SmartPlaylist.vala"
				_tmp15_ = !_tmp28_;
#line 2921 "SmartPlaylist.c"
			} else {
#line 303 "../core/Playlists/SmartPlaylist.vala"
				_tmp15_ = FALSE;
#line 2925 "SmartPlaylist.c"
			}
#line 303 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp15_) {
#line 2929 "SmartPlaylist.c"
				GeeArrayList* _tmp29_;
				GeeArrayList* _tmp30_;
				MusicMedia* _tmp31_;
#line 305 "../core/Playlists/SmartPlaylist.vala"
				_tmp29_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 305 "../core/Playlists/SmartPlaylist.vala"
				_tmp30_ = _tmp29_;
#line 305 "../core/Playlists/SmartPlaylist.vala"
				_tmp31_ = m;
#line 305 "../core/Playlists/SmartPlaylist.vala"
				if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp30_, _tmp31_)) {
#line 2941 "SmartPlaylist.c"
					GeeTreeSet* _tmp32_;
					MusicMedia* _tmp33_;
					GeeArrayList* _tmp34_;
					GeeArrayList* _tmp35_;
					MusicMedia* _tmp36_;
#line 306 "../core/Playlists/SmartPlaylist.vala"
					_tmp32_ = _data11_->added;
#line 306 "../core/Playlists/SmartPlaylist.vala"
					_tmp33_ = m;
#line 306 "../core/Playlists/SmartPlaylist.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 307 "../core/Playlists/SmartPlaylist.vala"
					_tmp34_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 307 "../core/Playlists/SmartPlaylist.vala"
					_tmp35_ = _tmp34_;
#line 307 "../core/Playlists/SmartPlaylist.vala"
					_tmp36_ = m;
#line 307 "../core/Playlists/SmartPlaylist.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
#line 2961 "SmartPlaylist.c"
				}
			} else {
				GeeArrayList* _tmp37_;
				GeeArrayList* _tmp38_;
				MusicMedia* _tmp39_;
#line 309 "../core/Playlists/SmartPlaylist.vala"
				_tmp37_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 309 "../core/Playlists/SmartPlaylist.vala"
				_tmp38_ = _tmp37_;
#line 309 "../core/Playlists/SmartPlaylist.vala"
				_tmp39_ = m;
#line 309 "../core/Playlists/SmartPlaylist.vala"
				if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp38_, _tmp39_)) {
#line 2975 "SmartPlaylist.c"
					GeeArrayList* _tmp40_;
					GeeArrayList* _tmp41_;
					MusicMedia* _tmp42_;
					GeeTreeSet* _tmp43_;
					MusicMedia* _tmp44_;
#line 312 "../core/Playlists/SmartPlaylist.vala"
					_tmp40_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 312 "../core/Playlists/SmartPlaylist.vala"
					_tmp41_ = _tmp40_;
#line 312 "../core/Playlists/SmartPlaylist.vala"
					_tmp42_ = m;
#line 312 "../core/Playlists/SmartPlaylist.vala"
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp41_, _tmp42_);
#line 313 "../core/Playlists/SmartPlaylist.vala"
					_tmp43_ = _data11_->removed;
#line 313 "../core/Playlists/SmartPlaylist.vala"
					_tmp44_ = m;
#line 313 "../core/Playlists/SmartPlaylist.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp44_);
#line 2995 "SmartPlaylist.c"
				}
			}
#line 316 "../core/Playlists/SmartPlaylist.vala"
			_tmp46_ = music_smart_playlist_get_limit (self);
#line 316 "../core/Playlists/SmartPlaylist.vala"
			_tmp47_ = _tmp46_;
#line 316 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp47_) {
#line 3004 "SmartPlaylist.c"
				guint _tmp48_;
				guint _tmp49_;
				GeeArrayList* _tmp50_;
				GeeArrayList* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp48_ = music_smart_playlist_get_limit_amount (self);
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp49_ = _tmp48_;
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp50_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp51_ = _tmp50_;
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp52_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp51_);
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp53_ = _tmp52_;
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp45_ = _tmp49_ <= ((guint) _tmp53_);
#line 3025 "SmartPlaylist.c"
			} else {
#line 316 "../core/Playlists/SmartPlaylist.vala"
				_tmp45_ = FALSE;
#line 3029 "SmartPlaylist.c"
			}
#line 316 "../core/Playlists/SmartPlaylist.vala"
			if (_tmp45_) {
#line 317 "../core/Playlists/SmartPlaylist.vala"
				_g_object_unref0 (m);
#line 317 "../core/Playlists/SmartPlaylist.vala"
				break;
#line 3037 "SmartPlaylist.c"
			}
#line 292 "../core/Playlists/SmartPlaylist.vala"
			_g_object_unref0 (m);
#line 3041 "SmartPlaylist.c"
		}
#line 292 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 3045 "SmartPlaylist.c"
	}
#line 320 "../core/Playlists/SmartPlaylist.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda11__gsource_func, block11_data_ref (_data11_), block11_data_unref);
#line 327 "../core/Playlists/SmartPlaylist.vala"
	result = NULL;
#line 327 "../core/Playlists/SmartPlaylist.vala"
	block11_data_unref (_data11_);
#line 327 "../core/Playlists/SmartPlaylist.vala"
	_data11_ = NULL;
#line 327 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3057 "SmartPlaylist.c"
}

static gpointer
___lambda10__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda10_ (self);
#line 288 "../core/Playlists/SmartPlaylist.vala"
	block10_data_unref (self);
#line 288 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3069 "SmartPlaylist.c"
}

static void
music_smart_playlist_analyse_list (MusicSmartPlaylist* self,
                                   GeeCollection* given_library)
{
	Block10Data* _data10_;
	GeeCollection* _tmp0_;
	GThread* _tmp1_;
	GThread* _tmp2_;
#line 287 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (given_library != NULL);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_data10_->_ref_count_ = 1;
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_data10_->self = g_object_ref (self);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = _g_object_ref0 (given_library);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (_data10_->given_library);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_data10_->given_library = _tmp0_;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = g_thread_new (NULL, ___lambda10__gthread_func, block10_data_ref (_data10_));
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_tmp2_ = _tmp1_;
#line 288 "../core/Playlists/SmartPlaylist.vala"
	_g_thread_unref0 (_tmp2_);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	block10_data_unref (_data10_);
#line 287 "../core/Playlists/SmartPlaylist.vala"
	_data10_ = NULL;
#line 3106 "SmartPlaylist.c"
}

MusicSmartPlaylistConditionalType
music_smart_playlist_get_conditional (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->get_conditional) {
#line 36 "../core/Playlists/SmartPlaylist.vala"
		return _klass_->get_conditional (self);
#line 3121 "SmartPlaylist.c"
	}
#line 36 "../core/Playlists/SmartPlaylist.vala"
	return 0;
#line 3125 "SmartPlaylist.c"
}

static MusicSmartPlaylistConditionalType
music_smart_playlist_real_get_conditional (MusicSmartPlaylist* base)
{
	MusicSmartPlaylistConditionalType result;
	MusicSmartPlaylist* self;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	result = self->priv->_conditional;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3139 "SmartPlaylist.c"
}

void
music_smart_playlist_set_conditional (MusicSmartPlaylist* self,
                                      MusicSmartPlaylistConditionalType value)
{
	MusicSmartPlaylistClass* _klass_;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->set_conditional) {
#line 36 "../core/Playlists/SmartPlaylist.vala"
		_klass_->set_conditional (self, value);
#line 3155 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_set_conditional (MusicSmartPlaylist* base,
                                           MusicSmartPlaylistConditionalType value)
{
	MusicSmartPlaylist* self;
	MusicSmartPlaylistConditionalType old_value;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 36 "../core/Playlists/SmartPlaylist.vala"
	old_value = music_smart_playlist_real_get_conditional (base);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	if (old_value != value) {
#line 36 "../core/Playlists/SmartPlaylist.vala"
		self->priv->_conditional = value;
#line 36 "../core/Playlists/SmartPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
#line 3175 "SmartPlaylist.c"
	}
}

gint
music_smart_playlist_get_query_count (MusicSmartPlaylist* self)
{
	gint result;
#line 38 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../core/Playlists/SmartPlaylist.vala"
	result = self->priv->_query_count;
#line 38 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3189 "SmartPlaylist.c"
}

void
music_smart_playlist_set_query_count (MusicSmartPlaylist* self,
                                      gint value)
{
	gint old_value;
#line 38 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 38 "../core/Playlists/SmartPlaylist.vala"
	old_value = music_smart_playlist_get_query_count (self);
#line 38 "../core/Playlists/SmartPlaylist.vala"
	if (old_value != value) {
#line 38 "../core/Playlists/SmartPlaylist.vala"
		self->priv->_query_count = value;
#line 38 "../core/Playlists/SmartPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY]);
#line 3207 "SmartPlaylist.c"
	}
}

gboolean
music_smart_playlist_get_limit (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 40 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->get_limit) {
#line 40 "../core/Playlists/SmartPlaylist.vala"
		return _klass_->get_limit (self);
#line 3223 "SmartPlaylist.c"
	}
#line 40 "../core/Playlists/SmartPlaylist.vala"
	return FALSE;
#line 3227 "SmartPlaylist.c"
}

static gboolean
music_smart_playlist_real_get_limit (MusicSmartPlaylist* base)
{
	gboolean result;
	MusicSmartPlaylist* self;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	result = self->priv->_limit;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3241 "SmartPlaylist.c"
}

void
music_smart_playlist_set_limit (MusicSmartPlaylist* self,
                                gboolean value)
{
	MusicSmartPlaylistClass* _klass_;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 40 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 40 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->set_limit) {
#line 40 "../core/Playlists/SmartPlaylist.vala"
		_klass_->set_limit (self, value);
#line 3257 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_set_limit (MusicSmartPlaylist* base,
                                     gboolean value)
{
	MusicSmartPlaylist* self;
	gboolean old_value;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	old_value = music_smart_playlist_real_get_limit (base);
#line 40 "../core/Playlists/SmartPlaylist.vala"
	if (old_value != value) {
#line 40 "../core/Playlists/SmartPlaylist.vala"
		self->priv->_limit = value;
#line 40 "../core/Playlists/SmartPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY]);
#line 3277 "SmartPlaylist.c"
	}
}

guint
music_smart_playlist_get_limit_amount (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 41 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 41 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->get_limit_amount) {
#line 41 "../core/Playlists/SmartPlaylist.vala"
		return _klass_->get_limit_amount (self);
#line 3293 "SmartPlaylist.c"
	}
#line 41 "../core/Playlists/SmartPlaylist.vala"
	return 0U;
#line 3297 "SmartPlaylist.c"
}

static guint
music_smart_playlist_real_get_limit_amount (MusicSmartPlaylist* base)
{
	guint result;
	MusicSmartPlaylist* self;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	result = self->priv->_limit_amount;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3311 "SmartPlaylist.c"
}

void
music_smart_playlist_set_limit_amount (MusicSmartPlaylist* self,
                                       guint value)
{
	MusicSmartPlaylistClass* _klass_;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Playlists/SmartPlaylist.vala"
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
#line 41 "../core/Playlists/SmartPlaylist.vala"
	if (_klass_->set_limit_amount) {
#line 41 "../core/Playlists/SmartPlaylist.vala"
		_klass_->set_limit_amount (self, value);
#line 3327 "SmartPlaylist.c"
	}
}

static void
music_smart_playlist_real_set_limit_amount (MusicSmartPlaylist* base,
                                            guint value)
{
	MusicSmartPlaylist* self;
	guint old_value;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	self = base;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	old_value = music_smart_playlist_real_get_limit_amount (base);
#line 41 "../core/Playlists/SmartPlaylist.vala"
	if (old_value != value) {
#line 41 "../core/Playlists/SmartPlaylist.vala"
		self->priv->_limit_amount = value;
#line 41 "../core/Playlists/SmartPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
#line 3347 "SmartPlaylist.c"
	}
}

MusicLibrary*
music_smart_playlist_get_library (MusicSmartPlaylist* self)
{
	MusicLibrary* result;
	MusicLibrary* _tmp0_;
#line 43 "../core/Playlists/SmartPlaylist.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = self->priv->_library;
#line 43 "../core/Playlists/SmartPlaylist.vala"
	result = _tmp0_;
#line 43 "../core/Playlists/SmartPlaylist.vala"
	return result;
#line 3364 "SmartPlaylist.c"
}

void
music_smart_playlist_set_library (MusicSmartPlaylist* self,
                                  MusicLibrary* value)
{
	MusicLibrary* old_value;
#line 43 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 43 "../core/Playlists/SmartPlaylist.vala"
	old_value = music_smart_playlist_get_library (self);
#line 43 "../core/Playlists/SmartPlaylist.vala"
	if (old_value != value) {
#line 3378 "SmartPlaylist.c"
		MusicLibrary* _tmp0_;
#line 43 "../core/Playlists/SmartPlaylist.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 43 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (self->priv->_library);
#line 43 "../core/Playlists/SmartPlaylist.vala"
		self->priv->_library = _tmp0_;
#line 43 "../core/Playlists/SmartPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY]);
#line 3388 "SmartPlaylist.c"
	}
}

static void
_music_smart_playlist___lambda12_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
#line 56 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (medias != NULL);
#line 57 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_analyse_list (self, medias);
#line 3400 "SmartPlaylist.c"
}

static void
__music_smart_playlist___lambda12__music_library_media_added (MusicLibrary* _sender,
                                                              GeeCollection* medias,
                                                              gpointer self)
{
#line 56 "../core/Playlists/SmartPlaylist.vala"
	_music_smart_playlist___lambda12_ ((MusicSmartPlaylist*) self, medias);
#line 3410 "SmartPlaylist.c"
}

static void
_music_smart_playlist___lambda13_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
#line 60 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (medias != NULL);
#line 61 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_analyse_list (self, medias);
#line 3421 "SmartPlaylist.c"
}

static void
__music_smart_playlist___lambda13__music_library_media_updated (MusicLibrary* _sender,
                                                                GeeCollection* medias,
                                                                gpointer self)
{
#line 60 "../core/Playlists/SmartPlaylist.vala"
	_music_smart_playlist___lambda13_ ((MusicSmartPlaylist*) self, medias);
#line 3431 "SmartPlaylist.c"
}

static void
_music_smart_playlist___lambda14_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
	GeeLinkedList* removed = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp13_;
#line 64 "../core/Playlists/SmartPlaylist.vala"
	g_return_if_fail (medias != NULL);
#line 65 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 65 "../core/Playlists/SmartPlaylist.vala"
	removed = _tmp0_;
#line 3447 "SmartPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 66 "../core/Playlists/SmartPlaylist.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) medias);
#line 66 "../core/Playlists/SmartPlaylist.vala"
		_m_it = _tmp1_;
#line 66 "../core/Playlists/SmartPlaylist.vala"
		while (TRUE) {
#line 3457 "SmartPlaylist.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GeeArrayList* _tmp6_;
			MusicMedia* _tmp7_;
#line 66 "../core/Playlists/SmartPlaylist.vala"
			_tmp2_ = _m_it;
#line 66 "../core/Playlists/SmartPlaylist.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 66 "../core/Playlists/SmartPlaylist.vala"
				break;
#line 3471 "SmartPlaylist.c"
			}
#line 66 "../core/Playlists/SmartPlaylist.vala"
			_tmp3_ = _m_it;
#line 66 "../core/Playlists/SmartPlaylist.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 66 "../core/Playlists/SmartPlaylist.vala"
			m = (MusicMedia*) _tmp4_;
#line 67 "../core/Playlists/SmartPlaylist.vala"
			_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 67 "../core/Playlists/SmartPlaylist.vala"
			_tmp6_ = _tmp5_;
#line 67 "../core/Playlists/SmartPlaylist.vala"
			_tmp7_ = m;
#line 67 "../core/Playlists/SmartPlaylist.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp6_, _tmp7_)) {
#line 3487 "SmartPlaylist.c"
				GeeArrayList* _tmp8_;
				GeeArrayList* _tmp9_;
				MusicMedia* _tmp10_;
				GeeLinkedList* _tmp11_;
				MusicMedia* _tmp12_;
#line 68 "../core/Playlists/SmartPlaylist.vala"
				_tmp8_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 68 "../core/Playlists/SmartPlaylist.vala"
				_tmp9_ = _tmp8_;
#line 68 "../core/Playlists/SmartPlaylist.vala"
				_tmp10_ = m;
#line 68 "../core/Playlists/SmartPlaylist.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp10_);
#line 69 "../core/Playlists/SmartPlaylist.vala"
				_tmp11_ = removed;
#line 69 "../core/Playlists/SmartPlaylist.vala"
				_tmp12_ = m;
#line 69 "../core/Playlists/SmartPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 3507 "SmartPlaylist.c"
			}
#line 66 "../core/Playlists/SmartPlaylist.vala"
			_g_object_unref0 (m);
#line 3511 "SmartPlaylist.c"
		}
#line 66 "../core/Playlists/SmartPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 3515 "SmartPlaylist.c"
	}
#line 73 "../core/Playlists/SmartPlaylist.vala"
	_tmp13_ = removed;
#line 73 "../core/Playlists/SmartPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp13_);
#line 64 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (removed);
#line 3523 "SmartPlaylist.c"
}

static void
__music_smart_playlist___lambda14__music_library_media_removed (MusicLibrary* _sender,
                                                                GeeCollection* medias,
                                                                gpointer self)
{
#line 64 "../core/Playlists/SmartPlaylist.vala"
	_music_smart_playlist___lambda14_ ((MusicSmartPlaylist*) self, medias);
#line 3533 "SmartPlaylist.c"
}

static GObject *
music_smart_playlist_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSmartPlaylist * self;
	GThemedIcon* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicLibrary* _tmp4_;
#line 52 "../core/Playlists/SmartPlaylist.vala"
	parent_class = G_OBJECT_CLASS (music_smart_playlist_parent_class);
#line 52 "../core/Playlists/SmartPlaylist.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../core/Playlists/SmartPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
#line 53 "../core/Playlists/SmartPlaylist.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("playlist-automatic");
#line 53 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (((MusicPlaylist*) self)->icon);
#line 53 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylist*) self)->icon = (GIcon*) _tmp0_;
#line 54 "../core/Playlists/SmartPlaylist.vala"
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 54 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (self->queries);
#line 54 "../core/Playlists/SmartPlaylist.vala"
	self->queries = _tmp1_;
#line 56 "../core/Playlists/SmartPlaylist.vala"
	_tmp2_ = self->priv->_library;
#line 56 "../core/Playlists/SmartPlaylist.vala"
	g_signal_connect_object (_tmp2_, "media-added", (GCallback) __music_smart_playlist___lambda12__music_library_media_added, self, 0);
#line 60 "../core/Playlists/SmartPlaylist.vala"
	_tmp3_ = self->priv->_library;
#line 60 "../core/Playlists/SmartPlaylist.vala"
	g_signal_connect_object (_tmp3_, "media-updated", (GCallback) __music_smart_playlist___lambda13__music_library_media_updated, self, 0);
#line 64 "../core/Playlists/SmartPlaylist.vala"
	_tmp4_ = self->priv->_library;
#line 64 "../core/Playlists/SmartPlaylist.vala"
	g_signal_connect_object (_tmp4_, "media-removed", (GCallback) __music_smart_playlist___lambda14__music_library_media_removed, self, 0);
#line 52 "../core/Playlists/SmartPlaylist.vala"
	return obj;
#line 3581 "SmartPlaylist.c"
}

static void
music_smart_playlist_class_init (MusicSmartPlaylistClass * klass,
                                 gpointer klass_data)
{
#line 30 "../core/Playlists/SmartPlaylist.vala"
	music_smart_playlist_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_type_class_adjust_private_offset (klass, &MusicSmartPlaylist_private_offset);
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_smart_playlist_real_add_media;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_smart_playlist_real_add_medias;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_smart_playlist_real_remove_media;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_smart_playlist_real_remove_medias;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->analyse_all = (void (*) (MusicSmartPlaylist*)) music_smart_playlist_real_analyse_all;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->clear_queries = (void (*) (MusicSmartPlaylist*)) music_smart_playlist_real_clear_queries;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->get_queries = (GeeCollection* (*) (MusicSmartPlaylist*)) music_smart_playlist_real_get_queries;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->add_query = (void (*) (MusicSmartPlaylist*, MusicSmartQuery*)) music_smart_playlist_real_add_query;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicSmartPlaylistClass *) klass)->add_queries = (void (*) (MusicSmartPlaylist*, GeeCollection*)) music_smart_playlist_real_add_queries;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_smart_playlist_real_clear;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_conditional = music_smart_playlist_real_get_conditional;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_conditional = music_smart_playlist_real_set_conditional;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit = music_smart_playlist_real_get_limit;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit = music_smart_playlist_real_set_limit;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = music_smart_playlist_real_get_limit_amount;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = music_smart_playlist_real_set_limit_amount;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_smart_playlist_get_property;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_smart_playlist_set_property;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->constructor = music_smart_playlist_constructor;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = music_smart_playlist_finalize;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY] = g_param_spec_int ("query-count", "query-count", "query-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, (guint) 50, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/SmartPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", MUSIC_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 3642 "SmartPlaylist.c"
}

static void
music_smart_playlist_instance_init (MusicSmartPlaylist * self,
                                    gpointer klass)
{
#line 30 "../core/Playlists/SmartPlaylist.vala"
	self->priv = music_smart_playlist_get_instance_private (self);
#line 36 "../core/Playlists/SmartPlaylist.vala"
	self->priv->_conditional = MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL;
#line 38 "../core/Playlists/SmartPlaylist.vala"
	self->priv->_query_count = 0;
#line 40 "../core/Playlists/SmartPlaylist.vala"
	self->priv->_limit = FALSE;
#line 41 "../core/Playlists/SmartPlaylist.vala"
	self->priv->_limit_amount = (guint) 50;
#line 3659 "SmartPlaylist.c"
}

static void
music_smart_playlist_finalize (GObject * obj)
{
	MusicSmartPlaylist * self;
#line 30 "../core/Playlists/SmartPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
#line 37 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (self->queries);
#line 43 "../core/Playlists/SmartPlaylist.vala"
	_g_object_unref0 (self->priv->_library);
#line 30 "../core/Playlists/SmartPlaylist.vala"
	G_OBJECT_CLASS (music_smart_playlist_parent_class)->finalize (obj);
#line 3674 "SmartPlaylist.c"
}

static GType
music_smart_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSmartPlaylist), 0, (GInstanceInitFunc) music_smart_playlist_instance_init, NULL };
	GType music_smart_playlist_type_id;
	music_smart_playlist_type_id = g_type_register_static (MUSIC_TYPE_PLAYLIST, "MusicSmartPlaylist", &g_define_type_info, 0);
	MusicSmartPlaylist_private_offset = g_type_add_instance_private (music_smart_playlist_type_id, sizeof (MusicSmartPlaylistPrivate));
	return music_smart_playlist_type_id;
}

GType
music_smart_playlist_get_type (void)
{
	static volatile gsize music_smart_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_smart_playlist_type_id__once)) {
		GType music_smart_playlist_type_id;
		music_smart_playlist_type_id = music_smart_playlist_get_type_once ();
		g_once_init_leave (&music_smart_playlist_type_id__once, music_smart_playlist_type_id);
	}
	return music_smart_playlist_type_id__once;
}

static void
_vala_music_smart_playlist_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
#line 30 "../core/Playlists/SmartPlaylist.vala"
	switch (property_id) {
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		g_value_set_enum (value, music_smart_playlist_get_conditional (self));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		g_value_set_int (value, music_smart_playlist_get_query_count (self));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		g_value_set_boolean (value, music_smart_playlist_get_limit (self));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		g_value_set_uint (value, music_smart_playlist_get_limit_amount (self));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		g_value_set_object (value, music_smart_playlist_get_library (self));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 3739 "SmartPlaylist.c"
		default:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 3745 "SmartPlaylist.c"
	}
}

static void
_vala_music_smart_playlist_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
#line 30 "../core/Playlists/SmartPlaylist.vala"
	switch (property_id) {
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		music_smart_playlist_set_conditional (self, g_value_get_enum (value));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		music_smart_playlist_set_query_count (self, g_value_get_int (value));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		music_smart_playlist_set_limit (self, g_value_get_boolean (value));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		music_smart_playlist_set_limit_amount (self, g_value_get_uint (value));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 30 "../core/Playlists/SmartPlaylist.vala"
		case MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		music_smart_playlist_set_library (self, g_value_get_object (value));
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 3789 "SmartPlaylist.c"
		default:
#line 30 "../core/Playlists/SmartPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Playlists/SmartPlaylist.vala"
		break;
#line 3795 "SmartPlaylist.c"
	}
}

