/* StaticPlaylist.c generated by valac 0.56.0, the Vala compiler
 * generated from StaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	MUSIC_STATIC_PLAYLIST_0_PROPERTY,
	MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY,
	MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY,
	MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY,
	MUSIC_STATIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicStaticPlaylistPrivate {
	gboolean _read_only;
	gboolean _show_badge;
	gboolean _allow_duplicate;
};

static gint MusicStaticPlaylist_private_offset;
static gpointer music_static_playlist_parent_class = NULL;

static void music_static_playlist_real_add_media (MusicPlaylist* base,
                                           MusicMedia* m);
static void music_static_playlist_real_add_medias (MusicPlaylist* base,
                                            GeeCollection* to_add);
static void music_static_playlist_real_remove_media (MusicPlaylist* base,
                                              MusicMedia* to_remove);
static void music_static_playlist_real_remove_medias (MusicPlaylist* base,
                                               GeeCollection* to_remove);
static void music_static_playlist_real_clear (MusicPlaylist* base);
static GObject * music_static_playlist_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void music_static_playlist_finalize (GObject * obj);
static GType music_static_playlist_get_type_once (void);
static void _vala_music_static_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_static_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
music_static_playlist_get_instance_private (MusicStaticPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicStaticPlaylist_private_offset);
}

MusicStaticPlaylist*
music_static_playlist_construct_with_info (GType object_type,
                                           gint rowid,
                                           const gchar* name)
{
	MusicStaticPlaylist * self = NULL;
#line 35 "../core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 36 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) g_object_new (object_type, "rowid", rowid, "name", name, NULL);
#line 35 "../core/Playlists/StaticPlaylist.vala"
	return self;
#line 102 "StaticPlaylist.c"
}

MusicStaticPlaylist*
music_static_playlist_new_with_info (gint rowid,
                                     const gchar* name)
{
#line 35 "../core/Playlists/StaticPlaylist.vala"
	return music_static_playlist_construct_with_info (MUSIC_TYPE_STATIC_PLAYLIST, rowid, name);
#line 111 "StaticPlaylist.c"
}

static void
music_static_playlist_real_add_media (MusicPlaylist* base,
                                      MusicMedia* m)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 43 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) base;
#line 43 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (m != NULL);
#line 44 "../core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 44 "../core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 45 "../core/Playlists/StaticPlaylist.vala"
	_tmp2_ = self->priv->_allow_duplicate;
#line 45 "../core/Playlists/StaticPlaylist.vala"
	if (_tmp2_) {
#line 45 "../core/Playlists/StaticPlaylist.vala"
		_tmp1_ = TRUE;
#line 137 "StaticPlaylist.c"
	} else {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
#line 45 "../core/Playlists/StaticPlaylist.vala"
		_tmp3_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 45 "../core/Playlists/StaticPlaylist.vala"
		_tmp4_ = _tmp3_;
#line 45 "../core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, m) == FALSE;
#line 147 "StaticPlaylist.c"
	}
#line 45 "../core/Playlists/StaticPlaylist.vala"
	if (_tmp1_) {
#line 151 "StaticPlaylist.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
#line 46 "../core/Playlists/StaticPlaylist.vala"
		_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 46 "../core/Playlists/StaticPlaylist.vala"
		_tmp6_ = _tmp5_;
#line 46 "../core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, m);
#line 47 "../core/Playlists/StaticPlaylist.vala"
		_tmp7_ = added_media;
#line 47 "../core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, m);
#line 48 "../core/Playlists/StaticPlaylist.vala"
		_tmp8_ = added_media;
#line 48 "../core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp8_);
#line 170 "StaticPlaylist.c"
	}
#line 51 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 43 "../core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 176 "StaticPlaylist.c"
}

static void
music_static_playlist_real_add_medias (MusicPlaylist* base,
                                       GeeCollection* to_add)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
#line 54 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) base;
#line 54 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_add != NULL);
#line 55 "../core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 55 "../core/Playlists/StaticPlaylist.vala"
	added_media = _tmp0_;
#line 195 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 56 "../core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_add);
#line 56 "../core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp1_;
#line 56 "../core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 205 "StaticPlaylist.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 56 "../core/Playlists/StaticPlaylist.vala"
			_tmp2_ = _m_it;
#line 56 "../core/Playlists/StaticPlaylist.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 56 "../core/Playlists/StaticPlaylist.vala"
				break;
#line 218 "StaticPlaylist.c"
			}
#line 56 "../core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 56 "../core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 56 "../core/Playlists/StaticPlaylist.vala"
			m = (MusicMedia*) _tmp4_;
#line 57 "../core/Playlists/StaticPlaylist.vala"
			_tmp6_ = self->priv->_allow_duplicate;
#line 57 "../core/Playlists/StaticPlaylist.vala"
			if (_tmp6_) {
#line 57 "../core/Playlists/StaticPlaylist.vala"
				_tmp5_ = TRUE;
#line 232 "StaticPlaylist.c"
			} else {
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				MusicMedia* _tmp9_;
#line 57 "../core/Playlists/StaticPlaylist.vala"
				_tmp7_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 57 "../core/Playlists/StaticPlaylist.vala"
				_tmp8_ = _tmp7_;
#line 57 "../core/Playlists/StaticPlaylist.vala"
				_tmp9_ = m;
#line 57 "../core/Playlists/StaticPlaylist.vala"
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_) == FALSE;
#line 245 "StaticPlaylist.c"
			}
#line 57 "../core/Playlists/StaticPlaylist.vala"
			if (_tmp5_) {
#line 249 "StaticPlaylist.c"
				GeeArrayList* _tmp10_;
				GeeArrayList* _tmp11_;
				MusicMedia* _tmp12_;
				GeeLinkedList* _tmp13_;
				MusicMedia* _tmp14_;
#line 58 "../core/Playlists/StaticPlaylist.vala"
				_tmp10_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 58 "../core/Playlists/StaticPlaylist.vala"
				_tmp11_ = _tmp10_;
#line 58 "../core/Playlists/StaticPlaylist.vala"
				_tmp12_ = m;
#line 58 "../core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
#line 59 "../core/Playlists/StaticPlaylist.vala"
				_tmp13_ = added_media;
#line 59 "../core/Playlists/StaticPlaylist.vala"
				_tmp14_ = m;
#line 59 "../core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 269 "StaticPlaylist.c"
			}
#line 56 "../core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 273 "StaticPlaylist.c"
		}
#line 56 "../core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 277 "StaticPlaylist.c"
	}
#line 63 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 64 "../core/Playlists/StaticPlaylist.vala"
	_tmp15_ = added_media;
#line 64 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp15_);
#line 54 "../core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (added_media);
#line 287 "StaticPlaylist.c"
}

static void
music_static_playlist_real_remove_media (MusicPlaylist* base,
                                         MusicMedia* to_remove)
{
	MusicStaticPlaylist * self;
	gboolean _tmp0_ = FALSE;
#line 67 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) base;
#line 67 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 68 "../core/Playlists/StaticPlaylist.vala"
	if (to_remove != NULL) {
#line 302 "StaticPlaylist.c"
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
#line 68 "../core/Playlists/StaticPlaylist.vala"
		_tmp1_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 68 "../core/Playlists/StaticPlaylist.vala"
		_tmp2_ = _tmp1_;
#line 68 "../core/Playlists/StaticPlaylist.vala"
		_tmp0_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, to_remove);
#line 311 "StaticPlaylist.c"
	} else {
#line 68 "../core/Playlists/StaticPlaylist.vala"
		_tmp0_ = FALSE;
#line 315 "StaticPlaylist.c"
	}
#line 68 "../core/Playlists/StaticPlaylist.vala"
	if (_tmp0_) {
#line 319 "StaticPlaylist.c"
		GeeLinkedList* removed_media = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
#line 69 "../core/Playlists/StaticPlaylist.vala"
		_tmp3_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 69 "../core/Playlists/StaticPlaylist.vala"
		removed_media = _tmp3_;
#line 70 "../core/Playlists/StaticPlaylist.vala"
		_tmp4_ = removed_media;
#line 70 "../core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, to_remove);
#line 71 "../core/Playlists/StaticPlaylist.vala"
		_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 71 "../core/Playlists/StaticPlaylist.vala"
		_tmp6_ = _tmp5_;
#line 71 "../core/Playlists/StaticPlaylist.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, to_remove);
#line 72 "../core/Playlists/StaticPlaylist.vala"
		_tmp7_ = removed_media;
#line 72 "../core/Playlists/StaticPlaylist.vala"
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp7_);
#line 68 "../core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (removed_media);
#line 346 "StaticPlaylist.c"
	}
#line 75 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 350 "StaticPlaylist.c"
}

static void
music_static_playlist_real_remove_medias (MusicPlaylist* base,
                                          GeeCollection* to_remove)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* removed_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
#line 78 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) base;
#line 78 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (to_remove != NULL);
#line 79 "../core/Playlists/StaticPlaylist.vala"
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 79 "../core/Playlists/StaticPlaylist.vala"
	removed_media = _tmp0_;
#line 369 "StaticPlaylist.c"
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
#line 80 "../core/Playlists/StaticPlaylist.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
#line 80 "../core/Playlists/StaticPlaylist.vala"
		_m_it = _tmp1_;
#line 80 "../core/Playlists/StaticPlaylist.vala"
		while (TRUE) {
#line 379 "StaticPlaylist.c"
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
#line 80 "../core/Playlists/StaticPlaylist.vala"
			_tmp2_ = _m_it;
#line 80 "../core/Playlists/StaticPlaylist.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 80 "../core/Playlists/StaticPlaylist.vala"
				break;
#line 392 "StaticPlaylist.c"
			}
#line 80 "../core/Playlists/StaticPlaylist.vala"
			_tmp3_ = _m_it;
#line 80 "../core/Playlists/StaticPlaylist.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 80 "../core/Playlists/StaticPlaylist.vala"
			m = (MusicMedia*) _tmp4_;
#line 81 "../core/Playlists/StaticPlaylist.vala"
			_tmp6_ = m;
#line 81 "../core/Playlists/StaticPlaylist.vala"
			if (_tmp6_ != NULL) {
#line 404 "StaticPlaylist.c"
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				MusicMedia* _tmp9_;
#line 81 "../core/Playlists/StaticPlaylist.vala"
				_tmp7_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 81 "../core/Playlists/StaticPlaylist.vala"
				_tmp8_ = _tmp7_;
#line 81 "../core/Playlists/StaticPlaylist.vala"
				_tmp9_ = m;
#line 81 "../core/Playlists/StaticPlaylist.vala"
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 416 "StaticPlaylist.c"
			} else {
#line 81 "../core/Playlists/StaticPlaylist.vala"
				_tmp5_ = FALSE;
#line 420 "StaticPlaylist.c"
			}
#line 81 "../core/Playlists/StaticPlaylist.vala"
			if (_tmp5_) {
#line 424 "StaticPlaylist.c"
				GeeLinkedList* _tmp10_;
				MusicMedia* _tmp11_;
				GeeArrayList* _tmp12_;
				GeeArrayList* _tmp13_;
				MusicMedia* _tmp14_;
#line 82 "../core/Playlists/StaticPlaylist.vala"
				_tmp10_ = removed_media;
#line 82 "../core/Playlists/StaticPlaylist.vala"
				_tmp11_ = m;
#line 82 "../core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 83 "../core/Playlists/StaticPlaylist.vala"
				_tmp12_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 83 "../core/Playlists/StaticPlaylist.vala"
				_tmp13_ = _tmp12_;
#line 83 "../core/Playlists/StaticPlaylist.vala"
				_tmp14_ = m;
#line 83 "../core/Playlists/StaticPlaylist.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 444 "StaticPlaylist.c"
			}
#line 80 "../core/Playlists/StaticPlaylist.vala"
			_g_object_unref0 (m);
#line 448 "StaticPlaylist.c"
		}
#line 80 "../core/Playlists/StaticPlaylist.vala"
		_g_object_unref0 (_m_it);
#line 452 "StaticPlaylist.c"
	}
#line 87 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 88 "../core/Playlists/StaticPlaylist.vala"
	_tmp15_ = removed_media;
#line 88 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp15_);
#line 78 "../core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (removed_media);
#line 462 "StaticPlaylist.c"
}

static void
music_static_playlist_real_clear (MusicPlaylist* base)
{
	MusicStaticPlaylist * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 91 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) base;
#line 92 "../core/Playlists/StaticPlaylist.vala"
	_tmp0_ = music_playlist_get_medias ((MusicPlaylist*) self);
#line 92 "../core/Playlists/StaticPlaylist.vala"
	_tmp1_ = _tmp0_;
#line 92 "../core/Playlists/StaticPlaylist.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 93 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "cleared");
#line 94 "../core/Playlists/StaticPlaylist.vala"
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
#line 483 "StaticPlaylist.c"
}

MusicStaticPlaylist*
music_static_playlist_construct (GType object_type)
{
	MusicStaticPlaylist * self = NULL;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	self = (MusicStaticPlaylist*) music_playlist_construct (object_type);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	return self;
#line 494 "StaticPlaylist.c"
}

MusicStaticPlaylist*
music_static_playlist_new (void)
{
#line 30 "../core/Playlists/StaticPlaylist.vala"
	return music_static_playlist_construct (MUSIC_TYPE_STATIC_PLAYLIST);
#line 502 "StaticPlaylist.c"
}

gboolean
music_static_playlist_get_read_only (MusicStaticPlaylist* self)
{
	gboolean result;
#line 31 "../core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../core/Playlists/StaticPlaylist.vala"
	result = self->priv->_read_only;
#line 31 "../core/Playlists/StaticPlaylist.vala"
	return result;
#line 515 "StaticPlaylist.c"
}

void
music_static_playlist_set_read_only (MusicStaticPlaylist* self,
                                     gboolean value)
{
	gboolean old_value;
#line 31 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 31 "../core/Playlists/StaticPlaylist.vala"
	old_value = music_static_playlist_get_read_only (self);
#line 31 "../core/Playlists/StaticPlaylist.vala"
	if (old_value != value) {
#line 31 "../core/Playlists/StaticPlaylist.vala"
		self->priv->_read_only = value;
#line 31 "../core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY]);
#line 533 "StaticPlaylist.c"
	}
}

gboolean
music_static_playlist_get_show_badge (MusicStaticPlaylist* self)
{
	gboolean result;
#line 32 "../core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../core/Playlists/StaticPlaylist.vala"
	result = self->priv->_show_badge;
#line 32 "../core/Playlists/StaticPlaylist.vala"
	return result;
#line 547 "StaticPlaylist.c"
}

void
music_static_playlist_set_show_badge (MusicStaticPlaylist* self,
                                      gboolean value)
{
	gboolean old_value;
#line 32 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Playlists/StaticPlaylist.vala"
	old_value = music_static_playlist_get_show_badge (self);
#line 32 "../core/Playlists/StaticPlaylist.vala"
	if (old_value != value) {
#line 32 "../core/Playlists/StaticPlaylist.vala"
		self->priv->_show_badge = value;
#line 32 "../core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY]);
#line 565 "StaticPlaylist.c"
	}
}

gboolean
music_static_playlist_get_allow_duplicate (MusicStaticPlaylist* self)
{
	gboolean result;
#line 33 "../core/Playlists/StaticPlaylist.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../core/Playlists/StaticPlaylist.vala"
	result = self->priv->_allow_duplicate;
#line 33 "../core/Playlists/StaticPlaylist.vala"
	return result;
#line 579 "StaticPlaylist.c"
}

void
music_static_playlist_set_allow_duplicate (MusicStaticPlaylist* self,
                                           gboolean value)
{
	gboolean old_value;
#line 33 "../core/Playlists/StaticPlaylist.vala"
	g_return_if_fail (self != NULL);
#line 33 "../core/Playlists/StaticPlaylist.vala"
	old_value = music_static_playlist_get_allow_duplicate (self);
#line 33 "../core/Playlists/StaticPlaylist.vala"
	if (old_value != value) {
#line 33 "../core/Playlists/StaticPlaylist.vala"
		self->priv->_allow_duplicate = value;
#line 33 "../core/Playlists/StaticPlaylist.vala"
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY]);
#line 597 "StaticPlaylist.c"
	}
}

static GObject *
music_static_playlist_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicStaticPlaylist * self;
	GThemedIcon* _tmp0_;
#line 39 "../core/Playlists/StaticPlaylist.vala"
	parent_class = G_OBJECT_CLASS (music_static_playlist_parent_class);
#line 39 "../core/Playlists/StaticPlaylist.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../core/Playlists/StaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
#line 40 "../core/Playlists/StaticPlaylist.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("playlist");
#line 40 "../core/Playlists/StaticPlaylist.vala"
	_g_object_unref0 (((MusicPlaylist*) self)->icon);
#line 40 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylist*) self)->icon = (GIcon*) _tmp0_;
#line 39 "../core/Playlists/StaticPlaylist.vala"
	return obj;
#line 624 "StaticPlaylist.c"
}

static void
music_static_playlist_class_init (MusicStaticPlaylistClass * klass,
                                  gpointer klass_data)
{
#line 30 "../core/Playlists/StaticPlaylist.vala"
	music_static_playlist_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	g_type_class_adjust_private_offset (klass, &MusicStaticPlaylist_private_offset);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_static_playlist_real_add_media;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_static_playlist_real_add_medias;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_static_playlist_real_remove_media;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_static_playlist_real_remove_medias;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_static_playlist_real_clear;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_static_playlist_get_property;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_static_playlist_set_property;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->constructor = music_static_playlist_constructor;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (klass)->finalize = music_static_playlist_finalize;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY] = g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Playlists/StaticPlaylist.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY] = g_param_spec_boolean ("allow-duplicate", "allow-duplicate", "allow-duplicate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 659 "StaticPlaylist.c"
}

static void
music_static_playlist_instance_init (MusicStaticPlaylist * self,
                                     gpointer klass)
{
#line 30 "../core/Playlists/StaticPlaylist.vala"
	self->priv = music_static_playlist_get_instance_private (self);
#line 31 "../core/Playlists/StaticPlaylist.vala"
	self->priv->_read_only = FALSE;
#line 32 "../core/Playlists/StaticPlaylist.vala"
	self->priv->_show_badge = FALSE;
#line 33 "../core/Playlists/StaticPlaylist.vala"
	self->priv->_allow_duplicate = FALSE;
#line 674 "StaticPlaylist.c"
}

static void
music_static_playlist_finalize (GObject * obj)
{
	MusicStaticPlaylist * self;
#line 30 "../core/Playlists/StaticPlaylist.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	G_OBJECT_CLASS (music_static_playlist_parent_class)->finalize (obj);
#line 685 "StaticPlaylist.c"
}

static GType
music_static_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicStaticPlaylist), 0, (GInstanceInitFunc) music_static_playlist_instance_init, NULL };
	GType music_static_playlist_type_id;
	music_static_playlist_type_id = g_type_register_static (MUSIC_TYPE_PLAYLIST, "MusicStaticPlaylist", &g_define_type_info, 0);
	MusicStaticPlaylist_private_offset = g_type_add_instance_private (music_static_playlist_type_id, sizeof (MusicStaticPlaylistPrivate));
	return music_static_playlist_type_id;
}

GType
music_static_playlist_get_type (void)
{
	static volatile gsize music_static_playlist_type_id__once = 0;
	if (g_once_init_enter (&music_static_playlist_type_id__once)) {
		GType music_static_playlist_type_id;
		music_static_playlist_type_id = music_static_playlist_get_type_once ();
		g_once_init_leave (&music_static_playlist_type_id__once, music_static_playlist_type_id);
	}
	return music_static_playlist_type_id__once;
}

static void
_vala_music_static_playlist_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, music_static_playlist_get_read_only (self));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, music_static_playlist_get_show_badge (self));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		g_value_set_boolean (value, music_static_playlist_get_allow_duplicate (self));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 738 "StaticPlaylist.c"
		default:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 744 "StaticPlaylist.c"
	}
}

static void
_vala_music_static_playlist_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
#line 30 "../core/Playlists/StaticPlaylist.vala"
	switch (property_id) {
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		music_static_playlist_set_read_only (self, g_value_get_boolean (value));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		music_static_playlist_set_show_badge (self, g_value_get_boolean (value));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 30 "../core/Playlists/StaticPlaylist.vala"
		case MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		music_static_playlist_set_allow_duplicate (self, g_value_get_boolean (value));
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 776 "StaticPlaylist.c"
		default:
#line 30 "../core/Playlists/StaticPlaylist.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Playlists/StaticPlaylist.vala"
		break;
#line 782 "StaticPlaylist.c"
	}
}

