/* PluginInterface.c generated by valac 0.56.0, the Vala compiler
 * generated from PluginInterface.vala, do not modify */

/*-
 * Copyright (c) 2012-2020 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Zeeshan Ali (Khattak) <zeeshanak@gnome.org> (from Rygel)
 *              Lucas Baudin <xapantu@gmail.com> (from Pantheon Files)
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	MUSIC_PLUGINS_INTERFACE_0_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY,
	MUSIC_PLUGINS_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;

struct _MusicPluginsInterfacePrivate {
	MusicPluginsManager* _manager;
	GtkNotebook* _context;
	GtkNotebook* _sidebar;
	GtkApplication* _noise_app;
	GtkToolbar* _toolbar;
	GtkWindow* _window;
	gchar* _set_name;
	gchar* _argument;
	GList* _all_source_view;
};

struct _Block7Data {
	int _ref_count_;
	MusicPluginsInterface* self;
	MusicPluginsInterfaceHookFunctionArg hook_function;
	gpointer hook_function_target;
};

struct _Block8Data {
	int _ref_count_;
	MusicPluginsInterface* self;
	MusicPluginsInterfaceHookFunction hook_function;
	gpointer hook_function_target;
};

static gint MusicPluginsInterface_private_offset;
static gpointer music_plugins_interface_parent_class = NULL;

static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda17_ (Block7Data* _data7_,
                   GtkTextView* m);
static void ____lambda17__music_plugins_manager_hook_source_view (MusicPluginsManager* _sender,
                                                           GtkTextView* view,
                                                           gpointer self);
static GList* music_plugins_interface_get_all_source_view (MusicPluginsInterface* self);
static void ___lambda18_ (Block7Data* _data7_,
                   GtkWindow* d);
static void ____lambda18__music_plugins_manager_hook_preferences_window (MusicPluginsManager* _sender,
                                                                  GtkWindow* window,
                                                                  gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda19_ (Block8Data* _data8_);
static void ____lambda19__music_plugins_manager_hook_notebook_context (MusicPluginsManager* _sender,
                                                                gpointer self);
static void ___lambda20_ (Block8Data* _data8_);
static void ____lambda20__music_plugins_manager_hook_notebook_sidebar (MusicPluginsManager* _sender,
                                                                gpointer self);
static void ___lambda21_ (Block8Data* _data8_);
static void ____lambda21__music_plugins_manager_hook_toolbar (MusicPluginsManager* _sender,
                                                       gpointer self);
static void ___lambda22_ (Block8Data* _data8_);
static void ____lambda22__music_plugins_manager_hook_new_window (MusicPluginsManager* _sender,
                                                          GtkWindow* window,
                                                          gpointer self);
VALA_EXTERN void music_plugins_interface_set_context (MusicPluginsInterface* self,
                                          GtkNotebook* value);
VALA_EXTERN void music_plugins_interface_set_sidebar (MusicPluginsInterface* self,
                                          GtkNotebook* value);
VALA_EXTERN void music_plugins_interface_set_noise_app (MusicPluginsInterface* self,
                                            GtkApplication* value);
VALA_EXTERN void music_plugins_interface_set_toolbar (MusicPluginsInterface* self,
                                          GtkToolbar* value);
static void music_plugins_interface_set_window (MusicPluginsInterface* self,
                                         GtkWindow* value);
VALA_EXTERN void music_plugins_interface_set_set_name (MusicPluginsInterface* self,
                                           const gchar* value);
static const gchar* music_plugins_interface_get_argument (MusicPluginsInterface* self);
static void music_plugins_interface_set_argument (MusicPluginsInterface* self,
                                           const gchar* value);
static void music_plugins_interface_set_all_source_view (MusicPluginsInterface* self,
                                                  GList* value);
static GObject * music_plugins_interface_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _music_plugins_interface___lambda23_ (MusicPluginsInterface* self,
                                           GtkWindow* m);
static void __music_plugins_interface___lambda23__music_plugins_manager_hook_new_window (MusicPluginsManager* _sender,
                                                                                  GtkWindow* window,
                                                                                  gpointer self);
static void _music_plugins_interface___lambda24_ (MusicPluginsInterface* self,
                                           GtkTextView* m);
static void __music_plugins_interface___lambda24__music_plugins_manager_hook_source_view (MusicPluginsManager* _sender,
                                                                                   GtkTextView* view,
                                                                                   gpointer self);
static void music_plugins_interface_finalize (GObject * obj);
static GType music_plugins_interface_get_type_once (void);
static void _vala_music_plugins_interface_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_music_plugins_interface_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
music_plugins_interface_get_instance_private (MusicPluginsInterface* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsInterface_private_offset);
}

static GType
music_plugins_interface_hook_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_PLUGINS_INTERFACE_HOOK_CONTEXT, "MUSIC_PLUGINS_INTERFACE_HOOK_CONTEXT", "context"}, {MUSIC_PLUGINS_INTERFACE_HOOK_SIDEBAR, "MUSIC_PLUGINS_INTERFACE_HOOK_SIDEBAR", "sidebar"}, {MUSIC_PLUGINS_INTERFACE_HOOK_TOOLBAR, "MUSIC_PLUGINS_INTERFACE_HOOK_TOOLBAR", "toolbar"}, {MUSIC_PLUGINS_INTERFACE_HOOK_SOURCE_VIEW, "MUSIC_PLUGINS_INTERFACE_HOOK_SOURCE_VIEW", "source-view"}, {MUSIC_PLUGINS_INTERFACE_HOOK_SETTINGS_WINDOW, "MUSIC_PLUGINS_INTERFACE_HOOK_SETTINGS_WINDOW", "settings-window"}, {MUSIC_PLUGINS_INTERFACE_HOOK_WINDOW, "MUSIC_PLUGINS_INTERFACE_HOOK_WINDOW", "window"}, {0, NULL, NULL}};
	GType music_plugins_interface_hook_type_id;
	music_plugins_interface_hook_type_id = g_enum_register_static ("MusicPluginsInterfaceHook", values);
	return music_plugins_interface_hook_type_id;
}

GType
music_plugins_interface_hook_get_type (void)
{
	static volatile gsize music_plugins_interface_hook_type_id__once = 0;
	if (g_once_init_enter (&music_plugins_interface_hook_type_id__once)) {
		GType music_plugins_interface_hook_type_id;
		music_plugins_interface_hook_type_id = music_plugins_interface_hook_get_type_once ();
		g_once_init_leave (&music_plugins_interface_hook_type_id__once, music_plugins_interface_hook_type_id);
	}
	return music_plugins_interface_hook_type_id__once;
}

MusicPluginsInterface*
music_plugins_interface_construct (GType object_type,
                                   MusicPluginsManager* manager)
{
	MusicPluginsInterface * self = NULL;
#line 58 "../core/PluginInterface.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 59 "../core/PluginInterface.vala"
	self = (MusicPluginsInterface*) g_object_new (object_type, "manager", manager, NULL);
#line 58 "../core/PluginInterface.vala"
	return self;
#line 198 "PluginInterface.c"
}

MusicPluginsInterface*
music_plugins_interface_new (MusicPluginsManager* manager)
{
#line 58 "../core/PluginInterface.vala"
	return music_plugins_interface_construct (MUSIC_PLUGINS_TYPE_INTERFACE, manager);
#line 206 "PluginInterface.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 74 "../core/PluginInterface.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 74 "../core/PluginInterface.vala"
	return _data7_;
#line 216 "PluginInterface.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 74 "../core/PluginInterface.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 226 "PluginInterface.c"
		MusicPluginsInterface* self;
#line 74 "../core/PluginInterface.vala"
		self = _data7_->self;
#line 74 "../core/PluginInterface.vala"
		_g_object_unref0 (self);
#line 74 "../core/PluginInterface.vala"
		g_slice_free (Block7Data, _data7_);
#line 234 "PluginInterface.c"
	}
}

static void
___lambda17_ (Block7Data* _data7_,
              GtkTextView* m)
{
	MusicPluginsInterface* self;
#line 77 "../core/PluginInterface.vala"
	self = _data7_->self;
#line 77 "../core/PluginInterface.vala"
	g_return_if_fail (m != NULL);
#line 78 "../core/PluginInterface.vala"
	_data7_->hook_function ((GObject*) m, _data7_->hook_function_target);
#line 249 "PluginInterface.c"
}

static void
____lambda17__music_plugins_manager_hook_source_view (MusicPluginsManager* _sender,
                                                      GtkTextView* view,
                                                      gpointer self)
{
#line 77 "../core/PluginInterface.vala"
	___lambda17_ (self, view);
#line 259 "PluginInterface.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 80 "../core/PluginInterface.vala"
	return self ? g_object_ref (self) : NULL;
#line 267 "PluginInterface.c"
}

static void
___lambda18_ (Block7Data* _data7_,
              GtkWindow* d)
{
	MusicPluginsInterface* self;
#line 85 "../core/PluginInterface.vala"
	self = _data7_->self;
#line 85 "../core/PluginInterface.vala"
	g_return_if_fail (d != NULL);
#line 86 "../core/PluginInterface.vala"
	_data7_->hook_function ((GObject*) d, _data7_->hook_function_target);
#line 281 "PluginInterface.c"
}

static void
____lambda18__music_plugins_manager_hook_preferences_window (MusicPluginsManager* _sender,
                                                             GtkWindow* window,
                                                             gpointer self)
{
#line 85 "../core/PluginInterface.vala"
	___lambda18_ (self, window);
#line 291 "PluginInterface.c"
}

void
music_plugins_interface_register_function_arg (MusicPluginsInterface* self,
                                               MusicPluginsInterfaceHook hook,
                                               MusicPluginsInterfaceHookFunctionArg hook_function,
                                               gpointer hook_function_target)
{
	Block7Data* _data7_;
#line 74 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 74 "../core/PluginInterface.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 74 "../core/PluginInterface.vala"
	_data7_->_ref_count_ = 1;
#line 74 "../core/PluginInterface.vala"
	_data7_->self = g_object_ref (self);
#line 74 "../core/PluginInterface.vala"
	_data7_->hook_function = hook_function;
#line 74 "../core/PluginInterface.vala"
	_data7_->hook_function_target = hook_function_target;
#line 75 "../core/PluginInterface.vala"
	switch (hook) {
#line 75 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_SOURCE_VIEW:
#line 317 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp0_;
			GList* _tmp1_;
#line 77 "../core/PluginInterface.vala"
			_tmp0_ = self->priv->_manager;
#line 77 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp0_, "hook-source-view", (GCallback) ____lambda17__music_plugins_manager_hook_source_view, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, G_CONNECT_AFTER);
#line 80 "../core/PluginInterface.vala"
			_tmp1_ = self->priv->_all_source_view;
#line 327 "PluginInterface.c"
			{
				GList* source_view_collection = NULL;
				GList* source_view_it = NULL;
#line 80 "../core/PluginInterface.vala"
				source_view_collection = _tmp1_;
#line 80 "../core/PluginInterface.vala"
				for (source_view_it = source_view_collection; source_view_it != NULL; source_view_it = source_view_it->next) {
#line 335 "PluginInterface.c"
					GtkTextView* _tmp2_;
					GtkTextView* source_view = NULL;
#line 80 "../core/PluginInterface.vala"
					_tmp2_ = _g_object_ref0 ((GtkTextView*) source_view_it->data);
#line 80 "../core/PluginInterface.vala"
					source_view = _tmp2_;
#line 342 "PluginInterface.c"
					{
						GtkTextView* _tmp3_;
#line 81 "../core/PluginInterface.vala"
						_tmp3_ = source_view;
#line 81 "../core/PluginInterface.vala"
						_data7_->hook_function ((GObject*) _tmp3_, _data7_->hook_function_target);
#line 80 "../core/PluginInterface.vala"
						_g_object_unref0 (source_view);
#line 351 "PluginInterface.c"
					}
				}
			}
#line 83 "../core/PluginInterface.vala"
			break;
#line 357 "PluginInterface.c"
		}
#line 75 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_SETTINGS_WINDOW:
#line 361 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp4_;
#line 85 "../core/PluginInterface.vala"
			_tmp4_ = self->priv->_manager;
#line 85 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp4_, "hook-preferences-window", (GCallback) ____lambda18__music_plugins_manager_hook_preferences_window, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, G_CONNECT_AFTER);
#line 88 "../core/PluginInterface.vala"
			break;
#line 370 "PluginInterface.c"
		}
		default:
#line 75 "../core/PluginInterface.vala"
		break;
#line 375 "PluginInterface.c"
	}
#line 74 "../core/PluginInterface.vala"
	block7_data_unref (_data7_);
#line 74 "../core/PluginInterface.vala"
	_data7_ = NULL;
#line 381 "PluginInterface.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 92 "../core/PluginInterface.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 92 "../core/PluginInterface.vala"
	return _data8_;
#line 391 "PluginInterface.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 92 "../core/PluginInterface.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 401 "PluginInterface.c"
		MusicPluginsInterface* self;
#line 92 "../core/PluginInterface.vala"
		self = _data8_->self;
#line 92 "../core/PluginInterface.vala"
		_g_object_unref0 (self);
#line 92 "../core/PluginInterface.vala"
		g_slice_free (Block8Data, _data8_);
#line 409 "PluginInterface.c"
	}
}

static void
___lambda19_ (Block8Data* _data8_)
{
	MusicPluginsInterface* self;
#line 95 "../core/PluginInterface.vala"
	self = _data8_->self;
#line 96 "../core/PluginInterface.vala"
	_data8_->hook_function (_data8_->hook_function_target);
#line 421 "PluginInterface.c"
}

static void
____lambda19__music_plugins_manager_hook_notebook_context (MusicPluginsManager* _sender,
                                                           gpointer self)
{
#line 95 "../core/PluginInterface.vala"
	___lambda19_ (self);
#line 430 "PluginInterface.c"
}

static void
___lambda20_ (Block8Data* _data8_)
{
	MusicPluginsInterface* self;
#line 103 "../core/PluginInterface.vala"
	self = _data8_->self;
#line 104 "../core/PluginInterface.vala"
	_data8_->hook_function (_data8_->hook_function_target);
#line 441 "PluginInterface.c"
}

static void
____lambda20__music_plugins_manager_hook_notebook_sidebar (MusicPluginsManager* _sender,
                                                           gpointer self)
{
#line 103 "../core/PluginInterface.vala"
	___lambda20_ (self);
#line 450 "PluginInterface.c"
}

static void
___lambda21_ (Block8Data* _data8_)
{
	MusicPluginsInterface* self;
#line 111 "../core/PluginInterface.vala"
	self = _data8_->self;
#line 112 "../core/PluginInterface.vala"
	_data8_->hook_function (_data8_->hook_function_target);
#line 461 "PluginInterface.c"
}

static void
____lambda21__music_plugins_manager_hook_toolbar (MusicPluginsManager* _sender,
                                                  gpointer self)
{
#line 111 "../core/PluginInterface.vala"
	___lambda21_ (self);
#line 470 "PluginInterface.c"
}

static void
___lambda22_ (Block8Data* _data8_)
{
	MusicPluginsInterface* self;
#line 119 "../core/PluginInterface.vala"
	self = _data8_->self;
#line 120 "../core/PluginInterface.vala"
	_data8_->hook_function (_data8_->hook_function_target);
#line 481 "PluginInterface.c"
}

static void
____lambda22__music_plugins_manager_hook_new_window (MusicPluginsManager* _sender,
                                                     GtkWindow* window,
                                                     gpointer self)
{
#line 119 "../core/PluginInterface.vala"
	___lambda22_ (self);
#line 491 "PluginInterface.c"
}

void
music_plugins_interface_register_function (MusicPluginsInterface* self,
                                           MusicPluginsInterfaceHook hook,
                                           MusicPluginsInterfaceHookFunction hook_function,
                                           gpointer hook_function_target)
{
	Block8Data* _data8_;
#line 92 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 92 "../core/PluginInterface.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 92 "../core/PluginInterface.vala"
	_data8_->_ref_count_ = 1;
#line 92 "../core/PluginInterface.vala"
	_data8_->self = g_object_ref (self);
#line 92 "../core/PluginInterface.vala"
	_data8_->hook_function = hook_function;
#line 92 "../core/PluginInterface.vala"
	_data8_->hook_function_target = hook_function_target;
#line 93 "../core/PluginInterface.vala"
	switch (hook) {
#line 93 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_CONTEXT:
#line 517 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp0_;
			GtkNotebook* _tmp1_;
#line 95 "../core/PluginInterface.vala"
			_tmp0_ = self->priv->_manager;
#line 95 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp0_, "hook-notebook-context", (GCallback) ____lambda19__music_plugins_manager_hook_notebook_context, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, G_CONNECT_AFTER);
#line 98 "../core/PluginInterface.vala"
			_tmp1_ = self->priv->_context;
#line 98 "../core/PluginInterface.vala"
			if (_tmp1_ != NULL) {
#line 99 "../core/PluginInterface.vala"
				_data8_->hook_function (_data8_->hook_function_target);
#line 531 "PluginInterface.c"
			}
#line 101 "../core/PluginInterface.vala"
			break;
#line 535 "PluginInterface.c"
		}
#line 93 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_SIDEBAR:
#line 539 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp2_;
			GtkNotebook* _tmp3_;
#line 103 "../core/PluginInterface.vala"
			_tmp2_ = self->priv->_manager;
#line 103 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp2_, "hook-notebook-sidebar", (GCallback) ____lambda20__music_plugins_manager_hook_notebook_sidebar, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, G_CONNECT_AFTER);
#line 106 "../core/PluginInterface.vala"
			_tmp3_ = self->priv->_sidebar;
#line 106 "../core/PluginInterface.vala"
			if (_tmp3_ != NULL) {
#line 107 "../core/PluginInterface.vala"
				_data8_->hook_function (_data8_->hook_function_target);
#line 553 "PluginInterface.c"
			}
#line 109 "../core/PluginInterface.vala"
			break;
#line 557 "PluginInterface.c"
		}
#line 93 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_TOOLBAR:
#line 561 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp4_;
			GtkToolbar* _tmp5_;
#line 111 "../core/PluginInterface.vala"
			_tmp4_ = self->priv->_manager;
#line 111 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp4_, "hook-toolbar", (GCallback) ____lambda21__music_plugins_manager_hook_toolbar, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, G_CONNECT_AFTER);
#line 114 "../core/PluginInterface.vala"
			_tmp5_ = self->priv->_toolbar;
#line 114 "../core/PluginInterface.vala"
			if (_tmp5_ != NULL) {
#line 115 "../core/PluginInterface.vala"
				_data8_->hook_function (_data8_->hook_function_target);
#line 575 "PluginInterface.c"
			}
#line 117 "../core/PluginInterface.vala"
			break;
#line 579 "PluginInterface.c"
		}
#line 93 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_HOOK_WINDOW:
#line 583 "PluginInterface.c"
		{
			MusicPluginsManager* _tmp6_;
			GtkWindow* _tmp7_;
#line 119 "../core/PluginInterface.vala"
			_tmp6_ = self->priv->_manager;
#line 119 "../core/PluginInterface.vala"
			g_signal_connect_data (_tmp6_, "hook-new-window", (GCallback) ____lambda22__music_plugins_manager_hook_new_window, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, G_CONNECT_AFTER);
#line 122 "../core/PluginInterface.vala"
			_tmp7_ = self->priv->_window;
#line 122 "../core/PluginInterface.vala"
			if (_tmp7_ != NULL) {
#line 123 "../core/PluginInterface.vala"
				_data8_->hook_function (_data8_->hook_function_target);
#line 597 "PluginInterface.c"
			}
#line 125 "../core/PluginInterface.vala"
			break;
#line 601 "PluginInterface.c"
		}
		default:
#line 93 "../core/PluginInterface.vala"
		break;
#line 606 "PluginInterface.c"
	}
#line 92 "../core/PluginInterface.vala"
	block8_data_unref (_data8_);
#line 92 "../core/PluginInterface.vala"
	_data8_ = NULL;
#line 612 "PluginInterface.c"
}

MusicPluginsManager*
music_plugins_interface_get_manager (MusicPluginsInterface* self)
{
	MusicPluginsManager* result;
	MusicPluginsManager* _tmp0_;
#line 33 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_manager;
#line 33 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 33 "../core/PluginInterface.vala"
	return result;
#line 628 "PluginInterface.c"
}

static void
music_plugins_interface_set_manager (MusicPluginsInterface* self,
                                     MusicPluginsManager* value)
{
	MusicPluginsManager* old_value;
#line 33 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 33 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_manager (self);
#line 33 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 33 "../core/PluginInterface.vala"
		self->priv->_manager = value;
#line 33 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY]);
#line 646 "PluginInterface.c"
	}
}

GtkNotebook*
music_plugins_interface_get_context (MusicPluginsInterface* self)
{
	GtkNotebook* result;
	GtkNotebook* _tmp0_;
#line 47 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_context;
#line 47 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 47 "../core/PluginInterface.vala"
	return result;
#line 663 "PluginInterface.c"
}

void
music_plugins_interface_set_context (MusicPluginsInterface* self,
                                     GtkNotebook* value)
{
	GtkNotebook* old_value;
#line 47 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_context (self);
#line 47 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 677 "PluginInterface.c"
		GtkNotebook* _tmp0_;
#line 47 "../core/PluginInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 47 "../core/PluginInterface.vala"
		_g_object_unref0 (self->priv->_context);
#line 47 "../core/PluginInterface.vala"
		self->priv->_context = _tmp0_;
#line 47 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY]);
#line 687 "PluginInterface.c"
	}
}

GtkNotebook*
music_plugins_interface_get_sidebar (MusicPluginsInterface* self)
{
	GtkNotebook* result;
	GtkNotebook* _tmp0_;
#line 48 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_sidebar;
#line 48 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 48 "../core/PluginInterface.vala"
	return result;
#line 704 "PluginInterface.c"
}

void
music_plugins_interface_set_sidebar (MusicPluginsInterface* self,
                                     GtkNotebook* value)
{
	GtkNotebook* old_value;
#line 48 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 48 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_sidebar (self);
#line 48 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 718 "PluginInterface.c"
		GtkNotebook* _tmp0_;
#line 48 "../core/PluginInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../core/PluginInterface.vala"
		_g_object_unref0 (self->priv->_sidebar);
#line 48 "../core/PluginInterface.vala"
		self->priv->_sidebar = _tmp0_;
#line 48 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY]);
#line 728 "PluginInterface.c"
	}
}

GtkApplication*
music_plugins_interface_get_noise_app (MusicPluginsInterface* self)
{
	GtkApplication* result;
	GtkApplication* _tmp0_;
#line 49 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_noise_app;
#line 49 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 49 "../core/PluginInterface.vala"
	return result;
#line 745 "PluginInterface.c"
}

void
music_plugins_interface_set_noise_app (MusicPluginsInterface* self,
                                       GtkApplication* value)
{
	GtkApplication* old_value;
#line 49 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 49 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_noise_app (self);
#line 49 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 759 "PluginInterface.c"
		GtkApplication* _tmp0_;
#line 49 "../core/PluginInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../core/PluginInterface.vala"
		_g_object_unref0 (self->priv->_noise_app);
#line 49 "../core/PluginInterface.vala"
		self->priv->_noise_app = _tmp0_;
#line 49 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY]);
#line 769 "PluginInterface.c"
	}
}

GtkToolbar*
music_plugins_interface_get_toolbar (MusicPluginsInterface* self)
{
	GtkToolbar* result;
	GtkToolbar* _tmp0_;
#line 50 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_toolbar;
#line 50 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 50 "../core/PluginInterface.vala"
	return result;
#line 786 "PluginInterface.c"
}

void
music_plugins_interface_set_toolbar (MusicPluginsInterface* self,
                                     GtkToolbar* value)
{
	GtkToolbar* old_value;
#line 50 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 50 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_toolbar (self);
#line 50 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 800 "PluginInterface.c"
		GtkToolbar* _tmp0_;
#line 50 "../core/PluginInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../core/PluginInterface.vala"
		_g_object_unref0 (self->priv->_toolbar);
#line 50 "../core/PluginInterface.vala"
		self->priv->_toolbar = _tmp0_;
#line 50 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY]);
#line 810 "PluginInterface.c"
	}
}

GtkWindow*
music_plugins_interface_get_window (MusicPluginsInterface* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 51 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_window;
#line 51 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 51 "../core/PluginInterface.vala"
	return result;
#line 827 "PluginInterface.c"
}

static void
music_plugins_interface_set_window (MusicPluginsInterface* self,
                                    GtkWindow* value)
{
	GtkWindow* old_value;
#line 51 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 51 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_window (self);
#line 51 "../core/PluginInterface.vala"
	if (old_value != value) {
#line 841 "PluginInterface.c"
		GtkWindow* _tmp0_;
#line 51 "../core/PluginInterface.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 51 "../core/PluginInterface.vala"
		_g_object_unref0 (self->priv->_window);
#line 51 "../core/PluginInterface.vala"
		self->priv->_window = _tmp0_;
#line 51 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY]);
#line 851 "PluginInterface.c"
	}
}

const gchar*
music_plugins_interface_get_set_name (MusicPluginsInterface* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_set_name;
#line 52 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 52 "../core/PluginInterface.vala"
	return result;
#line 868 "PluginInterface.c"
}

void
music_plugins_interface_set_set_name (MusicPluginsInterface* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 52 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 52 "../core/PluginInterface.vala"
	old_value = music_plugins_interface_get_set_name (self);
#line 52 "../core/PluginInterface.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 882 "PluginInterface.c"
		gchar* _tmp0_;
#line 52 "../core/PluginInterface.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../core/PluginInterface.vala"
		_g_free0 (self->priv->_set_name);
#line 52 "../core/PluginInterface.vala"
		self->priv->_set_name = _tmp0_;
#line 52 "../core/PluginInterface.vala"
		g_object_notify_by_pspec ((GObject *) self, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY]);
#line 892 "PluginInterface.c"
	}
}

static const gchar*
music_plugins_interface_get_argument (MusicPluginsInterface* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_argument;
#line 54 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 54 "../core/PluginInterface.vala"
	return result;
#line 909 "PluginInterface.c"
}

static void
music_plugins_interface_set_argument (MusicPluginsInterface* self,
                                      const gchar* value)
{
	gchar* _tmp0_;
#line 54 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 54 "../core/PluginInterface.vala"
	_tmp0_ = g_strdup (value);
#line 54 "../core/PluginInterface.vala"
	_g_free0 (self->priv->_argument);
#line 54 "../core/PluginInterface.vala"
	self->priv->_argument = _tmp0_;
#line 925 "PluginInterface.c"
}

static GList*
music_plugins_interface_get_all_source_view (MusicPluginsInterface* self)
{
	GList* result;
	GList* _tmp0_;
#line 56 "../core/PluginInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_all_source_view;
#line 56 "../core/PluginInterface.vala"
	result = _tmp0_;
#line 56 "../core/PluginInterface.vala"
	return result;
#line 941 "PluginInterface.c"
}

static void
music_plugins_interface_set_all_source_view (MusicPluginsInterface* self,
                                             GList* value)
{
#line 56 "../core/PluginInterface.vala"
	g_return_if_fail (self != NULL);
#line 56 "../core/PluginInterface.vala"
	self->priv->_all_source_view = value;
#line 952 "PluginInterface.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 63 "../core/PluginInterface.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 960 "PluginInterface.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 63 "../core/PluginInterface.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 968 "PluginInterface.c"
}

static void
_music_plugins_interface___lambda23_ (MusicPluginsInterface* self,
                                      GtkWindow* m)
{
#line 65 "../core/PluginInterface.vala"
	g_return_if_fail (m != NULL);
#line 66 "../core/PluginInterface.vala"
	music_plugins_interface_set_window (self, m);
#line 979 "PluginInterface.c"
}

static void
__music_plugins_interface___lambda23__music_plugins_manager_hook_new_window (MusicPluginsManager* _sender,
                                                                             GtkWindow* window,
                                                                             gpointer self)
{
#line 65 "../core/PluginInterface.vala"
	_music_plugins_interface___lambda23_ ((MusicPluginsInterface*) self, window);
#line 989 "PluginInterface.c"
}

static void
_music_plugins_interface___lambda24_ (MusicPluginsInterface* self,
                                      GtkTextView* m)
{
	GList* _tmp0_;
	GtkTextView* _tmp1_;
#line 69 "../core/PluginInterface.vala"
	g_return_if_fail (m != NULL);
#line 70 "../core/PluginInterface.vala"
	_tmp0_ = self->priv->_all_source_view;
#line 70 "../core/PluginInterface.vala"
	_tmp1_ = _g_object_ref0 (m);
#line 70 "../core/PluginInterface.vala"
	music_plugins_interface_set_all_source_view (self, g_list_append (_tmp0_, _tmp1_));
#line 1006 "PluginInterface.c"
}

static void
__music_plugins_interface___lambda24__music_plugins_manager_hook_source_view (MusicPluginsManager* _sender,
                                                                              GtkTextView* view,
                                                                              gpointer self)
{
#line 69 "../core/PluginInterface.vala"
	_music_plugins_interface___lambda24_ ((MusicPluginsInterface*) self, view);
#line 1016 "PluginInterface.c"
}

static GObject *
music_plugins_interface_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicPluginsInterface * self;
	GList* _tmp0_;
	MusicPluginsManager* _tmp1_;
	MusicPluginsManager* _tmp2_;
#line 62 "../core/PluginInterface.vala"
	parent_class = G_OBJECT_CLASS (music_plugins_interface_parent_class);
#line 62 "../core/PluginInterface.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 62 "../core/PluginInterface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_INTERFACE, MusicPluginsInterface);
#line 63 "../core/PluginInterface.vala"
	_tmp0_ = NULL;
#line 63 "../core/PluginInterface.vala"
	music_plugins_interface_set_all_source_view (self, _tmp0_);
#line 63 "../core/PluginInterface.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_list_free__g_object_unref0_ (_tmp0_), NULL));
#line 65 "../core/PluginInterface.vala"
	_tmp1_ = self->priv->_manager;
#line 65 "../core/PluginInterface.vala"
	g_signal_connect_object (_tmp1_, "hook-new-window", (GCallback) __music_plugins_interface___lambda23__music_plugins_manager_hook_new_window, self, 0);
#line 69 "../core/PluginInterface.vala"
	_tmp2_ = self->priv->_manager;
#line 69 "../core/PluginInterface.vala"
	g_signal_connect_object (_tmp2_, "hook-source-view", (GCallback) __music_plugins_interface___lambda24__music_plugins_manager_hook_source_view, self, 0);
#line 62 "../core/PluginInterface.vala"
	return obj;
#line 1052 "PluginInterface.c"
}

static void
music_plugins_interface_class_init (MusicPluginsInterfaceClass * klass,
                                    gpointer klass_data)
{
#line 32 "../core/PluginInterface.vala"
	music_plugins_interface_parent_class = g_type_class_peek_parent (klass);
#line 32 "../core/PluginInterface.vala"
	g_type_class_adjust_private_offset (klass, &MusicPluginsInterface_private_offset);
#line 32 "../core/PluginInterface.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_plugins_interface_get_property;
#line 32 "../core/PluginInterface.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_plugins_interface_set_property;
#line 32 "../core/PluginInterface.vala"
	G_OBJECT_CLASS (klass)->constructor = music_plugins_interface_constructor;
#line 32 "../core/PluginInterface.vala"
	G_OBJECT_CLASS (klass)->finalize = music_plugins_interface_finalize;
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY] = g_param_spec_object ("manager", "manager", "manager", MUSIC_PLUGINS_TYPE_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", gtk_notebook_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY] = g_param_spec_object ("sidebar", "sidebar", "sidebar", gtk_notebook_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY] = g_param_spec_object ("noise-app", "noise-app", "noise-app", gtk_application_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY] = g_param_spec_object ("toolbar", "toolbar", "toolbar", gtk_toolbar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "../core/PluginInterface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY, music_plugins_interface_properties[MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY] = g_param_spec_string ("set-name", "set-name", "set-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1085 "PluginInterface.c"
}

static void
music_plugins_interface_instance_init (MusicPluginsInterface * self,
                                       gpointer klass)
{
#line 32 "../core/PluginInterface.vala"
	self->priv = music_plugins_interface_get_instance_private (self);
#line 1094 "PluginInterface.c"
}

static void
music_plugins_interface_finalize (GObject * obj)
{
	MusicPluginsInterface * self;
#line 32 "../core/PluginInterface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_INTERFACE, MusicPluginsInterface);
#line 47 "../core/PluginInterface.vala"
	_g_object_unref0 (self->priv->_context);
#line 48 "../core/PluginInterface.vala"
	_g_object_unref0 (self->priv->_sidebar);
#line 49 "../core/PluginInterface.vala"
	_g_object_unref0 (self->priv->_noise_app);
#line 50 "../core/PluginInterface.vala"
	_g_object_unref0 (self->priv->_toolbar);
#line 51 "../core/PluginInterface.vala"
	_g_object_unref0 (self->priv->_window);
#line 52 "../core/PluginInterface.vala"
	_g_free0 (self->priv->_set_name);
#line 54 "../core/PluginInterface.vala"
	_g_free0 (self->priv->_argument);
#line 32 "../core/PluginInterface.vala"
	G_OBJECT_CLASS (music_plugins_interface_parent_class)->finalize (obj);
#line 1119 "PluginInterface.c"
}

static GType
music_plugins_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsInterface), 0, (GInstanceInitFunc) music_plugins_interface_instance_init, NULL };
	GType music_plugins_interface_type_id;
	music_plugins_interface_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPluginsInterface", &g_define_type_info, 0);
	MusicPluginsInterface_private_offset = g_type_add_instance_private (music_plugins_interface_type_id, sizeof (MusicPluginsInterfacePrivate));
	return music_plugins_interface_type_id;
}

GType
music_plugins_interface_get_type (void)
{
	static volatile gsize music_plugins_interface_type_id__once = 0;
	if (g_once_init_enter (&music_plugins_interface_type_id__once)) {
		GType music_plugins_interface_type_id;
		music_plugins_interface_type_id = music_plugins_interface_get_type_once ();
		g_once_init_leave (&music_plugins_interface_type_id__once, music_plugins_interface_type_id);
	}
	return music_plugins_interface_type_id__once;
}

static void
_vala_music_plugins_interface_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	MusicPluginsInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_INTERFACE, MusicPluginsInterface);
#line 32 "../core/PluginInterface.vala"
	switch (property_id) {
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_manager (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_context (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_sidebar (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_noise_app (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_toolbar (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_object (value, music_plugins_interface_get_window (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		g_value_set_string (value, music_plugins_interface_get_set_name (self));
#line 32 "../core/PluginInterface.vala"
		break;
#line 1196 "PluginInterface.c"
		default:
#line 32 "../core/PluginInterface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../core/PluginInterface.vala"
		break;
#line 1202 "PluginInterface.c"
	}
}

static void
_vala_music_plugins_interface_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	MusicPluginsInterface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_INTERFACE, MusicPluginsInterface);
#line 32 "../core/PluginInterface.vala"
	switch (property_id) {
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_MANAGER_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_manager (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_CONTEXT_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_context (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_SIDEBAR_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_sidebar (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_NOISE_APP_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_noise_app (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_TOOLBAR_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_toolbar (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_WINDOW_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_window (self, g_value_get_object (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 32 "../core/PluginInterface.vala"
		case MUSIC_PLUGINS_INTERFACE_SET_NAME_PROPERTY:
#line 32 "../core/PluginInterface.vala"
		music_plugins_interface_set_set_name (self, g_value_get_string (value));
#line 32 "../core/PluginInterface.vala"
		break;
#line 1258 "PluginInterface.c"
		default:
#line 32 "../core/PluginInterface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../core/PluginInterface.vala"
		break;
#line 1264 "PluginInterface.c"
	}
}

