/* Settings.c generated by valac 0.56.0, the Vala compiler
 * generated from Settings.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <granite.h>

enum  {
	MUSIC_SETTINGS_MAIN_0_PROPERTY,
	MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY,
	MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY,
	MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY,
	MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY,
	MUSIC_SETTINGS_MAIN_NUM_PROPERTIES
};
static GParamSpec* music_settings_main_properties[MUSIC_SETTINGS_MAIN_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicSettingsMainPrivate {
	gchar* _music_mount_name;
	gchar* _music_folder;
	gchar* _path_string;
	gchar** _plugins_disabled;
	gint _plugins_disabled_length1;
	gint __plugins_disabled_size_;
};

static gint MusicSettingsMain_private_offset;
static gpointer music_settings_main_parent_class = NULL;
static MusicSettingsMain* music_settings_main_main_settings;
static MusicSettingsMain* music_settings_main_main_settings = NULL;

static MusicSettingsMain* music_settings_main_new (void);
static MusicSettingsMain* music_settings_main_construct (GType object_type);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void music_settings_main_finalize (GObject * obj);
static GType music_settings_main_get_type_once (void);
static void _vala_music_settings_main_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_music_settings_main_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
music_settings_main_get_instance_private (MusicSettingsMain* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSettingsMain_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../core/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 98 "Settings.c"
}

MusicSettingsMain*
music_settings_main_get_default (void)
{
	MusicSettingsMain* _tmp0_;
	MusicSettingsMain* _tmp2_;
	MusicSettingsMain* _tmp3_;
	MusicSettingsMain* result;
#line 39 "../core/Settings.vala"
	_tmp0_ = music_settings_main_main_settings;
#line 39 "../core/Settings.vala"
	if (_tmp0_ == NULL) {
#line 112 "Settings.c"
		MusicSettingsMain* _tmp1_;
#line 40 "../core/Settings.vala"
		_tmp1_ = music_settings_main_new ();
#line 40 "../core/Settings.vala"
		_g_object_unref0 (music_settings_main_main_settings);
#line 40 "../core/Settings.vala"
		music_settings_main_main_settings = _tmp1_;
#line 120 "Settings.c"
	}
#line 41 "../core/Settings.vala"
	_tmp2_ = music_settings_main_main_settings;
#line 41 "../core/Settings.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 41 "../core/Settings.vala"
	result = _tmp3_;
#line 41 "../core/Settings.vala"
	return result;
#line 130 "Settings.c"
}

gboolean
music_settings_main_privacy_mode_enabled (MusicSettingsMain* self)
{
	GSettings* privacy_settings = NULL;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gboolean result;
#line 44 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../core/Settings.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.privacy");
#line 45 "../core/Settings.vala"
	privacy_settings = _tmp0_;
#line 46 "../core/Settings.vala"
	_tmp2_ = privacy_settings;
#line 46 "../core/Settings.vala"
	if (g_settings_get_boolean (_tmp2_, "remember-app-usage")) {
#line 46 "../core/Settings.vala"
		_tmp1_ = TRUE;
#line 153 "Settings.c"
	} else {
		GSettings* _tmp3_;
#line 47 "../core/Settings.vala"
		_tmp3_ = privacy_settings;
#line 47 "../core/Settings.vala"
		_tmp1_ = g_settings_get_boolean (_tmp3_, "remember-recent-files");
#line 160 "Settings.c"
	}
#line 46 "../core/Settings.vala"
	result = !_tmp1_;
#line 46 "../core/Settings.vala"
	_g_object_unref0 (privacy_settings);
#line 46 "../core/Settings.vala"
	return result;
#line 168 "Settings.c"
}

static MusicSettingsMain*
music_settings_main_construct (GType object_type)
{
	MusicSettingsMain * self = NULL;
	const gchar* _tmp0_;
#line 51 "../core/Settings.vala"
	self = (MusicSettingsMain*) granite_services_settings_construct (object_type, "io.elementary.music.settings");
#line 52 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_folder;
#line 52 "../core/Settings.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 182 "Settings.c"
		const gchar* _tmp1_;
#line 53 "../core/Settings.vala"
		_tmp1_ = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
#line 53 "../core/Settings.vala"
		music_settings_main_set_music_folder (self, _tmp1_);
#line 188 "Settings.c"
	}
#line 50 "../core/Settings.vala"
	return self;
#line 192 "Settings.c"
}

static MusicSettingsMain*
music_settings_main_new (void)
{
#line 50 "../core/Settings.vala"
	return music_settings_main_construct (MUSIC_SETTINGS_TYPE_MAIN);
#line 200 "Settings.c"
}

const gchar*
music_settings_main_get_music_mount_name (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_mount_name;
#line 31 "../core/Settings.vala"
	result = _tmp0_;
#line 31 "../core/Settings.vala"
	return result;
#line 216 "Settings.c"
}

void
music_settings_main_set_music_mount_name (MusicSettingsMain* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 31 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 31 "../core/Settings.vala"
	old_value = music_settings_main_get_music_mount_name (self);
#line 31 "../core/Settings.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 230 "Settings.c"
		gchar* _tmp0_;
#line 31 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../core/Settings.vala"
		_g_free0 (self->priv->_music_mount_name);
#line 31 "../core/Settings.vala"
		self->priv->_music_mount_name = _tmp0_;
#line 31 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY]);
#line 240 "Settings.c"
	}
}

const gchar*
music_settings_main_get_music_folder (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Settings.vala"
	_tmp0_ = self->priv->_music_folder;
#line 32 "../core/Settings.vala"
	result = _tmp0_;
#line 32 "../core/Settings.vala"
	return result;
#line 257 "Settings.c"
}

void
music_settings_main_set_music_folder (MusicSettingsMain* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 32 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Settings.vala"
	old_value = music_settings_main_get_music_folder (self);
#line 32 "../core/Settings.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 271 "Settings.c"
		gchar* _tmp0_;
#line 32 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../core/Settings.vala"
		_g_free0 (self->priv->_music_folder);
#line 32 "../core/Settings.vala"
		self->priv->_music_folder = _tmp0_;
#line 32 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY]);
#line 281 "Settings.c"
	}
}

const gchar*
music_settings_main_get_path_string (MusicSettingsMain* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../core/Settings.vala"
	_tmp0_ = self->priv->_path_string;
#line 33 "../core/Settings.vala"
	result = _tmp0_;
#line 33 "../core/Settings.vala"
	return result;
#line 298 "Settings.c"
}

void
music_settings_main_set_path_string (MusicSettingsMain* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 33 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 33 "../core/Settings.vala"
	old_value = music_settings_main_get_path_string (self);
#line 33 "../core/Settings.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 312 "Settings.c"
		gchar* _tmp0_;
#line 33 "../core/Settings.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../core/Settings.vala"
		_g_free0 (self->priv->_path_string);
#line 33 "../core/Settings.vala"
		self->priv->_path_string = _tmp0_;
#line 33 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY]);
#line 322 "Settings.c"
	}
}

gchar**
music_settings_main_get_plugins_disabled (MusicSettingsMain* self,
                                          gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 34 "../core/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../core/Settings.vala"
	_tmp0_ = self->priv->_plugins_disabled;
#line 34 "../core/Settings.vala"
	_tmp0__length1 = self->priv->_plugins_disabled_length1;
#line 34 "../core/Settings.vala"
	_tmp1_ = _tmp0_;
#line 34 "../core/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 34 "../core/Settings.vala"
	if (result_length1) {
#line 34 "../core/Settings.vala"
		*result_length1 = _tmp1__length1;
#line 349 "Settings.c"
	}
#line 34 "../core/Settings.vala"
	result = _tmp1_;
#line 34 "../core/Settings.vala"
	return result;
#line 355 "Settings.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 34 "../core/Settings.vala"
	if (length >= 0) {
#line 364 "Settings.c"
		gchar** result;
		gssize i;
#line 34 "../core/Settings.vala"
		result = g_new0 (gchar*, length + 1);
#line 34 "../core/Settings.vala"
		for (i = 0; i < length; i++) {
#line 371 "Settings.c"
			gchar* _tmp0_;
#line 34 "../core/Settings.vala"
			_tmp0_ = g_strdup (self[i]);
#line 34 "../core/Settings.vala"
			result[i] = _tmp0_;
#line 377 "Settings.c"
		}
#line 34 "../core/Settings.vala"
		return result;
#line 381 "Settings.c"
	}
#line 34 "../core/Settings.vala"
	return NULL;
#line 385 "Settings.c"
}

void
music_settings_main_set_plugins_disabled (MusicSettingsMain* self,
                                          gchar** value,
                                          gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 34 "../core/Settings.vala"
	g_return_if_fail (self != NULL);
#line 34 "../core/Settings.vala"
	old_value = music_settings_main_get_plugins_disabled (self, &old_value_length);
#line 34 "../core/Settings.vala"
	if (old_value != value) {
#line 401 "Settings.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 34 "../core/Settings.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 34 "../core/Settings.vala"
		_tmp0__length1 = value_length1;
#line 34 "../core/Settings.vala"
		self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
#line 34 "../core/Settings.vala"
		self->priv->_plugins_disabled = _tmp0_;
#line 34 "../core/Settings.vala"
		self->priv->_plugins_disabled_length1 = _tmp0__length1;
#line 34 "../core/Settings.vala"
		self->priv->__plugins_disabled_size_ = self->priv->_plugins_disabled_length1;
#line 34 "../core/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY]);
#line 418 "Settings.c"
	}
}

static void
music_settings_main_class_init (MusicSettingsMainClass * klass,
                                gpointer klass_data)
{
#line 30 "../core/Settings.vala"
	music_settings_main_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Settings.vala"
	g_type_class_adjust_private_offset (klass, &MusicSettingsMain_private_offset);
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_settings_main_get_property;
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_settings_main_set_property;
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = music_settings_main_finalize;
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY] = g_param_spec_string ("music-mount-name", "music-mount-name", "music-mount-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY] = g_param_spec_string ("music-folder", "music-folder", "music-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY] = g_param_spec_string ("path-string", "path-string", "path-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY, music_settings_main_properties[MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY] = g_param_spec_boxed ("plugins-disabled", "plugins-disabled", "plugins-disabled", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 444 "Settings.c"
}

static void
music_settings_main_instance_init (MusicSettingsMain * self,
                                   gpointer klass)
{
#line 30 "../core/Settings.vala"
	self->priv = music_settings_main_get_instance_private (self);
#line 453 "Settings.c"
}

static void
music_settings_main_finalize (GObject * obj)
{
	MusicSettingsMain * self;
#line 30 "../core/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
#line 31 "../core/Settings.vala"
	_g_free0 (self->priv->_music_mount_name);
#line 32 "../core/Settings.vala"
	_g_free0 (self->priv->_music_folder);
#line 33 "../core/Settings.vala"
	_g_free0 (self->priv->_path_string);
#line 34 "../core/Settings.vala"
	self->priv->_plugins_disabled = (_vala_array_free (self->priv->_plugins_disabled, self->priv->_plugins_disabled_length1, (GDestroyNotify) g_free), NULL);
#line 30 "../core/Settings.vala"
	G_OBJECT_CLASS (music_settings_main_parent_class)->finalize (obj);
#line 472 "Settings.c"
}

static GType
music_settings_main_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSettingsMain), 0, (GInstanceInitFunc) music_settings_main_instance_init, NULL };
	GType music_settings_main_type_id;
	music_settings_main_type_id = g_type_register_static (GRANITE_SERVICES_TYPE_SETTINGS, "MusicSettingsMain", &g_define_type_info, 0);
	MusicSettingsMain_private_offset = g_type_add_instance_private (music_settings_main_type_id, sizeof (MusicSettingsMainPrivate));
	return music_settings_main_type_id;
}

GType
music_settings_main_get_type (void)
{
	static volatile gsize music_settings_main_type_id__once = 0;
	if (g_once_init_enter (&music_settings_main_type_id__once)) {
		GType music_settings_main_type_id;
		music_settings_main_type_id = music_settings_main_get_type_once ();
		g_once_init_leave (&music_settings_main_type_id__once, music_settings_main_type_id);
	}
	return music_settings_main_type_id__once;
}

static void
_vala_music_settings_main_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	MusicSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
#line 30 "../core/Settings.vala"
	switch (property_id) {
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, music_settings_main_get_music_mount_name (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, music_settings_main_get_music_folder (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY:
#line 30 "../core/Settings.vala"
		g_value_set_string (value, music_settings_main_get_path_string (self));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
#line 527 "Settings.c"
		{
			int length;
#line 30 "../core/Settings.vala"
			g_value_set_boxed (value, music_settings_main_get_plugins_disabled (self, &length));
#line 532 "Settings.c"
		}
#line 30 "../core/Settings.vala"
		break;
#line 536 "Settings.c"
		default:
#line 30 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Settings.vala"
		break;
#line 542 "Settings.c"
	}
}

static void
_vala_music_settings_main_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	MusicSettingsMain * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_SETTINGS_TYPE_MAIN, MusicSettingsMain);
#line 30 "../core/Settings.vala"
	switch (property_id) {
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_MUSIC_MOUNT_NAME_PROPERTY:
#line 30 "../core/Settings.vala"
		music_settings_main_set_music_mount_name (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_MUSIC_FOLDER_PROPERTY:
#line 30 "../core/Settings.vala"
		music_settings_main_set_music_folder (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_PATH_STRING_PROPERTY:
#line 30 "../core/Settings.vala"
		music_settings_main_set_path_string (self, g_value_get_string (value));
#line 30 "../core/Settings.vala"
		break;
#line 30 "../core/Settings.vala"
		case MUSIC_SETTINGS_MAIN_PLUGINS_DISABLED_PROPERTY:
#line 576 "Settings.c"
		{
			gpointer boxed;
#line 30 "../core/Settings.vala"
			boxed = g_value_get_boxed (value);
#line 30 "../core/Settings.vala"
			music_settings_main_set_plugins_disabled (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 583 "Settings.c"
		}
#line 30 "../core/Settings.vala"
		break;
#line 587 "Settings.c"
		default:
#line 30 "../core/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Settings.vala"
		break;
#line 593 "Settings.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

