/* CompareFunctionHolder.c generated by valac 0.56.0, the Vala compiler
 * generated from CompareFunctionHolder.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))

inline gint
music_compare_titles (MusicMedia* a,
                      MusicMedia* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 32 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 32 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = music_media_get_display_title (a);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = music_media_get_display_title (b);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	result = _tmp4_;
#line 33 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 73 "CompareFunctionHolder.c"
}

inline gint
music_compare_genres (MusicMedia* a,
                      MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 36 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 36 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = music_media_get_display_genre (a);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = music_media_get_display_genre (b);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 37 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 38 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 39 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_album_artists (a, b);
#line 111 "CompareFunctionHolder.c"
	}
#line 40 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 40 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 117 "CompareFunctionHolder.c"
}

inline gint
music_compare_artists (MusicMedia* a,
                       MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 43 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 43 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = music_media_get_display_artist (a);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = music_media_get_display_artist (b);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 44 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 46 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 153 "CompareFunctionHolder.c"
		guint _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp5_ = music_media_get_year (a);
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp6_ = _tmp5_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp7_ = music_media_get_year (b);
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		_tmp8_ = _tmp7_;
#line 47 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_standard_unsigned (_tmp6_, _tmp8_);
#line 168 "CompareFunctionHolder.c"
	}
#line 48 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 49 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_albums (a, b);
#line 174 "CompareFunctionHolder.c"
	}
#line 50 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 50 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 180 "CompareFunctionHolder.c"
}

inline gint
music_compare_album_artists (MusicMedia* a,
                             MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 53 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 53 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = music_media_get_display_album_artist (a, TRUE);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = music_media_get_display_album_artist (b, TRUE);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 54 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 55 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 56 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_albums (a, b);
#line 218 "CompareFunctionHolder.c"
	}
#line 57 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 57 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 224 "CompareFunctionHolder.c"
}

inline gint
music_compare_albums (MusicMedia* a,
                      MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 60 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 60 "../core/Utils/CompareFunctionHolder.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp0_ = music_media_get_display_album (a);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp1_ = _tmp0_;
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp2_ = music_media_get_display_album (b);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp3_ = _tmp2_;
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp3_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	_g_free0 (_tmp1_);
#line 61 "../core/Utils/CompareFunctionHolder.vala"
	order = _tmp4_;
#line 62 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 260 "CompareFunctionHolder.c"
		guint _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp5_ = music_media_get_album_number (a);
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp6_ = _tmp5_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp7_ = music_media_get_album_number (b);
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		_tmp8_ = _tmp7_;
#line 63 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_standard_unsigned (_tmp6_, _tmp8_);
#line 275 "CompareFunctionHolder.c"
	}
#line 64 "../core/Utils/CompareFunctionHolder.vala"
	if (order == 0) {
#line 279 "CompareFunctionHolder.c"
		guint _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		_tmp9_ = music_media_get_track (a);
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		_tmp10_ = _tmp9_;
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		_tmp11_ = music_media_get_track (b);
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		_tmp12_ = _tmp11_;
#line 65 "../core/Utils/CompareFunctionHolder.vala"
		order = music_compare_standard_unsigned (_tmp10_, _tmp12_);
#line 294 "CompareFunctionHolder.c"
	}
#line 66 "../core/Utils/CompareFunctionHolder.vala"
	result = order;
#line 66 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 300 "CompareFunctionHolder.c"
}

inline gint
music_compare_standard (gint a,
                        gint b)
{
	gint result;
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 70 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 312 "CompareFunctionHolder.c"
}

inline gint
music_compare_standard_unsigned (guint a,
                                 guint b)
{
	gint result;
#line 74 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 74 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 324 "CompareFunctionHolder.c"
}

inline gint
music_compare_standard_64 (gint64 a,
                           gint64 b)
{
	gint result;
#line 78 "../core/Utils/CompareFunctionHolder.vala"
	result = ((gint) (a > b)) - ((gint) (a < b));
#line 78 "../core/Utils/CompareFunctionHolder.vala"
	return result;
#line 336 "CompareFunctionHolder.c"
}

