/* FileUtils.c generated by valac 0.56.0, the Vala compiler
 * generated from FileUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#define MUSIC_FILE_UTILS_APP_NAME "noise"

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

VALA_EXTERN GFile* music_file_utils_get_cache_directory (void);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

VALA_EXTERN const gchar* MUSIC_MEDIA_CONTENT_TYPES[50];

GFile*
music_file_utils_get_data_directory (void)
{
	gchar* data_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir_path = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 34 "../core/Utils/FileUtils.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 34 "../core/Utils/FileUtils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "../core/Utils/FileUtils.vala"
	data_dir = _tmp1_;
#line 35 "../core/Utils/FileUtils.vala"
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, data_dir, MUSIC_FILE_UTILS_APP_NAME, NULL);
#line 35 "../core/Utils/FileUtils.vala"
	dir_path = _tmp2_;
#line 36 "../core/Utils/FileUtils.vala"
	_tmp3_ = g_file_new_for_path (dir_path);
#line 36 "../core/Utils/FileUtils.vala"
	result = _tmp3_;
#line 36 "../core/Utils/FileUtils.vala"
	_g_free0 (dir_path);
#line 36 "../core/Utils/FileUtils.vala"
	_g_free0 (data_dir);
#line 36 "../core/Utils/FileUtils.vala"
	return result;
#line 94 "FileUtils.c"
}

GFile*
music_file_utils_get_cache_directory (void)
{
	gchar* data_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir_path = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* result;
#line 40 "../core/Utils/FileUtils.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 40 "../core/Utils/FileUtils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "../core/Utils/FileUtils.vala"
	data_dir = _tmp1_;
#line 41 "../core/Utils/FileUtils.vala"
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, data_dir, MUSIC_FILE_UTILS_APP_NAME, NULL);
#line 41 "../core/Utils/FileUtils.vala"
	dir_path = _tmp2_;
#line 42 "../core/Utils/FileUtils.vala"
	_tmp3_ = g_file_new_for_path (dir_path);
#line 42 "../core/Utils/FileUtils.vala"
	result = _tmp3_;
#line 42 "../core/Utils/FileUtils.vala"
	_g_free0 (dir_path);
#line 42 "../core/Utils/FileUtils.vala"
	_g_free0 (data_dir);
#line 42 "../core/Utils/FileUtils.vala"
	return result;
#line 127 "FileUtils.c"
}

guint64
music_file_utils_get_size (GFile* file,
                           GCancellable* cancellable)
{
	guint64 size = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 45 "../core/Utils/FileUtils.vala"
	g_return_val_if_fail (file != NULL, 0ULL);
#line 46 "../core/Utils/FileUtils.vala"
	size = (guint64) 0;
#line 141 "FileUtils.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
#line 49 "../core/Utils/FileUtils.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 49 "../core/Utils/FileUtils.vala"
		info = _tmp0_;
#line 49 "../core/Utils/FileUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "FileUtils.c"
			goto __catch0_g_error;
		}
#line 52 "../core/Utils/FileUtils.vala"
		size = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_SIZE);
#line 48 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (info);
#line 158 "FileUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 48 "../core/Utils/FileUtils.vala"
		err = _inner_error0_;
#line 48 "../core/Utils/FileUtils.vala"
		_inner_error0_ = NULL;
#line 54 "../core/Utils/FileUtils.vala"
		_tmp1_ = g_file_get_uri (file);
#line 54 "../core/Utils/FileUtils.vala"
		_tmp2_ = _tmp1_;
#line 54 "../core/Utils/FileUtils.vala"
		_tmp3_ = err;
#line 54 "../core/Utils/FileUtils.vala"
		_tmp4_ = _tmp3_->message;
#line 54 "../core/Utils/FileUtils.vala"
		g_warning ("FileUtils.vala:54: Could not get size of '%s': %s", _tmp2_, _tmp4_);
#line 54 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp2_);
#line 48 "../core/Utils/FileUtils.vala"
		_g_error_free0 (err);
#line 186 "FileUtils.c"
	}
	__finally0:
#line 48 "../core/Utils/FileUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "FileUtils.c"
		guint64 _tmp5_ = 0ULL;
#line 48 "../core/Utils/FileUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../core/Utils/FileUtils.vala"
		g_clear_error (&_inner_error0_);
#line 48 "../core/Utils/FileUtils.vala"
		return _tmp5_;
#line 199 "FileUtils.c"
	}
#line 57 "../core/Utils/FileUtils.vala"
	result = size;
#line 57 "../core/Utils/FileUtils.vala"
	return result;
#line 205 "FileUtils.c"
}

/**
     * Queries whether a content type equals or is a subtype of any other type in
     * an array of content types.
     *
     * @param file_content_type Content type of the file to compare.
     * @param content_types A string array containing the expected content types to compare against.
     * @return whether file_content_type is considered valid.
     */
static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 69 "../core/Utils/FileUtils.vala"
	if (length >= 0) {
#line 222 "FileUtils.c"
		gchar** result;
		gssize i;
#line 69 "../core/Utils/FileUtils.vala"
		result = g_new0 (gchar*, length + 1);
#line 69 "../core/Utils/FileUtils.vala"
		for (i = 0; i < length; i++) {
#line 229 "FileUtils.c"
			gchar* _tmp0_;
#line 69 "../core/Utils/FileUtils.vala"
			_tmp0_ = g_strdup (self[i]);
#line 69 "../core/Utils/FileUtils.vala"
			result[i] = _tmp0_;
#line 235 "FileUtils.c"
		}
#line 69 "../core/Utils/FileUtils.vala"
		return result;
#line 239 "FileUtils.c"
	}
#line 69 "../core/Utils/FileUtils.vala"
	return NULL;
#line 243 "FileUtils.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 71 "../core/Utils/FileUtils.vala"
	if (length >= 0) {
#line 252 "FileUtils.c"
		gchar** result;
		gssize i;
#line 71 "../core/Utils/FileUtils.vala"
		result = g_new0 (gchar*, length + 1);
#line 71 "../core/Utils/FileUtils.vala"
		for (i = 0; i < length; i++) {
#line 259 "FileUtils.c"
			gchar* _tmp0_;
#line 71 "../core/Utils/FileUtils.vala"
			_tmp0_ = g_strdup (self[i]);
#line 71 "../core/Utils/FileUtils.vala"
			result[i] = _tmp0_;
#line 265 "FileUtils.c"
		}
#line 71 "../core/Utils/FileUtils.vala"
		return result;
#line 269 "FileUtils.c"
	}
#line 71 "../core/Utils/FileUtils.vala"
	return NULL;
#line 273 "FileUtils.c"
}

gboolean
music_file_utils_is_valid_content_type (const gchar* file_content_type,
                                        gchar** content_types,
                                        gint content_types_length1)
{
	gchar** considered_content_type = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint considered_content_type_length1;
	gint _considered_content_type_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result;
#line 68 "../core/Utils/FileUtils.vala"
	g_return_val_if_fail (file_content_type != NULL, FALSE);
#line 69 "../core/Utils/FileUtils.vala"
	_tmp0_ = (content_types != NULL) ? _vala_array_dup2 (content_types, content_types_length1) : content_types;
#line 69 "../core/Utils/FileUtils.vala"
	_tmp0__length1 = content_types_length1;
#line 69 "../core/Utils/FileUtils.vala"
	considered_content_type = _tmp0_;
#line 69 "../core/Utils/FileUtils.vala"
	considered_content_type_length1 = _tmp0__length1;
#line 69 "../core/Utils/FileUtils.vala"
	_considered_content_type_size_ = considered_content_type_length1;
#line 70 "../core/Utils/FileUtils.vala"
	if (content_types == NULL) {
#line 303 "FileUtils.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 71 "../core/Utils/FileUtils.vala"
		_tmp1_ = _vala_array_dup3 (MUSIC_MEDIA_CONTENT_TYPES, G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES));
#line 71 "../core/Utils/FileUtils.vala"
		_tmp1__length1 = G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES);
#line 71 "../core/Utils/FileUtils.vala"
		considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../core/Utils/FileUtils.vala"
		considered_content_type = _tmp1_;
#line 71 "../core/Utils/FileUtils.vala"
		considered_content_type_length1 = _tmp1__length1;
#line 71 "../core/Utils/FileUtils.vala"
		_considered_content_type_size_ = considered_content_type_length1;
#line 318 "FileUtils.c"
	}
#line 74 "../core/Utils/FileUtils.vala"
	_tmp2_ = considered_content_type;
#line 74 "../core/Utils/FileUtils.vala"
	_tmp2__length1 = considered_content_type_length1;
#line 324 "FileUtils.c"
	{
		gchar** content_type_collection = NULL;
		gint content_type_collection_length1 = 0;
		gint _content_type_collection_size_ = 0;
		gint content_type_it = 0;
#line 74 "../core/Utils/FileUtils.vala"
		content_type_collection = _tmp2_;
#line 74 "../core/Utils/FileUtils.vala"
		content_type_collection_length1 = _tmp2__length1;
#line 74 "../core/Utils/FileUtils.vala"
		for (content_type_it = 0; content_type_it < content_type_collection_length1; content_type_it = content_type_it + 1) {
#line 336 "FileUtils.c"
			gchar* _tmp3_;
			gchar* content_type = NULL;
#line 74 "../core/Utils/FileUtils.vala"
			_tmp3_ = g_strdup (content_type_collection[content_type_it]);
#line 74 "../core/Utils/FileUtils.vala"
			content_type = _tmp3_;
#line 343 "FileUtils.c"
			{
				const gchar* _tmp4_;
#line 75 "../core/Utils/FileUtils.vala"
				_tmp4_ = content_type;
#line 75 "../core/Utils/FileUtils.vala"
				if (g_content_type_equals (file_content_type, _tmp4_)) {
#line 76 "../core/Utils/FileUtils.vala"
					result = TRUE;
#line 76 "../core/Utils/FileUtils.vala"
					_g_free0 (content_type);
#line 76 "../core/Utils/FileUtils.vala"
					considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
#line 76 "../core/Utils/FileUtils.vala"
					return result;
#line 358 "FileUtils.c"
				}
#line 74 "../core/Utils/FileUtils.vala"
				_g_free0 (content_type);
#line 362 "FileUtils.c"
			}
		}
	}
#line 80 "../core/Utils/FileUtils.vala"
	result = FALSE;
#line 80 "../core/Utils/FileUtils.vala"
	considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
#line 80 "../core/Utils/FileUtils.vala"
	return result;
#line 372 "FileUtils.c"
}

gint
music_file_utils_count_music_files (GFile* music_folder,
                                    GeeCollection* files)
{
	GFileInfo* file_info = NULL;
	gint index = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 83 "../core/Utils/FileUtils.vala"
	g_return_val_if_fail (music_folder != NULL, 0);
#line 83 "../core/Utils/FileUtils.vala"
	g_return_val_if_fail (files != NULL, 0);
#line 84 "../core/Utils/FileUtils.vala"
	file_info = NULL;
#line 85 "../core/Utils/FileUtils.vala"
	index = 0;
#line 391 "FileUtils.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
#line 88 "../core/Utils/FileUtils.vala"
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
#line 88 "../core/Utils/FileUtils.vala"
		enumerator = _tmp0_;
#line 88 "../core/Utils/FileUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 401 "FileUtils.c"
			goto __catch0_g_error;
		}
#line 89 "../core/Utils/FileUtils.vala"
		while (TRUE) {
#line 406 "FileUtils.c"
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
#line 89 "../core/Utils/FileUtils.vala"
			_tmp2_ = enumerator;
#line 89 "../core/Utils/FileUtils.vala"
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
#line 89 "../core/Utils/FileUtils.vala"
			_tmp1_ = _tmp3_;
#line 89 "../core/Utils/FileUtils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 89 "../core/Utils/FileUtils.vala"
				_g_object_unref0 (enumerator);
#line 428 "FileUtils.c"
				goto __catch0_g_error;
			}
#line 89 "../core/Utils/FileUtils.vala"
			_tmp4_ = _tmp1_;
#line 89 "../core/Utils/FileUtils.vala"
			_tmp1_ = NULL;
#line 89 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (file_info);
#line 89 "../core/Utils/FileUtils.vala"
			file_info = _tmp4_;
#line 89 "../core/Utils/FileUtils.vala"
			_tmp5_ = file_info;
#line 89 "../core/Utils/FileUtils.vala"
			if (!(_tmp5_ != NULL)) {
#line 89 "../core/Utils/FileUtils.vala"
				_g_object_unref0 (_tmp1_);
#line 89 "../core/Utils/FileUtils.vala"
				break;
#line 447 "FileUtils.c"
			}
#line 90 "../core/Utils/FileUtils.vala"
			_tmp6_ = file_info;
#line 90 "../core/Utils/FileUtils.vala"
			_tmp7_ = g_file_info_get_name (_tmp6_);
#line 90 "../core/Utils/FileUtils.vala"
			_tmp8_ = g_file_get_child (music_folder, _tmp7_);
#line 90 "../core/Utils/FileUtils.vala"
			file = _tmp8_;
#line 92 "../core/Utils/FileUtils.vala"
			_tmp10_ = file_info;
#line 92 "../core/Utils/FileUtils.vala"
			if (g_file_info_get_file_type (_tmp10_) == G_FILE_TYPE_REGULAR) {
#line 461 "FileUtils.c"
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
#line 92 "../core/Utils/FileUtils.vala"
				_tmp11_ = file_info;
#line 92 "../core/Utils/FileUtils.vala"
				_tmp12_ = g_file_info_get_content_type (_tmp11_);
#line 92 "../core/Utils/FileUtils.vala"
				_tmp9_ = music_file_utils_is_valid_content_type (_tmp12_, NULL, (gint) 0);
#line 470 "FileUtils.c"
			} else {
#line 92 "../core/Utils/FileUtils.vala"
				_tmp9_ = FALSE;
#line 474 "FileUtils.c"
			}
#line 92 "../core/Utils/FileUtils.vala"
			if (_tmp9_) {
#line 478 "FileUtils.c"
				gint _tmp13_;
				GFile* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 93 "../core/Utils/FileUtils.vala"
				_tmp13_ = index;
#line 93 "../core/Utils/FileUtils.vala"
				index = _tmp13_ + 1;
#line 94 "../core/Utils/FileUtils.vala"
				_tmp14_ = file;
#line 94 "../core/Utils/FileUtils.vala"
				_tmp15_ = g_file_get_uri (_tmp14_);
#line 94 "../core/Utils/FileUtils.vala"
				_tmp16_ = _tmp15_;
#line 94 "../core/Utils/FileUtils.vala"
				gee_collection_add (files, _tmp16_);
#line 94 "../core/Utils/FileUtils.vala"
				_g_free0 (_tmp16_);
#line 497 "FileUtils.c"
			} else {
				GFileInfo* _tmp17_;
#line 95 "../core/Utils/FileUtils.vala"
				_tmp17_ = file_info;
#line 95 "../core/Utils/FileUtils.vala"
				if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_DIRECTORY) {
#line 504 "FileUtils.c"
					GFile* _tmp18_;
#line 96 "../core/Utils/FileUtils.vala"
					_tmp18_ = file;
#line 96 "../core/Utils/FileUtils.vala"
					index += music_file_utils_count_music_files (_tmp18_, files);
#line 510 "FileUtils.c"
				}
			}
#line 89 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (file);
#line 89 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (_tmp1_);
#line 517 "FileUtils.c"
		}
#line 87 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (enumerator);
#line 521 "FileUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 87 "../core/Utils/FileUtils.vala"
		err = _inner_error0_;
#line 87 "../core/Utils/FileUtils.vala"
		_inner_error0_ = NULL;
#line 100 "../core/Utils/FileUtils.vala"
		_tmp19_ = err;
#line 100 "../core/Utils/FileUtils.vala"
		_tmp20_ = _tmp19_->message;
#line 100 "../core/Utils/FileUtils.vala"
		g_warning ("FileUtils.vala:100: Could not pre-scan music folder. Progress percenta" \
"ge may be off: %s\n", _tmp20_);
#line 87 "../core/Utils/FileUtils.vala"
		_g_error_free0 (err);
#line 541 "FileUtils.c"
	}
	__finally0:
#line 87 "../core/Utils/FileUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 546 "FileUtils.c"
		gint _tmp21_ = -1;
#line 87 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (file_info);
#line 87 "../core/Utils/FileUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 87 "../core/Utils/FileUtils.vala"
		g_clear_error (&_inner_error0_);
#line 87 "../core/Utils/FileUtils.vala"
		return _tmp21_;
#line 556 "FileUtils.c"
	}
#line 103 "../core/Utils/FileUtils.vala"
	result = index;
#line 103 "../core/Utils/FileUtils.vala"
	_g_object_unref0 (file_info);
#line 103 "../core/Utils/FileUtils.vala"
	return result;
#line 564 "FileUtils.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 591 "FileUtils.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 597 "FileUtils.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 603 "FileUtils.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 607 "FileUtils.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 615 "FileUtils.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 619 "FileUtils.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 631 "FileUtils.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1144 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1144 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1146 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1146 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 655 "FileUtils.c"
		gchar* _tmp2_;
#line 1147 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1147 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1147 "glib-2.0.vapi"
		return result;
#line 663 "FileUtils.c"
	} else {
#line 1149 "glib-2.0.vapi"
		result = -1;
#line 1149 "glib-2.0.vapi"
		return result;
#line 669 "FileUtils.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 692 "FileUtils.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 696 "FileUtils.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 702 "FileUtils.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 706 "FileUtils.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 710 "FileUtils.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 718 "FileUtils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 746 "FileUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 755 "FileUtils.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 769 "FileUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 778 "FileUtils.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 792 "FileUtils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 801 "FileUtils.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 810 "FileUtils.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 829 "FileUtils.c"
}

GFile*
music_file_utils_get_new_destination (MusicMedia* s)
{
	GFile* dest = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 106 "../core/Utils/FileUtils.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 840 "FileUtils.c"
	{
		GFile* original = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* ext = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gboolean _tmp9_;
		MusicSettingsMain* main_settings = NULL;
		MusicSettingsMain* _tmp23_;
		gchar* path = NULL;
		MusicSettingsMain* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gboolean _tmp28_ = FALSE;
		const gchar* _tmp29_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		const gchar* _tmp57_;
		guint _tmp58_;
		guint _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		MusicSettingsMain* _tmp63_;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		GFile* _tmp72_;
		GFile* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		GFile* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gboolean _tmp79_;
		GFile* _tmp80_;
		GFile* _tmp98_;
		GFile* _tmp99_;
		GFile* _tmp100_;
		gboolean _tmp101_;
#line 110 "../core/Utils/FileUtils.vala"
		_tmp0_ = music_media_get_uri (s);
#line 110 "../core/Utils/FileUtils.vala"
		_tmp1_ = _tmp0_;
#line 110 "../core/Utils/FileUtils.vala"
		_tmp2_ = _tmp1_;
#line 110 "../core/Utils/FileUtils.vala"
		_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 110 "../core/Utils/FileUtils.vala"
		_tmp4_ = _tmp3_;
#line 110 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp2_);
#line 110 "../core/Utils/FileUtils.vala"
		original = _tmp4_;
#line 112 "../core/Utils/FileUtils.vala"
		_tmp5_ = g_strdup ("");
#line 112 "../core/Utils/FileUtils.vala"
		ext = _tmp5_;
#line 113 "../core/Utils/FileUtils.vala"
		_tmp6_ = music_media_get_uri (s);
#line 113 "../core/Utils/FileUtils.vala"
		_tmp7_ = _tmp6_;
#line 113 "../core/Utils/FileUtils.vala"
		_tmp8_ = _tmp7_;
#line 113 "../core/Utils/FileUtils.vala"
		_tmp9_ = g_str_has_prefix (_tmp8_, "cdda://");
#line 113 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp8_);
#line 113 "../core/Utils/FileUtils.vala"
		if (_tmp9_) {
#line 945 "FileUtils.c"
			gchar* _tmp10_;
#line 114 "../core/Utils/FileUtils.vala"
			_tmp10_ = g_strdup (".mp3");
#line 114 "../core/Utils/FileUtils.vala"
			_g_free0 (ext);
#line 114 "../core/Utils/FileUtils.vala"
			ext = _tmp10_;
#line 953 "FileUtils.c"
		} else {
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gchar* _tmp22_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp11_ = music_media_get_uri (s);
#line 116 "../core/Utils/FileUtils.vala"
			_tmp12_ = _tmp11_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp13_ = _tmp12_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp14_ = music_media_get_uri (s);
#line 116 "../core/Utils/FileUtils.vala"
			_tmp15_ = _tmp14_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp16_ = _tmp15_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp17_ = music_media_get_uri (s);
#line 116 "../core/Utils/FileUtils.vala"
			_tmp18_ = _tmp17_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp19_ = _tmp18_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp20_ = strlen (_tmp19_);
#line 116 "../core/Utils/FileUtils.vala"
			_tmp21_ = _tmp20_;
#line 116 "../core/Utils/FileUtils.vala"
			_tmp22_ = string_slice (_tmp13_, (glong) string_last_index_of (_tmp16_, ".", 0), (glong) _tmp21_);
#line 116 "../core/Utils/FileUtils.vala"
			_g_free0 (ext);
#line 116 "../core/Utils/FileUtils.vala"
			ext = _tmp22_;
#line 116 "../core/Utils/FileUtils.vala"
			_g_free0 (_tmp19_);
#line 116 "../core/Utils/FileUtils.vala"
			_g_free0 (_tmp16_);
#line 116 "../core/Utils/FileUtils.vala"
			_g_free0 (_tmp13_);
#line 1001 "FileUtils.c"
		}
#line 120 "../core/Utils/FileUtils.vala"
		_tmp23_ = music_settings_main_get_default ();
#line 120 "../core/Utils/FileUtils.vala"
		main_settings = _tmp23_;
#line 121 "../core/Utils/FileUtils.vala"
		_tmp24_ = main_settings;
#line 121 "../core/Utils/FileUtils.vala"
		_tmp25_ = music_settings_main_get_path_string (_tmp24_);
#line 121 "../core/Utils/FileUtils.vala"
		_tmp26_ = _tmp25_;
#line 121 "../core/Utils/FileUtils.vala"
		_tmp27_ = g_strdup (_tmp26_);
#line 121 "../core/Utils/FileUtils.vala"
		path = _tmp27_;
#line 122 "../core/Utils/FileUtils.vala"
		_tmp29_ = path;
#line 122 "../core/Utils/FileUtils.vala"
		if (g_strcmp0 (_tmp29_, "") == 0) {
#line 122 "../core/Utils/FileUtils.vala"
			_tmp28_ = TRUE;
#line 1023 "FileUtils.c"
		} else {
			const gchar* _tmp30_;
#line 122 "../core/Utils/FileUtils.vala"
			_tmp30_ = path;
#line 122 "../core/Utils/FileUtils.vala"
			_tmp28_ = _tmp30_ == NULL;
#line 1030 "FileUtils.c"
		}
#line 122 "../core/Utils/FileUtils.vala"
		if (_tmp28_) {
#line 1034 "FileUtils.c"
			gchar* _tmp31_;
			MusicSettingsMain* _tmp32_;
#line 123 "../core/Utils/FileUtils.vala"
			_tmp31_ = g_strdup ("$ALBUM_ARTIST/$ALBUM/$TRACK - $TITLE");
#line 123 "../core/Utils/FileUtils.vala"
			_g_free0 (path);
#line 123 "../core/Utils/FileUtils.vala"
			path = _tmp31_;
#line 124 "../core/Utils/FileUtils.vala"
			_tmp32_ = main_settings;
#line 124 "../core/Utils/FileUtils.vala"
			music_settings_main_set_path_string (_tmp32_, "$ALBUM_ARTIST/$ALBUM/$TRACK - $TITLE");
#line 1047 "FileUtils.c"
		}
#line 127 "../core/Utils/FileUtils.vala"
		_tmp33_ = path;
#line 127 "../core/Utils/FileUtils.vala"
		_tmp34_ = music_media_get_display_album_artist (s, TRUE);
#line 127 "../core/Utils/FileUtils.vala"
		_tmp35_ = _tmp34_;
#line 127 "../core/Utils/FileUtils.vala"
		_tmp36_ = string_replace (_tmp35_, "/", "_");
#line 127 "../core/Utils/FileUtils.vala"
		_tmp37_ = _tmp36_;
#line 127 "../core/Utils/FileUtils.vala"
		_tmp38_ = string_replace (_tmp33_, "$ALBUM_ARTIST", _tmp37_);
#line 127 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 127 "../core/Utils/FileUtils.vala"
		path = _tmp38_;
#line 127 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp37_);
#line 127 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp35_);
#line 128 "../core/Utils/FileUtils.vala"
		_tmp39_ = path;
#line 128 "../core/Utils/FileUtils.vala"
		_tmp40_ = music_media_get_display_artist (s);
#line 128 "../core/Utils/FileUtils.vala"
		_tmp41_ = _tmp40_;
#line 128 "../core/Utils/FileUtils.vala"
		_tmp42_ = string_replace (_tmp41_, "/", "_");
#line 128 "../core/Utils/FileUtils.vala"
		_tmp43_ = _tmp42_;
#line 128 "../core/Utils/FileUtils.vala"
		_tmp44_ = string_replace (_tmp39_, "$ARTIST", _tmp43_);
#line 128 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 128 "../core/Utils/FileUtils.vala"
		path = _tmp44_;
#line 128 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp43_);
#line 128 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp41_);
#line 129 "../core/Utils/FileUtils.vala"
		_tmp45_ = path;
#line 129 "../core/Utils/FileUtils.vala"
		_tmp46_ = music_media_get_display_album (s);
#line 129 "../core/Utils/FileUtils.vala"
		_tmp47_ = _tmp46_;
#line 129 "../core/Utils/FileUtils.vala"
		_tmp48_ = string_replace (_tmp47_, "/", "_");
#line 129 "../core/Utils/FileUtils.vala"
		_tmp49_ = _tmp48_;
#line 129 "../core/Utils/FileUtils.vala"
		_tmp50_ = string_replace (_tmp45_, "$ALBUM", _tmp49_);
#line 129 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 129 "../core/Utils/FileUtils.vala"
		path = _tmp50_;
#line 129 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp49_);
#line 129 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp47_);
#line 130 "../core/Utils/FileUtils.vala"
		_tmp51_ = path;
#line 130 "../core/Utils/FileUtils.vala"
		_tmp52_ = music_media_get_display_title (s);
#line 130 "../core/Utils/FileUtils.vala"
		_tmp53_ = _tmp52_;
#line 130 "../core/Utils/FileUtils.vala"
		_tmp54_ = string_replace (_tmp53_, "/", "_");
#line 130 "../core/Utils/FileUtils.vala"
		_tmp55_ = _tmp54_;
#line 130 "../core/Utils/FileUtils.vala"
		_tmp56_ = string_replace (_tmp51_, "$TITLE", _tmp55_);
#line 130 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 130 "../core/Utils/FileUtils.vala"
		path = _tmp56_;
#line 130 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp55_);
#line 130 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp53_);
#line 131 "../core/Utils/FileUtils.vala"
		_tmp57_ = path;
#line 131 "../core/Utils/FileUtils.vala"
		_tmp58_ = music_media_get_track (s);
#line 131 "../core/Utils/FileUtils.vala"
		_tmp59_ = _tmp58_;
#line 131 "../core/Utils/FileUtils.vala"
		_tmp60_ = g_strdup_printf ("%u", _tmp59_);
#line 131 "../core/Utils/FileUtils.vala"
		_tmp61_ = _tmp60_;
#line 131 "../core/Utils/FileUtils.vala"
		_tmp62_ = string_replace (_tmp57_, "$TRACK", _tmp61_);
#line 131 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 131 "../core/Utils/FileUtils.vala"
		path = _tmp62_;
#line 131 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp61_);
#line 133 "../core/Utils/FileUtils.vala"
		_tmp63_ = main_settings;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp64_ = music_settings_main_get_music_folder (_tmp63_);
#line 133 "../core/Utils/FileUtils.vala"
		_tmp65_ = _tmp64_;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp66_ = path;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp67_ = ext;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp68_ = g_strconcat (_tmp66_, _tmp67_, NULL);
#line 133 "../core/Utils/FileUtils.vala"
		_tmp69_ = _tmp68_;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp70_ = g_build_path ("/", _tmp65_, _tmp69_, NULL);
#line 133 "../core/Utils/FileUtils.vala"
		_tmp71_ = _tmp70_;
#line 133 "../core/Utils/FileUtils.vala"
		_tmp72_ = g_file_new_for_path (_tmp71_);
#line 133 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (dest);
#line 133 "../core/Utils/FileUtils.vala"
		dest = _tmp72_;
#line 133 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp71_);
#line 133 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp69_);
#line 135 "../core/Utils/FileUtils.vala"
		_tmp73_ = original;
#line 135 "../core/Utils/FileUtils.vala"
		_tmp74_ = g_file_get_path (_tmp73_);
#line 135 "../core/Utils/FileUtils.vala"
		_tmp75_ = _tmp74_;
#line 135 "../core/Utils/FileUtils.vala"
		_tmp76_ = dest;
#line 135 "../core/Utils/FileUtils.vala"
		_tmp77_ = g_file_get_path (_tmp76_);
#line 135 "../core/Utils/FileUtils.vala"
		_tmp78_ = _tmp77_;
#line 135 "../core/Utils/FileUtils.vala"
		_tmp79_ = string_contains (_tmp75_, _tmp78_);
#line 135 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp78_);
#line 135 "../core/Utils/FileUtils.vala"
		_g_free0 (_tmp75_);
#line 135 "../core/Utils/FileUtils.vala"
		if (_tmp79_) {
#line 136 "../core/Utils/FileUtils.vala"
			g_debug ("FileUtils.vala:136: File is already in correct location\n");
#line 137 "../core/Utils/FileUtils.vala"
			result = NULL;
#line 137 "../core/Utils/FileUtils.vala"
			_g_free0 (path);
#line 137 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (main_settings);
#line 137 "../core/Utils/FileUtils.vala"
			_g_free0 (ext);
#line 137 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (original);
#line 137 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (dest);
#line 137 "../core/Utils/FileUtils.vala"
			return result;
#line 1211 "FileUtils.c"
		}
#line 140 "../core/Utils/FileUtils.vala"
		_tmp80_ = dest;
#line 140 "../core/Utils/FileUtils.vala"
		if (g_file_query_exists (_tmp80_, NULL)) {
#line 1217 "FileUtils.c"
			gint number = 0;
#line 141 "../core/Utils/FileUtils.vala"
			number = 2;
#line 142 "../core/Utils/FileUtils.vala"
			while (TRUE) {
#line 1223 "FileUtils.c"
				MusicSettingsMain* _tmp81_;
				const gchar* _tmp82_;
				const gchar* _tmp83_;
				const gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
				const gchar* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				gchar* _tmp92_;
				gchar* _tmp93_;
				GFile* _tmp94_;
				GFile* _tmp95_;
				gboolean _tmp96_;
				gint _tmp97_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp81_ = main_settings;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp82_ = music_settings_main_get_music_folder (_tmp81_);
#line 142 "../core/Utils/FileUtils.vala"
				_tmp83_ = _tmp82_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp84_ = path;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp85_ = g_strdup_printf (_ (" (%d)"), number);
#line 142 "../core/Utils/FileUtils.vala"
				_tmp86_ = _tmp85_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp87_ = g_strconcat (_tmp84_, _tmp86_, NULL);
#line 142 "../core/Utils/FileUtils.vala"
				_tmp88_ = _tmp87_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp89_ = ext;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp90_ = g_strconcat (_tmp88_, _tmp89_, NULL);
#line 142 "../core/Utils/FileUtils.vala"
				_tmp91_ = _tmp90_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp92_ = g_build_path ("/", _tmp83_, _tmp91_, NULL);
#line 142 "../core/Utils/FileUtils.vala"
				_tmp93_ = _tmp92_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp94_ = g_file_new_for_path (_tmp93_);
#line 142 "../core/Utils/FileUtils.vala"
				_g_object_unref0 (dest);
#line 142 "../core/Utils/FileUtils.vala"
				dest = _tmp94_;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp95_ = dest;
#line 142 "../core/Utils/FileUtils.vala"
				_tmp96_ = !g_file_query_exists (_tmp95_, NULL);
#line 142 "../core/Utils/FileUtils.vala"
				_g_free0 (_tmp93_);
#line 142 "../core/Utils/FileUtils.vala"
				_g_free0 (_tmp91_);
#line 142 "../core/Utils/FileUtils.vala"
				_g_free0 (_tmp88_);
#line 142 "../core/Utils/FileUtils.vala"
				_g_free0 (_tmp86_);
#line 142 "../core/Utils/FileUtils.vala"
				if (_tmp96_) {
#line 142 "../core/Utils/FileUtils.vala"
					break;
#line 1289 "FileUtils.c"
				}
#line 143 "../core/Utils/FileUtils.vala"
				_tmp97_ = number;
#line 143 "../core/Utils/FileUtils.vala"
				number = _tmp97_ + 1;
#line 1295 "FileUtils.c"
			}
		}
#line 148 "../core/Utils/FileUtils.vala"
		_tmp98_ = dest;
#line 148 "../core/Utils/FileUtils.vala"
		_tmp99_ = g_file_get_parent (_tmp98_);
#line 148 "../core/Utils/FileUtils.vala"
		_tmp100_ = _tmp99_;
#line 148 "../core/Utils/FileUtils.vala"
		_tmp101_ = !g_file_query_exists (_tmp100_, NULL);
#line 148 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (_tmp100_);
#line 148 "../core/Utils/FileUtils.vala"
		if (_tmp101_) {
#line 1310 "FileUtils.c"
			GFile* _tmp102_;
			GFile* _tmp103_;
			GFile* _tmp104_;
#line 149 "../core/Utils/FileUtils.vala"
			_tmp102_ = dest;
#line 149 "../core/Utils/FileUtils.vala"
			_tmp103_ = g_file_get_parent (_tmp102_);
#line 149 "../core/Utils/FileUtils.vala"
			_tmp104_ = _tmp103_;
#line 149 "../core/Utils/FileUtils.vala"
			g_file_make_directory_with_parents (_tmp104_, NULL, &_inner_error0_);
#line 149 "../core/Utils/FileUtils.vala"
			_g_object_unref0 (_tmp104_);
#line 149 "../core/Utils/FileUtils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../core/Utils/FileUtils.vala"
				_g_free0 (path);
#line 149 "../core/Utils/FileUtils.vala"
				_g_object_unref0 (main_settings);
#line 149 "../core/Utils/FileUtils.vala"
				_g_free0 (ext);
#line 149 "../core/Utils/FileUtils.vala"
				_g_object_unref0 (original);
#line 1334 "FileUtils.c"
				goto __catch0_g_error;
			}
		}
#line 109 "../core/Utils/FileUtils.vala"
		_g_free0 (path);
#line 109 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (main_settings);
#line 109 "../core/Utils/FileUtils.vala"
		_g_free0 (ext);
#line 109 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (original);
#line 1346 "FileUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp105_;
		const gchar* _tmp106_;
#line 109 "../core/Utils/FileUtils.vala"
		err = _inner_error0_;
#line 109 "../core/Utils/FileUtils.vala"
		_inner_error0_ = NULL;
#line 152 "../core/Utils/FileUtils.vala"
		_tmp105_ = err;
#line 152 "../core/Utils/FileUtils.vala"
		_tmp106_ = _tmp105_->message;
#line 152 "../core/Utils/FileUtils.vala"
		g_debug ("FileUtils.vala:152: Could not find new destination!: %s\n", _tmp106_);
#line 109 "../core/Utils/FileUtils.vala"
		_g_error_free0 (err);
#line 1366 "FileUtils.c"
	}
	__finally0:
#line 109 "../core/Utils/FileUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../core/Utils/FileUtils.vala"
		_g_object_unref0 (dest);
#line 109 "../core/Utils/FileUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../core/Utils/FileUtils.vala"
		g_clear_error (&_inner_error0_);
#line 109 "../core/Utils/FileUtils.vala"
		return NULL;
#line 1379 "FileUtils.c"
	}
#line 155 "../core/Utils/FileUtils.vala"
	result = dest;
#line 155 "../core/Utils/FileUtils.vala"
	return result;
#line 1385 "FileUtils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

