/* PlaylistsUtils.c generated by valac 0.56.0, the Vala compiler
 * generated from PlaylistsUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

VALA_EXTERN gboolean music_playlists_utils_save_playlist_pls (MusicPlaylist* p,
                                                  const gchar* folder_uri);
VALA_EXTERN gboolean music_playlists_utils_parse_paths_from_m3u (const gchar* uri,
                                                     GeeLinkedList** locals);
VALA_EXTERN gboolean music_playlists_utils_parse_paths_from_pls (const gchar* uri,
                                                     GeeLinkedList** locals,
                                                     gchar** title);
VALA_EXTERN void music_playlists_utils_parse_index_and_value (const gchar* prefix,
                                                  const gchar* line,
                                                  GeeHashMap** map);
VALA_EXTERN GeeCollection* music_playlists_utils_convert_paths_to_uris (GeeCollection* paths);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 88 "PlaylistsUtils.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 92 "PlaylistsUtils.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 98 "PlaylistsUtils.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 102 "PlaylistsUtils.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 106 "PlaylistsUtils.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 114 "PlaylistsUtils.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 142 "PlaylistsUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 151 "PlaylistsUtils.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 165 "PlaylistsUtils.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 174 "PlaylistsUtils.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 188 "PlaylistsUtils.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 197 "PlaylistsUtils.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 206 "PlaylistsUtils.c"
}

gboolean
music_playlists_utils_save_playlist_m3u (MusicPlaylist* p,
                                         const gchar* folder_uri,
                                         const gchar* without_path)
{
	gboolean rv = FALSE;
	gchar* to_save = NULL;
	gchar* _tmp0_;
	GFile* dest = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 31 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 31 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (folder_uri != NULL, FALSE);
#line 31 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (without_path != NULL, FALSE);
#line 32 "../core/Utils/PlaylistsUtils.vala"
	rv = FALSE;
#line 33 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = music_playlists_utils_get_playlist_m3u_file (p, without_path);
#line 33 "../core/Utils/PlaylistsUtils.vala"
	to_save = _tmp0_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = g_strconcat (folder_uri, "/", NULL);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = _tmp1_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = music_playlist_get_name (p);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = _tmp3_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp5_ = string_replace (_tmp4_, "/", "_");
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp6_ = _tmp5_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp7_ = g_strconcat (_tmp2_, _tmp6_, NULL);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp8_ = _tmp7_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp9_ = g_strconcat (_tmp8_, ".m3u", NULL);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp10_ = _tmp9_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp11_ = g_file_new_for_uri (_tmp10_);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_tmp12_ = _tmp11_;
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp10_);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp8_);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp6_);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp2_);
#line 35 "../core/Utils/PlaylistsUtils.vala"
	dest = _tmp12_;
#line 278 "PlaylistsUtils.c"
	{
		GFile* _tmp13_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp32_;
		GFileOutputStream* _tmp33_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp34_;
		GDataOutputStream* _tmp35_;
		GDataOutputStream* _tmp36_;
		const gchar* _tmp37_;
#line 38 "../core/Utils/PlaylistsUtils.vala"
		_tmp13_ = dest;
#line 38 "../core/Utils/PlaylistsUtils.vala"
		if (g_file_query_exists (_tmp13_, NULL)) {
#line 293 "PlaylistsUtils.c"
			gint i = 0;
#line 39 "../core/Utils/PlaylistsUtils.vala"
			i = 2;
#line 40 "../core/Utils/PlaylistsUtils.vala"
			while (TRUE) {
#line 299 "PlaylistsUtils.c"
				gchar* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GFile* _tmp28_;
				GFile* _tmp29_;
				gboolean _tmp30_;
				gint _tmp31_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp14_ = g_strconcat (folder_uri, "/", NULL);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp15_ = _tmp14_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp16_ = music_playlist_get_name (p);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp17_ = _tmp16_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp18_ = string_replace (_tmp17_, "/", "_");
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp19_ = _tmp18_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp21_ = _tmp20_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp22_ = g_strdup_printf ("(%d)", i);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp23_ = _tmp22_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp24_ = g_strconcat (_tmp21_, _tmp23_, NULL);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp25_ = _tmp24_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp26_ = g_strconcat (_tmp25_, ".m3u", NULL);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp27_ = _tmp26_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp28_ = g_file_new_for_uri (_tmp27_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (dest);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				dest = _tmp28_;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp29_ = dest;
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_tmp30_ = !g_file_query_exists (_tmp29_, NULL);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp27_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp25_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp23_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp21_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp19_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp15_);
#line 40 "../core/Utils/PlaylistsUtils.vala"
				if (_tmp30_) {
#line 40 "../core/Utils/PlaylistsUtils.vala"
					break;
#line 372 "PlaylistsUtils.c"
				}
#line 41 "../core/Utils/PlaylistsUtils.vala"
				_tmp31_ = i;
#line 41 "../core/Utils/PlaylistsUtils.vala"
				i = _tmp31_ + 1;
#line 378 "PlaylistsUtils.c"
			}
		}
#line 45 "../core/Utils/PlaylistsUtils.vala"
		_tmp32_ = dest;
#line 45 "../core/Utils/PlaylistsUtils.vala"
		_tmp33_ = g_file_create (_tmp32_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 45 "../core/Utils/PlaylistsUtils.vala"
		file_stream = _tmp33_;
#line 45 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 48 "../core/Utils/PlaylistsUtils.vala"
		_tmp34_ = file_stream;
#line 48 "../core/Utils/PlaylistsUtils.vala"
		_tmp35_ = g_data_output_stream_new ((GOutputStream*) _tmp34_);
#line 48 "../core/Utils/PlaylistsUtils.vala"
		data_stream = _tmp35_;
#line 49 "../core/Utils/PlaylistsUtils.vala"
		_tmp36_ = data_stream;
#line 49 "../core/Utils/PlaylistsUtils.vala"
		_tmp37_ = to_save;
#line 49 "../core/Utils/PlaylistsUtils.vala"
		g_data_output_stream_put_string (_tmp36_, _tmp37_, NULL, &_inner_error0_);
#line 49 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (data_stream);
#line 49 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (file_stream);
#line 410 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 50 "../core/Utils/PlaylistsUtils.vala"
		rv = TRUE;
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (data_stream);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file_stream);
#line 419 "PlaylistsUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		GFile* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GError* _tmp43_;
		const gchar* _tmp44_;
#line 36 "../core/Utils/PlaylistsUtils.vala"
		err = _inner_error0_;
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_inner_error0_ = NULL;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp38_ = music_playlist_get_name (p);
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp39_ = _tmp38_;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp40_ = dest;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp41_ = g_file_get_path (_tmp40_);
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp42_ = _tmp41_;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp43_ = err;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_tmp44_ = _tmp43_->message;
#line 53 "../core/Utils/PlaylistsUtils.vala"
		g_warning ("PlaylistsUtils.vala:53: Could not save playlist %s to m3u file %s: %s\n", _tmp39_, _tmp42_, _tmp44_);
#line 53 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (_tmp42_);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_g_error_free0 (err);
#line 456 "PlaylistsUtils.c"
	}
	__finally0:
#line 36 "../core/Utils/PlaylistsUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 461 "PlaylistsUtils.c"
		gboolean _tmp45_ = FALSE;
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (dest);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (to_save);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		g_clear_error (&_inner_error0_);
#line 36 "../core/Utils/PlaylistsUtils.vala"
		return _tmp45_;
#line 473 "PlaylistsUtils.c"
	}
#line 56 "../core/Utils/PlaylistsUtils.vala"
	result = rv;
#line 56 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (dest);
#line 56 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (to_save);
#line 56 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 483 "PlaylistsUtils.c"
}

gchar*
music_playlists_utils_get_playlist_m3u_file (MusicPlaylist* p,
                                             const gchar* without_path)
{
	gchar* to_save = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 59 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 59 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (without_path != NULL, NULL);
#line 60 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = g_strdup ("#EXTM3U");
#line 60 "../core/Utils/PlaylistsUtils.vala"
	to_save = _tmp0_;
#line 501 "PlaylistsUtils.c"
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
#line 62 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = music_playlist_iterator (p);
#line 62 "../core/Utils/PlaylistsUtils.vala"
		_s_it = _tmp1_;
#line 62 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 511 "PlaylistsUtils.c"
			GeeIterator* _tmp2_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* _tmp5_;
			const gchar* _tmp6_;
			MusicMedia* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			MusicMedia* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			MusicMedia* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			MusicMedia* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GFile* _tmp34_;
			GFile* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 62 "../core/Utils/PlaylistsUtils.vala"
			_tmp2_ = _s_it;
#line 62 "../core/Utils/PlaylistsUtils.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 62 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 560 "PlaylistsUtils.c"
			}
#line 62 "../core/Utils/PlaylistsUtils.vala"
			_tmp3_ = _s_it;
#line 62 "../core/Utils/PlaylistsUtils.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 62 "../core/Utils/PlaylistsUtils.vala"
			s = (MusicMedia*) _tmp4_;
#line 63 "../core/Utils/PlaylistsUtils.vala"
			_tmp5_ = s;
#line 63 "../core/Utils/PlaylistsUtils.vala"
			if (_tmp5_ == NULL) {
#line 64 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (s);
#line 64 "../core/Utils/PlaylistsUtils.vala"
				continue;
#line 576 "PlaylistsUtils.c"
			}
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp6_ = to_save;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp7_ = s;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp8_ = music_media_get_length (_tmp7_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = _tmp8_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = g_strdup_printf ("%u", _tmp9_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp11_ = _tmp10_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp12_ = g_strconcat ("\n\n#EXTINF:", _tmp11_, NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp13_ = _tmp12_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp14_ = g_strconcat (_tmp13_, ", ", NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp15_ = _tmp14_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp16_ = s;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp17_ = music_media_get_artist (_tmp16_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp18_ = _tmp17_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp19_ = g_strconcat (_tmp15_, _tmp18_, NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp20_ = _tmp19_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp21_ = g_strconcat (_tmp20_, " - ", NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp22_ = _tmp21_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp23_ = s;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp24_ = music_media_get_title (_tmp23_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp25_ = _tmp24_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp27_ = _tmp26_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp28_ = g_strconcat (_tmp27_, "\n", NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp29_ = _tmp28_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp30_ = s;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp31_ = music_media_get_uri (_tmp30_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp32_ = _tmp31_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp33_ = _tmp32_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp34_ = g_file_new_for_uri (_tmp33_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp35_ = _tmp34_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp36_ = g_file_get_path (_tmp35_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp37_ = _tmp36_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp38_ = g_strconcat (_tmp29_, _tmp37_, NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp39_ = _tmp38_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_tmp40_ = g_strconcat (_tmp6_, _tmp39_, NULL);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (to_save);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			to_save = _tmp40_;
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp39_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp37_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (_tmp35_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp33_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp29_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp27_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp22_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp20_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp15_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp13_);
#line 67 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp11_);
#line 68 "../core/Utils/PlaylistsUtils.vala"
			_tmp41_ = to_save;
#line 68 "../core/Utils/PlaylistsUtils.vala"
			_tmp42_ = string_replace (_tmp41_, without_path, "");
#line 68 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (to_save);
#line 68 "../core/Utils/PlaylistsUtils.vala"
			to_save = _tmp42_;
#line 62 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (s);
#line 684 "PlaylistsUtils.c"
		}
#line 62 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_s_it);
#line 688 "PlaylistsUtils.c"
	}
#line 71 "../core/Utils/PlaylistsUtils.vala"
	result = to_save;
#line 71 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 694 "PlaylistsUtils.c"
}

gboolean
music_playlists_utils_save_playlist_pls (MusicPlaylist* p,
                                         const gchar* folder_uri)
{
	gboolean rv = FALSE;
	gchar* to_save = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gint index = 0;
	GFile* dest = NULL;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GFile* _tmp47_;
	GFile* _tmp48_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 74 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 74 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (folder_uri != NULL, FALSE);
#line 75 "../core/Utils/PlaylistsUtils.vala"
	rv = FALSE;
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = music_playlist_get_name (p);
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = _tmp0_;
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = music_playlist_get_medias (p);
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = _tmp2_;
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp5_ = _tmp4_;
#line 76 "../core/Utils/PlaylistsUtils.vala"
	_tmp6_ = g_strdup_printf ("[playlist]\nX-GNOME-Title=%s\nNumberOfEntries=%d\nVersion=2", _tmp1_, _tmp5_);
#line 76 "../core/Utils/PlaylistsUtils.vala"
	to_save = _tmp6_;
#line 78 "../core/Utils/PlaylistsUtils.vala"
	index = 1;
#line 750 "PlaylistsUtils.c"
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp7_;
#line 79 "../core/Utils/PlaylistsUtils.vala"
		_tmp7_ = music_playlist_iterator (p);
#line 79 "../core/Utils/PlaylistsUtils.vala"
		_s_it = _tmp7_;
#line 79 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 760 "PlaylistsUtils.c"
			GeeIterator* _tmp8_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			MusicMedia* _tmp11_;
			const gchar* _tmp12_;
			MusicMedia* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			MusicMedia* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			const gchar* _tmp29_;
			MusicMedia* _tmp30_;
			guint _tmp31_;
			guint _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gint _tmp36_;
#line 79 "../core/Utils/PlaylistsUtils.vala"
			_tmp8_ = _s_it;
#line 79 "../core/Utils/PlaylistsUtils.vala"
			if (!gee_iterator_next (_tmp8_)) {
#line 79 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 797 "PlaylistsUtils.c"
			}
#line 79 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = _s_it;
#line 79 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 79 "../core/Utils/PlaylistsUtils.vala"
			s = (MusicMedia*) _tmp10_;
#line 80 "../core/Utils/PlaylistsUtils.vala"
			_tmp11_ = s;
#line 80 "../core/Utils/PlaylistsUtils.vala"
			if (_tmp11_ == NULL) {
#line 81 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (s);
#line 81 "../core/Utils/PlaylistsUtils.vala"
				continue;
#line 813 "PlaylistsUtils.c"
			}
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp12_ = to_save;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp13_ = s;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp14_ = music_media_get_uri (_tmp13_);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp15_ = _tmp14_;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp16_ = _tmp15_;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp17_ = string_replace (_tmp16_, folder_uri, "");
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp18_ = _tmp17_;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp19_ = g_strdup_printf ("\n\nFile%d=%s", index, _tmp18_);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp20_ = _tmp19_;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_tmp21_ = g_strconcat (_tmp12_, _tmp20_, NULL);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (to_save);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			to_save = _tmp21_;
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp20_);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp18_);
#line 83 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp16_);
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp22_ = to_save;
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp23_ = s;
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp24_ = music_media_get_title (_tmp23_);
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp25_ = _tmp24_;
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp26_ = g_strdup_printf ("\nTitle%d=%s", index, _tmp25_);
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp27_ = _tmp26_;
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_tmp28_ = g_strconcat (_tmp22_, _tmp27_, NULL);
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (to_save);
#line 84 "../core/Utils/PlaylistsUtils.vala"
			to_save = _tmp28_;
#line 84 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp27_);
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp29_ = to_save;
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp30_ = s;
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp31_ = music_media_get_length (_tmp30_);
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp32_ = _tmp31_;
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp33_ = g_strdup_printf ("\nLength%d=%u", index, _tmp32_);
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp34_ = _tmp33_;
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_tmp35_ = g_strconcat (_tmp29_, _tmp34_, NULL);
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (to_save);
#line 85 "../core/Utils/PlaylistsUtils.vala"
			to_save = _tmp35_;
#line 85 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp34_);
#line 86 "../core/Utils/PlaylistsUtils.vala"
			index = index + 1;
#line 86 "../core/Utils/PlaylistsUtils.vala"
			_tmp36_ = index;
#line 79 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (s);
#line 891 "PlaylistsUtils.c"
		}
#line 79 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_s_it);
#line 895 "PlaylistsUtils.c"
	}
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp37_ = g_strconcat (folder_uri, "/", NULL);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp38_ = _tmp37_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp39_ = music_playlist_get_name (p);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp40_ = _tmp39_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp41_ = string_replace (_tmp40_, "/", "_");
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp42_ = _tmp41_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp43_ = g_strconcat (_tmp38_, _tmp42_, NULL);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp44_ = _tmp43_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp45_ = g_strconcat (_tmp44_, ".pls", NULL);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp46_ = _tmp45_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp47_ = g_file_new_for_uri (_tmp46_);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_tmp48_ = _tmp47_;
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp46_);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp44_);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp42_);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp38_);
#line 89 "../core/Utils/PlaylistsUtils.vala"
	dest = _tmp48_;
#line 931 "PlaylistsUtils.c"
	{
		gint extra = 0;
		GFile* _tmp49_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp66_;
		GFileOutputStream* _tmp67_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp68_;
		GDataOutputStream* _tmp69_;
		GDataOutputStream* _tmp70_;
		const gchar* _tmp71_;
#line 92 "../core/Utils/PlaylistsUtils.vala"
		extra = 2;
#line 93 "../core/Utils/PlaylistsUtils.vala"
		_tmp49_ = dest;
#line 93 "../core/Utils/PlaylistsUtils.vala"
		if (g_file_query_exists (_tmp49_, NULL) == TRUE) {
#line 94 "../core/Utils/PlaylistsUtils.vala"
			while (TRUE) {
#line 951 "PlaylistsUtils.c"
				gchar* _tmp50_;
				gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				GFile* _tmp62_;
				GFile* _tmp63_;
				gboolean _tmp64_;
				gint _tmp65_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp50_ = g_strconcat (folder_uri, "/", NULL);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp51_ = _tmp50_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp52_ = music_playlist_get_name (p);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp53_ = _tmp52_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp54_ = string_replace (_tmp53_, "/", "_");
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp55_ = _tmp54_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp56_ = g_strdup_printf (_ ("%s (%d)"), _tmp55_, extra);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp57_ = _tmp56_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp58_ = g_strconcat (_tmp51_, _tmp57_, NULL);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp59_ = _tmp58_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp60_ = g_strconcat (_tmp59_, ".pls", NULL);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp61_ = _tmp60_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp62_ = g_file_new_for_uri (_tmp61_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (dest);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				dest = _tmp62_;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp63_ = dest;
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_tmp64_ = !g_file_query_exists (_tmp63_, NULL);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp61_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp59_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp57_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp55_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp51_);
#line 94 "../core/Utils/PlaylistsUtils.vala"
				if (_tmp64_) {
#line 94 "../core/Utils/PlaylistsUtils.vala"
					break;
#line 1016 "PlaylistsUtils.c"
				}
#line 96 "../core/Utils/PlaylistsUtils.vala"
				_tmp65_ = extra;
#line 96 "../core/Utils/PlaylistsUtils.vala"
				extra = _tmp65_ + 1;
#line 1022 "PlaylistsUtils.c"
			}
		}
#line 100 "../core/Utils/PlaylistsUtils.vala"
		_tmp66_ = dest;
#line 100 "../core/Utils/PlaylistsUtils.vala"
		_tmp67_ = g_file_create (_tmp66_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 100 "../core/Utils/PlaylistsUtils.vala"
		file_stream = _tmp67_;
#line 100 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1033 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 103 "../core/Utils/PlaylistsUtils.vala"
		_tmp68_ = file_stream;
#line 103 "../core/Utils/PlaylistsUtils.vala"
		_tmp69_ = g_data_output_stream_new ((GOutputStream*) _tmp68_);
#line 103 "../core/Utils/PlaylistsUtils.vala"
		data_stream = _tmp69_;
#line 104 "../core/Utils/PlaylistsUtils.vala"
		_tmp70_ = data_stream;
#line 104 "../core/Utils/PlaylistsUtils.vala"
		_tmp71_ = to_save;
#line 104 "../core/Utils/PlaylistsUtils.vala"
		g_data_output_stream_put_string (_tmp70_, _tmp71_, NULL, &_inner_error0_);
#line 104 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (data_stream);
#line 104 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (file_stream);
#line 1054 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 105 "../core/Utils/PlaylistsUtils.vala"
		rv = TRUE;
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (data_stream);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file_stream);
#line 1063 "PlaylistsUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp72_;
		const gchar* _tmp73_;
		GFile* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		GError* _tmp77_;
		const gchar* _tmp78_;
#line 90 "../core/Utils/PlaylistsUtils.vala"
		err = _inner_error0_;
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_inner_error0_ = NULL;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp72_ = music_playlist_get_name (p);
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp73_ = _tmp72_;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp74_ = dest;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp75_ = g_file_get_path (_tmp74_);
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp76_ = _tmp75_;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp77_ = err;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_tmp78_ = _tmp77_->message;
#line 108 "../core/Utils/PlaylistsUtils.vala"
		g_warning ("PlaylistsUtils.vala:108: Could not save playlist %s to pls file %s: %s" \
"\n", _tmp73_, _tmp76_, _tmp78_);
#line 108 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (_tmp76_);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_g_error_free0 (err);
#line 1100 "PlaylistsUtils.c"
	}
	__finally0:
#line 90 "../core/Utils/PlaylistsUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1105 "PlaylistsUtils.c"
		gboolean _tmp79_ = FALSE;
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (dest);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (to_save);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		g_clear_error (&_inner_error0_);
#line 90 "../core/Utils/PlaylistsUtils.vala"
		return _tmp79_;
#line 1117 "PlaylistsUtils.c"
	}
#line 111 "../core/Utils/PlaylistsUtils.vala"
	result = rv;
#line 111 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (dest);
#line 111 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (to_save);
#line 111 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 1127 "PlaylistsUtils.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1232 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1233 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1233 "glib-2.0.vapi"
	result = _tmp0_;
#line 1233 "glib-2.0.vapi"
	return result;
#line 1144 "PlaylistsUtils.c"
}

gboolean
music_playlists_utils_parse_paths_from_m3u (const gchar* uri,
                                            GeeLinkedList** locals)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 114 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 114 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (*locals != NULL, FALSE);
#line 120 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = g_file_new_for_uri (uri);
#line 120 "../core/Utils/PlaylistsUtils.vala"
	file = _tmp0_;
#line 121 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = file;
#line 121 "../core/Utils/PlaylistsUtils.vala"
	if (!g_file_query_exists (_tmp1_, NULL)) {
#line 122 "../core/Utils/PlaylistsUtils.vala"
		g_critical ("PlaylistsUtils.vala:122: The imported playlist doesn't exist !");
#line 123 "../core/Utils/PlaylistsUtils.vala"
		result = FALSE;
#line 123 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 123 "../core/Utils/PlaylistsUtils.vala"
		return result;
#line 1176 "PlaylistsUtils.c"
	}
	{
		gchar* line = NULL;
		gchar* previous_line = NULL;
		gchar* _tmp2_;
		GFileInputStream* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp6_;
#line 128 "../core/Utils/PlaylistsUtils.vala"
		_tmp2_ = g_strdup ("");
#line 128 "../core/Utils/PlaylistsUtils.vala"
		previous_line = _tmp2_;
#line 129 "../core/Utils/PlaylistsUtils.vala"
		_tmp4_ = file;
#line 129 "../core/Utils/PlaylistsUtils.vala"
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
#line 129 "../core/Utils/PlaylistsUtils.vala"
		_tmp3_ = _tmp5_;
#line 129 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (previous_line);
#line 129 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (line);
#line 1203 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 129 "../core/Utils/PlaylistsUtils.vala"
		_tmp6_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
#line 129 "../core/Utils/PlaylistsUtils.vala"
		dis = _tmp6_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 1212 "PlaylistsUtils.c"
			gchar* _tmp7_ = NULL;
			GDataInputStream* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp8_ = dis;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = g_data_input_stream_read_line (_tmp8_, NULL, NULL, &_inner_error0_);
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp7_ = _tmp9_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (dis);
#line 131 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (_tmp3_);
#line 131 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (previous_line);
#line 131 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (line);
#line 1238 "PlaylistsUtils.c"
				goto __catch0_g_error;
			}
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = _tmp7_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp7_ = NULL;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (line);
#line 131 "../core/Utils/PlaylistsUtils.vala"
			line = _tmp10_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_tmp11_ = line;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			if (!(_tmp11_ != NULL)) {
#line 131 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp7_);
#line 131 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 1257 "PlaylistsUtils.c"
			}
#line 132 "../core/Utils/PlaylistsUtils.vala"
			_tmp13_ = line;
#line 132 "../core/Utils/PlaylistsUtils.vala"
			if (string_get (_tmp13_, (glong) 0) != '#') {
#line 1263 "PlaylistsUtils.c"
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp14_ = line;
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp15_ = string_replace (_tmp14_, " ", "");
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp16_ = _tmp15_;
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp17_ = strlen (_tmp16_);
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp18_ = _tmp17_;
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp12_ = _tmp18_ > 0;
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp16_);
#line 1283 "PlaylistsUtils.c"
			} else {
#line 132 "../core/Utils/PlaylistsUtils.vala"
				_tmp12_ = FALSE;
#line 1287 "PlaylistsUtils.c"
			}
#line 132 "../core/Utils/PlaylistsUtils.vala"
			if (_tmp12_) {
#line 1291 "PlaylistsUtils.c"
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
#line 133 "../core/Utils/PlaylistsUtils.vala"
				_tmp19_ = line;
#line 133 "../core/Utils/PlaylistsUtils.vala"
				_tmp20_ = g_strconcat ("file://", _tmp19_, NULL);
#line 133 "../core/Utils/PlaylistsUtils.vala"
				_tmp21_ = _tmp20_;
#line 133 "../core/Utils/PlaylistsUtils.vala"
				g_warning ("PlaylistsUtils.vala:133: %s", _tmp21_);
#line 133 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp21_);
#line 134 "../core/Utils/PlaylistsUtils.vala"
				_tmp22_ = line;
#line 134 "../core/Utils/PlaylistsUtils.vala"
				_tmp23_ = g_strconcat ("file://", _tmp22_, NULL);
#line 134 "../core/Utils/PlaylistsUtils.vala"
				_tmp24_ = _tmp23_;
#line 134 "../core/Utils/PlaylistsUtils.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) (*locals), _tmp24_);
#line 134 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp24_);
#line 1318 "PlaylistsUtils.c"
			}
#line 137 "../core/Utils/PlaylistsUtils.vala"
			_tmp25_ = line;
#line 137 "../core/Utils/PlaylistsUtils.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 137 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (previous_line);
#line 137 "../core/Utils/PlaylistsUtils.vala"
			previous_line = _tmp26_;
#line 131 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp7_);
#line 1330 "PlaylistsUtils.c"
		}
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (dis);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_tmp3_);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (previous_line);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (line);
#line 1340 "PlaylistsUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 126 "../core/Utils/PlaylistsUtils.vala"
		err = _inner_error0_;
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_inner_error0_ = NULL;
#line 141 "../core/Utils/PlaylistsUtils.vala"
		_tmp27_ = err;
#line 141 "../core/Utils/PlaylistsUtils.vala"
		_tmp28_ = _tmp27_->message;
#line 141 "../core/Utils/PlaylistsUtils.vala"
		g_warning ("PlaylistsUtils.vala:141: Could not load m3u file at %s: %s\n", uri, _tmp28_);
#line 142 "../core/Utils/PlaylistsUtils.vala"
		result = FALSE;
#line 142 "../core/Utils/PlaylistsUtils.vala"
		_g_error_free0 (err);
#line 142 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 142 "../core/Utils/PlaylistsUtils.vala"
		return result;
#line 1366 "PlaylistsUtils.c"
	}
	__finally0:
#line 126 "../core/Utils/PlaylistsUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1371 "PlaylistsUtils.c"
		gboolean _tmp29_ = FALSE;
#line 126 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		g_clear_error (&_inner_error0_);
#line 126 "../core/Utils/PlaylistsUtils.vala"
		return _tmp29_;
#line 1381 "PlaylistsUtils.c"
	}
#line 145 "../core/Utils/PlaylistsUtils.vala"
	result = TRUE;
#line 145 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (file);
#line 145 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 1389 "PlaylistsUtils.c"
}

gboolean
music_playlists_utils_parse_paths_from_pls (const gchar* uri,
                                            GeeLinkedList** locals,
                                            gchar** title)
{
	GeeHashMap* files = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* titles = NULL;
	GeeHashMap* _tmp1_;
	GeeHashMap* lengths = NULL;
	GeeHashMap* _tmp2_;
	GFile* file = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 148 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 148 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (*locals != NULL, FALSE);
#line 148 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (*title != NULL, FALSE);
#line 149 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 149 "../core/Utils/PlaylistsUtils.vala"
	files = _tmp0_;
#line 150 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 150 "../core/Utils/PlaylistsUtils.vala"
	titles = _tmp1_;
#line 151 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 151 "../core/Utils/PlaylistsUtils.vala"
	lengths = _tmp2_;
#line 153 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = g_file_new_for_uri (uri);
#line 153 "../core/Utils/PlaylistsUtils.vala"
	file = _tmp3_;
#line 154 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = file;
#line 154 "../core/Utils/PlaylistsUtils.vala"
	if (!g_file_query_exists (_tmp4_, NULL)) {
#line 155 "../core/Utils/PlaylistsUtils.vala"
		result = FALSE;
#line 155 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 155 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (lengths);
#line 155 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (titles);
#line 155 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (files);
#line 155 "../core/Utils/PlaylistsUtils.vala"
		return result;
#line 1450 "PlaylistsUtils.c"
	}
	{
		gchar* line = NULL;
		GFileInputStream* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInputStream* _tmp7_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp8_;
#line 159 "../core/Utils/PlaylistsUtils.vala"
		_tmp6_ = file;
#line 159 "../core/Utils/PlaylistsUtils.vala"
		_tmp7_ = g_file_read (_tmp6_, NULL, &_inner_error0_);
#line 159 "../core/Utils/PlaylistsUtils.vala"
		_tmp5_ = _tmp7_;
#line 159 "../core/Utils/PlaylistsUtils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (line);
#line 1469 "PlaylistsUtils.c"
			goto __catch0_g_error;
		}
#line 159 "../core/Utils/PlaylistsUtils.vala"
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp5_);
#line 159 "../core/Utils/PlaylistsUtils.vala"
		dis = _tmp8_;
#line 161 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 1478 "PlaylistsUtils.c"
			gchar* _tmp9_ = NULL;
			GDataInputStream* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = dis;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = _tmp11_;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (dis);
#line 161 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (_tmp5_);
#line 161 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (line);
#line 1499 "PlaylistsUtils.c"
				goto __catch0_g_error;
			}
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp12_ = _tmp9_;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = NULL;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (line);
#line 161 "../core/Utils/PlaylistsUtils.vala"
			line = _tmp12_;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_tmp13_ = line;
#line 161 "../core/Utils/PlaylistsUtils.vala"
			if (!(_tmp13_ != NULL)) {
#line 161 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp9_);
#line 161 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 1518 "PlaylistsUtils.c"
			}
#line 162 "../core/Utils/PlaylistsUtils.vala"
			_tmp14_ = line;
#line 162 "../core/Utils/PlaylistsUtils.vala"
			if (g_str_has_prefix (_tmp14_, "File")) {
#line 1524 "PlaylistsUtils.c"
				const gchar* _tmp15_;
#line 163 "../core/Utils/PlaylistsUtils.vala"
				_tmp15_ = line;
#line 163 "../core/Utils/PlaylistsUtils.vala"
				music_playlists_utils_parse_index_and_value ("File", _tmp15_, &files);
#line 1530 "PlaylistsUtils.c"
			} else {
				const gchar* _tmp16_;
#line 164 "../core/Utils/PlaylistsUtils.vala"
				_tmp16_ = line;
#line 164 "../core/Utils/PlaylistsUtils.vala"
				if (g_str_has_prefix (_tmp16_, "X-GNOME-Title")) {
#line 1537 "PlaylistsUtils.c"
					gchar** parts = NULL;
					const gchar* _tmp17_;
					gchar** _tmp18_;
					gchar** _tmp19_;
					gint parts_length1;
					gint _parts_size_;
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
#line 165 "../core/Utils/PlaylistsUtils.vala"
					_tmp17_ = line;
#line 165 "../core/Utils/PlaylistsUtils.vala"
					_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "=", 2);
#line 165 "../core/Utils/PlaylistsUtils.vala"
					parts = _tmp19_;
#line 165 "../core/Utils/PlaylistsUtils.vala"
					parts_length1 = _vala_array_length (_tmp18_);
#line 165 "../core/Utils/PlaylistsUtils.vala"
					_parts_size_ = parts_length1;
#line 166 "../core/Utils/PlaylistsUtils.vala"
					_tmp20_ = parts;
#line 166 "../core/Utils/PlaylistsUtils.vala"
					_tmp20__length1 = parts_length1;
#line 166 "../core/Utils/PlaylistsUtils.vala"
					_tmp21_ = _tmp20_[1];
#line 166 "../core/Utils/PlaylistsUtils.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 166 "../core/Utils/PlaylistsUtils.vala"
					_g_free0 (*title);
#line 166 "../core/Utils/PlaylistsUtils.vala"
					*title = _tmp22_;
#line 164 "../core/Utils/PlaylistsUtils.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1572 "PlaylistsUtils.c"
				} else {
					const gchar* _tmp23_;
#line 167 "../core/Utils/PlaylistsUtils.vala"
					_tmp23_ = line;
#line 167 "../core/Utils/PlaylistsUtils.vala"
					if (g_str_has_prefix (_tmp23_, "Title")) {
#line 1579 "PlaylistsUtils.c"
						const gchar* _tmp24_;
#line 168 "../core/Utils/PlaylistsUtils.vala"
						_tmp24_ = line;
#line 168 "../core/Utils/PlaylistsUtils.vala"
						music_playlists_utils_parse_index_and_value ("Title", _tmp24_, &titles);
#line 1585 "PlaylistsUtils.c"
					} else {
						const gchar* _tmp25_;
#line 169 "../core/Utils/PlaylistsUtils.vala"
						_tmp25_ = line;
#line 169 "../core/Utils/PlaylistsUtils.vala"
						if (g_str_has_prefix (_tmp25_, "Length")) {
#line 1592 "PlaylistsUtils.c"
							const gchar* _tmp26_;
#line 170 "../core/Utils/PlaylistsUtils.vala"
							_tmp26_ = line;
#line 170 "../core/Utils/PlaylistsUtils.vala"
							music_playlists_utils_parse_index_and_value ("Length", _tmp26_, &lengths);
#line 1598 "PlaylistsUtils.c"
						}
					}
				}
			}
#line 161 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp9_);
#line 1605 "PlaylistsUtils.c"
		}
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (dis);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_tmp5_);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (line);
#line 1613 "PlaylistsUtils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 157 "../core/Utils/PlaylistsUtils.vala"
		err = _inner_error0_;
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_inner_error0_ = NULL;
#line 175 "../core/Utils/PlaylistsUtils.vala"
		_tmp27_ = err;
#line 175 "../core/Utils/PlaylistsUtils.vala"
		_tmp28_ = _tmp27_->message;
#line 175 "../core/Utils/PlaylistsUtils.vala"
		g_warning ("PlaylistsUtils.vala:175: Could not load m3u file at %s: %s\n", uri, _tmp28_);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		result = FALSE;
#line 176 "../core/Utils/PlaylistsUtils.vala"
		_g_error_free0 (err);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (lengths);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (titles);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (files);
#line 176 "../core/Utils/PlaylistsUtils.vala"
		return result;
#line 1645 "PlaylistsUtils.c"
	}
	__finally0:
#line 157 "../core/Utils/PlaylistsUtils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1650 "PlaylistsUtils.c"
		gboolean _tmp29_ = FALSE;
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (file);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (lengths);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (titles);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (files);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		g_clear_error (&_inner_error0_);
#line 157 "../core/Utils/PlaylistsUtils.vala"
		return _tmp29_;
#line 1666 "PlaylistsUtils.c"
	}
#line 178 "../core/Utils/PlaylistsUtils.vala"
	_tmp30_ = files;
#line 178 "../core/Utils/PlaylistsUtils.vala"
	_tmp31_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp30_);
#line 178 "../core/Utils/PlaylistsUtils.vala"
	_tmp32_ = _tmp31_;
#line 178 "../core/Utils/PlaylistsUtils.vala"
	_tmp33_ = _tmp32_;
#line 178 "../core/Utils/PlaylistsUtils.vala"
	gee_collection_add_all ((GeeCollection*) (*locals), _tmp33_);
#line 178 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (_tmp33_);
#line 181 "../core/Utils/PlaylistsUtils.vala"
	result = TRUE;
#line 181 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (file);
#line 181 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (lengths);
#line 181 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (titles);
#line 181 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (files);
#line 181 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 1692 "PlaylistsUtils.c"
}

void
music_playlists_utils_parse_index_and_value (const gchar* prefix,
                                             const gchar* line,
                                             GeeHashMap** map)
{
	gint index = 0;
	gchar* val = NULL;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 184 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (prefix != NULL);
#line 184 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (line != NULL);
#line 184 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (*map != NULL);
#line 187 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = _tmp0_ = g_strsplit (line, "=", 2);
#line 187 "../core/Utils/PlaylistsUtils.vala"
	parts = _tmp1_;
#line 187 "../core/Utils/PlaylistsUtils.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 187 "../core/Utils/PlaylistsUtils.vala"
	_parts_size_ = parts_length1;
#line 189 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = parts[0];
#line 189 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = string_replace (_tmp2_, prefix, "");
#line 189 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = _tmp3_;
#line 189 "../core/Utils/PlaylistsUtils.vala"
	index = atoi (_tmp4_);
#line 189 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp4_);
#line 190 "../core/Utils/PlaylistsUtils.vala"
	_tmp5_ = parts[1];
#line 190 "../core/Utils/PlaylistsUtils.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 190 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (val);
#line 190 "../core/Utils/PlaylistsUtils.vala"
	val = _tmp6_;
#line 192 "../core/Utils/PlaylistsUtils.vala"
	gee_abstract_map_set ((GeeAbstractMap*) (*map), (gpointer) ((gintptr) index), val);
#line 184 "../core/Utils/PlaylistsUtils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 184 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (val);
#line 1750 "PlaylistsUtils.c"
}

GeeCollection*
music_playlists_utils_convert_paths_to_uris (GeeCollection* paths)
{
	GeeTreeSet* uris = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result;
#line 195 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (paths != NULL, NULL);
#line 196 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 196 "../core/Utils/PlaylistsUtils.vala"
	uris = _tmp0_;
#line 1765 "PlaylistsUtils.c"
	{
		GeeIterator* _path_it = NULL;
		GeeIterator* _tmp1_;
#line 197 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) paths);
#line 197 "../core/Utils/PlaylistsUtils.vala"
		_path_it = _tmp1_;
#line 197 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 1775 "PlaylistsUtils.c"
			GeeIterator* _tmp2_;
			gchar* path = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeTreeSet* _tmp5_;
			const gchar* _tmp6_;
			GFile* _tmp7_;
			GFile* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 197 "../core/Utils/PlaylistsUtils.vala"
			_tmp2_ = _path_it;
#line 197 "../core/Utils/PlaylistsUtils.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 197 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 1792 "PlaylistsUtils.c"
			}
#line 197 "../core/Utils/PlaylistsUtils.vala"
			_tmp3_ = _path_it;
#line 197 "../core/Utils/PlaylistsUtils.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 197 "../core/Utils/PlaylistsUtils.vala"
			path = (gchar*) _tmp4_;
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp5_ = uris;
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp6_ = path;
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp7_ = g_file_new_for_path (_tmp6_);
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp8_ = _tmp7_;
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = g_file_get_uri (_tmp8_);
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = _tmp9_;
#line 198 "../core/Utils/PlaylistsUtils.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp10_);
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (_tmp10_);
#line 198 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (_tmp8_);
#line 197 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (path);
#line 1820 "PlaylistsUtils.c"
		}
#line 197 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_path_it);
#line 1824 "PlaylistsUtils.c"
	}
#line 201 "../core/Utils/PlaylistsUtils.vala"
	result = (GeeCollection*) uris;
#line 201 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 1830 "PlaylistsUtils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 219 "../core/Utils/PlaylistsUtils.vala"
	return self ? g_object_ref (self) : NULL;
#line 1838 "PlaylistsUtils.c"
}

void
music_playlists_utils_import_from_playlist_file_info (GeeHashMap* playlists,
                                                      MusicLibrary* library)
{
#line 204 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (playlists != NULL);
#line 204 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (library != NULL);
#line 1849 "PlaylistsUtils.c"
	{
		GeeIterator* _values_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_tmp0_ = gee_abstract_map_get_values ((GeeAbstractMap*) playlists);
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = _tmp0_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_tmp2_ = _tmp1_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_tmp4_ = _tmp3_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_tmp2_);
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_values_it = _tmp4_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 1873 "PlaylistsUtils.c"
			GeeIterator* _tmp5_;
			GeeLinkedList* values = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 206 "../core/Utils/PlaylistsUtils.vala"
			_tmp5_ = _values_it;
#line 206 "../core/Utils/PlaylistsUtils.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 206 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 1887 "PlaylistsUtils.c"
			}
#line 206 "../core/Utils/PlaylistsUtils.vala"
			_tmp6_ = _values_it;
#line 206 "../core/Utils/PlaylistsUtils.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 206 "../core/Utils/PlaylistsUtils.vala"
			values = (GeeLinkedList*) _tmp7_;
#line 207 "../core/Utils/PlaylistsUtils.vala"
			_tmp8_ = values;
#line 207 "../core/Utils/PlaylistsUtils.vala"
			_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 207 "../core/Utils/PlaylistsUtils.vala"
			_tmp10_ = _tmp9_;
#line 207 "../core/Utils/PlaylistsUtils.vala"
			if (_tmp10_ > 0) {
#line 1903 "PlaylistsUtils.c"
				GeeLinkedList* _tmp11_;
				gpointer _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
#line 208 "../core/Utils/PlaylistsUtils.vala"
				_tmp11_ = values;
#line 208 "../core/Utils/PlaylistsUtils.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, 0);
#line 208 "../core/Utils/PlaylistsUtils.vala"
				_tmp13_ = (gchar*) _tmp12_;
#line 208 "../core/Utils/PlaylistsUtils.vala"
				_tmp14_ = g_str_has_prefix (_tmp13_, "/");
#line 208 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (_tmp13_);
#line 208 "../core/Utils/PlaylistsUtils.vala"
				if (_tmp14_) {
#line 1920 "PlaylistsUtils.c"
					GeeLinkedList* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
#line 209 "../core/Utils/PlaylistsUtils.vala"
					_tmp15_ = values;
#line 209 "../core/Utils/PlaylistsUtils.vala"
					_tmp16_ = music_playlists_utils_convert_paths_to_uris ((GeeCollection*) _tmp15_);
#line 209 "../core/Utils/PlaylistsUtils.vala"
					_tmp17_ = _tmp16_;
#line 209 "../core/Utils/PlaylistsUtils.vala"
					music_library_add_files_to_library (library, _tmp17_);
#line 209 "../core/Utils/PlaylistsUtils.vala"
					_g_object_unref0 (_tmp17_);
#line 1934 "PlaylistsUtils.c"
				} else {
					GeeLinkedList* _tmp18_;
#line 211 "../core/Utils/PlaylistsUtils.vala"
					_tmp18_ = values;
#line 211 "../core/Utils/PlaylistsUtils.vala"
					music_library_add_files_to_library (library, (GeeCollection*) _tmp18_);
#line 1941 "PlaylistsUtils.c"
				}
			}
#line 206 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (values);
#line 1946 "PlaylistsUtils.c"
		}
#line 206 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_values_it);
#line 1950 "PlaylistsUtils.c"
	}
	{
		GeeIterator* _playlist_it = NULL;
		GeeSet* _tmp19_;
		GeeSet* _tmp20_;
		GeeSet* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_tmp19_ = gee_abstract_map_get_entries ((GeeAbstractMap*) playlists);
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_tmp20_ = _tmp19_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_tmp21_ = _tmp20_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_tmp23_ = _tmp22_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_tmp21_);
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_playlist_it = _tmp23_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
		while (TRUE) {
#line 1975 "PlaylistsUtils.c"
			GeeIterator* _tmp24_;
			GeeMapEntry* playlist = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			MusicStaticPlaylist* new_playlist = NULL;
			MusicStaticPlaylist* _tmp27_;
			MusicStaticPlaylist* _tmp28_;
			GeeMapEntry* _tmp29_;
			gconstpointer _tmp30_;
			gconstpointer _tmp31_;
			GeeLinkedList* medias_to_use = NULL;
			GeeMapEntry* _tmp32_;
			gconstpointer _tmp33_;
			gconstpointer _tmp34_;
			GeeLinkedList* _tmp35_;
			GeeLinkedList* to_add = NULL;
			GeeLinkedList* _tmp36_;
			MusicStaticPlaylist* _tmp60_;
			GeeLinkedList* _tmp61_;
			MusicStaticPlaylist* _tmp62_;
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_tmp24_ = _playlist_it;
#line 216 "../core/Utils/PlaylistsUtils.vala"
			if (!gee_iterator_next (_tmp24_)) {
#line 216 "../core/Utils/PlaylistsUtils.vala"
				break;
#line 2002 "PlaylistsUtils.c"
			}
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_tmp25_ = _playlist_it;
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_tmp26_ = gee_iterator_get (_tmp25_);
#line 216 "../core/Utils/PlaylistsUtils.vala"
			playlist = (GeeMapEntry*) _tmp26_;
#line 217 "../core/Utils/PlaylistsUtils.vala"
			_tmp27_ = music_static_playlist_new ();
#line 217 "../core/Utils/PlaylistsUtils.vala"
			new_playlist = _tmp27_;
#line 218 "../core/Utils/PlaylistsUtils.vala"
			_tmp28_ = new_playlist;
#line 218 "../core/Utils/PlaylistsUtils.vala"
			_tmp29_ = playlist;
#line 218 "../core/Utils/PlaylistsUtils.vala"
			_tmp30_ = gee_map_entry_get_key (_tmp29_);
#line 218 "../core/Utils/PlaylistsUtils.vala"
			_tmp31_ = _tmp30_;
#line 218 "../core/Utils/PlaylistsUtils.vala"
			music_playlist_set_name ((MusicPlaylist*) _tmp28_, (const gchar*) _tmp31_);
#line 219 "../core/Utils/PlaylistsUtils.vala"
			_tmp32_ = playlist;
#line 219 "../core/Utils/PlaylistsUtils.vala"
			_tmp33_ = gee_map_entry_get_value (_tmp32_);
#line 219 "../core/Utils/PlaylistsUtils.vala"
			_tmp34_ = _tmp33_;
#line 219 "../core/Utils/PlaylistsUtils.vala"
			_tmp35_ = _g_object_ref0 ((GeeLinkedList*) _tmp34_);
#line 219 "../core/Utils/PlaylistsUtils.vala"
			medias_to_use = _tmp35_;
#line 220 "../core/Utils/PlaylistsUtils.vala"
			_tmp36_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 220 "../core/Utils/PlaylistsUtils.vala"
			to_add = _tmp36_;
#line 2038 "PlaylistsUtils.c"
			{
				GeeIterator* _media_it = NULL;
				GeeCollection* _tmp37_;
				GeeCollection* _tmp38_;
				GeeIterator* _tmp39_;
				GeeIterator* _tmp40_;
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_tmp37_ = music_library_get_medias (library);
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_tmp38_ = _tmp37_;
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_tmp40_ = _tmp39_;
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (_tmp38_);
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_media_it = _tmp40_;
#line 221 "../core/Utils/PlaylistsUtils.vala"
				while (TRUE) {
#line 2059 "PlaylistsUtils.c"
					GeeIterator* _tmp41_;
					MusicMedia* media = NULL;
					GeeIterator* _tmp42_;
					gpointer _tmp43_;
					gboolean _tmp44_ = FALSE;
					GeeLinkedList* _tmp45_;
					MusicMedia* _tmp46_;
					GFile* _tmp47_;
					GFile* _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
					gboolean _tmp51_;
#line 221 "../core/Utils/PlaylistsUtils.vala"
					_tmp41_ = _media_it;
#line 221 "../core/Utils/PlaylistsUtils.vala"
					if (!gee_iterator_next (_tmp41_)) {
#line 221 "../core/Utils/PlaylistsUtils.vala"
						break;
#line 2078 "PlaylistsUtils.c"
					}
#line 221 "../core/Utils/PlaylistsUtils.vala"
					_tmp42_ = _media_it;
#line 221 "../core/Utils/PlaylistsUtils.vala"
					_tmp43_ = gee_iterator_get (_tmp42_);
#line 221 "../core/Utils/PlaylistsUtils.vala"
					media = (MusicMedia*) _tmp43_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp45_ = medias_to_use;
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp46_ = media;
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp47_ = music_media_get_file (_tmp46_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp48_ = _tmp47_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp49_ = g_file_get_path (_tmp48_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp50_ = _tmp49_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_tmp51_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp45_, _tmp50_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
					_g_free0 (_tmp50_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
					if (_tmp51_) {
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp44_ = TRUE;
#line 2106 "PlaylistsUtils.c"
					} else {
						GeeLinkedList* _tmp52_;
						MusicMedia* _tmp53_;
						GFile* _tmp54_;
						GFile* _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp52_ = medias_to_use;
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp53_ = media;
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp54_ = music_media_get_file (_tmp53_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp55_ = _tmp54_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp56_ = g_file_get_uri (_tmp55_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp57_ = _tmp56_;
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_tmp44_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp52_, _tmp57_);
#line 222 "../core/Utils/PlaylistsUtils.vala"
						_g_free0 (_tmp57_);
#line 2130 "PlaylistsUtils.c"
					}
#line 222 "../core/Utils/PlaylistsUtils.vala"
					if (_tmp44_) {
#line 2134 "PlaylistsUtils.c"
						GeeLinkedList* _tmp58_;
						MusicMedia* _tmp59_;
#line 223 "../core/Utils/PlaylistsUtils.vala"
						_tmp58_ = to_add;
#line 223 "../core/Utils/PlaylistsUtils.vala"
						_tmp59_ = media;
#line 223 "../core/Utils/PlaylistsUtils.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, _tmp59_);
#line 2143 "PlaylistsUtils.c"
					}
#line 221 "../core/Utils/PlaylistsUtils.vala"
					_g_object_unref0 (media);
#line 2147 "PlaylistsUtils.c"
				}
#line 221 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (_media_it);
#line 2151 "PlaylistsUtils.c"
			}
#line 226 "../core/Utils/PlaylistsUtils.vala"
			_tmp60_ = new_playlist;
#line 226 "../core/Utils/PlaylistsUtils.vala"
			_tmp61_ = to_add;
#line 226 "../core/Utils/PlaylistsUtils.vala"
			music_playlist_add_medias ((MusicPlaylist*) _tmp60_, (GeeCollection*) _tmp61_);
#line 227 "../core/Utils/PlaylistsUtils.vala"
			_tmp62_ = new_playlist;
#line 227 "../core/Utils/PlaylistsUtils.vala"
			music_library_add_playlist (library, _tmp62_);
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (to_add);
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (medias_to_use);
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (new_playlist);
#line 216 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (playlist);
#line 2171 "PlaylistsUtils.c"
		}
#line 216 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_playlist_it);
#line 2175 "PlaylistsUtils.c"
	}
}

gchar*
music_playlists_utils_get_new_playlist_name (GeeCollection* playlists,
                                             const gchar* name)
{
	gchar* base_name = NULL;
	gboolean is_fine = FALSE;
	gint index = 0;
	gchar* new_name = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 231 "../core/Utils/PlaylistsUtils.vala"
	g_return_val_if_fail (playlists != NULL, NULL);
#line 233 "../core/Utils/PlaylistsUtils.vala"
	if (name == NULL) {
#line 2194 "PlaylistsUtils.c"
		gchar* _tmp0_;
#line 234 "../core/Utils/PlaylistsUtils.vala"
		_tmp0_ = g_strdup (_ ("New playlist"));
#line 234 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (base_name);
#line 234 "../core/Utils/PlaylistsUtils.vala"
		base_name = _tmp0_;
#line 2202 "PlaylistsUtils.c"
	} else {
		gchar* _tmp1_;
#line 236 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = g_strdup (name);
#line 236 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (base_name);
#line 236 "../core/Utils/PlaylistsUtils.vala"
		base_name = _tmp1_;
#line 2211 "PlaylistsUtils.c"
	}
#line 237 "../core/Utils/PlaylistsUtils.vala"
	is_fine = TRUE;
#line 238 "../core/Utils/PlaylistsUtils.vala"
	index = 2;
#line 239 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = base_name;
#line 239 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 239 "../core/Utils/PlaylistsUtils.vala"
	new_name = _tmp3_;
#line 240 "../core/Utils/PlaylistsUtils.vala"
	while (TRUE) {
#line 2225 "PlaylistsUtils.c"
		gboolean found = FALSE;
#line 240 "../core/Utils/PlaylistsUtils.vala"
		if (!is_fine) {
#line 240 "../core/Utils/PlaylistsUtils.vala"
			break;
#line 2231 "PlaylistsUtils.c"
		}
#line 241 "../core/Utils/PlaylistsUtils.vala"
		found = FALSE;
#line 2235 "PlaylistsUtils.c"
		{
			GeeIterator* _p_it = NULL;
			GeeIterator* _tmp4_;
#line 242 "../core/Utils/PlaylistsUtils.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) playlists);
#line 242 "../core/Utils/PlaylistsUtils.vala"
			_p_it = _tmp4_;
#line 242 "../core/Utils/PlaylistsUtils.vala"
			while (TRUE) {
#line 2245 "PlaylistsUtils.c"
				GeeIterator* _tmp5_;
				MusicPlaylist* p = NULL;
				GeeIterator* _tmp6_;
				gpointer _tmp7_;
				MusicPlaylist* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 242 "../core/Utils/PlaylistsUtils.vala"
				_tmp5_ = _p_it;
#line 242 "../core/Utils/PlaylistsUtils.vala"
				if (!gee_iterator_next (_tmp5_)) {
#line 242 "../core/Utils/PlaylistsUtils.vala"
					break;
#line 2260 "PlaylistsUtils.c"
				}
#line 242 "../core/Utils/PlaylistsUtils.vala"
				_tmp6_ = _p_it;
#line 242 "../core/Utils/PlaylistsUtils.vala"
				_tmp7_ = gee_iterator_get (_tmp6_);
#line 242 "../core/Utils/PlaylistsUtils.vala"
				p = (MusicPlaylist*) _tmp7_;
#line 243 "../core/Utils/PlaylistsUtils.vala"
				_tmp8_ = p;
#line 243 "../core/Utils/PlaylistsUtils.vala"
				_tmp9_ = music_playlist_get_name (_tmp8_);
#line 243 "../core/Utils/PlaylistsUtils.vala"
				_tmp10_ = _tmp9_;
#line 243 "../core/Utils/PlaylistsUtils.vala"
				_tmp11_ = new_name;
#line 243 "../core/Utils/PlaylistsUtils.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 2278 "PlaylistsUtils.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
#line 245 "../core/Utils/PlaylistsUtils.vala"
					_tmp12_ = base_name;
#line 245 "../core/Utils/PlaylistsUtils.vala"
					_tmp13_ = g_strdup_printf (_ ("%s (%i)"), _tmp12_, index);
#line 245 "../core/Utils/PlaylistsUtils.vala"
					_g_free0 (new_name);
#line 245 "../core/Utils/PlaylistsUtils.vala"
					new_name = _tmp13_;
#line 246 "../core/Utils/PlaylistsUtils.vala"
					_tmp14_ = index;
#line 246 "../core/Utils/PlaylistsUtils.vala"
					index = _tmp14_ + 1;
#line 247 "../core/Utils/PlaylistsUtils.vala"
					found = TRUE;
#line 248 "../core/Utils/PlaylistsUtils.vala"
					_g_object_unref0 (p);
#line 248 "../core/Utils/PlaylistsUtils.vala"
					break;
#line 2300 "PlaylistsUtils.c"
				}
#line 242 "../core/Utils/PlaylistsUtils.vala"
				_g_object_unref0 (p);
#line 2304 "PlaylistsUtils.c"
			}
#line 242 "../core/Utils/PlaylistsUtils.vala"
			_g_object_unref0 (_p_it);
#line 2308 "PlaylistsUtils.c"
		}
#line 251 "../core/Utils/PlaylistsUtils.vala"
		if (found == FALSE) {
#line 252 "../core/Utils/PlaylistsUtils.vala"
			is_fine = FALSE;
#line 2314 "PlaylistsUtils.c"
		}
	}
#line 255 "../core/Utils/PlaylistsUtils.vala"
	result = new_name;
#line 255 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (base_name);
#line 255 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 2323 "PlaylistsUtils.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 2350 "PlaylistsUtils.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 2356 "PlaylistsUtils.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2362 "PlaylistsUtils.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2366 "PlaylistsUtils.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2374 "PlaylistsUtils.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2378 "PlaylistsUtils.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 2390 "PlaylistsUtils.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1144 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1144 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1146 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1146 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2414 "PlaylistsUtils.c"
		gchar* _tmp2_;
#line 1147 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1147 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1147 "glib-2.0.vapi"
		return result;
#line 2422 "PlaylistsUtils.c"
	} else {
#line 1149 "glib-2.0.vapi"
		result = -1;
#line 1149 "glib-2.0.vapi"
		return result;
#line 2428 "PlaylistsUtils.c"
	}
}

void
music_playlists_utils_export_playlist (MusicPlaylist* p)
{
	GtkFileFilter* m3u_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* pls_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileChooserNative* file_chooser = NULL;
	GtkFileChooserNative* _tmp6_;
	GtkFileChooserNative* _tmp7_;
	GtkFileChooserNative* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	GtkFileFilter* _tmp14_;
	GtkFileFilter* _tmp15_;
	GtkFileChooserNative* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileFilter* _tmp18_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp19_;
	MusicSettingsMain* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gboolean _tmp25_;
	gchar* file = NULL;
	gchar* _tmp32_;
	gchar* name = NULL;
	gchar* _tmp33_;
	gchar* extension = NULL;
	gchar* _tmp34_;
	GtkFileChooserNative* _tmp35_;
	GtkFileChooserNative* _tmp64_;
	gchar* original_name = NULL;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp80_;
#line 258 "../core/Utils/PlaylistsUtils.vala"
	g_return_if_fail (p != NULL);
#line 259 "../core/Utils/PlaylistsUtils.vala"
	if (p == NULL) {
#line 260 "../core/Utils/PlaylistsUtils.vala"
		return;
#line 2485 "PlaylistsUtils.c"
	}
#line 263 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = gtk_file_filter_new ();
#line 263 "../core/Utils/PlaylistsUtils.vala"
	g_object_ref_sink (_tmp0_);
#line 263 "../core/Utils/PlaylistsUtils.vala"
	m3u_filter = _tmp0_;
#line 264 "../core/Utils/PlaylistsUtils.vala"
	_tmp1_ = m3u_filter;
#line 264 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_add_pattern (_tmp1_, "*.m3u");
#line 265 "../core/Utils/PlaylistsUtils.vala"
	_tmp2_ = m3u_filter;
#line 265 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_set_name (_tmp2_, _ ("MPEG Version 3.0 Extended (*.m3u)"));
#line 267 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = gtk_file_filter_new ();
#line 267 "../core/Utils/PlaylistsUtils.vala"
	g_object_ref_sink (_tmp3_);
#line 267 "../core/Utils/PlaylistsUtils.vala"
	pls_filter = _tmp3_;
#line 268 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = pls_filter;
#line 268 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_add_pattern (_tmp4_, "*.pls");
#line 269 "../core/Utils/PlaylistsUtils.vala"
	_tmp5_ = pls_filter;
#line 269 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_set_name (_tmp5_, _ ("Shoutcast Playlist Version 2.0 (*.pls)"));
#line 271 "../core/Utils/PlaylistsUtils.vala"
	_tmp6_ = gtk_file_chooser_native_new (_ ("Export Playlist"), NULL, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save"), _ ("Cancel"));
#line 271 "../core/Utils/PlaylistsUtils.vala"
	file_chooser = _tmp6_;
#line 278 "../core/Utils/PlaylistsUtils.vala"
	_tmp7_ = file_chooser;
#line 278 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp7_, TRUE);
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_tmp8_ = file_chooser;
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_tmp9_ = music_playlist_get_name (p);
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_tmp10_ = _tmp9_;
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_tmp11_ = g_strconcat (_tmp10_, ".m3u", NULL);
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_tmp12_ = _tmp11_;
#line 279 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp8_, _tmp12_);
#line 279 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp12_);
#line 280 "../core/Utils/PlaylistsUtils.vala"
	_tmp13_ = file_chooser;
#line 280 "../core/Utils/PlaylistsUtils.vala"
	_tmp14_ = m3u_filter;
#line 280 "../core/Utils/PlaylistsUtils.vala"
	_tmp15_ = _g_object_ref0 (_tmp14_);
#line 280 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp13_, _tmp15_);
#line 281 "../core/Utils/PlaylistsUtils.vala"
	_tmp16_ = file_chooser;
#line 281 "../core/Utils/PlaylistsUtils.vala"
	_tmp17_ = pls_filter;
#line 281 "../core/Utils/PlaylistsUtils.vala"
	_tmp18_ = _g_object_ref0 (_tmp17_);
#line 281 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp16_, _tmp18_);
#line 284 "../core/Utils/PlaylistsUtils.vala"
	_tmp19_ = music_settings_main_get_default ();
#line 284 "../core/Utils/PlaylistsUtils.vala"
	main_settings = _tmp19_;
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp20_ = main_settings;
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp21_ = music_settings_main_get_music_folder (_tmp20_);
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp22_ = _tmp21_;
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp23_ = g_file_new_for_path (_tmp22_);
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp24_ = _tmp23_;
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_tmp25_ = g_file_query_exists (_tmp24_, NULL);
#line 285 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (_tmp24_);
#line 285 "../core/Utils/PlaylistsUtils.vala"
	if (_tmp25_) {
#line 2573 "PlaylistsUtils.c"
		GtkFileChooserNative* _tmp26_;
		MusicSettingsMain* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
#line 286 "../core/Utils/PlaylistsUtils.vala"
		_tmp26_ = file_chooser;
#line 286 "../core/Utils/PlaylistsUtils.vala"
		_tmp27_ = main_settings;
#line 286 "../core/Utils/PlaylistsUtils.vala"
		_tmp28_ = music_settings_main_get_music_folder (_tmp27_);
#line 286 "../core/Utils/PlaylistsUtils.vala"
		_tmp29_ = _tmp28_;
#line 286 "../core/Utils/PlaylistsUtils.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp26_, _tmp29_);
#line 2588 "PlaylistsUtils.c"
	} else {
		GtkFileChooserNative* _tmp30_;
		const gchar* _tmp31_;
#line 288 "../core/Utils/PlaylistsUtils.vala"
		_tmp30_ = file_chooser;
#line 288 "../core/Utils/PlaylistsUtils.vala"
		_tmp31_ = g_get_home_dir ();
#line 288 "../core/Utils/PlaylistsUtils.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp30_, _tmp31_);
#line 2598 "PlaylistsUtils.c"
	}
#line 291 "../core/Utils/PlaylistsUtils.vala"
	_tmp32_ = g_strdup ("");
#line 291 "../core/Utils/PlaylistsUtils.vala"
	file = _tmp32_;
#line 292 "../core/Utils/PlaylistsUtils.vala"
	_tmp33_ = g_strdup ("");
#line 292 "../core/Utils/PlaylistsUtils.vala"
	name = _tmp33_;
#line 293 "../core/Utils/PlaylistsUtils.vala"
	_tmp34_ = g_strdup ("");
#line 293 "../core/Utils/PlaylistsUtils.vala"
	extension = _tmp34_;
#line 294 "../core/Utils/PlaylistsUtils.vala"
	_tmp35_ = file_chooser;
#line 294 "../core/Utils/PlaylistsUtils.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp35_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2616 "PlaylistsUtils.c"
		GtkFileChooserNative* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gchar* _tmp43_;
		gboolean _tmp44_ = FALSE;
		const gchar* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		const gchar* _tmp62_;
		const gchar* _tmp63_;
#line 295 "../core/Utils/PlaylistsUtils.vala"
		_tmp36_ = file_chooser;
#line 295 "../core/Utils/PlaylistsUtils.vala"
		_tmp37_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp36_);
#line 295 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (file);
#line 295 "../core/Utils/PlaylistsUtils.vala"
		file = _tmp37_;
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp38_ = file;
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp39_ = file;
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp40_ = file;
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp41_ = strlen (_tmp40_);
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp42_ = _tmp41_;
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_tmp43_ = string_slice (_tmp38_, (glong) string_last_index_of (_tmp39_, ".", 0), (glong) _tmp42_);
#line 296 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (extension);
#line 296 "../core/Utils/PlaylistsUtils.vala"
		extension = _tmp43_;
#line 298 "../core/Utils/PlaylistsUtils.vala"
		_tmp45_ = extension;
#line 298 "../core/Utils/PlaylistsUtils.vala"
		_tmp46_ = strlen (_tmp45_);
#line 298 "../core/Utils/PlaylistsUtils.vala"
		_tmp47_ = _tmp46_;
#line 298 "../core/Utils/PlaylistsUtils.vala"
		if (_tmp47_ == 0) {
#line 298 "../core/Utils/PlaylistsUtils.vala"
			_tmp44_ = TRUE;
#line 2669 "PlaylistsUtils.c"
		} else {
			const gchar* _tmp48_;
#line 298 "../core/Utils/PlaylistsUtils.vala"
			_tmp48_ = extension;
#line 298 "../core/Utils/PlaylistsUtils.vala"
			_tmp44_ = string_get (_tmp48_, (glong) 0) != '.';
#line 2676 "PlaylistsUtils.c"
		}
#line 298 "../core/Utils/PlaylistsUtils.vala"
		if (_tmp44_) {
#line 2680 "PlaylistsUtils.c"
			const gchar* _tmp49_ = NULL;
			GtkFileChooserNative* _tmp50_;
			GtkFileFilter* _tmp51_;
			GtkFileFilter* _tmp52_;
			GtkFileFilter* _tmp53_;
			gchar* _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_tmp50_ = file_chooser;
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_tmp51_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp50_);
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_tmp52_ = _tmp51_;
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_tmp53_ = m3u_filter;
#line 299 "../core/Utils/PlaylistsUtils.vala"
			if (_tmp52_ == _tmp53_) {
#line 299 "../core/Utils/PlaylistsUtils.vala"
				_tmp49_ = ".m3u";
#line 2702 "PlaylistsUtils.c"
			} else {
#line 299 "../core/Utils/PlaylistsUtils.vala"
				_tmp49_ = ".pls";
#line 2706 "PlaylistsUtils.c"
			}
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_tmp54_ = g_strdup (_tmp49_);
#line 299 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (extension);
#line 299 "../core/Utils/PlaylistsUtils.vala"
			extension = _tmp54_;
#line 300 "../core/Utils/PlaylistsUtils.vala"
			_tmp55_ = file;
#line 300 "../core/Utils/PlaylistsUtils.vala"
			_tmp56_ = extension;
#line 300 "../core/Utils/PlaylistsUtils.vala"
			_tmp57_ = g_strconcat (_tmp55_, _tmp56_, NULL);
#line 300 "../core/Utils/PlaylistsUtils.vala"
			_g_free0 (file);
#line 300 "../core/Utils/PlaylistsUtils.vala"
			file = _tmp57_;
#line 2724 "PlaylistsUtils.c"
		}
#line 303 "../core/Utils/PlaylistsUtils.vala"
		_tmp58_ = file;
#line 303 "../core/Utils/PlaylistsUtils.vala"
		_tmp59_ = file;
#line 303 "../core/Utils/PlaylistsUtils.vala"
		_tmp60_ = file;
#line 303 "../core/Utils/PlaylistsUtils.vala"
		_tmp61_ = string_slice (_tmp58_, (glong) (string_last_index_of (_tmp59_, "/", 0) + 1), (glong) string_last_index_of (_tmp60_, ".", 0));
#line 303 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (name);
#line 303 "../core/Utils/PlaylistsUtils.vala"
		name = _tmp61_;
#line 304 "../core/Utils/PlaylistsUtils.vala"
		_tmp62_ = name;
#line 304 "../core/Utils/PlaylistsUtils.vala"
		_tmp63_ = extension;
#line 304 "../core/Utils/PlaylistsUtils.vala"
		g_message ("PlaylistsUtils.vala:304: name is %s extension is %s\n", _tmp62_, _tmp63_);
#line 2744 "PlaylistsUtils.c"
	}
#line 307 "../core/Utils/PlaylistsUtils.vala"
	_tmp64_ = file_chooser;
#line 307 "../core/Utils/PlaylistsUtils.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp64_);
#line 309 "../core/Utils/PlaylistsUtils.vala"
	_tmp65_ = music_playlist_get_name (p);
#line 309 "../core/Utils/PlaylistsUtils.vala"
	_tmp66_ = _tmp65_;
#line 309 "../core/Utils/PlaylistsUtils.vala"
	_tmp67_ = g_strdup (_tmp66_);
#line 309 "../core/Utils/PlaylistsUtils.vala"
	original_name = _tmp67_;
#line 310 "../core/Utils/PlaylistsUtils.vala"
	_tmp68_ = file;
#line 310 "../core/Utils/PlaylistsUtils.vala"
	if (g_strcmp0 (_tmp68_, "") != 0) {
#line 2762 "PlaylistsUtils.c"
		GFile* f = NULL;
		const gchar* _tmp69_;
		GFile* _tmp70_;
		gchar* folder = NULL;
		GFile* _tmp71_;
		GFile* _tmp72_;
		GFile* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		const gchar* _tmp76_;
		const gchar* _tmp77_;
#line 311 "../core/Utils/PlaylistsUtils.vala"
		_tmp69_ = file;
#line 311 "../core/Utils/PlaylistsUtils.vala"
		_tmp70_ = g_file_new_for_path (_tmp69_);
#line 311 "../core/Utils/PlaylistsUtils.vala"
		f = _tmp70_;
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_tmp71_ = f;
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_tmp72_ = g_file_get_parent (_tmp71_);
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_tmp73_ = _tmp72_;
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_tmp74_ = g_file_get_uri (_tmp73_);
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_tmp75_ = _tmp74_;
#line 313 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (_tmp73_);
#line 313 "../core/Utils/PlaylistsUtils.vala"
		folder = _tmp75_;
#line 314 "../core/Utils/PlaylistsUtils.vala"
		_tmp76_ = name;
#line 314 "../core/Utils/PlaylistsUtils.vala"
		music_playlist_set_name (p, _tmp76_);
#line 316 "../core/Utils/PlaylistsUtils.vala"
		_tmp77_ = file;
#line 316 "../core/Utils/PlaylistsUtils.vala"
		if (g_str_has_suffix (_tmp77_, ".m3u")) {
#line 2802 "PlaylistsUtils.c"
			const gchar* _tmp78_;
#line 317 "../core/Utils/PlaylistsUtils.vala"
			_tmp78_ = folder;
#line 317 "../core/Utils/PlaylistsUtils.vala"
			music_playlists_utils_save_playlist_m3u (p, _tmp78_, "");
#line 2808 "PlaylistsUtils.c"
		} else {
			const gchar* _tmp79_;
#line 319 "../core/Utils/PlaylistsUtils.vala"
			_tmp79_ = folder;
#line 319 "../core/Utils/PlaylistsUtils.vala"
			music_playlists_utils_save_playlist_pls (p, _tmp79_);
#line 2815 "PlaylistsUtils.c"
		}
#line 310 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (folder);
#line 310 "../core/Utils/PlaylistsUtils.vala"
		_g_object_unref0 (f);
#line 2821 "PlaylistsUtils.c"
	}
#line 323 "../core/Utils/PlaylistsUtils.vala"
	_tmp80_ = original_name;
#line 323 "../core/Utils/PlaylistsUtils.vala"
	music_playlist_set_name (p, _tmp80_);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (original_name);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (extension);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (name);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (file);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (main_settings);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (file_chooser);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (pls_filter);
#line 258 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (m3u_filter);
#line 2843 "PlaylistsUtils.c"
}

static void
_g_free0_ (gpointer var)
{
#line 353 "../core/Utils/PlaylistsUtils.vala"
	var = (g_free (var), NULL);
#line 2851 "PlaylistsUtils.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 353 "../core/Utils/PlaylistsUtils.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 2859 "PlaylistsUtils.c"
}

GeeHashMap*
music_playlists_utils_get_playlists_to_import (const gchar* set_title,
                                               GError** error)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkFileFilter* m3u_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* pls_filter = NULL;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileChooserNative* file_chooser = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkFileChooserNative* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	GtkFileChooserNative* _tmp14_;
	GtkFileChooserNative* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserNative* _tmp18_;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	GSList* files = NULL;
	GtkFileChooserNative* _tmp21_;
	GtkFileChooserNative* _tmp24_;
	GeeHashMap* playlists = NULL;
	GeeHashMap* _tmp25_;
	gboolean success = FALSE;
	GSList* _tmp26_;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 327 "../core/Utils/PlaylistsUtils.vala"
	_tmp0_ = g_strdup (set_title);
#line 327 "../core/Utils/PlaylistsUtils.vala"
	title = _tmp0_;
#line 328 "../core/Utils/PlaylistsUtils.vala"
	if (set_title == NULL) {
#line 328 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = TRUE;
#line 2907 "PlaylistsUtils.c"
	} else {
#line 328 "../core/Utils/PlaylistsUtils.vala"
		_tmp1_ = g_strcmp0 (set_title, "") == 0;
#line 2911 "PlaylistsUtils.c"
	}
#line 328 "../core/Utils/PlaylistsUtils.vala"
	if (_tmp1_) {
#line 2915 "PlaylistsUtils.c"
		gchar* _tmp2_;
#line 329 "../core/Utils/PlaylistsUtils.vala"
		_tmp2_ = g_strdup (_ ("Playlist"));
#line 329 "../core/Utils/PlaylistsUtils.vala"
		_g_free0 (title);
#line 329 "../core/Utils/PlaylistsUtils.vala"
		title = _tmp2_;
#line 2923 "PlaylistsUtils.c"
	}
#line 332 "../core/Utils/PlaylistsUtils.vala"
	_tmp3_ = gtk_file_filter_new ();
#line 332 "../core/Utils/PlaylistsUtils.vala"
	g_object_ref_sink (_tmp3_);
#line 332 "../core/Utils/PlaylistsUtils.vala"
	m3u_filter = _tmp3_;
#line 333 "../core/Utils/PlaylistsUtils.vala"
	_tmp4_ = m3u_filter;
#line 333 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_add_pattern (_tmp4_, "*.m3u");
#line 334 "../core/Utils/PlaylistsUtils.vala"
	_tmp5_ = m3u_filter;
#line 334 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_set_name (_tmp5_, _ ("MPEG Version 3.0 Extended (*.m3u)"));
#line 336 "../core/Utils/PlaylistsUtils.vala"
	_tmp6_ = gtk_file_filter_new ();
#line 336 "../core/Utils/PlaylistsUtils.vala"
	g_object_ref_sink (_tmp6_);
#line 336 "../core/Utils/PlaylistsUtils.vala"
	pls_filter = _tmp6_;
#line 337 "../core/Utils/PlaylistsUtils.vala"
	_tmp7_ = pls_filter;
#line 337 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_add_pattern (_tmp7_, "*.pls");
#line 338 "../core/Utils/PlaylistsUtils.vala"
	_tmp8_ = pls_filter;
#line 338 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_filter_set_name (_tmp8_, _ ("Shoutcast Playlist Version 2.0 (*.pls)"));
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_tmp9_ = title;
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_tmp10_ = g_strdup_printf (_ ("Import %s"), _tmp9_);
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_tmp11_ = _tmp10_;
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_tmp12_ = gtk_file_chooser_native_new (_tmp11_, NULL, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_tmp13_ = _tmp12_;
#line 340 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (_tmp11_);
#line 340 "../core/Utils/PlaylistsUtils.vala"
	file_chooser = _tmp13_;
#line 347 "../core/Utils/PlaylistsUtils.vala"
	_tmp14_ = file_chooser;
#line 347 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp14_, TRUE);
#line 348 "../core/Utils/PlaylistsUtils.vala"
	_tmp15_ = file_chooser;
#line 348 "../core/Utils/PlaylistsUtils.vala"
	_tmp16_ = m3u_filter;
#line 348 "../core/Utils/PlaylistsUtils.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 348 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp15_, _tmp17_);
#line 349 "../core/Utils/PlaylistsUtils.vala"
	_tmp18_ = file_chooser;
#line 349 "../core/Utils/PlaylistsUtils.vala"
	_tmp19_ = pls_filter;
#line 349 "../core/Utils/PlaylistsUtils.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 349 "../core/Utils/PlaylistsUtils.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp18_, _tmp20_);
#line 351 "../core/Utils/PlaylistsUtils.vala"
	files = NULL;
#line 352 "../core/Utils/PlaylistsUtils.vala"
	_tmp21_ = file_chooser;
#line 352 "../core/Utils/PlaylistsUtils.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp21_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2993 "PlaylistsUtils.c"
		GtkFileChooserNative* _tmp22_;
		GSList* _tmp23_;
#line 353 "../core/Utils/PlaylistsUtils.vala"
		_tmp22_ = file_chooser;
#line 353 "../core/Utils/PlaylistsUtils.vala"
		_tmp23_ = gtk_file_chooser_get_filenames ((GtkFileChooser*) _tmp22_);
#line 353 "../core/Utils/PlaylistsUtils.vala"
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 353 "../core/Utils/PlaylistsUtils.vala"
		files = _tmp23_;
#line 3004 "PlaylistsUtils.c"
	}
#line 355 "../core/Utils/PlaylistsUtils.vala"
	_tmp24_ = file_chooser;
#line 355 "../core/Utils/PlaylistsUtils.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp24_);
#line 357 "../core/Utils/PlaylistsUtils.vala"
	_tmp25_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 357 "../core/Utils/PlaylistsUtils.vala"
	playlists = _tmp25_;
#line 358 "../core/Utils/PlaylistsUtils.vala"
	success = FALSE;
#line 359 "../core/Utils/PlaylistsUtils.vala"
	_tmp26_ = files;
#line 3018 "PlaylistsUtils.c"
	{
		GSList* file_collection = NULL;
		GSList* file_it = NULL;
#line 359 "../core/Utils/PlaylistsUtils.vala"
		file_collection = _tmp26_;
#line 359 "../core/Utils/PlaylistsUtils.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 3026 "PlaylistsUtils.c"
			gchar* _tmp27_;
			gchar* file = NULL;
#line 359 "../core/Utils/PlaylistsUtils.vala"
			_tmp27_ = g_strdup ((const gchar*) file_it->data);
#line 359 "../core/Utils/PlaylistsUtils.vala"
			file = _tmp27_;
#line 3033 "PlaylistsUtils.c"
			{
				const gchar* _tmp28_;
#line 360 "../core/Utils/PlaylistsUtils.vala"
				_tmp28_ = file;
#line 360 "../core/Utils/PlaylistsUtils.vala"
				if (g_strcmp0 (_tmp28_, "") != 0) {
#line 3040 "PlaylistsUtils.c"
					gchar* name = NULL;
					const gchar* _tmp29_;
					GFile* _tmp30_;
					GFile* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					GeeLinkedList* paths = NULL;
					GeeLinkedList* _tmp34_;
					const gchar* _tmp35_;
					GeeHashMap* _tmp50_;
					const gchar* _tmp51_;
					GeeLinkedList* _tmp52_;
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_tmp29_ = file;
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_tmp30_ = g_file_new_for_path (_tmp29_);
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_tmp31_ = _tmp30_;
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_tmp32_ = g_file_get_basename (_tmp31_);
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_tmp33_ = _tmp32_;
#line 361 "../core/Utils/PlaylistsUtils.vala"
					_g_object_unref0 (_tmp31_);
#line 361 "../core/Utils/PlaylistsUtils.vala"
					name = _tmp33_;
#line 362 "../core/Utils/PlaylistsUtils.vala"
					_tmp34_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 362 "../core/Utils/PlaylistsUtils.vala"
					paths = _tmp34_;
#line 363 "../core/Utils/PlaylistsUtils.vala"
					_tmp35_ = file;
#line 363 "../core/Utils/PlaylistsUtils.vala"
					if (g_str_has_suffix (_tmp35_, ".m3u")) {
#line 3075 "PlaylistsUtils.c"
						const gchar* _tmp36_;
						gchar* _tmp37_;
						const gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gboolean _tmp41_;
#line 364 "../core/Utils/PlaylistsUtils.vala"
						_tmp36_ = name;
#line 364 "../core/Utils/PlaylistsUtils.vala"
						_tmp37_ = string_replace (_tmp36_, ".m3u", "");
#line 364 "../core/Utils/PlaylistsUtils.vala"
						_g_free0 (name);
#line 364 "../core/Utils/PlaylistsUtils.vala"
						name = _tmp37_;
#line 365 "../core/Utils/PlaylistsUtils.vala"
						_tmp38_ = file;
#line 365 "../core/Utils/PlaylistsUtils.vala"
						_tmp39_ = g_strconcat ("file://", _tmp38_, NULL);
#line 365 "../core/Utils/PlaylistsUtils.vala"
						_tmp40_ = _tmp39_;
#line 365 "../core/Utils/PlaylistsUtils.vala"
						_tmp41_ = music_playlists_utils_parse_paths_from_m3u (_tmp40_, &paths);
#line 365 "../core/Utils/PlaylistsUtils.vala"
						success = _tmp41_;
#line 365 "../core/Utils/PlaylistsUtils.vala"
						_g_free0 (_tmp40_);
#line 3102 "PlaylistsUtils.c"
					} else {
						const gchar* _tmp42_;
#line 366 "../core/Utils/PlaylistsUtils.vala"
						_tmp42_ = file;
#line 366 "../core/Utils/PlaylistsUtils.vala"
						if (g_str_has_suffix (_tmp42_, ".pls")) {
#line 3109 "PlaylistsUtils.c"
							const gchar* _tmp43_;
							gchar* _tmp44_;
							const gchar* _tmp45_;
							gchar* _tmp46_;
							gchar* _tmp47_;
							gboolean _tmp48_;
#line 367 "../core/Utils/PlaylistsUtils.vala"
							_tmp43_ = name;
#line 367 "../core/Utils/PlaylistsUtils.vala"
							_tmp44_ = string_replace (_tmp43_, ".pls", "");
#line 367 "../core/Utils/PlaylistsUtils.vala"
							_g_free0 (name);
#line 367 "../core/Utils/PlaylistsUtils.vala"
							name = _tmp44_;
#line 368 "../core/Utils/PlaylistsUtils.vala"
							_tmp45_ = file;
#line 368 "../core/Utils/PlaylistsUtils.vala"
							_tmp46_ = g_strconcat ("file://", _tmp45_, NULL);
#line 368 "../core/Utils/PlaylistsUtils.vala"
							_tmp47_ = _tmp46_;
#line 368 "../core/Utils/PlaylistsUtils.vala"
							_tmp48_ = music_playlists_utils_parse_paths_from_pls (_tmp47_, &paths, &name);
#line 368 "../core/Utils/PlaylistsUtils.vala"
							success = _tmp48_;
#line 368 "../core/Utils/PlaylistsUtils.vala"
							_g_free0 (_tmp47_);
#line 3136 "PlaylistsUtils.c"
						} else {
							GError* _tmp49_;
#line 370 "../core/Utils/PlaylistsUtils.vala"
							success = FALSE;
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_tmp49_ = g_error_new (g_quark_from_string ("not-recognized"), 1, "%s", _ ("Unrecognized playlist file. Import failed."));
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_inner_error0_ = _tmp49_;
#line 371 "../core/Utils/PlaylistsUtils.vala"
							g_propagate_error (error, _inner_error0_);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_object_unref0 (paths);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_free0 (name);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_free0 (file);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_object_unref0 (playlists);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_object_unref0 (file_chooser);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_object_unref0 (pls_filter);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_object_unref0 (m3u_filter);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							_g_free0 (title);
#line 371 "../core/Utils/PlaylistsUtils.vala"
							return NULL;
#line 3167 "PlaylistsUtils.c"
						}
					}
#line 373 "../core/Utils/PlaylistsUtils.vala"
					_tmp50_ = playlists;
#line 373 "../core/Utils/PlaylistsUtils.vala"
					_tmp51_ = name;
#line 373 "../core/Utils/PlaylistsUtils.vala"
					_tmp52_ = paths;
#line 373 "../core/Utils/PlaylistsUtils.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, _tmp51_, _tmp52_);
#line 360 "../core/Utils/PlaylistsUtils.vala"
					_g_object_unref0 (paths);
#line 360 "../core/Utils/PlaylistsUtils.vala"
					_g_free0 (name);
#line 3182 "PlaylistsUtils.c"
				}
#line 359 "../core/Utils/PlaylistsUtils.vala"
				_g_free0 (file);
#line 3186 "PlaylistsUtils.c"
			}
		}
	}
#line 377 "../core/Utils/PlaylistsUtils.vala"
	result = playlists;
#line 377 "../core/Utils/PlaylistsUtils.vala"
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
#line 377 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (file_chooser);
#line 377 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (pls_filter);
#line 377 "../core/Utils/PlaylistsUtils.vala"
	_g_object_unref0 (m3u_filter);
#line 377 "../core/Utils/PlaylistsUtils.vala"
	_g_free0 (title);
#line 377 "../core/Utils/PlaylistsUtils.vala"
	return result;
#line 3204 "PlaylistsUtils.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

