/* Search.c generated by valac 0.56.0, the Vala compiler
 * generated from Search.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN gchar* music_search_get_valid_search_string (const gchar* s);
VALA_EXTERN gchar* music_string_canonicalize_for_search (const gchar* str);
VALA_EXTERN guint* music_search_get_rating_from_string (const gchar* rating_string);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static guint* _uint_dup (guint* self);

void
music_search_search_in_media_list (GeeCollection* to_search,
                                   GeeCollection** results,
                                   const gchar* album_artist,
                                   const gchar* album,
                                   const gchar* genre,
                                   const gchar* grouping,
                                   const gchar* composer,
                                   gint year,
                                   gint rating,
                                   GCancellable* cancellable)
{
	GeeCollection* _vala_results = NULL;
	GeeTreeSet* _tmp0_;
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (to_search != NULL);
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (album_artist != NULL);
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (album != NULL);
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (genre != NULL);
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (grouping != NULL);
#line 46 "../core/Utils/Search.vala"
	g_return_if_fail (composer != NULL);
#line 56 "../core/Utils/Search.vala"
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 56 "../core/Utils/Search.vala"
	_g_object_unref0 (_vala_results);
#line 56 "../core/Utils/Search.vala"
	_vala_results = (GeeCollection*) _tmp0_;
#line 87 "Search.c"
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
#line 58 "../core/Utils/Search.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_search);
#line 58 "../core/Utils/Search.vala"
		_media_it = _tmp1_;
#line 58 "../core/Utils/Search.vala"
		while (TRUE) {
#line 97 "Search.c"
			GeeIterator* _tmp2_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
#line 58 "../core/Utils/Search.vala"
			_tmp2_ = _media_it;
#line 58 "../core/Utils/Search.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 58 "../core/Utils/Search.vala"
				break;
#line 110 "Search.c"
			}
#line 58 "../core/Utils/Search.vala"
			_tmp3_ = _media_it;
#line 58 "../core/Utils/Search.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 58 "../core/Utils/Search.vala"
			media = (MusicMedia*) _tmp4_;
#line 59 "../core/Utils/Search.vala"
			if (cancellable != NULL) {
#line 59 "../core/Utils/Search.vala"
				_tmp5_ = g_cancellable_is_cancelled (cancellable);
#line 122 "Search.c"
			} else {
#line 59 "../core/Utils/Search.vala"
				_tmp5_ = FALSE;
#line 126 "Search.c"
			}
#line 59 "../core/Utils/Search.vala"
			if (_tmp5_) {
#line 60 "../core/Utils/Search.vala"
				_g_object_unref0 (media);
#line 60 "../core/Utils/Search.vala"
				break;
#line 134 "Search.c"
			}
#line 62 "../core/Utils/Search.vala"
			_tmp6_ = media;
#line 62 "../core/Utils/Search.vala"
			if (music_search_match_fields_to_media (_tmp6_, album_artist, album, genre, grouping, composer, year, rating)) {
#line 140 "Search.c"
				GeeCollection* _tmp7_;
				MusicMedia* _tmp8_;
#line 63 "../core/Utils/Search.vala"
				_tmp7_ = _vala_results;
#line 63 "../core/Utils/Search.vala"
				_tmp8_ = media;
#line 63 "../core/Utils/Search.vala"
				gee_collection_add (_tmp7_, _tmp8_);
#line 149 "Search.c"
			}
#line 58 "../core/Utils/Search.vala"
			_g_object_unref0 (media);
#line 153 "Search.c"
		}
#line 58 "../core/Utils/Search.vala"
		_g_object_unref0 (_media_it);
#line 157 "Search.c"
	}
#line 46 "../core/Utils/Search.vala"
	if (results) {
#line 46 "../core/Utils/Search.vala"
		*results = _vala_results;
#line 163 "Search.c"
	} else {
#line 46 "../core/Utils/Search.vala"
		_g_object_unref0 (_vala_results);
#line 167 "Search.c"
	}
}

inline gboolean
music_search_match_fields_to_media (MusicMedia* media,
                                    const gchar* album_artist,
                                    const gchar* album,
                                    const gchar* genre,
                                    const gchar* grouping,
                                    const gchar* composer,
                                    gint year,
                                    gint rating)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (media != NULL, FALSE);
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (album_artist != NULL, FALSE);
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (album != NULL, FALSE);
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (genre != NULL, FALSE);
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (grouping != NULL, FALSE);
#line 72 "../core/Utils/Search.vala"
	g_return_val_if_fail (composer != NULL, FALSE);
#line 80 "../core/Utils/Search.vala"
	if (rating == -1) {
#line 80 "../core/Utils/Search.vala"
		_tmp6_ = TRUE;
#line 205 "Search.c"
	} else {
		guint _tmp7_;
		guint _tmp8_;
#line 80 "../core/Utils/Search.vala"
		_tmp7_ = music_media_get_rating (media);
#line 80 "../core/Utils/Search.vala"
		_tmp8_ = _tmp7_;
#line 80 "../core/Utils/Search.vala"
		_tmp6_ = _tmp8_ == ((guint) rating);
#line 215 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp6_) {
#line 219 "Search.c"
		gboolean _tmp9_ = FALSE;
#line 81 "../core/Utils/Search.vala"
		if (year == -1) {
#line 81 "../core/Utils/Search.vala"
			_tmp9_ = TRUE;
#line 225 "Search.c"
		} else {
			guint _tmp10_;
			guint _tmp11_;
#line 81 "../core/Utils/Search.vala"
			_tmp10_ = music_media_get_year (media);
#line 81 "../core/Utils/Search.vala"
			_tmp11_ = _tmp10_;
#line 81 "../core/Utils/Search.vala"
			_tmp9_ = _tmp11_ == ((guint) year);
#line 235 "Search.c"
		}
#line 81 "../core/Utils/Search.vala"
		_tmp5_ = _tmp9_;
#line 239 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp5_ = FALSE;
#line 243 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp5_) {
#line 247 "Search.c"
		gboolean _tmp12_ = FALSE;
#line 82 "../core/Utils/Search.vala"
		if (music_string_is_empty (genre, FALSE)) {
#line 82 "../core/Utils/Search.vala"
			_tmp12_ = TRUE;
#line 253 "Search.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 82 "../core/Utils/Search.vala"
			_tmp13_ = music_media_get_display_genre (media);
#line 82 "../core/Utils/Search.vala"
			_tmp14_ = _tmp13_;
#line 82 "../core/Utils/Search.vala"
			_tmp12_ = g_strcmp0 (_tmp14_, genre) == 0;
#line 82 "../core/Utils/Search.vala"
			_g_free0 (_tmp14_);
#line 265 "Search.c"
		}
#line 82 "../core/Utils/Search.vala"
		_tmp4_ = _tmp12_;
#line 269 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp4_ = FALSE;
#line 273 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp4_) {
#line 277 "Search.c"
		gboolean _tmp15_ = FALSE;
#line 83 "../core/Utils/Search.vala"
		if (music_string_is_empty (album_artist, FALSE)) {
#line 83 "../core/Utils/Search.vala"
			_tmp15_ = TRUE;
#line 283 "Search.c"
		} else {
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 83 "../core/Utils/Search.vala"
			_tmp16_ = music_media_get_display_album_artist (media, TRUE);
#line 83 "../core/Utils/Search.vala"
			_tmp17_ = _tmp16_;
#line 83 "../core/Utils/Search.vala"
			_tmp15_ = g_strcmp0 (_tmp17_, album_artist) == 0;
#line 83 "../core/Utils/Search.vala"
			_g_free0 (_tmp17_);
#line 295 "Search.c"
		}
#line 83 "../core/Utils/Search.vala"
		_tmp3_ = _tmp15_;
#line 299 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp3_ = FALSE;
#line 303 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp3_) {
#line 307 "Search.c"
		gboolean _tmp18_ = FALSE;
#line 84 "../core/Utils/Search.vala"
		if (music_string_is_empty (album, FALSE)) {
#line 84 "../core/Utils/Search.vala"
			_tmp18_ = TRUE;
#line 313 "Search.c"
		} else {
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 84 "../core/Utils/Search.vala"
			_tmp19_ = music_media_get_display_album (media);
#line 84 "../core/Utils/Search.vala"
			_tmp20_ = _tmp19_;
#line 84 "../core/Utils/Search.vala"
			_tmp18_ = g_strcmp0 (_tmp20_, album) == 0;
#line 84 "../core/Utils/Search.vala"
			_g_free0 (_tmp20_);
#line 325 "Search.c"
		}
#line 84 "../core/Utils/Search.vala"
		_tmp2_ = _tmp18_;
#line 329 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp2_ = FALSE;
#line 333 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp2_) {
#line 337 "Search.c"
		gboolean _tmp21_ = FALSE;
#line 85 "../core/Utils/Search.vala"
		if (music_string_is_empty (grouping, FALSE)) {
#line 85 "../core/Utils/Search.vala"
			_tmp21_ = TRUE;
#line 343 "Search.c"
		} else {
			const gchar* _tmp22_;
			const gchar* _tmp23_;
#line 85 "../core/Utils/Search.vala"
			_tmp22_ = music_media_get_grouping (media);
#line 85 "../core/Utils/Search.vala"
			_tmp23_ = _tmp22_;
#line 85 "../core/Utils/Search.vala"
			_tmp21_ = g_strcmp0 (_tmp23_, grouping) == 0;
#line 353 "Search.c"
		}
#line 85 "../core/Utils/Search.vala"
		_tmp1_ = _tmp21_;
#line 357 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp1_ = FALSE;
#line 361 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	if (_tmp1_) {
#line 365 "Search.c"
		gboolean _tmp24_ = FALSE;
#line 86 "../core/Utils/Search.vala"
		if (music_string_is_empty (composer, FALSE)) {
#line 86 "../core/Utils/Search.vala"
			_tmp24_ = TRUE;
#line 371 "Search.c"
		} else {
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 86 "../core/Utils/Search.vala"
			_tmp25_ = music_media_get_display_composer (media);
#line 86 "../core/Utils/Search.vala"
			_tmp26_ = _tmp25_;
#line 86 "../core/Utils/Search.vala"
			_tmp24_ = g_strcmp0 (_tmp26_, composer) == 0;
#line 86 "../core/Utils/Search.vala"
			_g_free0 (_tmp26_);
#line 383 "Search.c"
		}
#line 86 "../core/Utils/Search.vala"
		_tmp0_ = _tmp24_;
#line 387 "Search.c"
	} else {
#line 80 "../core/Utils/Search.vala"
		_tmp0_ = FALSE;
#line 391 "Search.c"
	}
#line 80 "../core/Utils/Search.vala"
	result = _tmp0_;
#line 80 "../core/Utils/Search.vala"
	return result;
#line 397 "Search.c"
}

inline gchar*
music_search_get_valid_search_string (const gchar* s)
{
	gchar* _tmp0_;
	gchar* result;
#line 89 "../core/Utils/Search.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 90 "../core/Utils/Search.vala"
	_tmp0_ = music_string_canonicalize_for_search (s);
#line 90 "../core/Utils/Search.vala"
	result = _tmp0_;
#line 90 "../core/Utils/Search.vala"
	return result;
#line 413 "Search.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1251 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1252 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1253 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 429 "Search.c"
		gchar* _tmp0_;
#line 1254 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1254 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1255 "glib-2.0.vapi"
		result = TRUE;
#line 1255 "glib-2.0.vapi"
		if (c) {
#line 1255 "glib-2.0.vapi"
			*c = _vala_c;
#line 441 "Search.c"
		}
#line 1255 "glib-2.0.vapi"
		return result;
#line 445 "Search.c"
	} else {
#line 1257 "glib-2.0.vapi"
		result = FALSE;
#line 1257 "glib-2.0.vapi"
		if (c) {
#line 1257 "glib-2.0.vapi"
			*c = _vala_c;
#line 453 "Search.c"
		}
#line 1257 "glib-2.0.vapi"
		return result;
#line 457 "Search.c"
	}
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 116 "../core/Utils/Search.vala"
	if (s1 == s2) {
#line 116 "../core/Utils/Search.vala"
		return TRUE;
#line 469 "Search.c"
	}
#line 116 "../core/Utils/Search.vala"
	if (s1 == NULL) {
#line 116 "../core/Utils/Search.vala"
		return FALSE;
#line 475 "Search.c"
	}
#line 116 "../core/Utils/Search.vala"
	if (s2 == NULL) {
#line 116 "../core/Utils/Search.vala"
		return FALSE;
#line 481 "Search.c"
	}
#line 116 "../core/Utils/Search.vala"
	return (*s1) == (*s2);
#line 485 "Search.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 122 "../core/Utils/Search.vala"
	dup = g_new0 (guint, 1);
#line 122 "../core/Utils/Search.vala"
	memcpy (dup, self, sizeof (guint));
#line 122 "../core/Utils/Search.vala"
	return dup;
#line 498 "Search.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 122 "../core/Utils/Search.vala"
	return self ? _uint_dup (self) : NULL;
#line 506 "Search.c"
}

inline guint*
music_search_get_rating_from_string (const gchar* rating_string)
{
	gint i = 0;
	gunichar c = 0U;
	guint rating = 0U;
	guint* _tmp8_;
	guint* _tmp9_;
	guint _tmp10_;
	guint* result;
#line 108 "../core/Utils/Search.vala"
	g_return_val_if_fail (rating_string != NULL, NULL);
#line 110 "../core/Utils/Search.vala"
	i = 0;
#line 523 "Search.c"
	{
		gboolean _tmp0_ = FALSE;
#line 114 "../core/Utils/Search.vala"
		rating = (guint) 0;
#line 114 "../core/Utils/Search.vala"
		_tmp0_ = TRUE;
#line 114 "../core/Utils/Search.vala"
		while (TRUE) {
#line 532 "Search.c"
			gunichar _tmp2_ = 0U;
			gboolean _tmp3_;
#line 114 "../core/Utils/Search.vala"
			if (!_tmp0_) {
#line 537 "Search.c"
				guint _tmp1_;
#line 114 "../core/Utils/Search.vala"
				_tmp1_ = rating;
#line 114 "../core/Utils/Search.vala"
				rating = _tmp1_ + 1;
#line 543 "Search.c"
			}
#line 114 "../core/Utils/Search.vala"
			_tmp0_ = FALSE;
#line 114 "../core/Utils/Search.vala"
			_tmp3_ = string_get_next_char (rating_string, &i, &_tmp2_);
#line 114 "../core/Utils/Search.vala"
			c = _tmp2_;
#line 114 "../core/Utils/Search.vala"
			if (!_tmp3_) {
#line 114 "../core/Utils/Search.vala"
				break;
#line 555 "Search.c"
			}
#line 115 "../core/Utils/Search.vala"
			if (c != ((gunichar) '*')) {
#line 559 "Search.c"
				guint* _tmp4_;
				guint _tmp5_;
#line 116 "../core/Utils/Search.vala"
				result = NULL;
#line 116 "../core/Utils/Search.vala"
				_tmp4_ = result;
#line 116 "../core/Utils/Search.vala"
				_tmp5_ = (guint) 0;
#line 116 "../core/Utils/Search.vala"
				_vala_warn_if_fail (_uint_equal (_tmp4_, &_tmp5_) != TRUE, "result != 0");
#line 116 "../core/Utils/Search.vala"
				return result;
#line 572 "Search.c"
			}
		}
	}
#line 119 "../core/Utils/Search.vala"
	if (rating == ((guint) 0)) {
#line 578 "Search.c"
		guint* _tmp6_;
		guint _tmp7_;
#line 120 "../core/Utils/Search.vala"
		result = NULL;
#line 120 "../core/Utils/Search.vala"
		_tmp6_ = result;
#line 120 "../core/Utils/Search.vala"
		_tmp7_ = (guint) 0;
#line 120 "../core/Utils/Search.vala"
		_vala_warn_if_fail (_uint_equal (_tmp6_, &_tmp7_) != TRUE, "result != 0");
#line 120 "../core/Utils/Search.vala"
		return result;
#line 591 "Search.c"
	}
#line 122 "../core/Utils/Search.vala"
	_tmp8_ = __uint_dup0 (&rating);
#line 122 "../core/Utils/Search.vala"
	result = _tmp8_;
#line 122 "../core/Utils/Search.vala"
	_tmp9_ = result;
#line 122 "../core/Utils/Search.vala"
	_tmp10_ = (guint) 0;
#line 122 "../core/Utils/Search.vala"
	_vala_warn_if_fail (_uint_equal (_tmp9_, &_tmp10_) != TRUE, "result != 0");
#line 122 "../core/Utils/Search.vala"
	return result;
#line 605 "Search.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 624 "Search.c"
}

inline gboolean
music_search_match_string_to_media (MusicMedia* m,
                                    const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint _tmp9_;
	guint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	gboolean result;
#line 125 "../core/Utils/Search.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 125 "../core/Utils/Search.vala"
	g_return_val_if_fail (search != NULL, FALSE);
#line 126 "../core/Utils/Search.vala"
	_tmp9_ = music_media_get_year (m);
#line 126 "../core/Utils/Search.vala"
	_tmp10_ = _tmp9_;
#line 126 "../core/Utils/Search.vala"
	_tmp11_ = g_strdup_printf ("%u", _tmp10_);
#line 126 "../core/Utils/Search.vala"
	_tmp12_ = _tmp11_;
#line 126 "../core/Utils/Search.vala"
	_tmp13_ = g_strcmp0 (search, _tmp12_) == 0;
#line 126 "../core/Utils/Search.vala"
	_g_free0 (_tmp12_);
#line 126 "../core/Utils/Search.vala"
	if (_tmp13_) {
#line 126 "../core/Utils/Search.vala"
		_tmp8_ = TRUE;
#line 666 "Search.c"
	} else {
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 127 "../core/Utils/Search.vala"
		_tmp14_ = music_media_get_display_title (m);
#line 127 "../core/Utils/Search.vala"
		_tmp15_ = _tmp14_;
#line 127 "../core/Utils/Search.vala"
		_tmp16_ = music_search_get_valid_search_string (_tmp15_);
#line 127 "../core/Utils/Search.vala"
		_tmp17_ = _tmp16_;
#line 127 "../core/Utils/Search.vala"
		_tmp8_ = string_contains (_tmp17_, search);
#line 127 "../core/Utils/Search.vala"
		_g_free0 (_tmp17_);
#line 127 "../core/Utils/Search.vala"
		_g_free0 (_tmp15_);
#line 686 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp8_) {
#line 126 "../core/Utils/Search.vala"
		_tmp7_ = TRUE;
#line 692 "Search.c"
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 128 "../core/Utils/Search.vala"
		_tmp18_ = music_media_get_album (m);
#line 128 "../core/Utils/Search.vala"
		_tmp19_ = _tmp18_;
#line 128 "../core/Utils/Search.vala"
		_tmp20_ = music_search_get_valid_search_string (_tmp19_);
#line 128 "../core/Utils/Search.vala"
		_tmp21_ = _tmp20_;
#line 128 "../core/Utils/Search.vala"
		_tmp7_ = string_contains (_tmp21_, search);
#line 128 "../core/Utils/Search.vala"
		_g_free0 (_tmp21_);
#line 710 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp7_) {
#line 126 "../core/Utils/Search.vala"
		_tmp6_ = TRUE;
#line 716 "Search.c"
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 129 "../core/Utils/Search.vala"
		_tmp22_ = music_media_get_artist (m);
#line 129 "../core/Utils/Search.vala"
		_tmp23_ = _tmp22_;
#line 129 "../core/Utils/Search.vala"
		_tmp24_ = music_search_get_valid_search_string (_tmp23_);
#line 129 "../core/Utils/Search.vala"
		_tmp25_ = _tmp24_;
#line 129 "../core/Utils/Search.vala"
		_tmp6_ = string_contains (_tmp25_, search);
#line 129 "../core/Utils/Search.vala"
		_g_free0 (_tmp25_);
#line 734 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp6_) {
#line 126 "../core/Utils/Search.vala"
		_tmp5_ = TRUE;
#line 740 "Search.c"
	} else {
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 130 "../core/Utils/Search.vala"
		_tmp26_ = music_media_get_album_artist (m);
#line 130 "../core/Utils/Search.vala"
		_tmp27_ = _tmp26_;
#line 130 "../core/Utils/Search.vala"
		_tmp28_ = music_search_get_valid_search_string (_tmp27_);
#line 130 "../core/Utils/Search.vala"
		_tmp29_ = _tmp28_;
#line 130 "../core/Utils/Search.vala"
		_tmp5_ = string_contains (_tmp29_, search);
#line 130 "../core/Utils/Search.vala"
		_g_free0 (_tmp29_);
#line 758 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp5_) {
#line 126 "../core/Utils/Search.vala"
		_tmp4_ = TRUE;
#line 764 "Search.c"
	} else {
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 131 "../core/Utils/Search.vala"
		_tmp30_ = music_media_get_genre (m);
#line 131 "../core/Utils/Search.vala"
		_tmp31_ = _tmp30_;
#line 131 "../core/Utils/Search.vala"
		_tmp32_ = music_search_get_valid_search_string (_tmp31_);
#line 131 "../core/Utils/Search.vala"
		_tmp33_ = _tmp32_;
#line 131 "../core/Utils/Search.vala"
		_tmp4_ = string_contains (_tmp33_, search);
#line 131 "../core/Utils/Search.vala"
		_g_free0 (_tmp33_);
#line 782 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp4_) {
#line 126 "../core/Utils/Search.vala"
		_tmp3_ = TRUE;
#line 788 "Search.c"
	} else {
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 132 "../core/Utils/Search.vala"
		_tmp34_ = music_media_get_composer (m);
#line 132 "../core/Utils/Search.vala"
		_tmp35_ = _tmp34_;
#line 132 "../core/Utils/Search.vala"
		_tmp36_ = music_search_get_valid_search_string (_tmp35_);
#line 132 "../core/Utils/Search.vala"
		_tmp37_ = _tmp36_;
#line 132 "../core/Utils/Search.vala"
		_tmp3_ = string_contains (_tmp37_, search);
#line 132 "../core/Utils/Search.vala"
		_g_free0 (_tmp37_);
#line 806 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp3_) {
#line 126 "../core/Utils/Search.vala"
		_tmp2_ = TRUE;
#line 812 "Search.c"
	} else {
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
#line 133 "../core/Utils/Search.vala"
		_tmp38_ = music_media_get_grouping (m);
#line 133 "../core/Utils/Search.vala"
		_tmp39_ = _tmp38_;
#line 133 "../core/Utils/Search.vala"
		_tmp40_ = music_search_get_valid_search_string (_tmp39_);
#line 133 "../core/Utils/Search.vala"
		_tmp41_ = _tmp40_;
#line 133 "../core/Utils/Search.vala"
		_tmp2_ = string_contains (_tmp41_, search);
#line 133 "../core/Utils/Search.vala"
		_g_free0 (_tmp41_);
#line 830 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp2_) {
#line 126 "../core/Utils/Search.vala"
		_tmp1_ = TRUE;
#line 836 "Search.c"
	} else {
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
#line 134 "../core/Utils/Search.vala"
		_tmp42_ = music_media_get_comment (m);
#line 134 "../core/Utils/Search.vala"
		_tmp43_ = _tmp42_;
#line 134 "../core/Utils/Search.vala"
		_tmp44_ = music_search_get_valid_search_string (_tmp43_);
#line 134 "../core/Utils/Search.vala"
		_tmp45_ = _tmp44_;
#line 134 "../core/Utils/Search.vala"
		_tmp1_ = string_contains (_tmp45_, search);
#line 134 "../core/Utils/Search.vala"
		_g_free0 (_tmp45_);
#line 854 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	if (_tmp1_) {
#line 126 "../core/Utils/Search.vala"
		_tmp0_ = TRUE;
#line 860 "Search.c"
	} else {
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
#line 135 "../core/Utils/Search.vala"
		_tmp46_ = music_media_get_lyrics (m);
#line 135 "../core/Utils/Search.vala"
		_tmp47_ = _tmp46_;
#line 135 "../core/Utils/Search.vala"
		_tmp48_ = music_search_get_valid_search_string (_tmp47_);
#line 135 "../core/Utils/Search.vala"
		_tmp49_ = _tmp48_;
#line 135 "../core/Utils/Search.vala"
		_tmp0_ = string_contains (_tmp49_, search);
#line 135 "../core/Utils/Search.vala"
		_g_free0 (_tmp49_);
#line 878 "Search.c"
	}
#line 126 "../core/Utils/Search.vala"
	result = _tmp0_;
#line 126 "../core/Utils/Search.vala"
	return result;
#line 884 "Search.c"
}

