/* String.c generated by valac 0.56.0, the Vala compiler
 * generated from String.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

VALA_EXTERN gchar* music_string_canonicalize_for_search (const gchar* str);
VALA_EXTERN gunichar music_string_strip_char (gunichar ch);
VALA_EXTERN gchar* music_string_locale_to_utf8 (const gchar* string_locale);
VALA_EXTERN guint* music_search_get_rating_from_string (const gchar* rating_string);
VALA_EXTERN gchar* music_search_get_valid_search_string (const gchar* s);

inline gboolean
music_string_is_empty (const gchar* text,
                       gboolean check_white_space)
{
	gboolean result;
#line 32 "../core/Utils/String.vala"
	if (text != NULL) {
#line 55 "String.c"
		gboolean _tmp0_ = FALSE;
#line 33 "../core/Utils/String.vala"
		if (check_white_space) {
#line 33 "../core/Utils/String.vala"
			_tmp0_ = music_string_is_white_space (text);
#line 61 "String.c"
		} else {
#line 33 "../core/Utils/String.vala"
			_tmp0_ = g_strcmp0 (text, "") == 0;
#line 65 "String.c"
		}
#line 33 "../core/Utils/String.vala"
		result = _tmp0_;
#line 33 "../core/Utils/String.vala"
		return result;
#line 71 "String.c"
	}
#line 34 "../core/Utils/String.vala"
	result = TRUE;
#line 34 "../core/Utils/String.vala"
	return result;
#line 77 "String.c"
}

/**
     * Compares two strings encoded in UTF-8. Used extensively in the views for sorting.
     *
     * It takes into account the current locale's sorting rules and is faster
     * than normal string comparison.
     *
     * /!\ DON'T USE THIS METHOD WITH STRINGS NOT ENCODED IN UTF-8.
     *
     * @param a first string.
     * @param b second string.
     * @return 0 if a == b, a positive number if a > b, or a negative number if a < b.
     */
inline gint
music_string_compare (const gchar* a,
                      const gchar* b)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp6_;
	gint result;
#line 51 "../core/Utils/String.vala"
	if (a != NULL) {
#line 102 "String.c"
		gchar* _tmp1_;
#line 51 "../core/Utils/String.vala"
		_tmp1_ = g_utf8_collate_key (a, (gssize) -1);
#line 51 "../core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
		_tmp0_ = _tmp1_;
#line 110 "String.c"
	} else {
		gchar* _tmp2_;
#line 51 "../core/Utils/String.vala"
		_tmp2_ = g_strdup ((const gchar*) NULL);
#line 51 "../core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
		_tmp0_ = _tmp2_;
#line 119 "String.c"
	}
#line 52 "../core/Utils/String.vala"
	if (b != NULL) {
#line 123 "String.c"
		gchar* _tmp4_;
#line 52 "../core/Utils/String.vala"
		_tmp4_ = g_utf8_collate_key (b, (gssize) -1);
#line 52 "../core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "../core/Utils/String.vala"
		_tmp3_ = _tmp4_;
#line 131 "String.c"
	} else {
		gchar* _tmp5_;
#line 52 "../core/Utils/String.vala"
		_tmp5_ = g_strdup ((const gchar*) NULL);
#line 52 "../core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "../core/Utils/String.vala"
		_tmp3_ = _tmp5_;
#line 140 "String.c"
	}
#line 51 "../core/Utils/String.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 51 "../core/Utils/String.vala"
	result = _tmp6_ (_tmp0_, _tmp3_);
#line 51 "../core/Utils/String.vala"
	_g_free0 (_tmp3_);
#line 51 "../core/Utils/String.vala"
	_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
	return result;
#line 152 "String.c"
}

/**
     * Checks whether a string contains only whitespace.
     *
     * @return //true// if text consists enterely of white space.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 178 "String.c"
}

inline gboolean
music_string_is_white_space (const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 60 "../core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 61 "../core/Utils/String.vala"
	_tmp0_ = string_strip (text);
#line 61 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 61 "../core/Utils/String.vala"
	_tmp2_ = strlen (_tmp1_);
#line 61 "../core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 61 "../core/Utils/String.vala"
	_tmp4_ = _tmp3_ == 0;
#line 61 "../core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 61 "../core/Utils/String.vala"
	result = _tmp4_;
#line 61 "../core/Utils/String.vala"
	return result;
#line 208 "String.c"
}

/**
     * Removes irrelevant and meaningless characters from a string. Useful for search operations.
     * (Taken from gnome-contacts' contacts-utils.vala)
     */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1251 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1252 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1253 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 228 "String.c"
		gchar* _tmp0_;
#line 1254 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1254 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1255 "glib-2.0.vapi"
		result = TRUE;
#line 1255 "glib-2.0.vapi"
		if (c) {
#line 1255 "glib-2.0.vapi"
			*c = _vala_c;
#line 240 "String.c"
		}
#line 1255 "glib-2.0.vapi"
		return result;
#line 244 "String.c"
	} else {
#line 1257 "glib-2.0.vapi"
		result = FALSE;
#line 1257 "glib-2.0.vapi"
		if (c) {
#line 1257 "glib-2.0.vapi"
			*c = _vala_c;
#line 252 "String.c"
		}
#line 1257 "glib-2.0.vapi"
		return result;
#line 256 "String.c"
	}
}

inline gchar*
music_string_canonicalize_for_search (const gchar* str)
{
	gunichar* buf = NULL;
	gunichar* _tmp0_;
	gint buf_length1;
	gint _buf_size_;
	GString* res = NULL;
	GString* _tmp1_;
	gunichar c = 0U;
	GString* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* result;
#line 68 "../core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 69 "../core/Utils/String.vala"
	_tmp0_ = g_new0 (gunichar, G_UNICHAR_MAX_DECOMPOSITION_LENGTH);
#line 69 "../core/Utils/String.vala"
	buf = _tmp0_;
#line 69 "../core/Utils/String.vala"
	buf_length1 = G_UNICHAR_MAX_DECOMPOSITION_LENGTH;
#line 69 "../core/Utils/String.vala"
	_buf_size_ = buf_length1;
#line 70 "../core/Utils/String.vala"
	_tmp1_ = g_string_new ("");
#line 70 "../core/Utils/String.vala"
	res = _tmp1_;
#line 288 "String.c"
	{
		gint i = 0;
#line 74 "../core/Utils/String.vala"
		i = 0;
#line 293 "String.c"
		{
			gboolean _tmp2_ = FALSE;
#line 74 "../core/Utils/String.vala"
			_tmp2_ = TRUE;
#line 74 "../core/Utils/String.vala"
			while (TRUE) {
#line 300 "String.c"
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar sc = 0U;
#line 74 "../core/Utils/String.vala"
				if (!_tmp2_) {
#line 306 "String.c"
				}
#line 74 "../core/Utils/String.vala"
				_tmp2_ = FALSE;
#line 74 "../core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 74 "../core/Utils/String.vala"
				c = _tmp3_;
#line 74 "../core/Utils/String.vala"
				if (!_tmp4_) {
#line 74 "../core/Utils/String.vala"
					break;
#line 318 "String.c"
				}
#line 75 "../core/Utils/String.vala"
				sc = music_string_strip_char (c);
#line 77 "../core/Utils/String.vala"
				if (sc != ((gunichar) 0)) {
#line 324 "String.c"
					gsize size = 0UL;
					gunichar* _tmp5_;
					gint _tmp5__length1;
#line 78 "../core/Utils/String.vala"
					_tmp5_ = buf;
#line 78 "../core/Utils/String.vala"
					_tmp5__length1 = buf_length1;
#line 78 "../core/Utils/String.vala"
					size = g_unichar_fully_decompose (sc, FALSE, _tmp5_, (gint) _tmp5__length1);
#line 80 "../core/Utils/String.vala"
					if (size > ((gsize) 0)) {
#line 336 "String.c"
						GString* _tmp6_;
						gunichar* _tmp7_;
						gint _tmp7__length1;
						gunichar _tmp8_;
#line 81 "../core/Utils/String.vala"
						_tmp6_ = res;
#line 81 "../core/Utils/String.vala"
						_tmp7_ = buf;
#line 81 "../core/Utils/String.vala"
						_tmp7__length1 = buf_length1;
#line 81 "../core/Utils/String.vala"
						_tmp8_ = _tmp7_[0];
#line 81 "../core/Utils/String.vala"
						g_string_append_unichar (_tmp6_, _tmp8_);
#line 351 "String.c"
					}
				}
			}
		}
	}
#line 85 "../core/Utils/String.vala"
	_tmp9_ = res;
#line 85 "../core/Utils/String.vala"
	_tmp10_ = _tmp9_->str;
#line 85 "../core/Utils/String.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 85 "../core/Utils/String.vala"
	result = _tmp11_;
#line 85 "../core/Utils/String.vala"
	_g_string_free0 (res);
#line 85 "../core/Utils/String.vala"
	buf = (g_free (buf), NULL);
#line 85 "../core/Utils/String.vala"
	return result;
#line 371 "String.c"
}

inline gunichar
music_string_strip_char (gunichar ch)
{
	gunichar result;
#line 89 "../core/Utils/String.vala"
	switch (g_unichar_type (ch)) {
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_CONTROL:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_FORMAT:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_UNASSIGNED:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_NON_SPACING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_COMBINING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_ENCLOSING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_LINE_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_SPACE_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_PARAGRAPH_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_DASH_PUNCTUATION:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_OPEN_PUNCTUATION:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_OTHER_PUNCTUATION:
#line 404 "String.c"
		{
#line 102 "../core/Utils/String.vala"
			result = (gunichar) 0;
#line 102 "../core/Utils/String.vala"
			return result;
#line 410 "String.c"
		}
		default:
		{
#line 104 "../core/Utils/String.vala"
			result = g_unichar_tolower (ch);
#line 104 "../core/Utils/String.vala"
			return result;
#line 418 "String.c"
		}
	}
}

/**
     * Converts a string encoded in the native operating system encoding to UTF-8.
     *
     * @param string_locale String in locale encoding.
     * @return String encoded in UTF-8, or //null// if the string could not be converted.
     */
gchar*
music_string_locale_to_utf8 (const gchar* string_locale)
{
	GError* _error_ = NULL;
	gsize bytes_read = 0UL;
	gsize bytes_written = 0UL;
	gchar* string_utf8 = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gsize _tmp2_ = 0UL;
	gsize _tmp3_ = 0UL;
	GError* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError* _tmp6_;
	gchar* result;
#line 114 "../core/Utils/String.vala"
	g_return_val_if_fail (string_locale != NULL, NULL);
#line 117 "../core/Utils/String.vala"
	_tmp0_ = strlen (string_locale);
#line 117 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 117 "../core/Utils/String.vala"
	_tmp5_ = g_locale_to_utf8 (string_locale, (gssize) _tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 117 "../core/Utils/String.vala"
	bytes_read = _tmp2_;
#line 117 "../core/Utils/String.vala"
	bytes_written = _tmp3_;
#line 117 "../core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 117 "../core/Utils/String.vala"
	_error_ = _tmp4_;
#line 117 "../core/Utils/String.vala"
	string_utf8 = _tmp5_;
#line 121 "../core/Utils/String.vala"
	_tmp6_ = _error_;
#line 121 "../core/Utils/String.vala"
	if (_tmp6_ != NULL) {
#line 122 "../core/Utils/String.vala"
		_g_free0 (string_utf8);
#line 122 "../core/Utils/String.vala"
		string_utf8 = NULL;
#line 470 "String.c"
	}
#line 124 "../core/Utils/String.vala"
	result = string_utf8;
#line 124 "../core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 124 "../core/Utils/String.vala"
	return result;
#line 478 "String.c"
}

/**
     * Base method used for searches. It does a previous parsing on the search string.
     *
     * If the output value of parsed_rating is greater than 0, then the view should
     * only display the media with that rating in the search results, and ignore
     * the value of parsed_search_string.
     *
     * @param search Non-parsed version of the search string.
     * @param parsed_rating location where the parsed rating it stored, or 0 if the
     * string didn't represent a valid rating.
     * @param parsed_search_string location where the canonicalized version of the
     * search string is stored. Should be passed to the methods in Music.Search.
     */
void
music_string_base_search_method (const gchar* search,
                                 guint* parsed_rating,
                                 gchar** parsed_search_string)
{
	guint _vala_parsed_rating = 0U;
	gchar* _vala_parsed_search_string = NULL;
	guint* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp4_;
	gchar* _tmp6_;
#line 140 "../core/Utils/String.vala"
	g_return_if_fail (search != NULL);
#line 142 "../core/Utils/String.vala"
	_vala_parsed_rating = (guint) 0;
#line 143 "../core/Utils/String.vala"
	_tmp0_ = string_strip (search);
#line 143 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 143 "../core/Utils/String.vala"
	_tmp2_ = music_search_get_rating_from_string (_tmp1_);
#line 143 "../core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 143 "../core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 143 "../core/Utils/String.vala"
	_result_ = _tmp3_;
#line 145 "../core/Utils/String.vala"
	_tmp4_ = _result_;
#line 145 "../core/Utils/String.vala"
	if (_tmp4_ != NULL) {
#line 528 "String.c"
		guint* _tmp5_;
#line 146 "../core/Utils/String.vala"
		_tmp5_ = _result_;
#line 146 "../core/Utils/String.vala"
		_vala_parsed_rating = CLAMP (*_tmp5_, (guint) 1, (guint) 5);
#line 534 "String.c"
	}
#line 149 "../core/Utils/String.vala"
	_tmp6_ = music_search_get_valid_search_string (search);
#line 149 "../core/Utils/String.vala"
	_g_free0 (_vala_parsed_search_string);
#line 149 "../core/Utils/String.vala"
	_vala_parsed_search_string = _tmp6_;
#line 140 "../core/Utils/String.vala"
	_g_free0 (_result_);
#line 140 "../core/Utils/String.vala"
	if (parsed_rating) {
#line 140 "../core/Utils/String.vala"
		*parsed_rating = _vala_parsed_rating;
#line 548 "String.c"
	}
#line 140 "../core/Utils/String.vala"
	if (parsed_search_string) {
#line 140 "../core/Utils/String.vala"
		*parsed_search_string = _vala_parsed_search_string;
#line 554 "String.c"
	} else {
#line 140 "../core/Utils/String.vala"
		_g_free0 (_vala_parsed_search_string);
#line 558 "String.c"
	}
}

/**
     * A method for extracting integers from strings.
     *
     * The method does its best to extract a number from a string by cleaning up
     * non-numeric characters before parsing the string with uint64.parse(). The
     * purpose of this method is to provide a safe way of extracting numbers
     * from strings without making everything crash when passing a weird localized
     * string that would normally lead uint64.parse, int64.parse or int.parse
     * to a segmentation fault. This happens due to encoding incompatibilities:
     * Remember that the standard C library doesn't know how to deal with variable-
     * length UTF-8 characters!
     *
     * If no number is found in the string, zero is returned.
     *
     * Examples:
     * "a23oe ew2" => 232
     " "32 text"   => 32
     * "ins1 32"   => 132
     * "a word"    => 0
     *
     * @param str string known to contain a valid integer
     * @return Result of parsing the string.
     */
static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 831 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 832 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 832 "glib-2.0.vapi"
	return result;
#line 596 "String.c"
}

inline guint64
music_string_uint_from_string (const gchar* str)
{
#line 177 "../core/Utils/String.vala"
	static const gushort MAX_DIGITS = (gushort) 18;
#line 604 "String.c"
	gushort ndigits = 0U;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	guint64 _tmp7_ = 0ULL;
	guint64 result;
#line 175 "../core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 178 "../core/Utils/String.vala"
	ndigits = (gushort) 0;
#line 180 "../core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 180 "../core/Utils/String.vala"
	_result_ = _tmp0_;
#line 619 "String.c"
	{
		gint i = 0;
#line 183 "../core/Utils/String.vala"
		i = 0;
#line 624 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 183 "../core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 183 "../core/Utils/String.vala"
			while (TRUE) {
#line 631 "String.c"
				gboolean _tmp2_ = FALSE;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
#line 183 "../core/Utils/String.vala"
				if (!_tmp1_) {
#line 637 "String.c"
				}
#line 183 "../core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 183 "../core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 183 "../core/Utils/String.vala"
				c = _tmp3_;
#line 183 "../core/Utils/String.vala"
				if (_tmp4_) {
#line 183 "../core/Utils/String.vala"
					_tmp2_ = ndigits < MAX_DIGITS;
#line 649 "String.c"
				} else {
#line 183 "../core/Utils/String.vala"
					_tmp2_ = FALSE;
#line 653 "String.c"
				}
#line 183 "../core/Utils/String.vala"
				if (!_tmp2_) {
#line 183 "../core/Utils/String.vala"
					break;
#line 659 "String.c"
				}
#line 184 "../core/Utils/String.vala"
				if (g_unichar_isdigit (c)) {
#line 663 "String.c"
					GString* _tmp5_;
					gushort _tmp6_;
#line 185 "../core/Utils/String.vala"
					_tmp5_ = _result_;
#line 185 "../core/Utils/String.vala"
					g_string_append_unichar (_tmp5_, c);
#line 186 "../core/Utils/String.vala"
					_tmp6_ = ndigits;
#line 186 "../core/Utils/String.vala"
					ndigits = _tmp6_ + 1;
#line 674 "String.c"
				}
			}
		}
	}
#line 190 "../core/Utils/String.vala"
	if (((gint) ndigits) == 0) {
#line 190 "../core/Utils/String.vala"
		_tmp7_ = (guint64) 0;
#line 683 "String.c"
	} else {
		GString* _tmp8_;
		const gchar* _tmp9_;
#line 190 "../core/Utils/String.vala"
		_tmp8_ = _result_;
#line 190 "../core/Utils/String.vala"
		_tmp9_ = _tmp8_->str;
#line 190 "../core/Utils/String.vala"
		_tmp7_ = uint64_parse (_tmp9_, (guint) 0);
#line 693 "String.c"
	}
#line 190 "../core/Utils/String.vala"
	result = _tmp7_;
#line 190 "../core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 190 "../core/Utils/String.vala"
	return result;
#line 701 "String.c"
}

