/* Media.c generated by valac 0.56.0, the Vala compiler
 * generated from Media.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

enum  {
	MUSIC_MEDIA_0_PROPERTY,
	MUSIC_MEDIA_ROWID_PROPERTY,
	MUSIC_MEDIA_URI_PROPERTY,
	MUSIC_MEDIA_FILE_SIZE_PROPERTY,
	MUSIC_MEDIA_FILE_EXISTS_PROPERTY,
	MUSIC_MEDIA_FILE_PROPERTY,
	MUSIC_MEDIA_IS_PREVIEW_PROPERTY,
	MUSIC_MEDIA_IS_TEMPORARY_PROPERTY,
	MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY,
	MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY,
	MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY,
	MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY,
	MUSIC_MEDIA_TITLE_PROPERTY,
	MUSIC_MEDIA_TRACK_PROPERTY,
	MUSIC_MEDIA_TRACK_COUNT_PROPERTY,
	MUSIC_MEDIA_COMPOSER_PROPERTY,
	MUSIC_MEDIA_ARTIST_PROPERTY,
	MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY,
	MUSIC_MEDIA_ALBUM_PROPERTY,
	MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY,
	MUSIC_MEDIA_ALBUM_COUNT_PROPERTY,
	MUSIC_MEDIA_ALBUM_INFO_PROPERTY,
	MUSIC_MEDIA_GROUPING_PROPERTY,
	MUSIC_MEDIA_GENRE_PROPERTY,
	MUSIC_MEDIA_COMMENT_PROPERTY,
	MUSIC_MEDIA_LYRICS_PROPERTY,
	MUSIC_MEDIA_YEAR_PROPERTY,
	MUSIC_MEDIA_BITRATE_PROPERTY,
	MUSIC_MEDIA_BPM_PROPERTY,
	MUSIC_MEDIA_SAMPLERATE_PROPERTY,
	MUSIC_MEDIA_LENGTH_PROPERTY,
	MUSIC_MEDIA_RATING_PROPERTY,
	MUSIC_MEDIA_PLAY_COUNT_PROPERTY,
	MUSIC_MEDIA_SKIP_COUNT_PROPERTY,
	MUSIC_MEDIA_DATE_ADDED_PROPERTY,
	MUSIC_MEDIA_LAST_PLAYED_PROPERTY,
	MUSIC_MEDIA_LAST_MODIFIED_PROPERTY,
	MUSIC_MEDIA_RESUME_POS_PROPERTY,
	MUSIC_MEDIA_SHOW_PROPERTY,
	MUSIC_MEDIA_NUM_PROPERTIES
};
static GParamSpec* music_media_properties[MUSIC_MEDIA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _MusicMediaPrivate {
	gint64 _rowid;
	guint64 _file_size;
	GFile* _file;
	gboolean _is_preview;
	gboolean _is_temporary;
	gboolean _location_unknown;
	gboolean _has_embedded;
	GIcon* _unique_status_image;
	gboolean _show_indicator;
	gchar* _title;
	guint _track;
	guint _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint _album_number;
	guint _album_count;
	MusicAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint _year;
	guint _bitrate;
	guint _bpm;
	guint _samplerate;
	guint _length;
	guint _play_count;
	guint _skip_count;
	guint _date_added;
	guint _last_played;
	guint _last_modified;
	gint _resume_pos;
	gboolean _show;
};

static gint MusicMedia_private_offset;
static gpointer music_media_parent_class = NULL;
gchar* music_media_UNKNOWN = NULL;

VALA_EXTERN gchar* music_string_locale_to_utf8 (const gchar* string_locale);
VALA_EXTERN gchar* music_media_get_simple_display_text (const gchar* text);
static void music_media_finalize (GObject * obj);
static GType music_media_get_type_once (void);
static void _vala_music_media_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_music_media_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
music_media_get_instance_private (MusicMedia* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMedia_private_offset);
}

inline gchar*
music_media_get_display_filename (MusicMedia* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* filename = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp11_;
	gchar* result;
#line 101 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../core/Media.vala"
	_tmp1_ = music_media_get_file (self);
#line 102 "../core/Media.vala"
	_tmp2_ = _tmp1_;
#line 102 "../core/Media.vala"
	_tmp3_ = g_file_get_basename (_tmp2_);
#line 102 "../core/Media.vala"
	_tmp0_ = _tmp3_;
#line 102 "../core/Media.vala"
	if (_tmp0_ == NULL) {
#line 176 "Media.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 102 "../core/Media.vala"
		_tmp4_ = music_media_UNKNOWN;
#line 102 "../core/Media.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 102 "../core/Media.vala"
		_g_free0 (_tmp0_);
#line 102 "../core/Media.vala"
		_tmp0_ = _tmp5_;
#line 187 "Media.c"
	}
#line 102 "../core/Media.vala"
	_tmp6_ = music_string_locale_to_utf8 (_tmp0_);
#line 102 "../core/Media.vala"
	filename = _tmp6_;
#line 103 "../core/Media.vala"
	_tmp8_ = filename;
#line 103 "../core/Media.vala"
	if (music_media_is_valid_string_field (_tmp8_)) {
#line 197 "Media.c"
		const gchar* _tmp9_;
#line 103 "../core/Media.vala"
		_tmp9_ = filename;
#line 103 "../core/Media.vala"
		_tmp7_ = _tmp9_;
#line 203 "Media.c"
	} else {
		const gchar* _tmp10_;
#line 103 "../core/Media.vala"
		_tmp10_ = music_media_UNKNOWN;
#line 103 "../core/Media.vala"
		_tmp7_ = _tmp10_;
#line 210 "Media.c"
	}
#line 103 "../core/Media.vala"
	_tmp11_ = g_strdup (_tmp7_);
#line 103 "../core/Media.vala"
	result = _tmp11_;
#line 103 "../core/Media.vala"
	_g_free0 (filename);
#line 103 "../core/Media.vala"
	_g_free0 (_tmp0_);
#line 103 "../core/Media.vala"
	return result;
#line 222 "Media.c"
}

inline gchar*
music_media_get_display_location (MusicMedia* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* filename = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* result;
#line 106 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../core/Media.vala"
	_tmp0_ = music_media_get_is_temporary (self);
#line 107 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 107 "../core/Media.vala"
	if (_tmp1_) {
#line 249 "Media.c"
		gchar* _tmp2_;
#line 108 "../core/Media.vala"
		_tmp2_ = g_strdup ("");
#line 108 "../core/Media.vala"
		result = _tmp2_;
#line 108 "../core/Media.vala"
		return result;
#line 257 "Media.c"
	}
#line 110 "../core/Media.vala"
	_tmp3_ = music_media_get_file (self);
#line 110 "../core/Media.vala"
	_tmp4_ = _tmp3_;
#line 110 "../core/Media.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 110 "../core/Media.vala"
	_tmp6_ = _tmp5_;
#line 110 "../core/Media.vala"
	_tmp7_ = music_string_locale_to_utf8 (_tmp6_);
#line 110 "../core/Media.vala"
	_tmp8_ = _tmp7_;
#line 110 "../core/Media.vala"
	_g_free0 (_tmp6_);
#line 110 "../core/Media.vala"
	filename = _tmp8_;
#line 112 "../core/Media.vala"
	_tmp9_ = filename;
#line 112 "../core/Media.vala"
	if (music_media_is_valid_string_field (_tmp9_)) {
#line 279 "Media.c"
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 113 "../core/Media.vala"
		_tmp10_ = music_media_get_file (self);
#line 113 "../core/Media.vala"
		_tmp11_ = _tmp10_;
#line 113 "../core/Media.vala"
		_tmp12_ = g_file_get_uri_scheme (_tmp11_);
#line 113 "../core/Media.vala"
		_tmp13_ = _tmp12_;
#line 113 "../core/Media.vala"
		_tmp14_ = filename;
#line 113 "../core/Media.vala"
		_tmp15_ = g_strdup_printf ("%s:/%s", _tmp13_, _tmp14_);
#line 113 "../core/Media.vala"
		_tmp16_ = _tmp15_;
#line 113 "../core/Media.vala"
		_g_free0 (_tmp13_);
#line 113 "../core/Media.vala"
		result = _tmp16_;
#line 113 "../core/Media.vala"
		_g_free0 (filename);
#line 113 "../core/Media.vala"
		return result;
#line 309 "Media.c"
	}
#line 115 "../core/Media.vala"
	_tmp17_ = music_media_UNKNOWN;
#line 115 "../core/Media.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 115 "../core/Media.vala"
	result = _tmp18_;
#line 115 "../core/Media.vala"
	_g_free0 (filename);
#line 115 "../core/Media.vala"
	return result;
#line 321 "Media.c"
}

inline gchar*
music_media_get_display_title (MusicMedia* self)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* result;
#line 118 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "../core/Media.vala"
	_tmp0_ = music_media_get_title (self);
#line 119 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 119 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 119 "../core/Media.vala"
	title = _tmp2_;
#line 120 "../core/Media.vala"
	_tmp4_ = title;
#line 120 "../core/Media.vala"
	if (music_media_is_valid_string_field (_tmp4_)) {
#line 348 "Media.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 120 "../core/Media.vala"
		_tmp5_ = title;
#line 120 "../core/Media.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 120 "../core/Media.vala"
		_g_free0 (_tmp3_);
#line 120 "../core/Media.vala"
		_tmp3_ = _tmp6_;
#line 359 "Media.c"
	} else {
		gchar* _tmp7_;
#line 120 "../core/Media.vala"
		_tmp7_ = music_media_get_display_filename (self);
#line 120 "../core/Media.vala"
		_g_free0 (_tmp3_);
#line 120 "../core/Media.vala"
		_tmp3_ = _tmp7_;
#line 368 "Media.c"
	}
#line 120 "../core/Media.vala"
	result = _tmp3_;
#line 120 "../core/Media.vala"
	_g_free0 (title);
#line 120 "../core/Media.vala"
	return result;
#line 376 "Media.c"
}

inline gchar*
music_media_get_display_composer (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 123 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 124 "../core/Media.vala"
	_tmp0_ = music_media_get_composer (self);
#line 124 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 124 "../core/Media.vala"
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
#line 124 "../core/Media.vala"
	result = _tmp2_;
#line 124 "../core/Media.vala"
	return result;
#line 398 "Media.c"
}

inline gchar*
music_media_get_display_artist (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 127 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../core/Media.vala"
	_tmp0_ = music_media_get_artist (self);
#line 128 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 128 "../core/Media.vala"
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
#line 128 "../core/Media.vala"
	result = _tmp2_;
#line 128 "../core/Media.vala"
	return result;
#line 420 "Media.c"
}

inline gchar*
music_media_get_display_album_artist (MusicMedia* self,
                                      gboolean use_artist_fallback)
{
	gchar* album_artist = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 131 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../core/Media.vala"
	_tmp0_ = music_media_get_album_artist (self);
#line 132 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 132 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 132 "../core/Media.vala"
	album_artist = _tmp2_;
#line 134 "../core/Media.vala"
	_tmp3_ = album_artist;
#line 134 "../core/Media.vala"
	if (music_media_is_valid_string_field (_tmp3_)) {
#line 135 "../core/Media.vala"
		result = album_artist;
#line 135 "../core/Media.vala"
		return result;
#line 453 "Media.c"
	}
#line 137 "../core/Media.vala"
	if (use_artist_fallback) {
#line 457 "Media.c"
		gchar* _tmp4_;
#line 138 "../core/Media.vala"
		_tmp4_ = music_media_get_display_artist (self);
#line 138 "../core/Media.vala"
		result = _tmp4_;
#line 138 "../core/Media.vala"
		_g_free0 (album_artist);
#line 138 "../core/Media.vala"
		return result;
#line 467 "Media.c"
	}
#line 140 "../core/Media.vala"
	_tmp5_ = music_media_UNKNOWN;
#line 140 "../core/Media.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 140 "../core/Media.vala"
	result = _tmp6_;
#line 140 "../core/Media.vala"
	_g_free0 (album_artist);
#line 140 "../core/Media.vala"
	return result;
#line 479 "Media.c"
}

inline gchar*
music_media_get_display_album (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 143 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 144 "../core/Media.vala"
	_tmp0_ = music_media_get_album (self);
#line 144 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 144 "../core/Media.vala"
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
#line 144 "../core/Media.vala"
	result = _tmp2_;
#line 144 "../core/Media.vala"
	return result;
#line 501 "Media.c"
}

inline gchar*
music_media_get_display_genre (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 147 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../core/Media.vala"
	_tmp0_ = music_media_get_genre (self);
#line 148 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 148 "../core/Media.vala"
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
#line 148 "../core/Media.vala"
	result = _tmp2_;
#line 148 "../core/Media.vala"
	return result;
#line 523 "Media.c"
}

inline gboolean
music_media_is_valid_string_field (const gchar* text)
{
	gboolean result;
#line 152 "../core/Media.vala"
	result = !music_string_is_empty (text, TRUE);
#line 152 "../core/Media.vala"
	return result;
#line 534 "Media.c"
}

guint
music_media_get_album_hashkey (MusicMedia* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	guint result;
#line 155 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 156 "../core/Media.vala"
	_tmp0_ = g_string_new ("");
#line 156 "../core/Media.vala"
	builder = _tmp0_;
#line 157 "../core/Media.vala"
	_tmp1_ = builder;
#line 157 "../core/Media.vala"
	_tmp2_ = music_media_get_album (self);
#line 157 "../core/Media.vala"
	_tmp3_ = _tmp2_;
#line 157 "../core/Media.vala"
	g_string_append (_tmp1_, _tmp3_);
#line 158 "../core/Media.vala"
	_tmp4_ = music_media_get_album_artist (self);
#line 158 "../core/Media.vala"
	_tmp5_ = _tmp4_;
#line 158 "../core/Media.vala"
	if (music_media_is_valid_string_field (_tmp5_)) {
#line 570 "Media.c"
		GString* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 159 "../core/Media.vala"
		_tmp6_ = builder;
#line 159 "../core/Media.vala"
		_tmp7_ = music_media_get_album_artist (self);
#line 159 "../core/Media.vala"
		_tmp8_ = _tmp7_;
#line 159 "../core/Media.vala"
		g_string_append (_tmp6_, _tmp8_);
#line 582 "Media.c"
	} else {
		GString* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 161 "../core/Media.vala"
		_tmp9_ = builder;
#line 161 "../core/Media.vala"
		_tmp10_ = music_media_get_artist (self);
#line 161 "../core/Media.vala"
		_tmp11_ = _tmp10_;
#line 161 "../core/Media.vala"
		g_string_append (_tmp9_, _tmp11_);
#line 595 "Media.c"
	}
#line 162 "../core/Media.vala"
	_tmp12_ = builder;
#line 162 "../core/Media.vala"
	_tmp13_ = _tmp12_->str;
#line 162 "../core/Media.vala"
	result = g_str_hash (_tmp13_);
#line 162 "../core/Media.vala"
	_g_string_free0 (builder);
#line 162 "../core/Media.vala"
	return result;
#line 607 "Media.c"
}

/**
     * It's called simple because it simply checks if the string is empty,
     * and returns UNKNOWN if it is.
     */
inline gchar*
music_media_get_simple_display_text (const gchar* text)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	gchar* result;
#line 169 "../core/Media.vala"
	if (music_media_is_valid_string_field (text)) {
#line 169 "../core/Media.vala"
		_tmp0_ = text;
#line 624 "Media.c"
	} else {
		const gchar* _tmp1_;
#line 169 "../core/Media.vala"
		_tmp1_ = music_media_UNKNOWN;
#line 169 "../core/Media.vala"
		_tmp0_ = _tmp1_;
#line 631 "Media.c"
	}
#line 169 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 169 "../core/Media.vala"
	result = _tmp2_;
#line 169 "../core/Media.vala"
	return result;
#line 639 "Media.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 661 "Media.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 665 "Media.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 671 "Media.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 675 "Media.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 679 "Media.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 687 "Media.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 715 "Media.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 724 "Media.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 738 "Media.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 747 "Media.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 761 "Media.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 770 "Media.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 779 "Media.c"
}

gchar*
music_media_get_title_markup (MusicMedia* self)
{
	gboolean is_valid_artist = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean is_valid_album = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gchar* result;
#line 172 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 176 "../core/Media.vala"
	_tmp0_ = music_media_get_artist (self);
#line 176 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 176 "../core/Media.vala"
	is_valid_artist = music_media_is_valid_string_field (_tmp1_);
#line 177 "../core/Media.vala"
	_tmp2_ = music_media_get_album (self);
#line 177 "../core/Media.vala"
	_tmp3_ = _tmp2_;
#line 177 "../core/Media.vala"
	is_valid_album = music_media_is_valid_string_field (_tmp3_);
#line 178 "../core/Media.vala"
	if (!is_valid_artist) {
#line 178 "../core/Media.vala"
		_tmp4_ = is_valid_album;
#line 811 "Media.c"
	} else {
#line 178 "../core/Media.vala"
		_tmp4_ = FALSE;
#line 815 "Media.c"
	}
#line 178 "../core/Media.vala"
	if (_tmp4_) {
#line 819 "Media.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 180 "../core/Media.vala"
		_tmp5_ = music_media_get_album (self);
#line 180 "../core/Media.vala"
		_tmp6_ = _tmp5_;
#line 180 "../core/Media.vala"
		_tmp7_ = g_markup_escape_text (_tmp6_, (gssize) -1);
#line 180 "../core/Media.vala"
		_tmp8_ = _tmp7_;
#line 180 "../core/Media.vala"
		_tmp9_ = g_strconcat ("<b>", _tmp8_, NULL);
#line 180 "../core/Media.vala"
		_tmp10_ = _tmp9_;
#line 180 "../core/Media.vala"
		_tmp11_ = g_strconcat (_tmp10_, "</b>", NULL);
#line 180 "../core/Media.vala"
		_tmp12_ = _tmp11_;
#line 180 "../core/Media.vala"
		_tmp13_ = string_replace (_ ("$NAME on $ALBUM"), "$ALBUM", _tmp12_);
#line 180 "../core/Media.vala"
		_tmp14_ = _tmp13_;
#line 180 "../core/Media.vala"
		_tmp15_ = music_media_get_display_title (self);
#line 180 "../core/Media.vala"
		_tmp16_ = _tmp15_;
#line 180 "../core/Media.vala"
		_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
#line 180 "../core/Media.vala"
		_tmp18_ = _tmp17_;
#line 180 "../core/Media.vala"
		_tmp19_ = g_strconcat ("<b>", _tmp18_, NULL);
#line 180 "../core/Media.vala"
		_tmp20_ = _tmp19_;
#line 180 "../core/Media.vala"
		_tmp21_ = g_strconcat (_tmp20_, "</b>", NULL);
#line 180 "../core/Media.vala"
		_tmp22_ = _tmp21_;
#line 180 "../core/Media.vala"
		_tmp23_ = string_replace (_tmp14_, "$NAME", _tmp22_);
#line 180 "../core/Media.vala"
		_tmp24_ = _tmp23_;
#line 180 "../core/Media.vala"
		_g_free0 (_tmp22_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp20_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp18_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp16_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp14_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp12_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp10_);
#line 180 "../core/Media.vala"
		_g_free0 (_tmp8_);
#line 180 "../core/Media.vala"
		result = _tmp24_;
#line 180 "../core/Media.vala"
		return result;
#line 900 "Media.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 181 "../core/Media.vala"
		if (is_valid_artist) {
#line 181 "../core/Media.vala"
			_tmp25_ = !is_valid_album;
#line 907 "Media.c"
		} else {
#line 181 "../core/Media.vala"
			_tmp25_ = FALSE;
#line 911 "Media.c"
		}
#line 181 "../core/Media.vala"
		if (_tmp25_) {
#line 915 "Media.c"
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
#line 183 "../core/Media.vala"
			_tmp26_ = music_media_get_artist (self);
#line 183 "../core/Media.vala"
			_tmp27_ = _tmp26_;
#line 183 "../core/Media.vala"
			_tmp28_ = g_markup_escape_text (_tmp27_, (gssize) -1);
#line 183 "../core/Media.vala"
			_tmp29_ = _tmp28_;
#line 183 "../core/Media.vala"
			_tmp30_ = g_strconcat ("<b>", _tmp29_, NULL);
#line 183 "../core/Media.vala"
			_tmp31_ = _tmp30_;
#line 183 "../core/Media.vala"
			_tmp32_ = g_strconcat (_tmp31_, "</b>", NULL);
#line 183 "../core/Media.vala"
			_tmp33_ = _tmp32_;
#line 183 "../core/Media.vala"
			_tmp34_ = string_replace (_ ("$NAME by $ARTIST"), "$ARTIST", _tmp33_);
#line 183 "../core/Media.vala"
			_tmp35_ = _tmp34_;
#line 183 "../core/Media.vala"
			_tmp36_ = music_media_get_display_title (self);
#line 183 "../core/Media.vala"
			_tmp37_ = _tmp36_;
#line 183 "../core/Media.vala"
			_tmp38_ = g_markup_escape_text (_tmp37_, (gssize) -1);
#line 183 "../core/Media.vala"
			_tmp39_ = _tmp38_;
#line 183 "../core/Media.vala"
			_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 183 "../core/Media.vala"
			_tmp41_ = _tmp40_;
#line 183 "../core/Media.vala"
			_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 183 "../core/Media.vala"
			_tmp43_ = _tmp42_;
#line 183 "../core/Media.vala"
			_tmp44_ = string_replace (_tmp35_, "$NAME", _tmp43_);
#line 183 "../core/Media.vala"
			_tmp45_ = _tmp44_;
#line 183 "../core/Media.vala"
			_g_free0 (_tmp43_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp41_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp39_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp37_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp35_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp33_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp31_);
#line 183 "../core/Media.vala"
			_g_free0 (_tmp29_);
#line 183 "../core/Media.vala"
			result = _tmp45_;
#line 183 "../core/Media.vala"
			return result;
#line 996 "Media.c"
		} else {
			gboolean _tmp46_ = FALSE;
#line 184 "../core/Media.vala"
			if (!is_valid_artist) {
#line 184 "../core/Media.vala"
				_tmp46_ = !is_valid_album;
#line 1003 "Media.c"
			} else {
#line 184 "../core/Media.vala"
				_tmp46_ = FALSE;
#line 1007 "Media.c"
			}
#line 184 "../core/Media.vala"
			if (_tmp46_) {
#line 1011 "Media.c"
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
#line 186 "../core/Media.vala"
				_tmp47_ = music_media_get_display_title (self);
#line 186 "../core/Media.vala"
				_tmp48_ = _tmp47_;
#line 186 "../core/Media.vala"
				_tmp49_ = g_markup_escape_text (_tmp48_, (gssize) -1);
#line 186 "../core/Media.vala"
				_tmp50_ = _tmp49_;
#line 186 "../core/Media.vala"
				_tmp51_ = g_strconcat ("<b>", _tmp50_, NULL);
#line 186 "../core/Media.vala"
				_tmp52_ = _tmp51_;
#line 186 "../core/Media.vala"
				_tmp53_ = g_strconcat (_tmp52_, "</b>", NULL);
#line 186 "../core/Media.vala"
				_tmp54_ = _tmp53_;
#line 186 "../core/Media.vala"
				_g_free0 (_tmp52_);
#line 186 "../core/Media.vala"
				_g_free0 (_tmp50_);
#line 186 "../core/Media.vala"
				_g_free0 (_tmp48_);
#line 186 "../core/Media.vala"
				result = _tmp54_;
#line 186 "../core/Media.vala"
				return result;
#line 1046 "Media.c"
			} else {
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				const gchar* _tmp75_;
				const gchar* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
#line 189 "../core/Media.vala"
				_tmp55_ = music_media_get_artist (self);
#line 189 "../core/Media.vala"
				_tmp56_ = _tmp55_;
#line 189 "../core/Media.vala"
				_tmp57_ = g_markup_escape_text (_tmp56_, (gssize) -1);
#line 189 "../core/Media.vala"
				_tmp58_ = _tmp57_;
#line 189 "../core/Media.vala"
				_tmp59_ = g_strconcat ("<b>", _tmp58_, NULL);
#line 189 "../core/Media.vala"
				_tmp60_ = _tmp59_;
#line 189 "../core/Media.vala"
				_tmp61_ = g_strconcat (_tmp60_, "</b>", NULL);
#line 189 "../core/Media.vala"
				_tmp62_ = _tmp61_;
#line 189 "../core/Media.vala"
				_tmp63_ = string_replace (_ ("$NAME by $ARTIST on $ALBUM"), "$ARTIST", _tmp62_);
#line 189 "../core/Media.vala"
				_tmp64_ = _tmp63_;
#line 189 "../core/Media.vala"
				_tmp65_ = music_media_get_display_title (self);
#line 189 "../core/Media.vala"
				_tmp66_ = _tmp65_;
#line 189 "../core/Media.vala"
				_tmp67_ = g_markup_escape_text (_tmp66_, (gssize) -1);
#line 189 "../core/Media.vala"
				_tmp68_ = _tmp67_;
#line 189 "../core/Media.vala"
				_tmp69_ = g_strconcat ("<b>", _tmp68_, NULL);
#line 189 "../core/Media.vala"
				_tmp70_ = _tmp69_;
#line 189 "../core/Media.vala"
				_tmp71_ = g_strconcat (_tmp70_, "</b>", NULL);
#line 189 "../core/Media.vala"
				_tmp72_ = _tmp71_;
#line 189 "../core/Media.vala"
				_tmp73_ = string_replace (_tmp64_, "$NAME", _tmp72_);
#line 189 "../core/Media.vala"
				_tmp74_ = _tmp73_;
#line 189 "../core/Media.vala"
				_tmp75_ = music_media_get_album (self);
#line 189 "../core/Media.vala"
				_tmp76_ = _tmp75_;
#line 189 "../core/Media.vala"
				_tmp77_ = g_markup_escape_text (_tmp76_, (gssize) -1);
#line 189 "../core/Media.vala"
				_tmp78_ = _tmp77_;
#line 189 "../core/Media.vala"
				_tmp79_ = g_strconcat ("<b>", _tmp78_, NULL);
#line 189 "../core/Media.vala"
				_tmp80_ = _tmp79_;
#line 189 "../core/Media.vala"
				_tmp81_ = g_strconcat (_tmp80_, "</b>", NULL);
#line 189 "../core/Media.vala"
				_tmp82_ = _tmp81_;
#line 189 "../core/Media.vala"
				_tmp83_ = string_replace (_tmp74_, "$ALBUM", _tmp82_);
#line 189 "../core/Media.vala"
				_tmp84_ = _tmp83_;
#line 189 "../core/Media.vala"
				_g_free0 (_tmp82_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp80_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp78_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp74_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp72_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp70_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp68_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp66_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp64_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp62_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp60_);
#line 189 "../core/Media.vala"
				_g_free0 (_tmp58_);
#line 189 "../core/Media.vala"
				result = _tmp84_;
#line 189 "../core/Media.vala"
				return result;
#line 1166 "Media.c"
			}
		}
	}
}

MusicMedia*
music_media_construct (GType object_type,
                       const gchar* uri)
{
	MusicMedia * self = NULL;
#line 193 "../core/Media.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 193 "../core/Media.vala"
	self = (MusicMedia*) g_object_new (object_type, NULL);
#line 194 "../core/Media.vala"
	music_media_set_uri (self, uri);
#line 193 "../core/Media.vala"
	return self;
#line 1185 "Media.c"
}

MusicMedia*
music_media_new (const gchar* uri)
{
#line 193 "../core/Media.vala"
	return music_media_construct (MUSIC_TYPE_MEDIA, uri);
#line 1193 "Media.c"
}

MusicMedia*
music_media_construct_from_file (GType object_type,
                                 GFile* file)
{
	MusicMedia * self = NULL;
#line 197 "../core/Media.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 197 "../core/Media.vala"
	self = (MusicMedia*) g_object_new (object_type, NULL);
#line 198 "../core/Media.vala"
	music_media_set_file (self, file);
#line 197 "../core/Media.vala"
	return self;
#line 1209 "Media.c"
}

MusicMedia*
music_media_new_from_file (GFile* file)
{
#line 197 "../core/Media.vala"
	return music_media_construct_from_file (MUSIC_TYPE_MEDIA, file);
#line 1217 "Media.c"
}

MusicMedia*
music_media_copy (MusicMedia* self)
{
	MusicMedia* rv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	guint64 _tmp5_;
	guint64 _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	guint _tmp57_;
	guint _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	GIcon* _tmp63_;
	GIcon* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	MusicMedia* result;
#line 201 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 202 "../core/Media.vala"
	_tmp0_ = music_media_get_uri (self);
#line 202 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 202 "../core/Media.vala"
	_tmp2_ = _tmp1_;
#line 202 "../core/Media.vala"
	_tmp3_ = music_media_new (_tmp2_);
#line 202 "../core/Media.vala"
	_tmp4_ = _tmp3_;
#line 202 "../core/Media.vala"
	_g_free0 (_tmp2_);
#line 202 "../core/Media.vala"
	rv = _tmp4_;
#line 204 "../core/Media.vala"
	_tmp5_ = music_media_get_file_size (self);
#line 204 "../core/Media.vala"
	_tmp6_ = _tmp5_;
#line 204 "../core/Media.vala"
	music_media_set_file_size (rv, _tmp6_);
#line 205 "../core/Media.vala"
	_tmp7_ = music_media_get_track (self);
#line 205 "../core/Media.vala"
	_tmp8_ = _tmp7_;
#line 205 "../core/Media.vala"
	music_media_set_track (rv, _tmp8_);
#line 206 "../core/Media.vala"
	_tmp9_ = music_media_get_track_count (self);
#line 206 "../core/Media.vala"
	_tmp10_ = _tmp9_;
#line 206 "../core/Media.vala"
	music_media_set_track_count (rv, _tmp10_);
#line 207 "../core/Media.vala"
	_tmp11_ = music_media_get_album_number (self);
#line 207 "../core/Media.vala"
	_tmp12_ = _tmp11_;
#line 207 "../core/Media.vala"
	music_media_set_album_number (rv, _tmp12_);
#line 208 "../core/Media.vala"
	_tmp13_ = music_media_get_album_count (self);
#line 208 "../core/Media.vala"
	_tmp14_ = _tmp13_;
#line 208 "../core/Media.vala"
	music_media_set_album_count (rv, _tmp14_);
#line 209 "../core/Media.vala"
	_tmp15_ = music_media_get_title (self);
#line 209 "../core/Media.vala"
	_tmp16_ = _tmp15_;
#line 209 "../core/Media.vala"
	music_media_set_title (rv, _tmp16_);
#line 210 "../core/Media.vala"
	_tmp17_ = music_media_get_artist (self);
#line 210 "../core/Media.vala"
	_tmp18_ = _tmp17_;
#line 210 "../core/Media.vala"
	music_media_set_artist (rv, _tmp18_);
#line 211 "../core/Media.vala"
	_tmp19_ = music_media_get_composer (self);
#line 211 "../core/Media.vala"
	_tmp20_ = _tmp19_;
#line 211 "../core/Media.vala"
	music_media_set_composer (rv, _tmp20_);
#line 212 "../core/Media.vala"
	_tmp21_ = music_media_get_album_artist (self);
#line 212 "../core/Media.vala"
	_tmp22_ = _tmp21_;
#line 212 "../core/Media.vala"
	music_media_set_album_artist (rv, _tmp22_);
#line 213 "../core/Media.vala"
	_tmp23_ = music_media_get_album (self);
#line 213 "../core/Media.vala"
	_tmp24_ = _tmp23_;
#line 213 "../core/Media.vala"
	music_media_set_album (rv, _tmp24_);
#line 214 "../core/Media.vala"
	_tmp25_ = music_media_get_genre (self);
#line 214 "../core/Media.vala"
	_tmp26_ = _tmp25_;
#line 214 "../core/Media.vala"
	music_media_set_genre (rv, _tmp26_);
#line 215 "../core/Media.vala"
	_tmp27_ = music_media_get_grouping (self);
#line 215 "../core/Media.vala"
	_tmp28_ = _tmp27_;
#line 215 "../core/Media.vala"
	music_media_set_grouping (rv, _tmp28_);
#line 216 "../core/Media.vala"
	_tmp29_ = music_media_get_comment (self);
#line 216 "../core/Media.vala"
	_tmp30_ = _tmp29_;
#line 216 "../core/Media.vala"
	music_media_set_comment (rv, _tmp30_);
#line 217 "../core/Media.vala"
	_tmp31_ = music_media_get_year (self);
#line 217 "../core/Media.vala"
	_tmp32_ = _tmp31_;
#line 217 "../core/Media.vala"
	music_media_set_year (rv, _tmp32_);
#line 218 "../core/Media.vala"
	_tmp33_ = music_media_get_bitrate (self);
#line 218 "../core/Media.vala"
	_tmp34_ = _tmp33_;
#line 218 "../core/Media.vala"
	music_media_set_bitrate (rv, _tmp34_);
#line 219 "../core/Media.vala"
	_tmp35_ = music_media_get_length (self);
#line 219 "../core/Media.vala"
	_tmp36_ = _tmp35_;
#line 219 "../core/Media.vala"
	music_media_set_length (rv, _tmp36_);
#line 220 "../core/Media.vala"
	_tmp37_ = music_media_get_samplerate (self);
#line 220 "../core/Media.vala"
	_tmp38_ = _tmp37_;
#line 220 "../core/Media.vala"
	music_media_set_samplerate (rv, _tmp38_);
#line 221 "../core/Media.vala"
	_tmp39_ = music_media_get_bpm (self);
#line 221 "../core/Media.vala"
	_tmp40_ = _tmp39_;
#line 221 "../core/Media.vala"
	music_media_set_bpm (rv, _tmp40_);
#line 222 "../core/Media.vala"
	_tmp41_ = music_media_get_rating (self);
#line 222 "../core/Media.vala"
	_tmp42_ = _tmp41_;
#line 222 "../core/Media.vala"
	music_media_set_rating (rv, _tmp42_);
#line 223 "../core/Media.vala"
	_tmp43_ = music_media_get_play_count (self);
#line 223 "../core/Media.vala"
	_tmp44_ = _tmp43_;
#line 223 "../core/Media.vala"
	music_media_set_play_count (rv, _tmp44_);
#line 224 "../core/Media.vala"
	_tmp45_ = music_media_get_skip_count (self);
#line 224 "../core/Media.vala"
	_tmp46_ = _tmp45_;
#line 224 "../core/Media.vala"
	music_media_set_skip_count (rv, _tmp46_);
#line 225 "../core/Media.vala"
	_tmp47_ = music_media_get_date_added (self);
#line 225 "../core/Media.vala"
	_tmp48_ = _tmp47_;
#line 225 "../core/Media.vala"
	music_media_set_date_added (rv, _tmp48_);
#line 226 "../core/Media.vala"
	_tmp49_ = music_media_get_last_played (self);
#line 226 "../core/Media.vala"
	_tmp50_ = _tmp49_;
#line 226 "../core/Media.vala"
	music_media_set_last_played (rv, _tmp50_);
#line 227 "../core/Media.vala"
	_tmp51_ = music_media_get_lyrics (self);
#line 227 "../core/Media.vala"
	_tmp52_ = _tmp51_;
#line 227 "../core/Media.vala"
	music_media_set_lyrics (rv, _tmp52_);
#line 228 "../core/Media.vala"
	_tmp53_ = music_media_get_is_preview (self);
#line 228 "../core/Media.vala"
	_tmp54_ = _tmp53_;
#line 228 "../core/Media.vala"
	music_media_set_is_preview (rv, _tmp54_);
#line 229 "../core/Media.vala"
	_tmp55_ = music_media_get_is_temporary (self);
#line 229 "../core/Media.vala"
	_tmp56_ = _tmp55_;
#line 229 "../core/Media.vala"
	music_media_set_is_temporary (rv, _tmp56_);
#line 230 "../core/Media.vala"
	_tmp57_ = music_media_get_last_modified (self);
#line 230 "../core/Media.vala"
	_tmp58_ = _tmp57_;
#line 230 "../core/Media.vala"
	music_media_set_last_modified (rv, _tmp58_);
#line 231 "../core/Media.vala"
	_tmp59_ = music_media_get_show (self);
#line 231 "../core/Media.vala"
	_tmp60_ = _tmp59_;
#line 231 "../core/Media.vala"
	music_media_set_show (rv, _tmp60_);
#line 232 "../core/Media.vala"
	_tmp61_ = music_media_get_show_indicator (self);
#line 232 "../core/Media.vala"
	_tmp62_ = _tmp61_;
#line 232 "../core/Media.vala"
	music_media_set_show_indicator (rv, _tmp62_);
#line 233 "../core/Media.vala"
	_tmp63_ = music_media_get_unique_status_image (self);
#line 233 "../core/Media.vala"
	_tmp64_ = _tmp63_;
#line 233 "../core/Media.vala"
	music_media_set_unique_status_image (rv, _tmp64_);
#line 234 "../core/Media.vala"
	_tmp65_ = music_media_get_location_unknown (self);
#line 234 "../core/Media.vala"
	_tmp66_ = _tmp65_;
#line 234 "../core/Media.vala"
	music_media_set_location_unknown (rv, _tmp66_);
#line 236 "../core/Media.vala"
	result = rv;
#line 236 "../core/Media.vala"
	return result;
#line 1498 "Media.c"
}

gint64
music_media_get_rowid (MusicMedia* self)
{
	gint64 result;
#line 35 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 35 "../core/Media.vala"
	result = self->priv->_rowid;
#line 35 "../core/Media.vala"
	return result;
#line 1511 "Media.c"
}

void
music_media_set_rowid (MusicMedia* self,
                       gint64 value)
{
	gint64 old_value;
#line 35 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 35 "../core/Media.vala"
	old_value = music_media_get_rowid (self);
#line 35 "../core/Media.vala"
	if (old_value != value) {
#line 35 "../core/Media.vala"
		self->priv->_rowid = value;
#line 35 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ROWID_PROPERTY]);
#line 1529 "Media.c"
	}
}

gchar*
music_media_get_uri (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 38 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 38 "../core/Media.vala"
	if (_klass_->get_uri) {
#line 38 "../core/Media.vala"
		return _klass_->get_uri (self);
#line 1545 "Media.c"
	}
#line 38 "../core/Media.vala"
	return NULL;
#line 1549 "Media.c"
}

static gchar*
music_media_real_get_uri (MusicMedia* base)
{
	gchar* result;
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
#line 38 "../core/Media.vala"
	self = base;
#line 38 "../core/Media.vala"
	_tmp0_ = music_media_get_file (self);
#line 38 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 38 "../core/Media.vala"
	_tmp2_ = g_file_get_uri (_tmp1_);
#line 38 "../core/Media.vala"
	result = _tmp2_;
#line 38 "../core/Media.vala"
	return result;
#line 1572 "Media.c"
}

void
music_media_set_uri (MusicMedia* self,
                     const gchar* value)
{
	MusicMediaClass* _klass_;
#line 39 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 39 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 39 "../core/Media.vala"
	if (_klass_->set_uri) {
#line 39 "../core/Media.vala"
		_klass_->set_uri (self, value);
#line 1588 "Media.c"
	}
}

static void
music_media_real_set_uri (MusicMedia* base,
                          const gchar* value)
{
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 39 "../core/Media.vala"
	self = base;
#line 39 "../core/Media.vala"
	_tmp0_ = g_file_new_for_uri (value);
#line 39 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 39 "../core/Media.vala"
	music_media_set_file (self, _tmp1_);
#line 39 "../core/Media.vala"
	_g_object_unref0 (_tmp1_);
#line 39 "../core/Media.vala"
	g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_URI_PROPERTY]);
#line 1611 "Media.c"
}

guint64
music_media_get_file_size (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 42 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 42 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 42 "../core/Media.vala"
	if (_klass_->get_file_size) {
#line 42 "../core/Media.vala"
		return _klass_->get_file_size (self);
#line 1626 "Media.c"
	}
#line 42 "../core/Media.vala"
	return 0ULL;
#line 1630 "Media.c"
}

static guint64
music_media_real_get_file_size (MusicMedia* base)
{
	guint64 result;
	MusicMedia* self;
#line 42 "../core/Media.vala"
	self = base;
#line 42 "../core/Media.vala"
	result = self->priv->_file_size;
#line 42 "../core/Media.vala"
	return result;
#line 1644 "Media.c"
}

void
music_media_set_file_size (MusicMedia* self,
                           guint64 value)
{
	MusicMediaClass* _klass_;
#line 42 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 42 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 42 "../core/Media.vala"
	if (_klass_->set_file_size) {
#line 42 "../core/Media.vala"
		_klass_->set_file_size (self, value);
#line 1660 "Media.c"
	}
}

static void
music_media_real_set_file_size (MusicMedia* base,
                                guint64 value)
{
	MusicMedia* self;
	guint64 old_value;
#line 42 "../core/Media.vala"
	self = base;
#line 42 "../core/Media.vala"
	old_value = music_media_real_get_file_size (base);
#line 42 "../core/Media.vala"
	if (old_value != value) {
#line 42 "../core/Media.vala"
		self->priv->_file_size = value;
#line 42 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_FILE_SIZE_PROPERTY]);
#line 1680 "Media.c"
	}
}

gboolean
music_media_get_file_exists (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 43 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 43 "../core/Media.vala"
	if (_klass_->get_file_exists) {
#line 43 "../core/Media.vala"
		return _klass_->get_file_exists (self);
#line 1696 "Media.c"
	}
#line 43 "../core/Media.vala"
	return FALSE;
#line 1700 "Media.c"
}

static gboolean
music_media_real_get_file_exists (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 43 "../core/Media.vala"
	self = base;
#line 43 "../core/Media.vala"
	_tmp0_ = music_media_get_file (self);
#line 43 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 43 "../core/Media.vala"
	result = g_file_query_exists (_tmp1_, NULL);
#line 43 "../core/Media.vala"
	return result;
#line 1720 "Media.c"
}

GFile*
music_media_get_file (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 45 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 45 "../core/Media.vala"
	if (_klass_->get_file) {
#line 45 "../core/Media.vala"
		return _klass_->get_file (self);
#line 1735 "Media.c"
	}
#line 45 "../core/Media.vala"
	return NULL;
#line 1739 "Media.c"
}

static GFile*
music_media_real_get_file (MusicMedia* base)
{
	GFile* result;
	MusicMedia* self;
	GFile* _tmp0_;
#line 45 "../core/Media.vala"
	self = base;
#line 45 "../core/Media.vala"
	_tmp0_ = self->priv->_file;
#line 45 "../core/Media.vala"
	result = _tmp0_;
#line 45 "../core/Media.vala"
	return result;
#line 1756 "Media.c"
}

void
music_media_set_file (MusicMedia* self,
                      GFile* value)
{
	MusicMediaClass* _klass_;
#line 45 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 45 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 45 "../core/Media.vala"
	if (_klass_->set_file) {
#line 45 "../core/Media.vala"
		_klass_->set_file (self, value);
#line 1772 "Media.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../core/Media.vala"
	return self ? g_object_ref (self) : NULL;
#line 1781 "Media.c"
}

static void
music_media_real_set_file (MusicMedia* base,
                           GFile* value)
{
	MusicMedia* self;
	GFile* old_value;
#line 45 "../core/Media.vala"
	self = base;
#line 45 "../core/Media.vala"
	old_value = music_media_real_get_file (base);
#line 45 "../core/Media.vala"
	if (old_value != value) {
#line 1796 "Media.c"
		GFile* _tmp0_;
#line 45 "../core/Media.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../core/Media.vala"
		_g_object_unref0 (self->priv->_file);
#line 45 "../core/Media.vala"
		self->priv->_file = _tmp0_;
#line 45 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_FILE_PROPERTY]);
#line 1806 "Media.c"
	}
}

gboolean
music_media_get_is_preview (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 47 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 47 "../core/Media.vala"
	if (_klass_->get_is_preview) {
#line 47 "../core/Media.vala"
		return _klass_->get_is_preview (self);
#line 1822 "Media.c"
	}
#line 47 "../core/Media.vala"
	return FALSE;
#line 1826 "Media.c"
}

static gboolean
music_media_real_get_is_preview (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 47 "../core/Media.vala"
	self = base;
#line 47 "../core/Media.vala"
	result = self->priv->_is_preview;
#line 47 "../core/Media.vala"
	return result;
#line 1840 "Media.c"
}

void
music_media_set_is_preview (MusicMedia* self,
                            gboolean value)
{
	MusicMediaClass* _klass_;
#line 47 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 47 "../core/Media.vala"
	if (_klass_->set_is_preview) {
#line 47 "../core/Media.vala"
		_klass_->set_is_preview (self, value);
#line 1856 "Media.c"
	}
}

static void
music_media_real_set_is_preview (MusicMedia* base,
                                 gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 47 "../core/Media.vala"
	self = base;
#line 47 "../core/Media.vala"
	old_value = music_media_real_get_is_preview (base);
#line 47 "../core/Media.vala"
	if (old_value != value) {
#line 47 "../core/Media.vala"
		self->priv->_is_preview = value;
#line 47 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_IS_PREVIEW_PROPERTY]);
#line 1876 "Media.c"
	}
}

gboolean
music_media_get_is_temporary (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 48 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 48 "../core/Media.vala"
	if (_klass_->get_is_temporary) {
#line 48 "../core/Media.vala"
		return _klass_->get_is_temporary (self);
#line 1892 "Media.c"
	}
#line 48 "../core/Media.vala"
	return FALSE;
#line 1896 "Media.c"
}

static gboolean
music_media_real_get_is_temporary (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 48 "../core/Media.vala"
	self = base;
#line 48 "../core/Media.vala"
	result = self->priv->_is_temporary;
#line 48 "../core/Media.vala"
	return result;
#line 1910 "Media.c"
}

void
music_media_set_is_temporary (MusicMedia* self,
                              gboolean value)
{
	MusicMediaClass* _klass_;
#line 48 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 48 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 48 "../core/Media.vala"
	if (_klass_->set_is_temporary) {
#line 48 "../core/Media.vala"
		_klass_->set_is_temporary (self, value);
#line 1926 "Media.c"
	}
}

static void
music_media_real_set_is_temporary (MusicMedia* base,
                                   gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 48 "../core/Media.vala"
	self = base;
#line 48 "../core/Media.vala"
	old_value = music_media_real_get_is_temporary (base);
#line 48 "../core/Media.vala"
	if (old_value != value) {
#line 48 "../core/Media.vala"
		self->priv->_is_temporary = value;
#line 48 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_IS_TEMPORARY_PROPERTY]);
#line 1946 "Media.c"
	}
}

gboolean
music_media_get_location_unknown (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 51 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 51 "../core/Media.vala"
	if (_klass_->get_location_unknown) {
#line 51 "../core/Media.vala"
		return _klass_->get_location_unknown (self);
#line 1962 "Media.c"
	}
#line 51 "../core/Media.vala"
	return FALSE;
#line 1966 "Media.c"
}

static gboolean
music_media_real_get_location_unknown (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 51 "../core/Media.vala"
	self = base;
#line 51 "../core/Media.vala"
	result = self->priv->_location_unknown;
#line 51 "../core/Media.vala"
	return result;
#line 1980 "Media.c"
}

void
music_media_set_location_unknown (MusicMedia* self,
                                  gboolean value)
{
	MusicMediaClass* _klass_;
#line 51 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 51 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 51 "../core/Media.vala"
	if (_klass_->set_location_unknown) {
#line 51 "../core/Media.vala"
		_klass_->set_location_unknown (self, value);
#line 1996 "Media.c"
	}
}

static void
music_media_real_set_location_unknown (MusicMedia* base,
                                       gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 51 "../core/Media.vala"
	self = base;
#line 51 "../core/Media.vala"
	old_value = music_media_real_get_location_unknown (base);
#line 51 "../core/Media.vala"
	if (old_value != value) {
#line 51 "../core/Media.vala"
		self->priv->_location_unknown = value;
#line 51 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY]);
#line 2016 "Media.c"
	}
}

gboolean
music_media_get_has_embedded (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 52 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 52 "../core/Media.vala"
	if (_klass_->get_has_embedded) {
#line 52 "../core/Media.vala"
		return _klass_->get_has_embedded (self);
#line 2032 "Media.c"
	}
#line 52 "../core/Media.vala"
	return FALSE;
#line 2036 "Media.c"
}

static gboolean
music_media_real_get_has_embedded (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 52 "../core/Media.vala"
	self = base;
#line 52 "../core/Media.vala"
	result = self->priv->_has_embedded;
#line 52 "../core/Media.vala"
	return result;
#line 2050 "Media.c"
}

void
music_media_set_has_embedded (MusicMedia* self,
                              gboolean value)
{
	MusicMediaClass* _klass_;
#line 52 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 52 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 52 "../core/Media.vala"
	if (_klass_->set_has_embedded) {
#line 52 "../core/Media.vala"
		_klass_->set_has_embedded (self, value);
#line 2066 "Media.c"
	}
}

static void
music_media_real_set_has_embedded (MusicMedia* base,
                                   gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 52 "../core/Media.vala"
	self = base;
#line 52 "../core/Media.vala"
	old_value = music_media_real_get_has_embedded (base);
#line 52 "../core/Media.vala"
	if (old_value != value) {
#line 52 "../core/Media.vala"
		self->priv->_has_embedded = value;
#line 52 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY]);
#line 2086 "Media.c"
	}
}

GIcon*
music_media_get_unique_status_image (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 56 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 56 "../core/Media.vala"
	if (_klass_->get_unique_status_image) {
#line 56 "../core/Media.vala"
		return _klass_->get_unique_status_image (self);
#line 2102 "Media.c"
	}
#line 56 "../core/Media.vala"
	return NULL;
#line 2106 "Media.c"
}

static GIcon*
music_media_real_get_unique_status_image (MusicMedia* base)
{
	GIcon* result;
	MusicMedia* self;
	GIcon* _tmp0_;
#line 56 "../core/Media.vala"
	self = base;
#line 56 "../core/Media.vala"
	_tmp0_ = self->priv->_unique_status_image;
#line 56 "../core/Media.vala"
	result = _tmp0_;
#line 56 "../core/Media.vala"
	return result;
#line 2123 "Media.c"
}

void
music_media_set_unique_status_image (MusicMedia* self,
                                     GIcon* value)
{
	MusicMediaClass* _klass_;
#line 56 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 56 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 56 "../core/Media.vala"
	if (_klass_->set_unique_status_image) {
#line 56 "../core/Media.vala"
		_klass_->set_unique_status_image (self, value);
#line 2139 "Media.c"
	}
}

static void
music_media_real_set_unique_status_image (MusicMedia* base,
                                          GIcon* value)
{
	MusicMedia* self;
	GIcon* old_value;
#line 56 "../core/Media.vala"
	self = base;
#line 56 "../core/Media.vala"
	old_value = music_media_real_get_unique_status_image (base);
#line 56 "../core/Media.vala"
	if (old_value != value) {
#line 2155 "Media.c"
		GIcon* _tmp0_;
#line 56 "../core/Media.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../core/Media.vala"
		_g_object_unref0 (self->priv->_unique_status_image);
#line 56 "../core/Media.vala"
		self->priv->_unique_status_image = _tmp0_;
#line 56 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY]);
#line 2165 "Media.c"
	}
}

gboolean
music_media_get_show_indicator (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 57 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 57 "../core/Media.vala"
	if (_klass_->get_show_indicator) {
#line 57 "../core/Media.vala"
		return _klass_->get_show_indicator (self);
#line 2181 "Media.c"
	}
#line 57 "../core/Media.vala"
	return FALSE;
#line 2185 "Media.c"
}

static gboolean
music_media_real_get_show_indicator (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 57 "../core/Media.vala"
	self = base;
#line 57 "../core/Media.vala"
	result = self->priv->_show_indicator;
#line 57 "../core/Media.vala"
	return result;
#line 2199 "Media.c"
}

void
music_media_set_show_indicator (MusicMedia* self,
                                gboolean value)
{
	MusicMediaClass* _klass_;
#line 57 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 57 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 57 "../core/Media.vala"
	if (_klass_->set_show_indicator) {
#line 57 "../core/Media.vala"
		_klass_->set_show_indicator (self, value);
#line 2215 "Media.c"
	}
}

static void
music_media_real_set_show_indicator (MusicMedia* base,
                                     gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 57 "../core/Media.vala"
	self = base;
#line 57 "../core/Media.vala"
	old_value = music_media_real_get_show_indicator (base);
#line 57 "../core/Media.vala"
	if (old_value != value) {
#line 57 "../core/Media.vala"
		self->priv->_show_indicator = value;
#line 57 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY]);
#line 2235 "Media.c"
	}
}

const gchar*
music_media_get_title (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 62 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 62 "../core/Media.vala"
	if (_klass_->get_title) {
#line 62 "../core/Media.vala"
		return _klass_->get_title (self);
#line 2251 "Media.c"
	}
#line 62 "../core/Media.vala"
	return NULL;
#line 2255 "Media.c"
}

static const gchar*
music_media_real_get_title (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 62 "../core/Media.vala"
	self = base;
#line 62 "../core/Media.vala"
	_tmp0_ = self->priv->_title;
#line 62 "../core/Media.vala"
	result = _tmp0_;
#line 62 "../core/Media.vala"
	return result;
#line 2272 "Media.c"
}

void
music_media_set_title (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
#line 62 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 62 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 62 "../core/Media.vala"
	if (_klass_->set_title) {
#line 62 "../core/Media.vala"
		_klass_->set_title (self, value);
#line 2288 "Media.c"
	}
}

static void
music_media_real_set_title (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 62 "../core/Media.vala"
	self = base;
#line 62 "../core/Media.vala"
	old_value = music_media_real_get_title (base);
#line 62 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2304 "Media.c"
		gchar* _tmp0_;
#line 62 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../core/Media.vala"
		_g_free0 (self->priv->_title);
#line 62 "../core/Media.vala"
		self->priv->_title = _tmp0_;
#line 62 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TITLE_PROPERTY]);
#line 2314 "Media.c"
	}
}

guint
music_media_get_track (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 63 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 63 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 63 "../core/Media.vala"
	if (_klass_->get_track) {
#line 63 "../core/Media.vala"
		return _klass_->get_track (self);
#line 2330 "Media.c"
	}
#line 63 "../core/Media.vala"
	return 0U;
#line 2334 "Media.c"
}

static guint
music_media_real_get_track (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 63 "../core/Media.vala"
	self = base;
#line 63 "../core/Media.vala"
	result = self->priv->_track;
#line 63 "../core/Media.vala"
	return result;
#line 2348 "Media.c"
}

void
music_media_set_track (MusicMedia* self,
                       guint value)
{
	MusicMediaClass* _klass_;
#line 63 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 63 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 63 "../core/Media.vala"
	if (_klass_->set_track) {
#line 63 "../core/Media.vala"
		_klass_->set_track (self, value);
#line 2364 "Media.c"
	}
}

static void
music_media_real_set_track (MusicMedia* base,
                            guint value)
{
	MusicMedia* self;
	guint old_value;
#line 63 "../core/Media.vala"
	self = base;
#line 63 "../core/Media.vala"
	old_value = music_media_real_get_track (base);
#line 63 "../core/Media.vala"
	if (old_value != value) {
#line 63 "../core/Media.vala"
		self->priv->_track = value;
#line 63 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TRACK_PROPERTY]);
#line 2384 "Media.c"
	}
}

guint
music_media_get_track_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 64 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 64 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 64 "../core/Media.vala"
	if (_klass_->get_track_count) {
#line 64 "../core/Media.vala"
		return _klass_->get_track_count (self);
#line 2400 "Media.c"
	}
#line 64 "../core/Media.vala"
	return 0U;
#line 2404 "Media.c"
}

static guint
music_media_real_get_track_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 64 "../core/Media.vala"
	self = base;
#line 64 "../core/Media.vala"
	result = self->priv->_track_count;
#line 64 "../core/Media.vala"
	return result;
#line 2418 "Media.c"
}

void
music_media_set_track_count (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
#line 64 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 64 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 64 "../core/Media.vala"
	if (_klass_->set_track_count) {
#line 64 "../core/Media.vala"
		_klass_->set_track_count (self, value);
#line 2434 "Media.c"
	}
}

static void
music_media_real_set_track_count (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
#line 64 "../core/Media.vala"
	self = base;
#line 64 "../core/Media.vala"
	old_value = music_media_real_get_track_count (base);
#line 64 "../core/Media.vala"
	if (old_value != value) {
#line 64 "../core/Media.vala"
		self->priv->_track_count = value;
#line 64 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TRACK_COUNT_PROPERTY]);
#line 2454 "Media.c"
	}
}

const gchar*
music_media_get_composer (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 65 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 65 "../core/Media.vala"
	if (_klass_->get_composer) {
#line 65 "../core/Media.vala"
		return _klass_->get_composer (self);
#line 2470 "Media.c"
	}
#line 65 "../core/Media.vala"
	return NULL;
#line 2474 "Media.c"
}

static const gchar*
music_media_real_get_composer (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 65 "../core/Media.vala"
	self = base;
#line 65 "../core/Media.vala"
	_tmp0_ = self->priv->_composer;
#line 65 "../core/Media.vala"
	result = _tmp0_;
#line 65 "../core/Media.vala"
	return result;
#line 2491 "Media.c"
}

void
music_media_set_composer (MusicMedia* self,
                          const gchar* value)
{
	MusicMediaClass* _klass_;
#line 65 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 65 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 65 "../core/Media.vala"
	if (_klass_->set_composer) {
#line 65 "../core/Media.vala"
		_klass_->set_composer (self, value);
#line 2507 "Media.c"
	}
}

static void
music_media_real_set_composer (MusicMedia* base,
                               const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 65 "../core/Media.vala"
	self = base;
#line 65 "../core/Media.vala"
	old_value = music_media_real_get_composer (base);
#line 65 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2523 "Media.c"
		gchar* _tmp0_;
#line 65 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 65 "../core/Media.vala"
		_g_free0 (self->priv->_composer);
#line 65 "../core/Media.vala"
		self->priv->_composer = _tmp0_;
#line 65 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_COMPOSER_PROPERTY]);
#line 2533 "Media.c"
	}
}

const gchar*
music_media_get_artist (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 66 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 66 "../core/Media.vala"
	if (_klass_->get_artist) {
#line 66 "../core/Media.vala"
		return _klass_->get_artist (self);
#line 2549 "Media.c"
	}
#line 66 "../core/Media.vala"
	return NULL;
#line 2553 "Media.c"
}

static const gchar*
music_media_real_get_artist (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 66 "../core/Media.vala"
	self = base;
#line 66 "../core/Media.vala"
	_tmp0_ = self->priv->_artist;
#line 66 "../core/Media.vala"
	result = _tmp0_;
#line 66 "../core/Media.vala"
	return result;
#line 2570 "Media.c"
}

void
music_media_set_artist (MusicMedia* self,
                        const gchar* value)
{
	MusicMediaClass* _klass_;
#line 66 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 66 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 66 "../core/Media.vala"
	if (_klass_->set_artist) {
#line 66 "../core/Media.vala"
		_klass_->set_artist (self, value);
#line 2586 "Media.c"
	}
}

static void
music_media_real_set_artist (MusicMedia* base,
                             const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 66 "../core/Media.vala"
	self = base;
#line 66 "../core/Media.vala"
	old_value = music_media_real_get_artist (base);
#line 66 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2602 "Media.c"
		gchar* _tmp0_;
#line 66 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 66 "../core/Media.vala"
		_g_free0 (self->priv->_artist);
#line 66 "../core/Media.vala"
		self->priv->_artist = _tmp0_;
#line 66 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ARTIST_PROPERTY]);
#line 2612 "Media.c"
	}
}

const gchar*
music_media_get_album_artist (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 67 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 67 "../core/Media.vala"
	if (_klass_->get_album_artist) {
#line 67 "../core/Media.vala"
		return _klass_->get_album_artist (self);
#line 2628 "Media.c"
	}
#line 67 "../core/Media.vala"
	return NULL;
#line 2632 "Media.c"
}

static const gchar*
music_media_real_get_album_artist (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 67 "../core/Media.vala"
	self = base;
#line 67 "../core/Media.vala"
	_tmp0_ = self->priv->_album_artist;
#line 67 "../core/Media.vala"
	result = _tmp0_;
#line 67 "../core/Media.vala"
	return result;
#line 2649 "Media.c"
}

void
music_media_set_album_artist (MusicMedia* self,
                              const gchar* value)
{
	MusicMediaClass* _klass_;
#line 67 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 67 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 67 "../core/Media.vala"
	if (_klass_->set_album_artist) {
#line 67 "../core/Media.vala"
		_klass_->set_album_artist (self, value);
#line 2665 "Media.c"
	}
}

static void
music_media_real_set_album_artist (MusicMedia* base,
                                   const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 67 "../core/Media.vala"
	self = base;
#line 67 "../core/Media.vala"
	old_value = music_media_real_get_album_artist (base);
#line 67 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2681 "Media.c"
		gchar* _tmp0_;
#line 67 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 67 "../core/Media.vala"
		_g_free0 (self->priv->_album_artist);
#line 67 "../core/Media.vala"
		self->priv->_album_artist = _tmp0_;
#line 67 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY]);
#line 2691 "Media.c"
	}
}

const gchar*
music_media_get_album (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 68 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 68 "../core/Media.vala"
	if (_klass_->get_album) {
#line 68 "../core/Media.vala"
		return _klass_->get_album (self);
#line 2707 "Media.c"
	}
#line 68 "../core/Media.vala"
	return NULL;
#line 2711 "Media.c"
}

static const gchar*
music_media_real_get_album (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 68 "../core/Media.vala"
	self = base;
#line 68 "../core/Media.vala"
	_tmp0_ = self->priv->_album;
#line 68 "../core/Media.vala"
	result = _tmp0_;
#line 68 "../core/Media.vala"
	return result;
#line 2728 "Media.c"
}

void
music_media_set_album (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
#line 68 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 68 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 68 "../core/Media.vala"
	if (_klass_->set_album) {
#line 68 "../core/Media.vala"
		_klass_->set_album (self, value);
#line 2744 "Media.c"
	}
}

static void
music_media_real_set_album (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 68 "../core/Media.vala"
	self = base;
#line 68 "../core/Media.vala"
	old_value = music_media_real_get_album (base);
#line 68 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2760 "Media.c"
		gchar* _tmp0_;
#line 68 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 68 "../core/Media.vala"
		_g_free0 (self->priv->_album);
#line 68 "../core/Media.vala"
		self->priv->_album = _tmp0_;
#line 68 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_PROPERTY]);
#line 2770 "Media.c"
	}
}

guint
music_media_get_album_number (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 69 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 69 "../core/Media.vala"
	if (_klass_->get_album_number) {
#line 69 "../core/Media.vala"
		return _klass_->get_album_number (self);
#line 2786 "Media.c"
	}
#line 69 "../core/Media.vala"
	return 0U;
#line 2790 "Media.c"
}

static guint
music_media_real_get_album_number (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 69 "../core/Media.vala"
	self = base;
#line 69 "../core/Media.vala"
	result = self->priv->_album_number;
#line 69 "../core/Media.vala"
	return result;
#line 2804 "Media.c"
}

void
music_media_set_album_number (MusicMedia* self,
                              guint value)
{
	MusicMediaClass* _klass_;
#line 69 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 69 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 69 "../core/Media.vala"
	if (_klass_->set_album_number) {
#line 69 "../core/Media.vala"
		_klass_->set_album_number (self, value);
#line 2820 "Media.c"
	}
}

static void
music_media_real_set_album_number (MusicMedia* base,
                                   guint value)
{
	MusicMedia* self;
	guint old_value;
#line 69 "../core/Media.vala"
	self = base;
#line 69 "../core/Media.vala"
	old_value = music_media_real_get_album_number (base);
#line 69 "../core/Media.vala"
	if (old_value != value) {
#line 69 "../core/Media.vala"
		self->priv->_album_number = value;
#line 69 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY]);
#line 2840 "Media.c"
	}
}

guint
music_media_get_album_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 70 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 70 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 70 "../core/Media.vala"
	if (_klass_->get_album_count) {
#line 70 "../core/Media.vala"
		return _klass_->get_album_count (self);
#line 2856 "Media.c"
	}
#line 70 "../core/Media.vala"
	return 0U;
#line 2860 "Media.c"
}

static guint
music_media_real_get_album_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 70 "../core/Media.vala"
	self = base;
#line 70 "../core/Media.vala"
	result = self->priv->_album_count;
#line 70 "../core/Media.vala"
	return result;
#line 2874 "Media.c"
}

void
music_media_set_album_count (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
#line 70 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 70 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 70 "../core/Media.vala"
	if (_klass_->set_album_count) {
#line 70 "../core/Media.vala"
		_klass_->set_album_count (self, value);
#line 2890 "Media.c"
	}
}

static void
music_media_real_set_album_count (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
#line 70 "../core/Media.vala"
	self = base;
#line 70 "../core/Media.vala"
	old_value = music_media_real_get_album_count (base);
#line 70 "../core/Media.vala"
	if (old_value != value) {
#line 70 "../core/Media.vala"
		self->priv->_album_count = value;
#line 70 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_COUNT_PROPERTY]);
#line 2910 "Media.c"
	}
}

MusicAlbum*
music_media_get_album_info (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 71 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 71 "../core/Media.vala"
	if (_klass_->get_album_info) {
#line 71 "../core/Media.vala"
		return _klass_->get_album_info (self);
#line 2926 "Media.c"
	}
#line 71 "../core/Media.vala"
	return NULL;
#line 2930 "Media.c"
}

static MusicAlbum*
music_media_real_get_album_info (MusicMedia* base)
{
	MusicAlbum* result;
	MusicMedia* self;
	MusicAlbum* _tmp0_;
#line 71 "../core/Media.vala"
	self = base;
#line 71 "../core/Media.vala"
	_tmp0_ = self->priv->_album_info;
#line 71 "../core/Media.vala"
	result = _tmp0_;
#line 71 "../core/Media.vala"
	return result;
#line 2947 "Media.c"
}

void
music_media_set_album_info (MusicMedia* self,
                            MusicAlbum* value)
{
	MusicMediaClass* _klass_;
#line 71 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 71 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 71 "../core/Media.vala"
	if (_klass_->set_album_info) {
#line 71 "../core/Media.vala"
		_klass_->set_album_info (self, value);
#line 2963 "Media.c"
	}
}

static void
music_media_real_set_album_info (MusicMedia* base,
                                 MusicAlbum* value)
{
	MusicMedia* self;
	MusicAlbum* old_value;
#line 71 "../core/Media.vala"
	self = base;
#line 71 "../core/Media.vala"
	old_value = music_media_real_get_album_info (base);
#line 71 "../core/Media.vala"
	if (old_value != value) {
#line 71 "../core/Media.vala"
		self->priv->_album_info = value;
#line 71 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_INFO_PROPERTY]);
#line 2983 "Media.c"
	}
}

const gchar*
music_media_get_grouping (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 72 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 72 "../core/Media.vala"
	if (_klass_->get_grouping) {
#line 72 "../core/Media.vala"
		return _klass_->get_grouping (self);
#line 2999 "Media.c"
	}
#line 72 "../core/Media.vala"
	return NULL;
#line 3003 "Media.c"
}

static const gchar*
music_media_real_get_grouping (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 72 "../core/Media.vala"
	self = base;
#line 72 "../core/Media.vala"
	_tmp0_ = self->priv->_grouping;
#line 72 "../core/Media.vala"
	result = _tmp0_;
#line 72 "../core/Media.vala"
	return result;
#line 3020 "Media.c"
}

void
music_media_set_grouping (MusicMedia* self,
                          const gchar* value)
{
	MusicMediaClass* _klass_;
#line 72 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 72 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 72 "../core/Media.vala"
	if (_klass_->set_grouping) {
#line 72 "../core/Media.vala"
		_klass_->set_grouping (self, value);
#line 3036 "Media.c"
	}
}

static void
music_media_real_set_grouping (MusicMedia* base,
                               const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 72 "../core/Media.vala"
	self = base;
#line 72 "../core/Media.vala"
	old_value = music_media_real_get_grouping (base);
#line 72 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3052 "Media.c"
		gchar* _tmp0_;
#line 72 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 72 "../core/Media.vala"
		_g_free0 (self->priv->_grouping);
#line 72 "../core/Media.vala"
		self->priv->_grouping = _tmp0_;
#line 72 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_GROUPING_PROPERTY]);
#line 3062 "Media.c"
	}
}

const gchar*
music_media_get_genre (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 73 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 73 "../core/Media.vala"
	if (_klass_->get_genre) {
#line 73 "../core/Media.vala"
		return _klass_->get_genre (self);
#line 3078 "Media.c"
	}
#line 73 "../core/Media.vala"
	return NULL;
#line 3082 "Media.c"
}

static const gchar*
music_media_real_get_genre (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 73 "../core/Media.vala"
	self = base;
#line 73 "../core/Media.vala"
	_tmp0_ = self->priv->_genre;
#line 73 "../core/Media.vala"
	result = _tmp0_;
#line 73 "../core/Media.vala"
	return result;
#line 3099 "Media.c"
}

void
music_media_set_genre (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
#line 73 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 73 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 73 "../core/Media.vala"
	if (_klass_->set_genre) {
#line 73 "../core/Media.vala"
		_klass_->set_genre (self, value);
#line 3115 "Media.c"
	}
}

static void
music_media_real_set_genre (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 73 "../core/Media.vala"
	self = base;
#line 73 "../core/Media.vala"
	old_value = music_media_real_get_genre (base);
#line 73 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3131 "Media.c"
		gchar* _tmp0_;
#line 73 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 73 "../core/Media.vala"
		_g_free0 (self->priv->_genre);
#line 73 "../core/Media.vala"
		self->priv->_genre = _tmp0_;
#line 73 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_GENRE_PROPERTY]);
#line 3141 "Media.c"
	}
}

const gchar*
music_media_get_comment (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 74 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 74 "../core/Media.vala"
	if (_klass_->get_comment) {
#line 74 "../core/Media.vala"
		return _klass_->get_comment (self);
#line 3157 "Media.c"
	}
#line 74 "../core/Media.vala"
	return NULL;
#line 3161 "Media.c"
}

static const gchar*
music_media_real_get_comment (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 74 "../core/Media.vala"
	self = base;
#line 74 "../core/Media.vala"
	_tmp0_ = self->priv->_comment;
#line 74 "../core/Media.vala"
	result = _tmp0_;
#line 74 "../core/Media.vala"
	return result;
#line 3178 "Media.c"
}

void
music_media_set_comment (MusicMedia* self,
                         const gchar* value)
{
	MusicMediaClass* _klass_;
#line 74 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 74 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 74 "../core/Media.vala"
	if (_klass_->set_comment) {
#line 74 "../core/Media.vala"
		_klass_->set_comment (self, value);
#line 3194 "Media.c"
	}
}

static void
music_media_real_set_comment (MusicMedia* base,
                              const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 74 "../core/Media.vala"
	self = base;
#line 74 "../core/Media.vala"
	old_value = music_media_real_get_comment (base);
#line 74 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3210 "Media.c"
		gchar* _tmp0_;
#line 74 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../core/Media.vala"
		_g_free0 (self->priv->_comment);
#line 74 "../core/Media.vala"
		self->priv->_comment = _tmp0_;
#line 74 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_COMMENT_PROPERTY]);
#line 3220 "Media.c"
	}
}

const gchar*
music_media_get_lyrics (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 75 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 75 "../core/Media.vala"
	if (_klass_->get_lyrics) {
#line 75 "../core/Media.vala"
		return _klass_->get_lyrics (self);
#line 3236 "Media.c"
	}
#line 75 "../core/Media.vala"
	return NULL;
#line 3240 "Media.c"
}

static const gchar*
music_media_real_get_lyrics (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
#line 75 "../core/Media.vala"
	self = base;
#line 75 "../core/Media.vala"
	_tmp0_ = self->priv->_lyrics;
#line 75 "../core/Media.vala"
	result = _tmp0_;
#line 75 "../core/Media.vala"
	return result;
#line 3257 "Media.c"
}

void
music_media_set_lyrics (MusicMedia* self,
                        const gchar* value)
{
	MusicMediaClass* _klass_;
#line 75 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 75 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 75 "../core/Media.vala"
	if (_klass_->set_lyrics) {
#line 75 "../core/Media.vala"
		_klass_->set_lyrics (self, value);
#line 3273 "Media.c"
	}
}

static void
music_media_real_set_lyrics (MusicMedia* base,
                             const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
#line 75 "../core/Media.vala"
	self = base;
#line 75 "../core/Media.vala"
	old_value = music_media_real_get_lyrics (base);
#line 75 "../core/Media.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3289 "Media.c"
		gchar* _tmp0_;
#line 75 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 75 "../core/Media.vala"
		_g_free0 (self->priv->_lyrics);
#line 75 "../core/Media.vala"
		self->priv->_lyrics = _tmp0_;
#line 75 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LYRICS_PROPERTY]);
#line 3299 "Media.c"
	}
}

guint
music_media_get_year (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 76 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 76 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 76 "../core/Media.vala"
	if (_klass_->get_year) {
#line 76 "../core/Media.vala"
		return _klass_->get_year (self);
#line 3315 "Media.c"
	}
#line 76 "../core/Media.vala"
	return 0U;
#line 3319 "Media.c"
}

static guint
music_media_real_get_year (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 76 "../core/Media.vala"
	self = base;
#line 76 "../core/Media.vala"
	result = self->priv->_year;
#line 76 "../core/Media.vala"
	return result;
#line 3333 "Media.c"
}

void
music_media_set_year (MusicMedia* self,
                      guint value)
{
	MusicMediaClass* _klass_;
#line 76 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 76 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 76 "../core/Media.vala"
	if (_klass_->set_year) {
#line 76 "../core/Media.vala"
		_klass_->set_year (self, value);
#line 3349 "Media.c"
	}
}

static void
music_media_real_set_year (MusicMedia* base,
                           guint value)
{
	MusicMedia* self;
	guint old_value;
#line 76 "../core/Media.vala"
	self = base;
#line 76 "../core/Media.vala"
	old_value = music_media_real_get_year (base);
#line 76 "../core/Media.vala"
	if (old_value != value) {
#line 76 "../core/Media.vala"
		self->priv->_year = value;
#line 76 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_YEAR_PROPERTY]);
#line 3369 "Media.c"
	}
}

guint
music_media_get_bitrate (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 77 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 77 "../core/Media.vala"
	if (_klass_->get_bitrate) {
#line 77 "../core/Media.vala"
		return _klass_->get_bitrate (self);
#line 3385 "Media.c"
	}
#line 77 "../core/Media.vala"
	return 0U;
#line 3389 "Media.c"
}

static guint
music_media_real_get_bitrate (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 77 "../core/Media.vala"
	self = base;
#line 77 "../core/Media.vala"
	result = self->priv->_bitrate;
#line 77 "../core/Media.vala"
	return result;
#line 3403 "Media.c"
}

void
music_media_set_bitrate (MusicMedia* self,
                         guint value)
{
	MusicMediaClass* _klass_;
#line 77 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 77 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 77 "../core/Media.vala"
	if (_klass_->set_bitrate) {
#line 77 "../core/Media.vala"
		_klass_->set_bitrate (self, value);
#line 3419 "Media.c"
	}
}

static void
music_media_real_set_bitrate (MusicMedia* base,
                              guint value)
{
	MusicMedia* self;
	guint old_value;
#line 77 "../core/Media.vala"
	self = base;
#line 77 "../core/Media.vala"
	old_value = music_media_real_get_bitrate (base);
#line 77 "../core/Media.vala"
	if (old_value != value) {
#line 77 "../core/Media.vala"
		self->priv->_bitrate = value;
#line 77 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_BITRATE_PROPERTY]);
#line 3439 "Media.c"
	}
}

guint
music_media_get_bpm (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 78 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 78 "../core/Media.vala"
	if (_klass_->get_bpm) {
#line 78 "../core/Media.vala"
		return _klass_->get_bpm (self);
#line 3455 "Media.c"
	}
#line 78 "../core/Media.vala"
	return 0U;
#line 3459 "Media.c"
}

static guint
music_media_real_get_bpm (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 78 "../core/Media.vala"
	self = base;
#line 78 "../core/Media.vala"
	result = self->priv->_bpm;
#line 78 "../core/Media.vala"
	return result;
#line 3473 "Media.c"
}

void
music_media_set_bpm (MusicMedia* self,
                     guint value)
{
	MusicMediaClass* _klass_;
#line 78 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 78 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 78 "../core/Media.vala"
	if (_klass_->set_bpm) {
#line 78 "../core/Media.vala"
		_klass_->set_bpm (self, value);
#line 3489 "Media.c"
	}
}

static void
music_media_real_set_bpm (MusicMedia* base,
                          guint value)
{
	MusicMedia* self;
	guint old_value;
#line 78 "../core/Media.vala"
	self = base;
#line 78 "../core/Media.vala"
	old_value = music_media_real_get_bpm (base);
#line 78 "../core/Media.vala"
	if (old_value != value) {
#line 78 "../core/Media.vala"
		self->priv->_bpm = value;
#line 78 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_BPM_PROPERTY]);
#line 3509 "Media.c"
	}
}

guint
music_media_get_samplerate (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 79 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 79 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 79 "../core/Media.vala"
	if (_klass_->get_samplerate) {
#line 79 "../core/Media.vala"
		return _klass_->get_samplerate (self);
#line 3525 "Media.c"
	}
#line 79 "../core/Media.vala"
	return 0U;
#line 3529 "Media.c"
}

static guint
music_media_real_get_samplerate (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 79 "../core/Media.vala"
	self = base;
#line 79 "../core/Media.vala"
	result = self->priv->_samplerate;
#line 79 "../core/Media.vala"
	return result;
#line 3543 "Media.c"
}

void
music_media_set_samplerate (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
#line 79 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 79 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 79 "../core/Media.vala"
	if (_klass_->set_samplerate) {
#line 79 "../core/Media.vala"
		_klass_->set_samplerate (self, value);
#line 3559 "Media.c"
	}
}

static void
music_media_real_set_samplerate (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
#line 79 "../core/Media.vala"
	self = base;
#line 79 "../core/Media.vala"
	old_value = music_media_real_get_samplerate (base);
#line 79 "../core/Media.vala"
	if (old_value != value) {
#line 79 "../core/Media.vala"
		self->priv->_samplerate = value;
#line 79 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SAMPLERATE_PROPERTY]);
#line 3579 "Media.c"
	}
}

guint
music_media_get_length (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 81 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 81 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 81 "../core/Media.vala"
	if (_klass_->get_length) {
#line 81 "../core/Media.vala"
		return _klass_->get_length (self);
#line 3595 "Media.c"
	}
#line 81 "../core/Media.vala"
	return 0U;
#line 3599 "Media.c"
}

static guint
music_media_real_get_length (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 81 "../core/Media.vala"
	self = base;
#line 81 "../core/Media.vala"
	result = self->priv->_length;
#line 81 "../core/Media.vala"
	return result;
#line 3613 "Media.c"
}

void
music_media_set_length (MusicMedia* self,
                        guint value)
{
	MusicMediaClass* _klass_;
#line 81 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 81 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 81 "../core/Media.vala"
	if (_klass_->set_length) {
#line 81 "../core/Media.vala"
		_klass_->set_length (self, value);
#line 3629 "Media.c"
	}
}

static void
music_media_real_set_length (MusicMedia* base,
                             guint value)
{
	MusicMedia* self;
	guint old_value;
#line 81 "../core/Media.vala"
	self = base;
#line 81 "../core/Media.vala"
	old_value = music_media_real_get_length (base);
#line 81 "../core/Media.vala"
	if (old_value != value) {
#line 81 "../core/Media.vala"
		self->priv->_length = value;
#line 81 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LENGTH_PROPERTY]);
#line 3649 "Media.c"
	}
}

guint
music_media_get_rating (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 85 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 85 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 85 "../core/Media.vala"
	if (_klass_->get_rating) {
#line 85 "../core/Media.vala"
		return _klass_->get_rating (self);
#line 3665 "Media.c"
	}
#line 85 "../core/Media.vala"
	return 0U;
#line 3669 "Media.c"
}

static guint
music_media_real_get_rating (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 85 "../core/Media.vala"
	self = base;
#line 85 "../core/Media.vala"
	result = self->_rating;
#line 85 "../core/Media.vala"
	return result;
#line 3683 "Media.c"
}

void
music_media_set_rating (MusicMedia* self,
                        guint value)
{
	MusicMediaClass* _klass_;
#line 86 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 86 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 86 "../core/Media.vala"
	if (_klass_->set_rating) {
#line 86 "../core/Media.vala"
		_klass_->set_rating (self, value);
#line 3699 "Media.c"
	}
}

static void
music_media_real_set_rating (MusicMedia* base,
                             guint value)
{
	MusicMedia* self;
#line 86 "../core/Media.vala"
	self = base;
#line 86 "../core/Media.vala"
	self->_rating = CLAMP (value, (guint) 0, (guint) 5);
#line 86 "../core/Media.vala"
	g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_RATING_PROPERTY]);
#line 3714 "Media.c"
}

guint
music_media_get_play_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 92 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 92 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 92 "../core/Media.vala"
	if (_klass_->get_play_count) {
#line 92 "../core/Media.vala"
		return _klass_->get_play_count (self);
#line 3729 "Media.c"
	}
#line 92 "../core/Media.vala"
	return 0U;
#line 3733 "Media.c"
}

static guint
music_media_real_get_play_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 92 "../core/Media.vala"
	self = base;
#line 92 "../core/Media.vala"
	result = self->priv->_play_count;
#line 92 "../core/Media.vala"
	return result;
#line 3747 "Media.c"
}

void
music_media_set_play_count (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
#line 92 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 92 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 92 "../core/Media.vala"
	if (_klass_->set_play_count) {
#line 92 "../core/Media.vala"
		_klass_->set_play_count (self, value);
#line 3763 "Media.c"
	}
}

static void
music_media_real_set_play_count (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
#line 92 "../core/Media.vala"
	self = base;
#line 92 "../core/Media.vala"
	old_value = music_media_real_get_play_count (base);
#line 92 "../core/Media.vala"
	if (old_value != value) {
#line 92 "../core/Media.vala"
		self->priv->_play_count = value;
#line 92 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_PLAY_COUNT_PROPERTY]);
#line 3783 "Media.c"
	}
}

guint
music_media_get_skip_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 93 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 93 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 93 "../core/Media.vala"
	if (_klass_->get_skip_count) {
#line 93 "../core/Media.vala"
		return _klass_->get_skip_count (self);
#line 3799 "Media.c"
	}
#line 93 "../core/Media.vala"
	return 0U;
#line 3803 "Media.c"
}

static guint
music_media_real_get_skip_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 93 "../core/Media.vala"
	self = base;
#line 93 "../core/Media.vala"
	result = self->priv->_skip_count;
#line 93 "../core/Media.vala"
	return result;
#line 3817 "Media.c"
}

void
music_media_set_skip_count (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
#line 93 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 93 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 93 "../core/Media.vala"
	if (_klass_->set_skip_count) {
#line 93 "../core/Media.vala"
		_klass_->set_skip_count (self, value);
#line 3833 "Media.c"
	}
}

static void
music_media_real_set_skip_count (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
#line 93 "../core/Media.vala"
	self = base;
#line 93 "../core/Media.vala"
	old_value = music_media_real_get_skip_count (base);
#line 93 "../core/Media.vala"
	if (old_value != value) {
#line 93 "../core/Media.vala"
		self->priv->_skip_count = value;
#line 93 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SKIP_COUNT_PROPERTY]);
#line 3853 "Media.c"
	}
}

guint
music_media_get_date_added (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 94 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 94 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 94 "../core/Media.vala"
	if (_klass_->get_date_added) {
#line 94 "../core/Media.vala"
		return _klass_->get_date_added (self);
#line 3869 "Media.c"
	}
#line 94 "../core/Media.vala"
	return 0U;
#line 3873 "Media.c"
}

static guint
music_media_real_get_date_added (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 94 "../core/Media.vala"
	self = base;
#line 94 "../core/Media.vala"
	result = self->priv->_date_added;
#line 94 "../core/Media.vala"
	return result;
#line 3887 "Media.c"
}

void
music_media_set_date_added (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
#line 94 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 94 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 94 "../core/Media.vala"
	if (_klass_->set_date_added) {
#line 94 "../core/Media.vala"
		_klass_->set_date_added (self, value);
#line 3903 "Media.c"
	}
}

static void
music_media_real_set_date_added (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
#line 94 "../core/Media.vala"
	self = base;
#line 94 "../core/Media.vala"
	old_value = music_media_real_get_date_added (base);
#line 94 "../core/Media.vala"
	if (old_value != value) {
#line 94 "../core/Media.vala"
		self->priv->_date_added = value;
#line 94 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_DATE_ADDED_PROPERTY]);
#line 3923 "Media.c"
	}
}

guint
music_media_get_last_played (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 95 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 95 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 95 "../core/Media.vala"
	if (_klass_->get_last_played) {
#line 95 "../core/Media.vala"
		return _klass_->get_last_played (self);
#line 3939 "Media.c"
	}
#line 95 "../core/Media.vala"
	return 0U;
#line 3943 "Media.c"
}

static guint
music_media_real_get_last_played (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 95 "../core/Media.vala"
	self = base;
#line 95 "../core/Media.vala"
	result = self->priv->_last_played;
#line 95 "../core/Media.vala"
	return result;
#line 3957 "Media.c"
}

void
music_media_set_last_played (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
#line 95 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 95 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 95 "../core/Media.vala"
	if (_klass_->set_last_played) {
#line 95 "../core/Media.vala"
		_klass_->set_last_played (self, value);
#line 3973 "Media.c"
	}
}

static void
music_media_real_set_last_played (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
#line 95 "../core/Media.vala"
	self = base;
#line 95 "../core/Media.vala"
	old_value = music_media_real_get_last_played (base);
#line 95 "../core/Media.vala"
	if (old_value != value) {
#line 95 "../core/Media.vala"
		self->priv->_last_played = value;
#line 95 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LAST_PLAYED_PROPERTY]);
#line 3993 "Media.c"
	}
}

guint
music_media_get_last_modified (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 96 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 96 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 96 "../core/Media.vala"
	if (_klass_->get_last_modified) {
#line 96 "../core/Media.vala"
		return _klass_->get_last_modified (self);
#line 4009 "Media.c"
	}
#line 96 "../core/Media.vala"
	return 0U;
#line 4013 "Media.c"
}

static guint
music_media_real_get_last_modified (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
#line 96 "../core/Media.vala"
	self = base;
#line 96 "../core/Media.vala"
	result = self->priv->_last_modified;
#line 96 "../core/Media.vala"
	return result;
#line 4027 "Media.c"
}

void
music_media_set_last_modified (MusicMedia* self,
                               guint value)
{
	MusicMediaClass* _klass_;
#line 96 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 96 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 96 "../core/Media.vala"
	if (_klass_->set_last_modified) {
#line 96 "../core/Media.vala"
		_klass_->set_last_modified (self, value);
#line 4043 "Media.c"
	}
}

static void
music_media_real_set_last_modified (MusicMedia* base,
                                    guint value)
{
	MusicMedia* self;
	guint old_value;
#line 96 "../core/Media.vala"
	self = base;
#line 96 "../core/Media.vala"
	old_value = music_media_real_get_last_modified (base);
#line 96 "../core/Media.vala"
	if (old_value != value) {
#line 96 "../core/Media.vala"
		self->priv->_last_modified = value;
#line 96 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LAST_MODIFIED_PROPERTY]);
#line 4063 "Media.c"
	}
}

gint
music_media_get_resume_pos (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 98 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 98 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 98 "../core/Media.vala"
	if (_klass_->get_resume_pos) {
#line 98 "../core/Media.vala"
		return _klass_->get_resume_pos (self);
#line 4079 "Media.c"
	}
#line 98 "../core/Media.vala"
	return -1;
#line 4083 "Media.c"
}

static gint
music_media_real_get_resume_pos (MusicMedia* base)
{
	gint result;
	MusicMedia* self;
#line 98 "../core/Media.vala"
	self = base;
#line 98 "../core/Media.vala"
	result = self->priv->_resume_pos;
#line 98 "../core/Media.vala"
	return result;
#line 4097 "Media.c"
}

void
music_media_set_resume_pos (MusicMedia* self,
                            gint value)
{
	MusicMediaClass* _klass_;
#line 98 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 98 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 98 "../core/Media.vala"
	if (_klass_->set_resume_pos) {
#line 98 "../core/Media.vala"
		_klass_->set_resume_pos (self, value);
#line 4113 "Media.c"
	}
}

static void
music_media_real_set_resume_pos (MusicMedia* base,
                                 gint value)
{
	MusicMedia* self;
	gint old_value;
#line 98 "../core/Media.vala"
	self = base;
#line 98 "../core/Media.vala"
	old_value = music_media_real_get_resume_pos (base);
#line 98 "../core/Media.vala"
	if (old_value != value) {
#line 98 "../core/Media.vala"
		self->priv->_resume_pos = value;
#line 98 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_RESUME_POS_PROPERTY]);
#line 4133 "Media.c"
	}
}

gboolean
music_media_get_show (MusicMedia* self)
{
	MusicMediaClass* _klass_;
#line 99 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 99 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 99 "../core/Media.vala"
	if (_klass_->get_show) {
#line 99 "../core/Media.vala"
		return _klass_->get_show (self);
#line 4149 "Media.c"
	}
#line 99 "../core/Media.vala"
	return FALSE;
#line 4153 "Media.c"
}

static gboolean
music_media_real_get_show (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
#line 99 "../core/Media.vala"
	self = base;
#line 99 "../core/Media.vala"
	result = self->priv->_show;
#line 99 "../core/Media.vala"
	return result;
#line 4167 "Media.c"
}

void
music_media_set_show (MusicMedia* self,
                      gboolean value)
{
	MusicMediaClass* _klass_;
#line 99 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 99 "../core/Media.vala"
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
#line 99 "../core/Media.vala"
	if (_klass_->set_show) {
#line 99 "../core/Media.vala"
		_klass_->set_show (self, value);
#line 4183 "Media.c"
	}
}

static void
music_media_real_set_show (MusicMedia* base,
                           gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
#line 99 "../core/Media.vala"
	self = base;
#line 99 "../core/Media.vala"
	old_value = music_media_real_get_show (base);
#line 99 "../core/Media.vala"
	if (old_value != value) {
#line 99 "../core/Media.vala"
		self->priv->_show = value;
#line 99 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SHOW_PROPERTY]);
#line 4203 "Media.c"
	}
}

static void
music_media_class_init (MusicMediaClass * klass,
                        gpointer klass_data)
{
	gchar* _tmp0_;
#line 30 "../core/Media.vala"
	music_media_parent_class = g_type_class_peek_parent (klass);
#line 30 "../core/Media.vala"
	g_type_class_adjust_private_offset (klass, &MusicMedia_private_offset);
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_uri = music_media_real_get_uri;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_uri = music_media_real_set_uri;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_file_size = music_media_real_get_file_size;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_file_size = music_media_real_set_file_size;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_file_exists = music_media_real_get_file_exists;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_file = music_media_real_get_file;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_file = music_media_real_set_file;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_is_preview = music_media_real_get_is_preview;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_is_preview = music_media_real_set_is_preview;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_is_temporary = music_media_real_get_is_temporary;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_is_temporary = music_media_real_set_is_temporary;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_location_unknown = music_media_real_get_location_unknown;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_location_unknown = music_media_real_set_location_unknown;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_has_embedded = music_media_real_get_has_embedded;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_has_embedded = music_media_real_set_has_embedded;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_unique_status_image = music_media_real_get_unique_status_image;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_unique_status_image = music_media_real_set_unique_status_image;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_show_indicator = music_media_real_get_show_indicator;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_show_indicator = music_media_real_set_show_indicator;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_title = music_media_real_get_title;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_title = music_media_real_set_title;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_track = music_media_real_get_track;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_track = music_media_real_set_track;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_track_count = music_media_real_get_track_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_track_count = music_media_real_set_track_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_composer = music_media_real_get_composer;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_composer = music_media_real_set_composer;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_artist = music_media_real_get_artist;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_artist = music_media_real_set_artist;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_album_artist = music_media_real_get_album_artist;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_album_artist = music_media_real_set_album_artist;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_album = music_media_real_get_album;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_album = music_media_real_set_album;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_album_number = music_media_real_get_album_number;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_album_number = music_media_real_set_album_number;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_album_count = music_media_real_get_album_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_album_count = music_media_real_set_album_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_album_info = music_media_real_get_album_info;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_album_info = music_media_real_set_album_info;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_grouping = music_media_real_get_grouping;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_grouping = music_media_real_set_grouping;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_genre = music_media_real_get_genre;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_genre = music_media_real_set_genre;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_comment = music_media_real_get_comment;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_comment = music_media_real_set_comment;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_lyrics = music_media_real_get_lyrics;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_lyrics = music_media_real_set_lyrics;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_year = music_media_real_get_year;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_year = music_media_real_set_year;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_bitrate = music_media_real_get_bitrate;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_bitrate = music_media_real_set_bitrate;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_bpm = music_media_real_get_bpm;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_bpm = music_media_real_set_bpm;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_samplerate = music_media_real_get_samplerate;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_samplerate = music_media_real_set_samplerate;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_length = music_media_real_get_length;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_length = music_media_real_set_length;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_rating = music_media_real_get_rating;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_rating = music_media_real_set_rating;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_play_count = music_media_real_get_play_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_play_count = music_media_real_set_play_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_skip_count = music_media_real_get_skip_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_skip_count = music_media_real_set_skip_count;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_date_added = music_media_real_get_date_added;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_date_added = music_media_real_set_date_added;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_last_played = music_media_real_get_last_played;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_last_played = music_media_real_set_last_played;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_last_modified = music_media_real_get_last_modified;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_last_modified = music_media_real_set_last_modified;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_resume_pos = music_media_real_get_resume_pos;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_resume_pos = music_media_real_set_resume_pos;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->get_show = music_media_real_get_show;
#line 30 "../core/Media.vala"
	MUSIC_MEDIA_CLASS (klass)->set_show = music_media_real_set_show;
#line 30 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_music_media_get_property;
#line 30 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_music_media_set_property;
#line 30 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->finalize = music_media_finalize;
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ROWID_PROPERTY, music_media_properties[MUSIC_MEDIA_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_URI_PROPERTY, music_media_properties[MUSIC_MEDIA_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_SIZE_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_EXISTS_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("file-exists", "file-exists", "file-exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_IS_PREVIEW_PROPERTY, music_media_properties[MUSIC_MEDIA_IS_PREVIEW_PROPERTY] = g_param_spec_boolean ("is-preview", "is-preview", "is-preview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_IS_TEMPORARY_PROPERTY, music_media_properties[MUSIC_MEDIA_IS_TEMPORARY_PROPERTY] = g_param_spec_boolean ("is-temporary", "is-temporary", "is-temporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY, music_media_properties[MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY] = g_param_spec_boolean ("location-unknown", "location-unknown", "location-unknown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY, music_media_properties[MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY] = g_param_spec_boolean ("has-embedded", "has-embedded", "has-embedded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY, music_media_properties[MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY] = g_param_spec_object ("unique-status-image", "unique-status-image", "unique-status-image", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY, music_media_properties[MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY] = g_param_spec_boolean ("show-indicator", "show-indicator", "show-indicator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4390 "Media.c"
	/**
	     * Metadata Fields
	     */
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TITLE_PROPERTY, music_media_properties[MUSIC_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TRACK_PROPERTY, music_media_properties[MUSIC_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TRACK_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_COMPOSER_PROPERTY, music_media_properties[MUSIC_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ARTIST_PROPERTY, music_media_properties[MUSIC_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_INFO_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", MUSIC_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_GROUPING_PROPERTY, music_media_properties[MUSIC_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_GENRE_PROPERTY, music_media_properties[MUSIC_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_COMMENT_PROPERTY, music_media_properties[MUSIC_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LYRICS_PROPERTY, music_media_properties[MUSIC_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_YEAR_PROPERTY, music_media_properties[MUSIC_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_BITRATE_PROPERTY, music_media_properties[MUSIC_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_BPM_PROPERTY, music_media_properties[MUSIC_MEDIA_BPM_PROPERTY] = g_param_spec_uint ("bpm", "bpm", "bpm", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SAMPLERATE_PROPERTY, music_media_properties[MUSIC_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LENGTH_PROPERTY, music_media_properties[MUSIC_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_RATING_PROPERTY, music_media_properties[MUSIC_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4434 "Media.c"
	/**
	     * Internal stats
	     */
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_PLAY_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SKIP_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_DATE_ADDED_PROPERTY, music_media_properties[MUSIC_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LAST_PLAYED_PROPERTY, music_media_properties[MUSIC_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LAST_MODIFIED_PROPERTY, music_media_properties[MUSIC_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_RESUME_POS_PROPERTY, music_media_properties[MUSIC_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SHOW_PROPERTY, music_media_properties[MUSIC_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 33 "../core/Media.vala"
	_tmp0_ = g_strdup (_ ("Unknown"));
#line 33 "../core/Media.vala"
	music_media_UNKNOWN = _tmp0_;
#line 4456 "Media.c"
}

static void
music_media_instance_init (MusicMedia * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 30 "../core/Media.vala"
	self->priv = music_media_get_instance_private (self);
#line 42 "../core/Media.vala"
	self->priv->_file_size = (guint64) 0;
#line 47 "../core/Media.vala"
	self->priv->_is_preview = FALSE;
#line 48 "../core/Media.vala"
	self->priv->_is_temporary = FALSE;
#line 51 "../core/Media.vala"
	self->priv->_location_unknown = FALSE;
#line 52 "../core/Media.vala"
	self->priv->_has_embedded = FALSE;
#line 57 "../core/Media.vala"
	self->priv->_show_indicator = FALSE;
#line 62 "../core/Media.vala"
	_tmp0_ = g_strdup ("");
#line 62 "../core/Media.vala"
	self->priv->_title = _tmp0_;
#line 63 "../core/Media.vala"
	self->priv->_track = (guint) 0;
#line 64 "../core/Media.vala"
	self->priv->_track_count = (guint) 0;
#line 65 "../core/Media.vala"
	_tmp1_ = g_strdup ("");
#line 65 "../core/Media.vala"
	self->priv->_composer = _tmp1_;
#line 66 "../core/Media.vala"
	_tmp2_ = g_strdup ("");
#line 66 "../core/Media.vala"
	self->priv->_artist = _tmp2_;
#line 67 "../core/Media.vala"
	_tmp3_ = g_strdup ("");
#line 67 "../core/Media.vala"
	self->priv->_album_artist = _tmp3_;
#line 68 "../core/Media.vala"
	_tmp4_ = g_strdup ("");
#line 68 "../core/Media.vala"
	self->priv->_album = _tmp4_;
#line 69 "../core/Media.vala"
	self->priv->_album_number = (guint) 1;
#line 70 "../core/Media.vala"
	self->priv->_album_count = (guint) 1;
#line 71 "../core/Media.vala"
	self->priv->_album_info = NULL;
#line 72 "../core/Media.vala"
	_tmp5_ = g_strdup ("");
#line 72 "../core/Media.vala"
	self->priv->_grouping = _tmp5_;
#line 73 "../core/Media.vala"
	_tmp6_ = g_strdup ("");
#line 73 "../core/Media.vala"
	self->priv->_genre = _tmp6_;
#line 74 "../core/Media.vala"
	_tmp7_ = g_strdup ("");
#line 74 "../core/Media.vala"
	self->priv->_comment = _tmp7_;
#line 75 "../core/Media.vala"
	_tmp8_ = g_strdup ("");
#line 75 "../core/Media.vala"
	self->priv->_lyrics = _tmp8_;
#line 76 "../core/Media.vala"
	self->priv->_year = (guint) 0;
#line 77 "../core/Media.vala"
	self->priv->_bitrate = (guint) 0;
#line 78 "../core/Media.vala"
	self->priv->_bpm = (guint) 0;
#line 79 "../core/Media.vala"
	self->priv->_samplerate = (guint) 0;
#line 81 "../core/Media.vala"
	self->priv->_length = (guint) 0;
#line 92 "../core/Media.vala"
	self->priv->_play_count = (guint) 0;
#line 93 "../core/Media.vala"
	self->priv->_skip_count = (guint) 0;
#line 94 "../core/Media.vala"
	self->priv->_date_added = (guint) 0;
#line 95 "../core/Media.vala"
	self->priv->_last_played = (guint) 0;
#line 96 "../core/Media.vala"
	self->priv->_last_modified = (guint) 0;
#line 98 "../core/Media.vala"
	self->priv->_resume_pos = 0;
#line 99 "../core/Media.vala"
	self->priv->_show = TRUE;
#line 4556 "Media.c"
}

static void
music_media_finalize (GObject * obj)
{
	MusicMedia * self;
#line 30 "../core/Media.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA, MusicMedia);
#line 45 "../core/Media.vala"
	_g_object_unref0 (self->priv->_file);
#line 56 "../core/Media.vala"
	_g_object_unref0 (self->priv->_unique_status_image);
#line 62 "../core/Media.vala"
	_g_free0 (self->priv->_title);
#line 65 "../core/Media.vala"
	_g_free0 (self->priv->_composer);
#line 66 "../core/Media.vala"
	_g_free0 (self->priv->_artist);
#line 67 "../core/Media.vala"
	_g_free0 (self->priv->_album_artist);
#line 68 "../core/Media.vala"
	_g_free0 (self->priv->_album);
#line 72 "../core/Media.vala"
	_g_free0 (self->priv->_grouping);
#line 73 "../core/Media.vala"
	_g_free0 (self->priv->_genre);
#line 74 "../core/Media.vala"
	_g_free0 (self->priv->_comment);
#line 75 "../core/Media.vala"
	_g_free0 (self->priv->_lyrics);
#line 30 "../core/Media.vala"
	G_OBJECT_CLASS (music_media_parent_class)->finalize (obj);
#line 4589 "Media.c"
}

static GType
music_media_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMedia), 0, (GInstanceInitFunc) music_media_instance_init, NULL };
	GType music_media_type_id;
	music_media_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicMedia", &g_define_type_info, 0);
	MusicMedia_private_offset = g_type_add_instance_private (music_media_type_id, sizeof (MusicMediaPrivate));
	return music_media_type_id;
}

GType
music_media_get_type (void)
{
	static volatile gsize music_media_type_id__once = 0;
	if (g_once_init_enter (&music_media_type_id__once)) {
		GType music_media_type_id;
		music_media_type_id = music_media_get_type_once ();
		g_once_init_leave (&music_media_type_id__once, music_media_type_id);
	}
	return music_media_type_id__once;
}

static void
_vala_music_media_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	MusicMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA, MusicMedia);
#line 30 "../core/Media.vala"
	switch (property_id) {
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ROWID_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_int64 (value, music_media_get_rowid (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_URI_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_take_string (value, music_media_get_uri (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_FILE_SIZE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint64 (value, music_media_get_file_size (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_FILE_EXISTS_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_file_exists (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_FILE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_object (value, music_media_get_file (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_IS_PREVIEW_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_is_preview (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_IS_TEMPORARY_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_is_temporary (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_location_unknown (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_has_embedded (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_object (value, music_media_get_unique_status_image (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_show_indicator (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TITLE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_title (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TRACK_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_track (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TRACK_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_track_count (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_COMPOSER_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_composer (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ARTIST_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_artist (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_album_artist (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_album (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_album_number (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_album_count (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_INFO_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_object (value, music_media_get_album_info (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_GROUPING_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_grouping (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_GENRE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_genre (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_COMMENT_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_comment (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LYRICS_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_string (value, music_media_get_lyrics (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_YEAR_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_year (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_BITRATE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_bitrate (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_BPM_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_bpm (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SAMPLERATE_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_samplerate (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LENGTH_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_length (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_RATING_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_rating (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_PLAY_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_play_count (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SKIP_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_skip_count (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_DATE_ADDED_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_date_added (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LAST_PLAYED_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_last_played (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LAST_MODIFIED_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_uint (value, music_media_get_last_modified (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_RESUME_POS_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_int (value, music_media_get_resume_pos (self));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SHOW_PROPERTY:
#line 30 "../core/Media.vala"
		g_value_set_boolean (value, music_media_get_show (self));
#line 30 "../core/Media.vala"
		break;
#line 4852 "Media.c"
		default:
#line 30 "../core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Media.vala"
		break;
#line 4858 "Media.c"
	}
}

static void
_vala_music_media_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	MusicMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA, MusicMedia);
#line 30 "../core/Media.vala"
	switch (property_id) {
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ROWID_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_rowid (self, g_value_get_int64 (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_URI_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_uri (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_FILE_SIZE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_file_size (self, g_value_get_uint64 (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_FILE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_file (self, g_value_get_object (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_IS_PREVIEW_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_is_preview (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_IS_TEMPORARY_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_is_temporary (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_location_unknown (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_has_embedded (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_unique_status_image (self, g_value_get_object (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_show_indicator (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TITLE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_title (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TRACK_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_track (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_TRACK_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_track_count (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_COMPOSER_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_composer (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ARTIST_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_artist (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_album_artist (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_album (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_album_number (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_album_count (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_ALBUM_INFO_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_album_info (self, g_value_get_object (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_GROUPING_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_grouping (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_GENRE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_genre (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_COMMENT_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_comment (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LYRICS_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_lyrics (self, g_value_get_string (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_YEAR_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_year (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_BITRATE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_bitrate (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_BPM_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_bpm (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SAMPLERATE_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_samplerate (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LENGTH_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_length (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_RATING_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_rating (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_PLAY_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_play_count (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SKIP_COUNT_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_skip_count (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_DATE_ADDED_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_date_added (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LAST_PLAYED_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_last_played (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_LAST_MODIFIED_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_last_modified (self, g_value_get_uint (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_RESUME_POS_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_resume_pos (self, g_value_get_int (value));
#line 30 "../core/Media.vala"
		break;
#line 30 "../core/Media.vala"
		case MUSIC_MEDIA_SHOW_PROPERTY:
#line 30 "../core/Media.vala"
		music_media_set_show (self, g_value_get_boolean (value));
#line 30 "../core/Media.vala"
		break;
#line 5094 "Media.c"
		default:
#line 30 "../core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../core/Media.vala"
		break;
#line 5100 "Media.c"
	}
}

